<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountEmailEvent ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountEmailEvent
 * @subpackage Arrays
 */
class ArrayOfAccountEmailEvent extends AbstractStructArrayBase
{
    /**
     * The AccountEmailEvent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountEmailEvent[]
     */
    public $AccountEmailEvent;
    /**
     * Constructor method for ArrayOfAccountEmailEvent
     * @uses ArrayOfAccountEmailEvent::setAccountEmailEvent()
     * @param \StructType\AccountEmailEvent[] $accountEmailEvent
     */
    public function __construct(array $accountEmailEvent = array())
    {
        $this
            ->setAccountEmailEvent($accountEmailEvent);
    }
    /**
     * Get AccountEmailEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountEmailEvent[]|null
     */
    public function getAccountEmailEvent()
    {
        return isset($this->AccountEmailEvent) ? $this->AccountEmailEvent : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountEmailEvent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountEmailEvent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountEmailEventForArrayConstraintsFromSetAccountEmailEvent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountEmailEventAccountEmailEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountEmailEventAccountEmailEventItem instanceof \StructType\AccountEmailEvent) {
                $invalidValues[] = is_object($arrayOfAccountEmailEventAccountEmailEventItem) ? get_class($arrayOfAccountEmailEventAccountEmailEventItem) : sprintf('%s(%s)', gettype($arrayOfAccountEmailEventAccountEmailEventItem), var_export($arrayOfAccountEmailEventAccountEmailEventItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AccountEmailEvent property can only contain items of type \StructType\AccountEmailEvent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountEmailEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountEmailEvent[] $accountEmailEvent
     * @return \ArrayType\ArrayOfAccountEmailEvent
     */
    public function setAccountEmailEvent(array $accountEmailEvent = array())
    {
        // validation for constraint: array
        if ('' !== ($accountEmailEventArrayErrorMessage = self::validateAccountEmailEventForArrayConstraintsFromSetAccountEmailEvent($accountEmailEvent))) {
            throw new \InvalidArgumentException($accountEmailEventArrayErrorMessage, __LINE__);
        }
        if (is_null($accountEmailEvent) || (is_array($accountEmailEvent) && empty($accountEmailEvent))) {
            unset($this->AccountEmailEvent);
        } else {
            $this->AccountEmailEvent = $accountEmailEvent;
        }
        return $this;
    }
    /**
     * Add item to AccountEmailEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountEmailEvent $item
     * @return \ArrayType\ArrayOfAccountEmailEvent
     */
    public function addToAccountEmailEvent(\StructType\AccountEmailEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountEmailEvent) {
            throw new \InvalidArgumentException(sprintf('The AccountEmailEvent property can only contain items of type \StructType\AccountEmailEvent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AccountEmailEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountEmailEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountEmailEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountEmailEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountEmailEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountEmailEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountEmailEvent
     */
    public function getAttributeName()
    {
        return 'AccountEmailEvent';
    }
}
