<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountEventDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountEventDetail
 * @subpackage Arrays
 */
class ArrayOfAccountEventDetail extends AbstractStructArrayBase
{
    /**
     * The AccountEventDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountEventDetail[]
     */
    public $AccountEventDetail;
    /**
     * Constructor method for ArrayOfAccountEventDetail
     * @uses ArrayOfAccountEventDetail::setAccountEventDetail()
     * @param \StructType\AccountEventDetail[] $accountEventDetail
     */
    public function __construct(array $accountEventDetail = array())
    {
        $this
            ->setAccountEventDetail($accountEventDetail);
    }
    /**
     * Get AccountEventDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountEventDetail[]|null
     */
    public function getAccountEventDetail()
    {
        return isset($this->AccountEventDetail) ? $this->AccountEventDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountEventDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountEventDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountEventDetailForArrayConstraintsFromSetAccountEventDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountEventDetailAccountEventDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountEventDetailAccountEventDetailItem instanceof \StructType\AccountEventDetail) {
                $invalidValues[] = is_object($arrayOfAccountEventDetailAccountEventDetailItem) ? get_class($arrayOfAccountEventDetailAccountEventDetailItem) : sprintf('%s(%s)', gettype($arrayOfAccountEventDetailAccountEventDetailItem), var_export($arrayOfAccountEventDetailAccountEventDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AccountEventDetail property can only contain items of type \StructType\AccountEventDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountEventDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountEventDetail[] $accountEventDetail
     * @return \ArrayType\ArrayOfAccountEventDetail
     */
    public function setAccountEventDetail(array $accountEventDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($accountEventDetailArrayErrorMessage = self::validateAccountEventDetailForArrayConstraintsFromSetAccountEventDetail($accountEventDetail))) {
            throw new \InvalidArgumentException($accountEventDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($accountEventDetail) || (is_array($accountEventDetail) && empty($accountEventDetail))) {
            unset($this->AccountEventDetail);
        } else {
            $this->AccountEventDetail = $accountEventDetail;
        }
        return $this;
    }
    /**
     * Add item to AccountEventDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountEventDetail $item
     * @return \ArrayType\ArrayOfAccountEventDetail
     */
    public function addToAccountEventDetail(\StructType\AccountEventDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountEventDetail) {
            throw new \InvalidArgumentException(sprintf('The AccountEventDetail property can only contain items of type \StructType\AccountEventDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AccountEventDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountEventDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountEventDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountEventDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountEventDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountEventDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountEventDetail
     */
    public function getAttributeName()
    {
        return 'AccountEventDetail';
    }
}
