<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountMasterDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountMasterDetails
 * @subpackage Arrays
 */
class ArrayOfAccountMasterDetails extends AbstractStructArrayBase
{
    /**
     * The AccountMasterDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountMasterDetails[]
     */
    public $AccountMasterDetails;
    /**
     * Constructor method for ArrayOfAccountMasterDetails
     * @uses ArrayOfAccountMasterDetails::setAccountMasterDetails()
     * @param \StructType\AccountMasterDetails[] $accountMasterDetails
     */
    public function __construct(array $accountMasterDetails = array())
    {
        $this
            ->setAccountMasterDetails($accountMasterDetails);
    }
    /**
     * Get AccountMasterDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountMasterDetails[]|null
     */
    public function getAccountMasterDetails()
    {
        return isset($this->AccountMasterDetails) ? $this->AccountMasterDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountMasterDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountMasterDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountMasterDetailsForArrayConstraintsFromSetAccountMasterDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountMasterDetailsAccountMasterDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountMasterDetailsAccountMasterDetailsItem instanceof \StructType\AccountMasterDetails) {
                $invalidValues[] = is_object($arrayOfAccountMasterDetailsAccountMasterDetailsItem) ? get_class($arrayOfAccountMasterDetailsAccountMasterDetailsItem) : sprintf('%s(%s)', gettype($arrayOfAccountMasterDetailsAccountMasterDetailsItem), var_export($arrayOfAccountMasterDetailsAccountMasterDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AccountMasterDetails property can only contain items of type \StructType\AccountMasterDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountMasterDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountMasterDetails[] $accountMasterDetails
     * @return \ArrayType\ArrayOfAccountMasterDetails
     */
    public function setAccountMasterDetails(array $accountMasterDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($accountMasterDetailsArrayErrorMessage = self::validateAccountMasterDetailsForArrayConstraintsFromSetAccountMasterDetails($accountMasterDetails))) {
            throw new \InvalidArgumentException($accountMasterDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($accountMasterDetails) || (is_array($accountMasterDetails) && empty($accountMasterDetails))) {
            unset($this->AccountMasterDetails);
        } else {
            $this->AccountMasterDetails = $accountMasterDetails;
        }
        return $this;
    }
    /**
     * Add item to AccountMasterDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountMasterDetails $item
     * @return \ArrayType\ArrayOfAccountMasterDetails
     */
    public function addToAccountMasterDetails(\StructType\AccountMasterDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountMasterDetails) {
            throw new \InvalidArgumentException(sprintf('The AccountMasterDetails property can only contain items of type \StructType\AccountMasterDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AccountMasterDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountMasterDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountMasterDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountMasterDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountMasterDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountMasterDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountMasterDetails
     */
    public function getAttributeName()
    {
        return 'AccountMasterDetails';
    }
}
