<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountMasterDetailsAccountFixedRoutes ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountMasterDetailsAccountFixedRoutes
 * @subpackage Arrays
 */
class ArrayOfAccountMasterDetailsAccountFixedRoutes extends AbstractStructArrayBase
{
    /**
     * The AccountMasterDetailsAccountFixedRoutes
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountMasterDetailsAccountFixedRoutes[]
     */
    public $AccountMasterDetailsAccountFixedRoutes;
    /**
     * Constructor method for ArrayOfAccountMasterDetailsAccountFixedRoutes
     * @uses ArrayOfAccountMasterDetailsAccountFixedRoutes::setAccountMasterDetailsAccountFixedRoutes()
     * @param \StructType\AccountMasterDetailsAccountFixedRoutes[] $accountMasterDetailsAccountFixedRoutes
     */
    public function __construct(array $accountMasterDetailsAccountFixedRoutes = array())
    {
        $this
            ->setAccountMasterDetailsAccountFixedRoutes($accountMasterDetailsAccountFixedRoutes);
    }
    /**
     * Get AccountMasterDetailsAccountFixedRoutes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountMasterDetailsAccountFixedRoutes[]|null
     */
    public function getAccountMasterDetailsAccountFixedRoutes()
    {
        return isset($this->AccountMasterDetailsAccountFixedRoutes) ? $this->AccountMasterDetailsAccountFixedRoutes : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountMasterDetailsAccountFixedRoutes method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountMasterDetailsAccountFixedRoutes method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountMasterDetailsAccountFixedRoutesForArrayConstraintsFromSetAccountMasterDetailsAccountFixedRoutes(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountMasterDetailsAccountFixedRoutesAccountMasterDetailsAccountFixedRoutesItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountMasterDetailsAccountFixedRoutesAccountMasterDetailsAccountFixedRoutesItem instanceof \StructType\AccountMasterDetailsAccountFixedRoutes) {
                $invalidValues[] = is_object($arrayOfAccountMasterDetailsAccountFixedRoutesAccountMasterDetailsAccountFixedRoutesItem) ? get_class($arrayOfAccountMasterDetailsAccountFixedRoutesAccountMasterDetailsAccountFixedRoutesItem) : sprintf('%s(%s)', gettype($arrayOfAccountMasterDetailsAccountFixedRoutesAccountMasterDetailsAccountFixedRoutesItem), var_export($arrayOfAccountMasterDetailsAccountFixedRoutesAccountMasterDetailsAccountFixedRoutesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AccountMasterDetailsAccountFixedRoutes property can only contain items of type \StructType\AccountMasterDetailsAccountFixedRoutes, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountMasterDetailsAccountFixedRoutes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountMasterDetailsAccountFixedRoutes[] $accountMasterDetailsAccountFixedRoutes
     * @return \ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes
     */
    public function setAccountMasterDetailsAccountFixedRoutes(array $accountMasterDetailsAccountFixedRoutes = array())
    {
        // validation for constraint: array
        if ('' !== ($accountMasterDetailsAccountFixedRoutesArrayErrorMessage = self::validateAccountMasterDetailsAccountFixedRoutesForArrayConstraintsFromSetAccountMasterDetailsAccountFixedRoutes($accountMasterDetailsAccountFixedRoutes))) {
            throw new \InvalidArgumentException($accountMasterDetailsAccountFixedRoutesArrayErrorMessage, __LINE__);
        }
        if (is_null($accountMasterDetailsAccountFixedRoutes) || (is_array($accountMasterDetailsAccountFixedRoutes) && empty($accountMasterDetailsAccountFixedRoutes))) {
            unset($this->AccountMasterDetailsAccountFixedRoutes);
        } else {
            $this->AccountMasterDetailsAccountFixedRoutes = $accountMasterDetailsAccountFixedRoutes;
        }
        return $this;
    }
    /**
     * Add item to AccountMasterDetailsAccountFixedRoutes value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountMasterDetailsAccountFixedRoutes $item
     * @return \ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes
     */
    public function addToAccountMasterDetailsAccountFixedRoutes(\StructType\AccountMasterDetailsAccountFixedRoutes $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountMasterDetailsAccountFixedRoutes) {
            throw new \InvalidArgumentException(sprintf('The AccountMasterDetailsAccountFixedRoutes property can only contain items of type \StructType\AccountMasterDetailsAccountFixedRoutes, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AccountMasterDetailsAccountFixedRoutes[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountMasterDetailsAccountFixedRoutes|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountMasterDetailsAccountFixedRoutes|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountMasterDetailsAccountFixedRoutes|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountMasterDetailsAccountFixedRoutes|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountMasterDetailsAccountFixedRoutes|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountMasterDetailsAccountFixedRoutes
     */
    public function getAttributeName()
    {
        return 'AccountMasterDetailsAccountFixedRoutes';
    }
}
