<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAssetDecommissionDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAssetDecommissionDetails
 * @subpackage Arrays
 */
class ArrayOfAssetDecommissionDetails extends AbstractStructArrayBase
{
    /**
     * The AssetDecommissionDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AssetDecommissionDetails[]
     */
    public $AssetDecommissionDetails;
    /**
     * Constructor method for ArrayOfAssetDecommissionDetails
     * @uses ArrayOfAssetDecommissionDetails::setAssetDecommissionDetails()
     * @param \StructType\AssetDecommissionDetails[] $assetDecommissionDetails
     */
    public function __construct(array $assetDecommissionDetails = array())
    {
        $this
            ->setAssetDecommissionDetails($assetDecommissionDetails);
    }
    /**
     * Get AssetDecommissionDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AssetDecommissionDetails[]|null
     */
    public function getAssetDecommissionDetails()
    {
        return isset($this->AssetDecommissionDetails) ? $this->AssetDecommissionDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAssetDecommissionDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAssetDecommissionDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAssetDecommissionDetailsForArrayConstraintsFromSetAssetDecommissionDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAssetDecommissionDetailsAssetDecommissionDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAssetDecommissionDetailsAssetDecommissionDetailsItem instanceof \StructType\AssetDecommissionDetails) {
                $invalidValues[] = is_object($arrayOfAssetDecommissionDetailsAssetDecommissionDetailsItem) ? get_class($arrayOfAssetDecommissionDetailsAssetDecommissionDetailsItem) : sprintf('%s(%s)', gettype($arrayOfAssetDecommissionDetailsAssetDecommissionDetailsItem), var_export($arrayOfAssetDecommissionDetailsAssetDecommissionDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AssetDecommissionDetails property can only contain items of type \StructType\AssetDecommissionDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AssetDecommissionDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AssetDecommissionDetails[] $assetDecommissionDetails
     * @return \ArrayType\ArrayOfAssetDecommissionDetails
     */
    public function setAssetDecommissionDetails(array $assetDecommissionDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($assetDecommissionDetailsArrayErrorMessage = self::validateAssetDecommissionDetailsForArrayConstraintsFromSetAssetDecommissionDetails($assetDecommissionDetails))) {
            throw new \InvalidArgumentException($assetDecommissionDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($assetDecommissionDetails) || (is_array($assetDecommissionDetails) && empty($assetDecommissionDetails))) {
            unset($this->AssetDecommissionDetails);
        } else {
            $this->AssetDecommissionDetails = $assetDecommissionDetails;
        }
        return $this;
    }
    /**
     * Add item to AssetDecommissionDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\AssetDecommissionDetails $item
     * @return \ArrayType\ArrayOfAssetDecommissionDetails
     */
    public function addToAssetDecommissionDetails(\StructType\AssetDecommissionDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AssetDecommissionDetails) {
            throw new \InvalidArgumentException(sprintf('The AssetDecommissionDetails property can only contain items of type \StructType\AssetDecommissionDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AssetDecommissionDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AssetDecommissionDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AssetDecommissionDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AssetDecommissionDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AssetDecommissionDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AssetDecommissionDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AssetDecommissionDetails
     */
    public function getAttributeName()
    {
        return 'AssetDecommissionDetails';
    }
}
