<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAssetDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAssetDetails
 * @subpackage Arrays
 */
class ArrayOfAssetDetails extends AbstractStructArrayBase
{
    /**
     * The AssetDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AssetDetails[]
     */
    public $AssetDetails;
    /**
     * Constructor method for ArrayOfAssetDetails
     * @uses ArrayOfAssetDetails::setAssetDetails()
     * @param \StructType\AssetDetails[] $assetDetails
     */
    public function __construct(array $assetDetails = array())
    {
        $this
            ->setAssetDetails($assetDetails);
    }
    /**
     * Get AssetDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AssetDetails[]|null
     */
    public function getAssetDetails()
    {
        return isset($this->AssetDetails) ? $this->AssetDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAssetDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAssetDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAssetDetailsForArrayConstraintsFromSetAssetDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAssetDetailsAssetDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAssetDetailsAssetDetailsItem instanceof \StructType\AssetDetails) {
                $invalidValues[] = is_object($arrayOfAssetDetailsAssetDetailsItem) ? get_class($arrayOfAssetDetailsAssetDetailsItem) : sprintf('%s(%s)', gettype($arrayOfAssetDetailsAssetDetailsItem), var_export($arrayOfAssetDetailsAssetDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AssetDetails property can only contain items of type \StructType\AssetDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AssetDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AssetDetails[] $assetDetails
     * @return \ArrayType\ArrayOfAssetDetails
     */
    public function setAssetDetails(array $assetDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($assetDetailsArrayErrorMessage = self::validateAssetDetailsForArrayConstraintsFromSetAssetDetails($assetDetails))) {
            throw new \InvalidArgumentException($assetDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($assetDetails) || (is_array($assetDetails) && empty($assetDetails))) {
            unset($this->AssetDetails);
        } else {
            $this->AssetDetails = $assetDetails;
        }
        return $this;
    }
    /**
     * Add item to AssetDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\AssetDetails $item
     * @return \ArrayType\ArrayOfAssetDetails
     */
    public function addToAssetDetails(\StructType\AssetDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AssetDetails) {
            throw new \InvalidArgumentException(sprintf('The AssetDetails property can only contain items of type \StructType\AssetDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AssetDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AssetDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AssetDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AssetDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AssetDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AssetDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AssetDetails
     */
    public function getAttributeName()
    {
        return 'AssetDetails';
    }
}
