<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAssetTransferDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAssetTransferDetails
 * @subpackage Arrays
 */
class ArrayOfAssetTransferDetails extends AbstractStructArrayBase
{
    /**
     * The AssetTransferDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AssetTransferDetails[]
     */
    public $AssetTransferDetails;
    /**
     * Constructor method for ArrayOfAssetTransferDetails
     * @uses ArrayOfAssetTransferDetails::setAssetTransferDetails()
     * @param \StructType\AssetTransferDetails[] $assetTransferDetails
     */
    public function __construct(array $assetTransferDetails = array())
    {
        $this
            ->setAssetTransferDetails($assetTransferDetails);
    }
    /**
     * Get AssetTransferDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AssetTransferDetails[]|null
     */
    public function getAssetTransferDetails()
    {
        return isset($this->AssetTransferDetails) ? $this->AssetTransferDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAssetTransferDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAssetTransferDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAssetTransferDetailsForArrayConstraintsFromSetAssetTransferDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAssetTransferDetailsAssetTransferDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAssetTransferDetailsAssetTransferDetailsItem instanceof \StructType\AssetTransferDetails) {
                $invalidValues[] = is_object($arrayOfAssetTransferDetailsAssetTransferDetailsItem) ? get_class($arrayOfAssetTransferDetailsAssetTransferDetailsItem) : sprintf('%s(%s)', gettype($arrayOfAssetTransferDetailsAssetTransferDetailsItem), var_export($arrayOfAssetTransferDetailsAssetTransferDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AssetTransferDetails property can only contain items of type \StructType\AssetTransferDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AssetTransferDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AssetTransferDetails[] $assetTransferDetails
     * @return \ArrayType\ArrayOfAssetTransferDetails
     */
    public function setAssetTransferDetails(array $assetTransferDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($assetTransferDetailsArrayErrorMessage = self::validateAssetTransferDetailsForArrayConstraintsFromSetAssetTransferDetails($assetTransferDetails))) {
            throw new \InvalidArgumentException($assetTransferDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($assetTransferDetails) || (is_array($assetTransferDetails) && empty($assetTransferDetails))) {
            unset($this->AssetTransferDetails);
        } else {
            $this->AssetTransferDetails = $assetTransferDetails;
        }
        return $this;
    }
    /**
     * Add item to AssetTransferDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\AssetTransferDetails $item
     * @return \ArrayType\ArrayOfAssetTransferDetails
     */
    public function addToAssetTransferDetails(\StructType\AssetTransferDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AssetTransferDetails) {
            throw new \InvalidArgumentException(sprintf('The AssetTransferDetails property can only contain items of type \StructType\AssetTransferDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AssetTransferDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AssetTransferDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AssetTransferDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AssetTransferDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AssetTransferDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AssetTransferDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AssetTransferDetails
     */
    public function getAttributeName()
    {
        return 'AssetTransferDetails';
    }
}
