<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBranchListBranch ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBranchListBranch
 * @subpackage Arrays
 */
class ArrayOfBranchListBranch extends AbstractStructArrayBase
{
    /**
     * The BranchListBranch
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BranchListBranch[]
     */
    public $BranchListBranch;
    /**
     * Constructor method for ArrayOfBranchListBranch
     * @uses ArrayOfBranchListBranch::setBranchListBranch()
     * @param \StructType\BranchListBranch[] $branchListBranch
     */
    public function __construct(array $branchListBranch = array())
    {
        $this
            ->setBranchListBranch($branchListBranch);
    }
    /**
     * Get BranchListBranch value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BranchListBranch[]|null
     */
    public function getBranchListBranch()
    {
        return isset($this->BranchListBranch) ? $this->BranchListBranch : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBranchListBranch method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBranchListBranch method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBranchListBranchForArrayConstraintsFromSetBranchListBranch(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBranchListBranchBranchListBranchItem) {
            // validation for constraint: itemType
            if (!$arrayOfBranchListBranchBranchListBranchItem instanceof \StructType\BranchListBranch) {
                $invalidValues[] = is_object($arrayOfBranchListBranchBranchListBranchItem) ? get_class($arrayOfBranchListBranchBranchListBranchItem) : sprintf('%s(%s)', gettype($arrayOfBranchListBranchBranchListBranchItem), var_export($arrayOfBranchListBranchBranchListBranchItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BranchListBranch property can only contain items of type \StructType\BranchListBranch, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BranchListBranch value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BranchListBranch[] $branchListBranch
     * @return \ArrayType\ArrayOfBranchListBranch
     */
    public function setBranchListBranch(array $branchListBranch = array())
    {
        // validation for constraint: array
        if ('' !== ($branchListBranchArrayErrorMessage = self::validateBranchListBranchForArrayConstraintsFromSetBranchListBranch($branchListBranch))) {
            throw new \InvalidArgumentException($branchListBranchArrayErrorMessage, __LINE__);
        }
        if (is_null($branchListBranch) || (is_array($branchListBranch) && empty($branchListBranch))) {
            unset($this->BranchListBranch);
        } else {
            $this->BranchListBranch = $branchListBranch;
        }
        return $this;
    }
    /**
     * Add item to BranchListBranch value
     * @throws \InvalidArgumentException
     * @param \StructType\BranchListBranch $item
     * @return \ArrayType\ArrayOfBranchListBranch
     */
    public function addToBranchListBranch(\StructType\BranchListBranch $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BranchListBranch) {
            throw new \InvalidArgumentException(sprintf('The BranchListBranch property can only contain items of type \StructType\BranchListBranch, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BranchListBranch[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BranchListBranch|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BranchListBranch|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BranchListBranch|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BranchListBranch|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BranchListBranch|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BranchListBranch
     */
    public function getAttributeName()
    {
        return 'BranchListBranch';
    }
}
