<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBranchType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBranchType
 * @subpackage Arrays
 */
class ArrayOfBranchType extends AbstractStructArrayBase
{
    /**
     * The BranchType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BranchType[]
     */
    public $BranchType;
    /**
     * Constructor method for ArrayOfBranchType
     * @uses ArrayOfBranchType::setBranchType()
     * @param \StructType\BranchType[] $branchType
     */
    public function __construct(array $branchType = array())
    {
        $this
            ->setBranchType($branchType);
    }
    /**
     * Get BranchType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BranchType[]|null
     */
    public function getBranchType()
    {
        return isset($this->BranchType) ? $this->BranchType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBranchType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBranchType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBranchTypeForArrayConstraintsFromSetBranchType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBranchTypeBranchTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfBranchTypeBranchTypeItem instanceof \StructType\BranchType) {
                $invalidValues[] = is_object($arrayOfBranchTypeBranchTypeItem) ? get_class($arrayOfBranchTypeBranchTypeItem) : sprintf('%s(%s)', gettype($arrayOfBranchTypeBranchTypeItem), var_export($arrayOfBranchTypeBranchTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BranchType property can only contain items of type \StructType\BranchType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BranchType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BranchType[] $branchType
     * @return \ArrayType\ArrayOfBranchType
     */
    public function setBranchType(array $branchType = array())
    {
        // validation for constraint: array
        if ('' !== ($branchTypeArrayErrorMessage = self::validateBranchTypeForArrayConstraintsFromSetBranchType($branchType))) {
            throw new \InvalidArgumentException($branchTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($branchType) || (is_array($branchType) && empty($branchType))) {
            unset($this->BranchType);
        } else {
            $this->BranchType = $branchType;
        }
        return $this;
    }
    /**
     * Add item to BranchType value
     * @throws \InvalidArgumentException
     * @param \StructType\BranchType $item
     * @return \ArrayType\ArrayOfBranchType
     */
    public function addToBranchType(\StructType\BranchType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BranchType) {
            throw new \InvalidArgumentException(sprintf('The BranchType property can only contain items of type \StructType\BranchType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BranchType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BranchType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BranchType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BranchType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BranchType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BranchType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BranchType
     */
    public function getAttributeName()
    {
        return 'BranchType';
    }
}
