<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfConstingRulesDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfConstingRulesDetails
 * @subpackage Arrays
 */
class ArrayOfConstingRulesDetails extends AbstractStructArrayBase
{
    /**
     * The ConstingRulesDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ConstingRulesDetails[]
     */
    public $ConstingRulesDetails;
    /**
     * Constructor method for ArrayOfConstingRulesDetails
     * @uses ArrayOfConstingRulesDetails::setConstingRulesDetails()
     * @param \StructType\ConstingRulesDetails[] $constingRulesDetails
     */
    public function __construct(array $constingRulesDetails = array())
    {
        $this
            ->setConstingRulesDetails($constingRulesDetails);
    }
    /**
     * Get ConstingRulesDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ConstingRulesDetails[]|null
     */
    public function getConstingRulesDetails()
    {
        return isset($this->ConstingRulesDetails) ? $this->ConstingRulesDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setConstingRulesDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setConstingRulesDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateConstingRulesDetailsForArrayConstraintsFromSetConstingRulesDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfConstingRulesDetailsConstingRulesDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfConstingRulesDetailsConstingRulesDetailsItem instanceof \StructType\ConstingRulesDetails) {
                $invalidValues[] = is_object($arrayOfConstingRulesDetailsConstingRulesDetailsItem) ? get_class($arrayOfConstingRulesDetailsConstingRulesDetailsItem) : sprintf('%s(%s)', gettype($arrayOfConstingRulesDetailsConstingRulesDetailsItem), var_export($arrayOfConstingRulesDetailsConstingRulesDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ConstingRulesDetails property can only contain items of type \StructType\ConstingRulesDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ConstingRulesDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ConstingRulesDetails[] $constingRulesDetails
     * @return \ArrayType\ArrayOfConstingRulesDetails
     */
    public function setConstingRulesDetails(array $constingRulesDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($constingRulesDetailsArrayErrorMessage = self::validateConstingRulesDetailsForArrayConstraintsFromSetConstingRulesDetails($constingRulesDetails))) {
            throw new \InvalidArgumentException($constingRulesDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($constingRulesDetails) || (is_array($constingRulesDetails) && empty($constingRulesDetails))) {
            unset($this->ConstingRulesDetails);
        } else {
            $this->ConstingRulesDetails = $constingRulesDetails;
        }
        return $this;
    }
    /**
     * Add item to ConstingRulesDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\ConstingRulesDetails $item
     * @return \ArrayType\ArrayOfConstingRulesDetails
     */
    public function addToConstingRulesDetails(\StructType\ConstingRulesDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ConstingRulesDetails) {
            throw new \InvalidArgumentException(sprintf('The ConstingRulesDetails property can only contain items of type \StructType\ConstingRulesDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ConstingRulesDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ConstingRulesDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ConstingRulesDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ConstingRulesDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ConstingRulesDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ConstingRulesDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ConstingRulesDetails
     */
    public function getAttributeName()
    {
        return 'ConstingRulesDetails';
    }
}
