<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDRAccountMaster ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDRAccountMaster
 * @subpackage Arrays
 */
class ArrayOfDRAccountMaster extends AbstractStructArrayBase
{
    /**
     * The DRAccountMaster
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DRAccountMaster[]
     */
    public $DRAccountMaster;
    /**
     * Constructor method for ArrayOfDRAccountMaster
     * @uses ArrayOfDRAccountMaster::setDRAccountMaster()
     * @param \StructType\DRAccountMaster[] $dRAccountMaster
     */
    public function __construct(array $dRAccountMaster = array())
    {
        $this
            ->setDRAccountMaster($dRAccountMaster);
    }
    /**
     * Get DRAccountMaster value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DRAccountMaster[]|null
     */
    public function getDRAccountMaster()
    {
        return isset($this->DRAccountMaster) ? $this->DRAccountMaster : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDRAccountMaster method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDRAccountMaster method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDRAccountMasterForArrayConstraintsFromSetDRAccountMaster(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDRAccountMasterDRAccountMasterItem) {
            // validation for constraint: itemType
            if (!$arrayOfDRAccountMasterDRAccountMasterItem instanceof \StructType\DRAccountMaster) {
                $invalidValues[] = is_object($arrayOfDRAccountMasterDRAccountMasterItem) ? get_class($arrayOfDRAccountMasterDRAccountMasterItem) : sprintf('%s(%s)', gettype($arrayOfDRAccountMasterDRAccountMasterItem), var_export($arrayOfDRAccountMasterDRAccountMasterItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DRAccountMaster property can only contain items of type \StructType\DRAccountMaster, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DRAccountMaster value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DRAccountMaster[] $dRAccountMaster
     * @return \ArrayType\ArrayOfDRAccountMaster
     */
    public function setDRAccountMaster(array $dRAccountMaster = array())
    {
        // validation for constraint: array
        if ('' !== ($dRAccountMasterArrayErrorMessage = self::validateDRAccountMasterForArrayConstraintsFromSetDRAccountMaster($dRAccountMaster))) {
            throw new \InvalidArgumentException($dRAccountMasterArrayErrorMessage, __LINE__);
        }
        if (is_null($dRAccountMaster) || (is_array($dRAccountMaster) && empty($dRAccountMaster))) {
            unset($this->DRAccountMaster);
        } else {
            $this->DRAccountMaster = $dRAccountMaster;
        }
        return $this;
    }
    /**
     * Add item to DRAccountMaster value
     * @throws \InvalidArgumentException
     * @param \StructType\DRAccountMaster $item
     * @return \ArrayType\ArrayOfDRAccountMaster
     */
    public function addToDRAccountMaster(\StructType\DRAccountMaster $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DRAccountMaster) {
            throw new \InvalidArgumentException(sprintf('The DRAccountMaster property can only contain items of type \StructType\DRAccountMaster, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DRAccountMaster[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DRAccountMaster|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DRAccountMaster|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DRAccountMaster|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DRAccountMaster|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DRAccountMaster|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DRAccountMaster
     */
    public function getAttributeName()
    {
        return 'DRAccountMaster';
    }
}
