<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDRStop ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDRStop
 * @subpackage Arrays
 */
class ArrayOfDRStop extends AbstractStructArrayBase
{
    /**
     * The DRStop
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DRStop[]
     */
    public $DRStop;
    /**
     * Constructor method for ArrayOfDRStop
     * @uses ArrayOfDRStop::setDRStop()
     * @param \StructType\DRStop[] $dRStop
     */
    public function __construct(array $dRStop = array())
    {
        $this
            ->setDRStop($dRStop);
    }
    /**
     * Get DRStop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DRStop[]|null
     */
    public function getDRStop()
    {
        return isset($this->DRStop) ? $this->DRStop : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDRStop method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDRStop method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDRStopForArrayConstraintsFromSetDRStop(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDRStopDRStopItem) {
            // validation for constraint: itemType
            if (!$arrayOfDRStopDRStopItem instanceof \StructType\DRStop) {
                $invalidValues[] = is_object($arrayOfDRStopDRStopItem) ? get_class($arrayOfDRStopDRStopItem) : sprintf('%s(%s)', gettype($arrayOfDRStopDRStopItem), var_export($arrayOfDRStopDRStopItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DRStop property can only contain items of type \StructType\DRStop, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DRStop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DRStop[] $dRStop
     * @return \ArrayType\ArrayOfDRStop
     */
    public function setDRStop(array $dRStop = array())
    {
        // validation for constraint: array
        if ('' !== ($dRStopArrayErrorMessage = self::validateDRStopForArrayConstraintsFromSetDRStop($dRStop))) {
            throw new \InvalidArgumentException($dRStopArrayErrorMessage, __LINE__);
        }
        if (is_null($dRStop) || (is_array($dRStop) && empty($dRStop))) {
            unset($this->DRStop);
        } else {
            $this->DRStop = $dRStop;
        }
        return $this;
    }
    /**
     * Add item to DRStop value
     * @throws \InvalidArgumentException
     * @param \StructType\DRStop $item
     * @return \ArrayType\ArrayOfDRStop
     */
    public function addToDRStop(\StructType\DRStop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DRStop) {
            throw new \InvalidArgumentException(sprintf('The DRStop property can only contain items of type \StructType\DRStop, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DRStop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DRStop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DRStop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DRStop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DRStop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DRStop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DRStop
     */
    public function getAttributeName()
    {
        return 'DRStop';
    }
}
