<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDRTimeWindow ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDRTimeWindow
 * @subpackage Arrays
 */
class ArrayOfDRTimeWindow extends AbstractStructArrayBase
{
    /**
     * The DRTimeWindow
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DRTimeWindow[]
     */
    public $DRTimeWindow;
    /**
     * Constructor method for ArrayOfDRTimeWindow
     * @uses ArrayOfDRTimeWindow::setDRTimeWindow()
     * @param \StructType\DRTimeWindow[] $dRTimeWindow
     */
    public function __construct(array $dRTimeWindow = array())
    {
        $this
            ->setDRTimeWindow($dRTimeWindow);
    }
    /**
     * Get DRTimeWindow value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DRTimeWindow[]|null
     */
    public function getDRTimeWindow()
    {
        return isset($this->DRTimeWindow) ? $this->DRTimeWindow : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDRTimeWindow method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDRTimeWindow method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDRTimeWindowForArrayConstraintsFromSetDRTimeWindow(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDRTimeWindowDRTimeWindowItem) {
            // validation for constraint: itemType
            if (!$arrayOfDRTimeWindowDRTimeWindowItem instanceof \StructType\DRTimeWindow) {
                $invalidValues[] = is_object($arrayOfDRTimeWindowDRTimeWindowItem) ? get_class($arrayOfDRTimeWindowDRTimeWindowItem) : sprintf('%s(%s)', gettype($arrayOfDRTimeWindowDRTimeWindowItem), var_export($arrayOfDRTimeWindowDRTimeWindowItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DRTimeWindow property can only contain items of type \StructType\DRTimeWindow, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DRTimeWindow value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DRTimeWindow[] $dRTimeWindow
     * @return \ArrayType\ArrayOfDRTimeWindow
     */
    public function setDRTimeWindow(array $dRTimeWindow = array())
    {
        // validation for constraint: array
        if ('' !== ($dRTimeWindowArrayErrorMessage = self::validateDRTimeWindowForArrayConstraintsFromSetDRTimeWindow($dRTimeWindow))) {
            throw new \InvalidArgumentException($dRTimeWindowArrayErrorMessage, __LINE__);
        }
        if (is_null($dRTimeWindow) || (is_array($dRTimeWindow) && empty($dRTimeWindow))) {
            unset($this->DRTimeWindow);
        } else {
            $this->DRTimeWindow = $dRTimeWindow;
        }
        return $this;
    }
    /**
     * Add item to DRTimeWindow value
     * @throws \InvalidArgumentException
     * @param \StructType\DRTimeWindow $item
     * @return \ArrayType\ArrayOfDRTimeWindow
     */
    public function addToDRTimeWindow(\StructType\DRTimeWindow $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DRTimeWindow) {
            throw new \InvalidArgumentException(sprintf('The DRTimeWindow property can only contain items of type \StructType\DRTimeWindow, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DRTimeWindow[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DRTimeWindow|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DRTimeWindow|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DRTimeWindow|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DRTimeWindow|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DRTimeWindow|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DRTimeWindow
     */
    public function getAttributeName()
    {
        return 'DRTimeWindow';
    }
}
