<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDRUserField ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDRUserField
 * @subpackage Arrays
 */
class ArrayOfDRUserField extends AbstractStructArrayBase
{
    /**
     * The DRUserField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DRUserField[]
     */
    public $DRUserField;
    /**
     * Constructor method for ArrayOfDRUserField
     * @uses ArrayOfDRUserField::setDRUserField()
     * @param \StructType\DRUserField[] $dRUserField
     */
    public function __construct(array $dRUserField = array())
    {
        $this
            ->setDRUserField($dRUserField);
    }
    /**
     * Get DRUserField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DRUserField[]|null
     */
    public function getDRUserField()
    {
        return isset($this->DRUserField) ? $this->DRUserField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDRUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDRUserField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDRUserFieldForArrayConstraintsFromSetDRUserField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDRUserFieldDRUserFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfDRUserFieldDRUserFieldItem instanceof \StructType\DRUserField) {
                $invalidValues[] = is_object($arrayOfDRUserFieldDRUserFieldItem) ? get_class($arrayOfDRUserFieldDRUserFieldItem) : sprintf('%s(%s)', gettype($arrayOfDRUserFieldDRUserFieldItem), var_export($arrayOfDRUserFieldDRUserFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DRUserField property can only contain items of type \StructType\DRUserField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DRUserField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DRUserField[] $dRUserField
     * @return \ArrayType\ArrayOfDRUserField
     */
    public function setDRUserField(array $dRUserField = array())
    {
        // validation for constraint: array
        if ('' !== ($dRUserFieldArrayErrorMessage = self::validateDRUserFieldForArrayConstraintsFromSetDRUserField($dRUserField))) {
            throw new \InvalidArgumentException($dRUserFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($dRUserField) || (is_array($dRUserField) && empty($dRUserField))) {
            unset($this->DRUserField);
        } else {
            $this->DRUserField = $dRUserField;
        }
        return $this;
    }
    /**
     * Add item to DRUserField value
     * @throws \InvalidArgumentException
     * @param \StructType\DRUserField $item
     * @return \ArrayType\ArrayOfDRUserField
     */
    public function addToDRUserField(\StructType\DRUserField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DRUserField) {
            throw new \InvalidArgumentException(sprintf('The DRUserField property can only contain items of type \StructType\DRUserField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DRUserField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DRUserField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DRUserField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DRUserField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DRUserField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DRUserField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DRUserField
     */
    public function getAttributeName()
    {
        return 'DRUserField';
    }
}
