<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDRVolume ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDRVolume
 * @subpackage Arrays
 */
class ArrayOfDRVolume extends AbstractStructArrayBase
{
    /**
     * The DRVolume
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DRVolume[]
     */
    public $DRVolume;
    /**
     * Constructor method for ArrayOfDRVolume
     * @uses ArrayOfDRVolume::setDRVolume()
     * @param \StructType\DRVolume[] $dRVolume
     */
    public function __construct(array $dRVolume = array())
    {
        $this
            ->setDRVolume($dRVolume);
    }
    /**
     * Get DRVolume value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DRVolume[]|null
     */
    public function getDRVolume()
    {
        return isset($this->DRVolume) ? $this->DRVolume : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDRVolume method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDRVolume method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDRVolumeForArrayConstraintsFromSetDRVolume(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDRVolumeDRVolumeItem) {
            // validation for constraint: itemType
            if (!$arrayOfDRVolumeDRVolumeItem instanceof \StructType\DRVolume) {
                $invalidValues[] = is_object($arrayOfDRVolumeDRVolumeItem) ? get_class($arrayOfDRVolumeDRVolumeItem) : sprintf('%s(%s)', gettype($arrayOfDRVolumeDRVolumeItem), var_export($arrayOfDRVolumeDRVolumeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DRVolume property can only contain items of type \StructType\DRVolume, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DRVolume value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DRVolume[] $dRVolume
     * @return \ArrayType\ArrayOfDRVolume
     */
    public function setDRVolume(array $dRVolume = array())
    {
        // validation for constraint: array
        if ('' !== ($dRVolumeArrayErrorMessage = self::validateDRVolumeForArrayConstraintsFromSetDRVolume($dRVolume))) {
            throw new \InvalidArgumentException($dRVolumeArrayErrorMessage, __LINE__);
        }
        if (is_null($dRVolume) || (is_array($dRVolume) && empty($dRVolume))) {
            unset($this->DRVolume);
        } else {
            $this->DRVolume = $dRVolume;
        }
        return $this;
    }
    /**
     * Add item to DRVolume value
     * @throws \InvalidArgumentException
     * @param \StructType\DRVolume $item
     * @return \ArrayType\ArrayOfDRVolume
     */
    public function addToDRVolume(\StructType\DRVolume $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DRVolume) {
            throw new \InvalidArgumentException(sprintf('The DRVolume property can only contain items of type \StructType\DRVolume, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DRVolume[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DRVolume|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DRVolume|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DRVolume|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DRVolume|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DRVolume|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DRVolume
     */
    public function getAttributeName()
    {
        return 'DRVolume';
    }
}
