<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceDataEvent ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeviceDataEvent
 * @subpackage Arrays
 */
class ArrayOfDeviceDataEvent extends AbstractStructArrayBase
{
    /**
     * The DeviceDataEvent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeviceDataEvent[]
     */
    public $DeviceDataEvent;
    /**
     * Constructor method for ArrayOfDeviceDataEvent
     * @uses ArrayOfDeviceDataEvent::setDeviceDataEvent()
     * @param \StructType\DeviceDataEvent[] $deviceDataEvent
     */
    public function __construct(array $deviceDataEvent = array())
    {
        $this
            ->setDeviceDataEvent($deviceDataEvent);
    }
    /**
     * Get DeviceDataEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeviceDataEvent[]|null
     */
    public function getDeviceDataEvent()
    {
        return isset($this->DeviceDataEvent) ? $this->DeviceDataEvent : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceDataEvent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceDataEvent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceDataEventForArrayConstraintsFromSetDeviceDataEvent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceDataEventDeviceDataEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceDataEventDeviceDataEventItem instanceof \StructType\DeviceDataEvent) {
                $invalidValues[] = is_object($arrayOfDeviceDataEventDeviceDataEventItem) ? get_class($arrayOfDeviceDataEventDeviceDataEventItem) : sprintf('%s(%s)', gettype($arrayOfDeviceDataEventDeviceDataEventItem), var_export($arrayOfDeviceDataEventDeviceDataEventItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceDataEvent property can only contain items of type \StructType\DeviceDataEvent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceDataEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataEvent[] $deviceDataEvent
     * @return \ArrayType\ArrayOfDeviceDataEvent
     */
    public function setDeviceDataEvent(array $deviceDataEvent = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceDataEventArrayErrorMessage = self::validateDeviceDataEventForArrayConstraintsFromSetDeviceDataEvent($deviceDataEvent))) {
            throw new \InvalidArgumentException($deviceDataEventArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceDataEvent) || (is_array($deviceDataEvent) && empty($deviceDataEvent))) {
            unset($this->DeviceDataEvent);
        } else {
            $this->DeviceDataEvent = $deviceDataEvent;
        }
        return $this;
    }
    /**
     * Add item to DeviceDataEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataEvent $item
     * @return \ArrayType\ArrayOfDeviceDataEvent
     */
    public function addToDeviceDataEvent(\StructType\DeviceDataEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeviceDataEvent) {
            throw new \InvalidArgumentException(sprintf('The DeviceDataEvent property can only contain items of type \StructType\DeviceDataEvent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceDataEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeviceDataEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeviceDataEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeviceDataEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeviceDataEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeviceDataEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceDataEvent
     */
    public function getAttributeName()
    {
        return 'DeviceDataEvent';
    }
}
