<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceDataEventOrders ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeviceDataEventOrders
 * @subpackage Arrays
 */
class ArrayOfDeviceDataEventOrders extends AbstractStructArrayBase
{
    /**
     * The DeviceDataEventOrders
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeviceDataEventOrders[]
     */
    public $DeviceDataEventOrders;
    /**
     * Constructor method for ArrayOfDeviceDataEventOrders
     * @uses ArrayOfDeviceDataEventOrders::setDeviceDataEventOrders()
     * @param \StructType\DeviceDataEventOrders[] $deviceDataEventOrders
     */
    public function __construct(array $deviceDataEventOrders = array())
    {
        $this
            ->setDeviceDataEventOrders($deviceDataEventOrders);
    }
    /**
     * Get DeviceDataEventOrders value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeviceDataEventOrders[]|null
     */
    public function getDeviceDataEventOrders()
    {
        return isset($this->DeviceDataEventOrders) ? $this->DeviceDataEventOrders : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceDataEventOrders method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceDataEventOrders method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceDataEventOrdersForArrayConstraintsFromSetDeviceDataEventOrders(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceDataEventOrdersDeviceDataEventOrdersItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceDataEventOrdersDeviceDataEventOrdersItem instanceof \StructType\DeviceDataEventOrders) {
                $invalidValues[] = is_object($arrayOfDeviceDataEventOrdersDeviceDataEventOrdersItem) ? get_class($arrayOfDeviceDataEventOrdersDeviceDataEventOrdersItem) : sprintf('%s(%s)', gettype($arrayOfDeviceDataEventOrdersDeviceDataEventOrdersItem), var_export($arrayOfDeviceDataEventOrdersDeviceDataEventOrdersItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceDataEventOrders property can only contain items of type \StructType\DeviceDataEventOrders, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceDataEventOrders value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataEventOrders[] $deviceDataEventOrders
     * @return \ArrayType\ArrayOfDeviceDataEventOrders
     */
    public function setDeviceDataEventOrders(array $deviceDataEventOrders = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceDataEventOrdersArrayErrorMessage = self::validateDeviceDataEventOrdersForArrayConstraintsFromSetDeviceDataEventOrders($deviceDataEventOrders))) {
            throw new \InvalidArgumentException($deviceDataEventOrdersArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceDataEventOrders) || (is_array($deviceDataEventOrders) && empty($deviceDataEventOrders))) {
            unset($this->DeviceDataEventOrders);
        } else {
            $this->DeviceDataEventOrders = $deviceDataEventOrders;
        }
        return $this;
    }
    /**
     * Add item to DeviceDataEventOrders value
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataEventOrders $item
     * @return \ArrayType\ArrayOfDeviceDataEventOrders
     */
    public function addToDeviceDataEventOrders(\StructType\DeviceDataEventOrders $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeviceDataEventOrders) {
            throw new \InvalidArgumentException(sprintf('The DeviceDataEventOrders property can only contain items of type \StructType\DeviceDataEventOrders, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceDataEventOrders[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeviceDataEventOrders|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeviceDataEventOrders|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeviceDataEventOrders|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeviceDataEventOrders|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeviceDataEventOrders|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceDataEventOrders
     */
    public function getAttributeName()
    {
        return 'DeviceDataEventOrders';
    }
}
