<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceDataGPS ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeviceDataGPS
 * @subpackage Arrays
 */
class ArrayOfDeviceDataGPS extends AbstractStructArrayBase
{
    /**
     * The DeviceDataGPS
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeviceDataGPS[]
     */
    public $DeviceDataGPS;
    /**
     * Constructor method for ArrayOfDeviceDataGPS
     * @uses ArrayOfDeviceDataGPS::setDeviceDataGPS()
     * @param \StructType\DeviceDataGPS[] $deviceDataGPS
     */
    public function __construct(array $deviceDataGPS = array())
    {
        $this
            ->setDeviceDataGPS($deviceDataGPS);
    }
    /**
     * Get DeviceDataGPS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeviceDataGPS[]|null
     */
    public function getDeviceDataGPS()
    {
        return isset($this->DeviceDataGPS) ? $this->DeviceDataGPS : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceDataGPS method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceDataGPS method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceDataGPSForArrayConstraintsFromSetDeviceDataGPS(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceDataGPSDeviceDataGPSItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceDataGPSDeviceDataGPSItem instanceof \StructType\DeviceDataGPS) {
                $invalidValues[] = is_object($arrayOfDeviceDataGPSDeviceDataGPSItem) ? get_class($arrayOfDeviceDataGPSDeviceDataGPSItem) : sprintf('%s(%s)', gettype($arrayOfDeviceDataGPSDeviceDataGPSItem), var_export($arrayOfDeviceDataGPSDeviceDataGPSItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceDataGPS property can only contain items of type \StructType\DeviceDataGPS, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceDataGPS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataGPS[] $deviceDataGPS
     * @return \ArrayType\ArrayOfDeviceDataGPS
     */
    public function setDeviceDataGPS(array $deviceDataGPS = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceDataGPSArrayErrorMessage = self::validateDeviceDataGPSForArrayConstraintsFromSetDeviceDataGPS($deviceDataGPS))) {
            throw new \InvalidArgumentException($deviceDataGPSArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceDataGPS) || (is_array($deviceDataGPS) && empty($deviceDataGPS))) {
            unset($this->DeviceDataGPS);
        } else {
            $this->DeviceDataGPS = $deviceDataGPS;
        }
        return $this;
    }
    /**
     * Add item to DeviceDataGPS value
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataGPS $item
     * @return \ArrayType\ArrayOfDeviceDataGPS
     */
    public function addToDeviceDataGPS(\StructType\DeviceDataGPS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeviceDataGPS) {
            throw new \InvalidArgumentException(sprintf('The DeviceDataGPS property can only contain items of type \StructType\DeviceDataGPS, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceDataGPS[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeviceDataGPS|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeviceDataGPS|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeviceDataGPS|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeviceDataGPS|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeviceDataGPS|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceDataGPS
     */
    public function getAttributeName()
    {
        return 'DeviceDataGPS';
    }
}
