<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceDataGPS1 ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeviceDataGPS1
 * @subpackage Arrays
 */
class ArrayOfDeviceDataGPS1 extends AbstractStructArrayBase
{
    /**
     * The DeviceDataGPS1
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeviceDataGPS1[]
     */
    public $DeviceDataGPS1;
    /**
     * Constructor method for ArrayOfDeviceDataGPS1
     * @uses ArrayOfDeviceDataGPS1::setDeviceDataGPS1()
     * @param \StructType\DeviceDataGPS1[] $deviceDataGPS1
     */
    public function __construct(array $deviceDataGPS1 = array())
    {
        $this
            ->setDeviceDataGPS1($deviceDataGPS1);
    }
    /**
     * Get DeviceDataGPS1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeviceDataGPS1[]|null
     */
    public function getDeviceDataGPS1()
    {
        return isset($this->DeviceDataGPS1) ? $this->DeviceDataGPS1 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceDataGPS1 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceDataGPS1 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceDataGPS1ForArrayConstraintsFromSetDeviceDataGPS1(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceDataGPS1DeviceDataGPS1Item) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceDataGPS1DeviceDataGPS1Item instanceof \StructType\DeviceDataGPS1) {
                $invalidValues[] = is_object($arrayOfDeviceDataGPS1DeviceDataGPS1Item) ? get_class($arrayOfDeviceDataGPS1DeviceDataGPS1Item) : sprintf('%s(%s)', gettype($arrayOfDeviceDataGPS1DeviceDataGPS1Item), var_export($arrayOfDeviceDataGPS1DeviceDataGPS1Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceDataGPS1 property can only contain items of type \StructType\DeviceDataGPS1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceDataGPS1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataGPS1[] $deviceDataGPS1
     * @return \ArrayType\ArrayOfDeviceDataGPS1
     */
    public function setDeviceDataGPS1(array $deviceDataGPS1 = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceDataGPS1ArrayErrorMessage = self::validateDeviceDataGPS1ForArrayConstraintsFromSetDeviceDataGPS1($deviceDataGPS1))) {
            throw new \InvalidArgumentException($deviceDataGPS1ArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceDataGPS1) || (is_array($deviceDataGPS1) && empty($deviceDataGPS1))) {
            unset($this->DeviceDataGPS1);
        } else {
            $this->DeviceDataGPS1 = $deviceDataGPS1;
        }
        return $this;
    }
    /**
     * Add item to DeviceDataGPS1 value
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataGPS1 $item
     * @return \ArrayType\ArrayOfDeviceDataGPS1
     */
    public function addToDeviceDataGPS1(\StructType\DeviceDataGPS1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeviceDataGPS1) {
            throw new \InvalidArgumentException(sprintf('The DeviceDataGPS1 property can only contain items of type \StructType\DeviceDataGPS1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceDataGPS1[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeviceDataGPS1|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeviceDataGPS1|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeviceDataGPS1|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeviceDataGPS1|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeviceDataGPS1|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceDataGPS1
     */
    public function getAttributeName()
    {
        return 'DeviceDataGPS1';
    }
}
