<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeviceDataStop ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeviceDataStop
 * @subpackage Arrays
 */
class ArrayOfDeviceDataStop extends AbstractStructArrayBase
{
    /**
     * The DeviceDataStop
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DeviceDataStop[]
     */
    public $DeviceDataStop;
    /**
     * Constructor method for ArrayOfDeviceDataStop
     * @uses ArrayOfDeviceDataStop::setDeviceDataStop()
     * @param \StructType\DeviceDataStop[] $deviceDataStop
     */
    public function __construct(array $deviceDataStop = array())
    {
        $this
            ->setDeviceDataStop($deviceDataStop);
    }
    /**
     * Get DeviceDataStop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DeviceDataStop[]|null
     */
    public function getDeviceDataStop()
    {
        return isset($this->DeviceDataStop) ? $this->DeviceDataStop : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDeviceDataStop method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeviceDataStop method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeviceDataStopForArrayConstraintsFromSetDeviceDataStop(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDeviceDataStopDeviceDataStopItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeviceDataStopDeviceDataStopItem instanceof \StructType\DeviceDataStop) {
                $invalidValues[] = is_object($arrayOfDeviceDataStopDeviceDataStopItem) ? get_class($arrayOfDeviceDataStopDeviceDataStopItem) : sprintf('%s(%s)', gettype($arrayOfDeviceDataStopDeviceDataStopItem), var_export($arrayOfDeviceDataStopDeviceDataStopItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeviceDataStop property can only contain items of type \StructType\DeviceDataStop, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeviceDataStop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataStop[] $deviceDataStop
     * @return \ArrayType\ArrayOfDeviceDataStop
     */
    public function setDeviceDataStop(array $deviceDataStop = array())
    {
        // validation for constraint: array
        if ('' !== ($deviceDataStopArrayErrorMessage = self::validateDeviceDataStopForArrayConstraintsFromSetDeviceDataStop($deviceDataStop))) {
            throw new \InvalidArgumentException($deviceDataStopArrayErrorMessage, __LINE__);
        }
        if (is_null($deviceDataStop) || (is_array($deviceDataStop) && empty($deviceDataStop))) {
            unset($this->DeviceDataStop);
        } else {
            $this->DeviceDataStop = $deviceDataStop;
        }
        return $this;
    }
    /**
     * Add item to DeviceDataStop value
     * @throws \InvalidArgumentException
     * @param \StructType\DeviceDataStop $item
     * @return \ArrayType\ArrayOfDeviceDataStop
     */
    public function addToDeviceDataStop(\StructType\DeviceDataStop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeviceDataStop) {
            throw new \InvalidArgumentException(sprintf('The DeviceDataStop property can only contain items of type \StructType\DeviceDataStop, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeviceDataStop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeviceDataStop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeviceDataStop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeviceDataStop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeviceDataStop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeviceDataStop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeviceDataStop
     */
    public function getAttributeName()
    {
        return 'DeviceDataStop';
    }
}
