<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDriverDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDriverDetails
 * @subpackage Arrays
 */
class ArrayOfDriverDetails extends AbstractStructArrayBase
{
    /**
     * The DriverDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DriverDetails[]
     */
    public $DriverDetails;
    /**
     * Constructor method for ArrayOfDriverDetails
     * @uses ArrayOfDriverDetails::setDriverDetails()
     * @param \StructType\DriverDetails[] $driverDetails
     */
    public function __construct(array $driverDetails = array())
    {
        $this
            ->setDriverDetails($driverDetails);
    }
    /**
     * Get DriverDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DriverDetails[]|null
     */
    public function getDriverDetails()
    {
        return isset($this->DriverDetails) ? $this->DriverDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDriverDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDriverDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDriverDetailsForArrayConstraintsFromSetDriverDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDriverDetailsDriverDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfDriverDetailsDriverDetailsItem instanceof \StructType\DriverDetails) {
                $invalidValues[] = is_object($arrayOfDriverDetailsDriverDetailsItem) ? get_class($arrayOfDriverDetailsDriverDetailsItem) : sprintf('%s(%s)', gettype($arrayOfDriverDetailsDriverDetailsItem), var_export($arrayOfDriverDetailsDriverDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DriverDetails property can only contain items of type \StructType\DriverDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DriverDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DriverDetails[] $driverDetails
     * @return \ArrayType\ArrayOfDriverDetails
     */
    public function setDriverDetails(array $driverDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($driverDetailsArrayErrorMessage = self::validateDriverDetailsForArrayConstraintsFromSetDriverDetails($driverDetails))) {
            throw new \InvalidArgumentException($driverDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($driverDetails) || (is_array($driverDetails) && empty($driverDetails))) {
            unset($this->DriverDetails);
        } else {
            $this->DriverDetails = $driverDetails;
        }
        return $this;
    }
    /**
     * Add item to DriverDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\DriverDetails $item
     * @return \ArrayType\ArrayOfDriverDetails
     */
    public function addToDriverDetails(\StructType\DriverDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DriverDetails) {
            throw new \InvalidArgumentException(sprintf('The DriverDetails property can only contain items of type \StructType\DriverDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DriverDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DriverDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DriverDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DriverDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DriverDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DriverDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DriverDetails
     */
    public function getAttributeName()
    {
        return 'DriverDetails';
    }
}
