<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEmailPerson ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEmailPerson
 * @subpackage Arrays
 */
class ArrayOfEmailPerson extends AbstractStructArrayBase
{
    /**
     * The EmailPerson
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EmailPerson[]
     */
    public $EmailPerson;
    /**
     * Constructor method for ArrayOfEmailPerson
     * @uses ArrayOfEmailPerson::setEmailPerson()
     * @param \StructType\EmailPerson[] $emailPerson
     */
    public function __construct(array $emailPerson = array())
    {
        $this
            ->setEmailPerson($emailPerson);
    }
    /**
     * Get EmailPerson value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EmailPerson[]|null
     */
    public function getEmailPerson()
    {
        return isset($this->EmailPerson) ? $this->EmailPerson : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEmailPerson method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEmailPerson method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEmailPersonForArrayConstraintsFromSetEmailPerson(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEmailPersonEmailPersonItem) {
            // validation for constraint: itemType
            if (!$arrayOfEmailPersonEmailPersonItem instanceof \StructType\EmailPerson) {
                $invalidValues[] = is_object($arrayOfEmailPersonEmailPersonItem) ? get_class($arrayOfEmailPersonEmailPersonItem) : sprintf('%s(%s)', gettype($arrayOfEmailPersonEmailPersonItem), var_export($arrayOfEmailPersonEmailPersonItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EmailPerson property can only contain items of type \StructType\EmailPerson, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EmailPerson value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EmailPerson[] $emailPerson
     * @return \ArrayType\ArrayOfEmailPerson
     */
    public function setEmailPerson(array $emailPerson = array())
    {
        // validation for constraint: array
        if ('' !== ($emailPersonArrayErrorMessage = self::validateEmailPersonForArrayConstraintsFromSetEmailPerson($emailPerson))) {
            throw new \InvalidArgumentException($emailPersonArrayErrorMessage, __LINE__);
        }
        if (is_null($emailPerson) || (is_array($emailPerson) && empty($emailPerson))) {
            unset($this->EmailPerson);
        } else {
            $this->EmailPerson = $emailPerson;
        }
        return $this;
    }
    /**
     * Add item to EmailPerson value
     * @throws \InvalidArgumentException
     * @param \StructType\EmailPerson $item
     * @return \ArrayType\ArrayOfEmailPerson
     */
    public function addToEmailPerson(\StructType\EmailPerson $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EmailPerson) {
            throw new \InvalidArgumentException(sprintf('The EmailPerson property can only contain items of type \StructType\EmailPerson, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EmailPerson[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EmailPerson|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EmailPerson|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EmailPerson|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EmailPerson|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EmailPerson|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EmailPerson
     */
    public function getAttributeName()
    {
        return 'EmailPerson';
    }
}
