<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEventRecords ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEventRecords
 * @subpackage Arrays
 */
class ArrayOfEventRecords extends AbstractStructArrayBase
{
    /**
     * The EventRecords
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EventRecords[]
     */
    public $EventRecords;
    /**
     * Constructor method for ArrayOfEventRecords
     * @uses ArrayOfEventRecords::setEventRecords()
     * @param \StructType\EventRecords[] $eventRecords
     */
    public function __construct(array $eventRecords = array())
    {
        $this
            ->setEventRecords($eventRecords);
    }
    /**
     * Get EventRecords value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EventRecords[]|null
     */
    public function getEventRecords()
    {
        return isset($this->EventRecords) ? $this->EventRecords : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEventRecords method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventRecords method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventRecordsForArrayConstraintsFromSetEventRecords(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEventRecordsEventRecordsItem) {
            // validation for constraint: itemType
            if (!$arrayOfEventRecordsEventRecordsItem instanceof \StructType\EventRecords) {
                $invalidValues[] = is_object($arrayOfEventRecordsEventRecordsItem) ? get_class($arrayOfEventRecordsEventRecordsItem) : sprintf('%s(%s)', gettype($arrayOfEventRecordsEventRecordsItem), var_export($arrayOfEventRecordsEventRecordsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EventRecords property can only contain items of type \StructType\EventRecords, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EventRecords value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EventRecords[] $eventRecords
     * @return \ArrayType\ArrayOfEventRecords
     */
    public function setEventRecords(array $eventRecords = array())
    {
        // validation for constraint: array
        if ('' !== ($eventRecordsArrayErrorMessage = self::validateEventRecordsForArrayConstraintsFromSetEventRecords($eventRecords))) {
            throw new \InvalidArgumentException($eventRecordsArrayErrorMessage, __LINE__);
        }
        if (is_null($eventRecords) || (is_array($eventRecords) && empty($eventRecords))) {
            unset($this->EventRecords);
        } else {
            $this->EventRecords = $eventRecords;
        }
        return $this;
    }
    /**
     * Add item to EventRecords value
     * @throws \InvalidArgumentException
     * @param \StructType\EventRecords $item
     * @return \ArrayType\ArrayOfEventRecords
     */
    public function addToEventRecords(\StructType\EventRecords $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EventRecords) {
            throw new \InvalidArgumentException(sprintf('The EventRecords property can only contain items of type \StructType\EventRecords, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EventRecords[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EventRecords|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EventRecords|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EventRecords|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EventRecords|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EventRecords|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EventRecords
     */
    public function getAttributeName()
    {
        return 'EventRecords';
    }
}
