<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormDetailListFormDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFormDetailListFormDetail
 * @subpackage Arrays
 */
class ArrayOfFormDetailListFormDetail extends AbstractStructArrayBase
{
    /**
     * The FormDetailListFormDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FormDetailListFormDetail[]
     */
    public $FormDetailListFormDetail;
    /**
     * Constructor method for ArrayOfFormDetailListFormDetail
     * @uses ArrayOfFormDetailListFormDetail::setFormDetailListFormDetail()
     * @param \StructType\FormDetailListFormDetail[] $formDetailListFormDetail
     */
    public function __construct(array $formDetailListFormDetail = array())
    {
        $this
            ->setFormDetailListFormDetail($formDetailListFormDetail);
    }
    /**
     * Get FormDetailListFormDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FormDetailListFormDetail[]|null
     */
    public function getFormDetailListFormDetail()
    {
        return isset($this->FormDetailListFormDetail) ? $this->FormDetailListFormDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFormDetailListFormDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormDetailListFormDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormDetailListFormDetailForArrayConstraintsFromSetFormDetailListFormDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFormDetailListFormDetailFormDetailListFormDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormDetailListFormDetailFormDetailListFormDetailItem instanceof \StructType\FormDetailListFormDetail) {
                $invalidValues[] = is_object($arrayOfFormDetailListFormDetailFormDetailListFormDetailItem) ? get_class($arrayOfFormDetailListFormDetailFormDetailListFormDetailItem) : sprintf('%s(%s)', gettype($arrayOfFormDetailListFormDetailFormDetailListFormDetailItem), var_export($arrayOfFormDetailListFormDetailFormDetailListFormDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormDetailListFormDetail property can only contain items of type \StructType\FormDetailListFormDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormDetailListFormDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FormDetailListFormDetail[] $formDetailListFormDetail
     * @return \ArrayType\ArrayOfFormDetailListFormDetail
     */
    public function setFormDetailListFormDetail(array $formDetailListFormDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($formDetailListFormDetailArrayErrorMessage = self::validateFormDetailListFormDetailForArrayConstraintsFromSetFormDetailListFormDetail($formDetailListFormDetail))) {
            throw new \InvalidArgumentException($formDetailListFormDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($formDetailListFormDetail) || (is_array($formDetailListFormDetail) && empty($formDetailListFormDetail))) {
            unset($this->FormDetailListFormDetail);
        } else {
            $this->FormDetailListFormDetail = $formDetailListFormDetail;
        }
        return $this;
    }
    /**
     * Add item to FormDetailListFormDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\FormDetailListFormDetail $item
     * @return \ArrayType\ArrayOfFormDetailListFormDetail
     */
    public function addToFormDetailListFormDetail(\StructType\FormDetailListFormDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FormDetailListFormDetail) {
            throw new \InvalidArgumentException(sprintf('The FormDetailListFormDetail property can only contain items of type \StructType\FormDetailListFormDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormDetailListFormDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FormDetailListFormDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FormDetailListFormDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FormDetailListFormDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FormDetailListFormDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FormDetailListFormDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormDetailListFormDetail
     */
    public function getAttributeName()
    {
        return 'FormDetailListFormDetail';
    }
}
