<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormItemType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFormItemType
 * @subpackage Arrays
 */
class ArrayOfFormItemType extends AbstractStructArrayBase
{
    /**
     * The FormItemType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FormItemType[]
     */
    public $FormItemType;
    /**
     * Constructor method for ArrayOfFormItemType
     * @uses ArrayOfFormItemType::setFormItemType()
     * @param \StructType\FormItemType[] $formItemType
     */
    public function __construct(array $formItemType = array())
    {
        $this
            ->setFormItemType($formItemType);
    }
    /**
     * Get FormItemType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FormItemType[]|null
     */
    public function getFormItemType()
    {
        return isset($this->FormItemType) ? $this->FormItemType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFormItemType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormItemType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormItemTypeForArrayConstraintsFromSetFormItemType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFormItemTypeFormItemTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormItemTypeFormItemTypeItem instanceof \StructType\FormItemType) {
                $invalidValues[] = is_object($arrayOfFormItemTypeFormItemTypeItem) ? get_class($arrayOfFormItemTypeFormItemTypeItem) : sprintf('%s(%s)', gettype($arrayOfFormItemTypeFormItemTypeItem), var_export($arrayOfFormItemTypeFormItemTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormItemType property can only contain items of type \StructType\FormItemType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormItemType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FormItemType[] $formItemType
     * @return \ArrayType\ArrayOfFormItemType
     */
    public function setFormItemType(array $formItemType = array())
    {
        // validation for constraint: array
        if ('' !== ($formItemTypeArrayErrorMessage = self::validateFormItemTypeForArrayConstraintsFromSetFormItemType($formItemType))) {
            throw new \InvalidArgumentException($formItemTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($formItemType) || (is_array($formItemType) && empty($formItemType))) {
            unset($this->FormItemType);
        } else {
            $this->FormItemType = $formItemType;
        }
        return $this;
    }
    /**
     * Add item to FormItemType value
     * @throws \InvalidArgumentException
     * @param \StructType\FormItemType $item
     * @return \ArrayType\ArrayOfFormItemType
     */
    public function addToFormItemType(\StructType\FormItemType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FormItemType) {
            throw new \InvalidArgumentException(sprintf('The FormItemType property can only contain items of type \StructType\FormItemType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormItemType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FormItemType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FormItemType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FormItemType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FormItemType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FormItemType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormItemType
     */
    public function getAttributeName()
    {
        return 'FormItemType';
    }
}
