<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFormListForm ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFormListForm
 * @subpackage Arrays
 */
class ArrayOfFormListForm extends AbstractStructArrayBase
{
    /**
     * The FormListForm
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FormListForm[]
     */
    public $FormListForm;
    /**
     * Constructor method for ArrayOfFormListForm
     * @uses ArrayOfFormListForm::setFormListForm()
     * @param \StructType\FormListForm[] $formListForm
     */
    public function __construct(array $formListForm = array())
    {
        $this
            ->setFormListForm($formListForm);
    }
    /**
     * Get FormListForm value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FormListForm[]|null
     */
    public function getFormListForm()
    {
        return isset($this->FormListForm) ? $this->FormListForm : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFormListForm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFormListForm method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFormListFormForArrayConstraintsFromSetFormListForm(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFormListFormFormListFormItem) {
            // validation for constraint: itemType
            if (!$arrayOfFormListFormFormListFormItem instanceof \StructType\FormListForm) {
                $invalidValues[] = is_object($arrayOfFormListFormFormListFormItem) ? get_class($arrayOfFormListFormFormListFormItem) : sprintf('%s(%s)', gettype($arrayOfFormListFormFormListFormItem), var_export($arrayOfFormListFormFormListFormItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FormListForm property can only contain items of type \StructType\FormListForm, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FormListForm value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FormListForm[] $formListForm
     * @return \ArrayType\ArrayOfFormListForm
     */
    public function setFormListForm(array $formListForm = array())
    {
        // validation for constraint: array
        if ('' !== ($formListFormArrayErrorMessage = self::validateFormListFormForArrayConstraintsFromSetFormListForm($formListForm))) {
            throw new \InvalidArgumentException($formListFormArrayErrorMessage, __LINE__);
        }
        if (is_null($formListForm) || (is_array($formListForm) && empty($formListForm))) {
            unset($this->FormListForm);
        } else {
            $this->FormListForm = $formListForm;
        }
        return $this;
    }
    /**
     * Add item to FormListForm value
     * @throws \InvalidArgumentException
     * @param \StructType\FormListForm $item
     * @return \ArrayType\ArrayOfFormListForm
     */
    public function addToFormListForm(\StructType\FormListForm $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FormListForm) {
            throw new \InvalidArgumentException(sprintf('The FormListForm property can only contain items of type \StructType\FormListForm, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FormListForm[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FormListForm|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FormListForm|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FormListForm|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FormListForm|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FormListForm|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FormListForm
     */
    public function getAttributeName()
    {
        return 'FormListForm';
    }
}
