<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGPSPointDetailType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGPSPointDetailType
 * @subpackage Arrays
 */
class ArrayOfGPSPointDetailType extends AbstractStructArrayBase
{
    /**
     * The GPSPointDetailType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GPSPointDetailType[]
     */
    public $GPSPointDetailType;
    /**
     * Constructor method for ArrayOfGPSPointDetailType
     * @uses ArrayOfGPSPointDetailType::setGPSPointDetailType()
     * @param \StructType\GPSPointDetailType[] $gPSPointDetailType
     */
    public function __construct(array $gPSPointDetailType = array())
    {
        $this
            ->setGPSPointDetailType($gPSPointDetailType);
    }
    /**
     * Get GPSPointDetailType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GPSPointDetailType[]|null
     */
    public function getGPSPointDetailType()
    {
        return isset($this->GPSPointDetailType) ? $this->GPSPointDetailType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGPSPointDetailType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGPSPointDetailType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGPSPointDetailTypeForArrayConstraintsFromSetGPSPointDetailType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGPSPointDetailTypeGPSPointDetailTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfGPSPointDetailTypeGPSPointDetailTypeItem instanceof \StructType\GPSPointDetailType) {
                $invalidValues[] = is_object($arrayOfGPSPointDetailTypeGPSPointDetailTypeItem) ? get_class($arrayOfGPSPointDetailTypeGPSPointDetailTypeItem) : sprintf('%s(%s)', gettype($arrayOfGPSPointDetailTypeGPSPointDetailTypeItem), var_export($arrayOfGPSPointDetailTypeGPSPointDetailTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GPSPointDetailType property can only contain items of type \StructType\GPSPointDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GPSPointDetailType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GPSPointDetailType[] $gPSPointDetailType
     * @return \ArrayType\ArrayOfGPSPointDetailType
     */
    public function setGPSPointDetailType(array $gPSPointDetailType = array())
    {
        // validation for constraint: array
        if ('' !== ($gPSPointDetailTypeArrayErrorMessage = self::validateGPSPointDetailTypeForArrayConstraintsFromSetGPSPointDetailType($gPSPointDetailType))) {
            throw new \InvalidArgumentException($gPSPointDetailTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($gPSPointDetailType) || (is_array($gPSPointDetailType) && empty($gPSPointDetailType))) {
            unset($this->GPSPointDetailType);
        } else {
            $this->GPSPointDetailType = $gPSPointDetailType;
        }
        return $this;
    }
    /**
     * Add item to GPSPointDetailType value
     * @throws \InvalidArgumentException
     * @param \StructType\GPSPointDetailType $item
     * @return \ArrayType\ArrayOfGPSPointDetailType
     */
    public function addToGPSPointDetailType(\StructType\GPSPointDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GPSPointDetailType) {
            throw new \InvalidArgumentException(sprintf('The GPSPointDetailType property can only contain items of type \StructType\GPSPointDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GPSPointDetailType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GPSPointDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GPSPointDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GPSPointDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GPSPointDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GPSPointDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GPSPointDetailType
     */
    public function getAttributeName()
    {
        return 'GPSPointDetailType';
    }
}
