<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImportRoutesRoute ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfImportRoutesRoute
 * @subpackage Arrays
 */
class ArrayOfImportRoutesRoute extends AbstractStructArrayBase
{
    /**
     * The ImportRoutesRoute
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportRoutesRoute[]
     */
    public $ImportRoutesRoute;
    /**
     * Constructor method for ArrayOfImportRoutesRoute
     * @uses ArrayOfImportRoutesRoute::setImportRoutesRoute()
     * @param \StructType\ImportRoutesRoute[] $importRoutesRoute
     */
    public function __construct(array $importRoutesRoute = array())
    {
        $this
            ->setImportRoutesRoute($importRoutesRoute);
    }
    /**
     * Get ImportRoutesRoute value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportRoutesRoute[]|null
     */
    public function getImportRoutesRoute()
    {
        return isset($this->ImportRoutesRoute) ? $this->ImportRoutesRoute : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImportRoutesRoute method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImportRoutesRoute method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImportRoutesRouteForArrayConstraintsFromSetImportRoutesRoute(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImportRoutesRouteImportRoutesRouteItem) {
            // validation for constraint: itemType
            if (!$arrayOfImportRoutesRouteImportRoutesRouteItem instanceof \StructType\ImportRoutesRoute) {
                $invalidValues[] = is_object($arrayOfImportRoutesRouteImportRoutesRouteItem) ? get_class($arrayOfImportRoutesRouteImportRoutesRouteItem) : sprintf('%s(%s)', gettype($arrayOfImportRoutesRouteImportRoutesRouteItem), var_export($arrayOfImportRoutesRouteImportRoutesRouteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImportRoutesRoute property can only contain items of type \StructType\ImportRoutesRoute, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImportRoutesRoute value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ImportRoutesRoute[] $importRoutesRoute
     * @return \ArrayType\ArrayOfImportRoutesRoute
     */
    public function setImportRoutesRoute(array $importRoutesRoute = array())
    {
        // validation for constraint: array
        if ('' !== ($importRoutesRouteArrayErrorMessage = self::validateImportRoutesRouteForArrayConstraintsFromSetImportRoutesRoute($importRoutesRoute))) {
            throw new \InvalidArgumentException($importRoutesRouteArrayErrorMessage, __LINE__);
        }
        if (is_null($importRoutesRoute) || (is_array($importRoutesRoute) && empty($importRoutesRoute))) {
            unset($this->ImportRoutesRoute);
        } else {
            $this->ImportRoutesRoute = $importRoutesRoute;
        }
        return $this;
    }
    /**
     * Add item to ImportRoutesRoute value
     * @throws \InvalidArgumentException
     * @param \StructType\ImportRoutesRoute $item
     * @return \ArrayType\ArrayOfImportRoutesRoute
     */
    public function addToImportRoutesRoute(\StructType\ImportRoutesRoute $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImportRoutesRoute) {
            throw new \InvalidArgumentException(sprintf('The ImportRoutesRoute property can only contain items of type \StructType\ImportRoutesRoute, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImportRoutesRoute[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImportRoutesRoute|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImportRoutesRoute|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImportRoutesRoute|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImportRoutesRoute|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImportRoutesRoute|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImportRoutesRoute
     */
    public function getAttributeName()
    {
        return 'ImportRoutesRoute';
    }
}
