<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfImportRoutesRouteNextRt ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfImportRoutesRouteNextRt
 * @subpackage Arrays
 */
class ArrayOfImportRoutesRouteNextRt extends AbstractStructArrayBase
{
    /**
     * The ImportRoutesRouteNextRt
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ImportRoutesRouteNextRt[]
     */
    public $ImportRoutesRouteNextRt;
    /**
     * Constructor method for ArrayOfImportRoutesRouteNextRt
     * @uses ArrayOfImportRoutesRouteNextRt::setImportRoutesRouteNextRt()
     * @param \StructType\ImportRoutesRouteNextRt[] $importRoutesRouteNextRt
     */
    public function __construct(array $importRoutesRouteNextRt = array())
    {
        $this
            ->setImportRoutesRouteNextRt($importRoutesRouteNextRt);
    }
    /**
     * Get ImportRoutesRouteNextRt value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ImportRoutesRouteNextRt[]|null
     */
    public function getImportRoutesRouteNextRt()
    {
        return isset($this->ImportRoutesRouteNextRt) ? $this->ImportRoutesRouteNextRt : null;
    }
    /**
     * This method is responsible for validating the values passed to the setImportRoutesRouteNextRt method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImportRoutesRouteNextRt method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImportRoutesRouteNextRtForArrayConstraintsFromSetImportRoutesRouteNextRt(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfImportRoutesRouteNextRtImportRoutesRouteNextRtItem) {
            // validation for constraint: itemType
            if (!$arrayOfImportRoutesRouteNextRtImportRoutesRouteNextRtItem instanceof \StructType\ImportRoutesRouteNextRt) {
                $invalidValues[] = is_object($arrayOfImportRoutesRouteNextRtImportRoutesRouteNextRtItem) ? get_class($arrayOfImportRoutesRouteNextRtImportRoutesRouteNextRtItem) : sprintf('%s(%s)', gettype($arrayOfImportRoutesRouteNextRtImportRoutesRouteNextRtItem), var_export($arrayOfImportRoutesRouteNextRtImportRoutesRouteNextRtItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ImportRoutesRouteNextRt property can only contain items of type \StructType\ImportRoutesRouteNextRt, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ImportRoutesRouteNextRt value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ImportRoutesRouteNextRt[] $importRoutesRouteNextRt
     * @return \ArrayType\ArrayOfImportRoutesRouteNextRt
     */
    public function setImportRoutesRouteNextRt(array $importRoutesRouteNextRt = array())
    {
        // validation for constraint: array
        if ('' !== ($importRoutesRouteNextRtArrayErrorMessage = self::validateImportRoutesRouteNextRtForArrayConstraintsFromSetImportRoutesRouteNextRt($importRoutesRouteNextRt))) {
            throw new \InvalidArgumentException($importRoutesRouteNextRtArrayErrorMessage, __LINE__);
        }
        if (is_null($importRoutesRouteNextRt) || (is_array($importRoutesRouteNextRt) && empty($importRoutesRouteNextRt))) {
            unset($this->ImportRoutesRouteNextRt);
        } else {
            $this->ImportRoutesRouteNextRt = $importRoutesRouteNextRt;
        }
        return $this;
    }
    /**
     * Add item to ImportRoutesRouteNextRt value
     * @throws \InvalidArgumentException
     * @param \StructType\ImportRoutesRouteNextRt $item
     * @return \ArrayType\ArrayOfImportRoutesRouteNextRt
     */
    public function addToImportRoutesRouteNextRt(\StructType\ImportRoutesRouteNextRt $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ImportRoutesRouteNextRt) {
            throw new \InvalidArgumentException(sprintf('The ImportRoutesRouteNextRt property can only contain items of type \StructType\ImportRoutesRouteNextRt, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ImportRoutesRouteNextRt[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ImportRoutesRouteNextRt|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ImportRoutesRouteNextRt|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ImportRoutesRouteNextRt|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ImportRoutesRouteNextRt|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ImportRoutesRouteNextRt|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ImportRoutesRouteNextRt
     */
    public function getAttributeName()
    {
        return 'ImportRoutesRouteNextRt';
    }
}
