<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInsertShipToDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfInsertShipToDetails
 * @subpackage Arrays
 */
class ArrayOfInsertShipToDetails extends AbstractStructArrayBase
{
    /**
     * The InsertShipToDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InsertShipToDetails[]
     */
    public $InsertShipToDetails;
    /**
     * Constructor method for ArrayOfInsertShipToDetails
     * @uses ArrayOfInsertShipToDetails::setInsertShipToDetails()
     * @param \StructType\InsertShipToDetails[] $insertShipToDetails
     */
    public function __construct(array $insertShipToDetails = array())
    {
        $this
            ->setInsertShipToDetails($insertShipToDetails);
    }
    /**
     * Get InsertShipToDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InsertShipToDetails[]|null
     */
    public function getInsertShipToDetails()
    {
        return isset($this->InsertShipToDetails) ? $this->InsertShipToDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInsertShipToDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInsertShipToDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInsertShipToDetailsForArrayConstraintsFromSetInsertShipToDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInsertShipToDetailsInsertShipToDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfInsertShipToDetailsInsertShipToDetailsItem instanceof \StructType\InsertShipToDetails) {
                $invalidValues[] = is_object($arrayOfInsertShipToDetailsInsertShipToDetailsItem) ? get_class($arrayOfInsertShipToDetailsInsertShipToDetailsItem) : sprintf('%s(%s)', gettype($arrayOfInsertShipToDetailsInsertShipToDetailsItem), var_export($arrayOfInsertShipToDetailsInsertShipToDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InsertShipToDetails property can only contain items of type \StructType\InsertShipToDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InsertShipToDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InsertShipToDetails[] $insertShipToDetails
     * @return \ArrayType\ArrayOfInsertShipToDetails
     */
    public function setInsertShipToDetails(array $insertShipToDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($insertShipToDetailsArrayErrorMessage = self::validateInsertShipToDetailsForArrayConstraintsFromSetInsertShipToDetails($insertShipToDetails))) {
            throw new \InvalidArgumentException($insertShipToDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($insertShipToDetails) || (is_array($insertShipToDetails) && empty($insertShipToDetails))) {
            unset($this->InsertShipToDetails);
        } else {
            $this->InsertShipToDetails = $insertShipToDetails;
        }
        return $this;
    }
    /**
     * Add item to InsertShipToDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\InsertShipToDetails $item
     * @return \ArrayType\ArrayOfInsertShipToDetails
     */
    public function addToInsertShipToDetails(\StructType\InsertShipToDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InsertShipToDetails) {
            throw new \InvalidArgumentException(sprintf('The InsertShipToDetails property can only contain items of type \StructType\InsertShipToDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InsertShipToDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InsertShipToDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InsertShipToDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InsertShipToDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InsertShipToDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InsertShipToDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InsertShipToDetails
     */
    public function getAttributeName()
    {
        return 'InsertShipToDetails';
    }
}
