<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMasterRouteResponse ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMasterRouteResponse
 * @subpackage Arrays
 */
class ArrayOfMasterRouteResponse extends AbstractStructArrayBase
{
    /**
     * The MasterRouteResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MasterRouteResponse[]
     */
    public $MasterRouteResponse;
    /**
     * Constructor method for ArrayOfMasterRouteResponse
     * @uses ArrayOfMasterRouteResponse::setMasterRouteResponse()
     * @param \StructType\MasterRouteResponse[] $masterRouteResponse
     */
    public function __construct(array $masterRouteResponse = array())
    {
        $this
            ->setMasterRouteResponse($masterRouteResponse);
    }
    /**
     * Get MasterRouteResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MasterRouteResponse[]|null
     */
    public function getMasterRouteResponse()
    {
        return isset($this->MasterRouteResponse) ? $this->MasterRouteResponse : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMasterRouteResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMasterRouteResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMasterRouteResponseForArrayConstraintsFromSetMasterRouteResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMasterRouteResponseMasterRouteResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfMasterRouteResponseMasterRouteResponseItem instanceof \StructType\MasterRouteResponse) {
                $invalidValues[] = is_object($arrayOfMasterRouteResponseMasterRouteResponseItem) ? get_class($arrayOfMasterRouteResponseMasterRouteResponseItem) : sprintf('%s(%s)', gettype($arrayOfMasterRouteResponseMasterRouteResponseItem), var_export($arrayOfMasterRouteResponseMasterRouteResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MasterRouteResponse property can only contain items of type \StructType\MasterRouteResponse, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MasterRouteResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MasterRouteResponse[] $masterRouteResponse
     * @return \ArrayType\ArrayOfMasterRouteResponse
     */
    public function setMasterRouteResponse(array $masterRouteResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($masterRouteResponseArrayErrorMessage = self::validateMasterRouteResponseForArrayConstraintsFromSetMasterRouteResponse($masterRouteResponse))) {
            throw new \InvalidArgumentException($masterRouteResponseArrayErrorMessage, __LINE__);
        }
        if (is_null($masterRouteResponse) || (is_array($masterRouteResponse) && empty($masterRouteResponse))) {
            unset($this->MasterRouteResponse);
        } else {
            $this->MasterRouteResponse = $masterRouteResponse;
        }
        return $this;
    }
    /**
     * Add item to MasterRouteResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\MasterRouteResponse $item
     * @return \ArrayType\ArrayOfMasterRouteResponse
     */
    public function addToMasterRouteResponse(\StructType\MasterRouteResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MasterRouteResponse) {
            throw new \InvalidArgumentException(sprintf('The MasterRouteResponse property can only contain items of type \StructType\MasterRouteResponse, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MasterRouteResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MasterRouteResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MasterRouteResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MasterRouteResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MasterRouteResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MasterRouteResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MasterRouteResponse
     */
    public function getAttributeName()
    {
        return 'MasterRouteResponse';
    }
}
