<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderDetailActualDetailType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderDetailActualDetailType
 * @subpackage Arrays
 */
class ArrayOfOrderDetailActualDetailType extends AbstractStructArrayBase
{
    /**
     * The OrderDetailActualDetailType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderDetailActualDetailType[]
     */
    public $OrderDetailActualDetailType;
    /**
     * Constructor method for ArrayOfOrderDetailActualDetailType
     * @uses ArrayOfOrderDetailActualDetailType::setOrderDetailActualDetailType()
     * @param \StructType\OrderDetailActualDetailType[] $orderDetailActualDetailType
     */
    public function __construct(array $orderDetailActualDetailType = array())
    {
        $this
            ->setOrderDetailActualDetailType($orderDetailActualDetailType);
    }
    /**
     * Get OrderDetailActualDetailType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderDetailActualDetailType[]|null
     */
    public function getOrderDetailActualDetailType()
    {
        return isset($this->OrderDetailActualDetailType) ? $this->OrderDetailActualDetailType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderDetailActualDetailType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderDetailActualDetailType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderDetailActualDetailTypeForArrayConstraintsFromSetOrderDetailActualDetailType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderDetailActualDetailTypeOrderDetailActualDetailTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderDetailActualDetailTypeOrderDetailActualDetailTypeItem instanceof \StructType\OrderDetailActualDetailType) {
                $invalidValues[] = is_object($arrayOfOrderDetailActualDetailTypeOrderDetailActualDetailTypeItem) ? get_class($arrayOfOrderDetailActualDetailTypeOrderDetailActualDetailTypeItem) : sprintf('%s(%s)', gettype($arrayOfOrderDetailActualDetailTypeOrderDetailActualDetailTypeItem), var_export($arrayOfOrderDetailActualDetailTypeOrderDetailActualDetailTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderDetailActualDetailType property can only contain items of type \StructType\OrderDetailActualDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderDetailActualDetailType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderDetailActualDetailType[] $orderDetailActualDetailType
     * @return \ArrayType\ArrayOfOrderDetailActualDetailType
     */
    public function setOrderDetailActualDetailType(array $orderDetailActualDetailType = array())
    {
        // validation for constraint: array
        if ('' !== ($orderDetailActualDetailTypeArrayErrorMessage = self::validateOrderDetailActualDetailTypeForArrayConstraintsFromSetOrderDetailActualDetailType($orderDetailActualDetailType))) {
            throw new \InvalidArgumentException($orderDetailActualDetailTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($orderDetailActualDetailType) || (is_array($orderDetailActualDetailType) && empty($orderDetailActualDetailType))) {
            unset($this->OrderDetailActualDetailType);
        } else {
            $this->OrderDetailActualDetailType = $orderDetailActualDetailType;
        }
        return $this;
    }
    /**
     * Add item to OrderDetailActualDetailType value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderDetailActualDetailType $item
     * @return \ArrayType\ArrayOfOrderDetailActualDetailType
     */
    public function addToOrderDetailActualDetailType(\StructType\OrderDetailActualDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderDetailActualDetailType) {
            throw new \InvalidArgumentException(sprintf('The OrderDetailActualDetailType property can only contain items of type \StructType\OrderDetailActualDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderDetailActualDetailType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderDetailActualDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderDetailActualDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderDetailActualDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderDetailActualDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderDetailActualDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderDetailActualDetailType
     */
    public function getAttributeName()
    {
        return 'OrderDetailActualDetailType';
    }
}
