<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderDetailPlanDetailType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderDetailPlanDetailType
 * @subpackage Arrays
 */
class ArrayOfOrderDetailPlanDetailType extends AbstractStructArrayBase
{
    /**
     * The OrderDetailPlanDetailType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderDetailPlanDetailType[]
     */
    public $OrderDetailPlanDetailType;
    /**
     * Constructor method for ArrayOfOrderDetailPlanDetailType
     * @uses ArrayOfOrderDetailPlanDetailType::setOrderDetailPlanDetailType()
     * @param \StructType\OrderDetailPlanDetailType[] $orderDetailPlanDetailType
     */
    public function __construct(array $orderDetailPlanDetailType = array())
    {
        $this
            ->setOrderDetailPlanDetailType($orderDetailPlanDetailType);
    }
    /**
     * Get OrderDetailPlanDetailType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderDetailPlanDetailType[]|null
     */
    public function getOrderDetailPlanDetailType()
    {
        return isset($this->OrderDetailPlanDetailType) ? $this->OrderDetailPlanDetailType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderDetailPlanDetailType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderDetailPlanDetailType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderDetailPlanDetailTypeForArrayConstraintsFromSetOrderDetailPlanDetailType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderDetailPlanDetailTypeOrderDetailPlanDetailTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderDetailPlanDetailTypeOrderDetailPlanDetailTypeItem instanceof \StructType\OrderDetailPlanDetailType) {
                $invalidValues[] = is_object($arrayOfOrderDetailPlanDetailTypeOrderDetailPlanDetailTypeItem) ? get_class($arrayOfOrderDetailPlanDetailTypeOrderDetailPlanDetailTypeItem) : sprintf('%s(%s)', gettype($arrayOfOrderDetailPlanDetailTypeOrderDetailPlanDetailTypeItem), var_export($arrayOfOrderDetailPlanDetailTypeOrderDetailPlanDetailTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderDetailPlanDetailType property can only contain items of type \StructType\OrderDetailPlanDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderDetailPlanDetailType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderDetailPlanDetailType[] $orderDetailPlanDetailType
     * @return \ArrayType\ArrayOfOrderDetailPlanDetailType
     */
    public function setOrderDetailPlanDetailType(array $orderDetailPlanDetailType = array())
    {
        // validation for constraint: array
        if ('' !== ($orderDetailPlanDetailTypeArrayErrorMessage = self::validateOrderDetailPlanDetailTypeForArrayConstraintsFromSetOrderDetailPlanDetailType($orderDetailPlanDetailType))) {
            throw new \InvalidArgumentException($orderDetailPlanDetailTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($orderDetailPlanDetailType) || (is_array($orderDetailPlanDetailType) && empty($orderDetailPlanDetailType))) {
            unset($this->OrderDetailPlanDetailType);
        } else {
            $this->OrderDetailPlanDetailType = $orderDetailPlanDetailType;
        }
        return $this;
    }
    /**
     * Add item to OrderDetailPlanDetailType value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderDetailPlanDetailType $item
     * @return \ArrayType\ArrayOfOrderDetailPlanDetailType
     */
    public function addToOrderDetailPlanDetailType(\StructType\OrderDetailPlanDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderDetailPlanDetailType) {
            throw new \InvalidArgumentException(sprintf('The OrderDetailPlanDetailType property can only contain items of type \StructType\OrderDetailPlanDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderDetailPlanDetailType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderDetailPlanDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderDetailPlanDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderDetailPlanDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderDetailPlanDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderDetailPlanDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderDetailPlanDetailType
     */
    public function getAttributeName()
    {
        return 'OrderDetailPlanDetailType';
    }
}
