<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderDetailType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderDetailType
 * @subpackage Arrays
 */
class ArrayOfOrderDetailType extends AbstractStructArrayBase
{
    /**
     * The OrderDetailType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderDetailType[]
     */
    public $OrderDetailType;
    /**
     * Constructor method for ArrayOfOrderDetailType
     * @uses ArrayOfOrderDetailType::setOrderDetailType()
     * @param \StructType\OrderDetailType[] $orderDetailType
     */
    public function __construct(array $orderDetailType = array())
    {
        $this
            ->setOrderDetailType($orderDetailType);
    }
    /**
     * Get OrderDetailType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderDetailType[]|null
     */
    public function getOrderDetailType()
    {
        return isset($this->OrderDetailType) ? $this->OrderDetailType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderDetailType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderDetailType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderDetailTypeForArrayConstraintsFromSetOrderDetailType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderDetailTypeOrderDetailTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderDetailTypeOrderDetailTypeItem instanceof \StructType\OrderDetailType) {
                $invalidValues[] = is_object($arrayOfOrderDetailTypeOrderDetailTypeItem) ? get_class($arrayOfOrderDetailTypeOrderDetailTypeItem) : sprintf('%s(%s)', gettype($arrayOfOrderDetailTypeOrderDetailTypeItem), var_export($arrayOfOrderDetailTypeOrderDetailTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderDetailType property can only contain items of type \StructType\OrderDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderDetailType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderDetailType[] $orderDetailType
     * @return \ArrayType\ArrayOfOrderDetailType
     */
    public function setOrderDetailType(array $orderDetailType = array())
    {
        // validation for constraint: array
        if ('' !== ($orderDetailTypeArrayErrorMessage = self::validateOrderDetailTypeForArrayConstraintsFromSetOrderDetailType($orderDetailType))) {
            throw new \InvalidArgumentException($orderDetailTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($orderDetailType) || (is_array($orderDetailType) && empty($orderDetailType))) {
            unset($this->OrderDetailType);
        } else {
            $this->OrderDetailType = $orderDetailType;
        }
        return $this;
    }
    /**
     * Add item to OrderDetailType value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderDetailType $item
     * @return \ArrayType\ArrayOfOrderDetailType
     */
    public function addToOrderDetailType(\StructType\OrderDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderDetailType) {
            throw new \InvalidArgumentException(sprintf('The OrderDetailType property can only contain items of type \StructType\OrderDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderDetailType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderDetailType
     */
    public function getAttributeName()
    {
        return 'OrderDetailType';
    }
}
