<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderEvent ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderEvent
 * @subpackage Arrays
 */
class ArrayOfOrderEvent extends AbstractStructArrayBase
{
    /**
     * The OrderEvent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderEvent[]
     */
    public $OrderEvent;
    /**
     * Constructor method for ArrayOfOrderEvent
     * @uses ArrayOfOrderEvent::setOrderEvent()
     * @param \StructType\OrderEvent[] $orderEvent
     */
    public function __construct(array $orderEvent = array())
    {
        $this
            ->setOrderEvent($orderEvent);
    }
    /**
     * Get OrderEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderEvent[]|null
     */
    public function getOrderEvent()
    {
        return isset($this->OrderEvent) ? $this->OrderEvent : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderEvent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderEvent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderEventForArrayConstraintsFromSetOrderEvent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderEventOrderEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderEventOrderEventItem instanceof \StructType\OrderEvent) {
                $invalidValues[] = is_object($arrayOfOrderEventOrderEventItem) ? get_class($arrayOfOrderEventOrderEventItem) : sprintf('%s(%s)', gettype($arrayOfOrderEventOrderEventItem), var_export($arrayOfOrderEventOrderEventItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderEvent property can only contain items of type \StructType\OrderEvent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderEvent[] $orderEvent
     * @return \ArrayType\ArrayOfOrderEvent
     */
    public function setOrderEvent(array $orderEvent = array())
    {
        // validation for constraint: array
        if ('' !== ($orderEventArrayErrorMessage = self::validateOrderEventForArrayConstraintsFromSetOrderEvent($orderEvent))) {
            throw new \InvalidArgumentException($orderEventArrayErrorMessage, __LINE__);
        }
        if (is_null($orderEvent) || (is_array($orderEvent) && empty($orderEvent))) {
            unset($this->OrderEvent);
        } else {
            $this->OrderEvent = $orderEvent;
        }
        return $this;
    }
    /**
     * Add item to OrderEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderEvent $item
     * @return \ArrayType\ArrayOfOrderEvent
     */
    public function addToOrderEvent(\StructType\OrderEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderEvent) {
            throw new \InvalidArgumentException(sprintf('The OrderEvent property can only contain items of type \StructType\OrderEvent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderEvent
     */
    public function getAttributeName()
    {
        return 'OrderEvent';
    }
}
