<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderEventType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOrderEventType
 * @subpackage Arrays
 */
class ArrayOfOrderEventType extends AbstractStructArrayBase
{
    /**
     * The OrderEventType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $OrderEventType;
    /**
     * Constructor method for ArrayOfOrderEventType
     * @uses ArrayOfOrderEventType::setOrderEventType()
     * @param string[] $orderEventType
     */
    public function __construct(array $orderEventType = array())
    {
        $this
            ->setOrderEventType($orderEventType);
    }
    /**
     * Get OrderEventType value
     * @return string[]|null
     */
    public function getOrderEventType()
    {
        return $this->OrderEventType;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderEventType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderEventType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderEventTypeForArrayConstraintsFromSetOrderEventType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOrderEventTypeOrderEventTypeItem) {
            // validation for constraint: enumeration
            if (!\EnumType\OrderEventType::valueIsValid($arrayOfOrderEventTypeOrderEventTypeItem)) {
                $invalidValues[] = is_object($arrayOfOrderEventTypeOrderEventTypeItem) ? get_class($arrayOfOrderEventTypeOrderEventTypeItem) : sprintf('%s(%s)', gettype($arrayOfOrderEventTypeOrderEventTypeItem), var_export($arrayOfOrderEventTypeOrderEventTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\OrderEventType', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\OrderEventType::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderEventType value
     * @uses \EnumType\OrderEventType::valueIsValid()
     * @uses \EnumType\OrderEventType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $orderEventType
     * @return \ArrayType\ArrayOfOrderEventType
     */
    public function setOrderEventType(array $orderEventType = array())
    {
        // validation for constraint: array
        if ('' !== ($orderEventTypeArrayErrorMessage = self::validateOrderEventTypeForArrayConstraintsFromSetOrderEventType($orderEventType))) {
            throw new \InvalidArgumentException($orderEventTypeArrayErrorMessage, __LINE__);
        }
        $this->OrderEventType = $orderEventType;
        return $this;
    }
    /**
     * Add item to OrderEventType value
     * @uses \EnumType\OrderEventType::valueIsValid()
     * @uses \EnumType\OrderEventType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfOrderEventType
     */
    public function addToOrderEventType($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\OrderEventType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\OrderEventType', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\OrderEventType::getValidValues())), __LINE__);
        }
        $this->OrderEventType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\OrderEventType::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfOrderEventType
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\OrderEventType::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\OrderEventType', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\OrderEventType::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderEventType
     */
    public function getAttributeName()
    {
        return 'OrderEventType';
    }
}
