<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOverTime ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOverTime
 * @subpackage Arrays
 */
class ArrayOfOverTime extends AbstractStructArrayBase
{
    /**
     * The OverTime
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OverTime[]
     */
    public $OverTime;
    /**
     * Constructor method for ArrayOfOverTime
     * @uses ArrayOfOverTime::setOverTime()
     * @param \StructType\OverTime[] $overTime
     */
    public function __construct(array $overTime = array())
    {
        $this
            ->setOverTime($overTime);
    }
    /**
     * Get OverTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OverTime[]|null
     */
    public function getOverTime()
    {
        return isset($this->OverTime) ? $this->OverTime : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOverTime method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOverTime method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOverTimeForArrayConstraintsFromSetOverTime(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOverTimeOverTimeItem) {
            // validation for constraint: itemType
            if (!$arrayOfOverTimeOverTimeItem instanceof \StructType\OverTime) {
                $invalidValues[] = is_object($arrayOfOverTimeOverTimeItem) ? get_class($arrayOfOverTimeOverTimeItem) : sprintf('%s(%s)', gettype($arrayOfOverTimeOverTimeItem), var_export($arrayOfOverTimeOverTimeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OverTime property can only contain items of type \StructType\OverTime, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OverTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OverTime[] $overTime
     * @return \ArrayType\ArrayOfOverTime
     */
    public function setOverTime(array $overTime = array())
    {
        // validation for constraint: array
        if ('' !== ($overTimeArrayErrorMessage = self::validateOverTimeForArrayConstraintsFromSetOverTime($overTime))) {
            throw new \InvalidArgumentException($overTimeArrayErrorMessage, __LINE__);
        }
        if (is_null($overTime) || (is_array($overTime) && empty($overTime))) {
            unset($this->OverTime);
        } else {
            $this->OverTime = $overTime;
        }
        return $this;
    }
    /**
     * Add item to OverTime value
     * @throws \InvalidArgumentException
     * @param \StructType\OverTime $item
     * @return \ArrayType\ArrayOfOverTime
     */
    public function addToOverTime(\StructType\OverTime $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OverTime) {
            throw new \InvalidArgumentException(sprintf('The OverTime property can only contain items of type \StructType\OverTime, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OverTime[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OverTime|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OverTime|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OverTime|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OverTime|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OverTime|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OverTime
     */
    public function getAttributeName()
    {
        return 'OverTime';
    }
}
