<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQtyField ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQtyField
 * @subpackage Arrays
 */
class ArrayOfQtyField extends AbstractStructArrayBase
{
    /**
     * The QtyField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QtyField[]
     */
    public $QtyField;
    /**
     * Constructor method for ArrayOfQtyField
     * @uses ArrayOfQtyField::setQtyField()
     * @param \StructType\QtyField[] $qtyField
     */
    public function __construct(array $qtyField = array())
    {
        $this
            ->setQtyField($qtyField);
    }
    /**
     * Get QtyField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QtyField[]|null
     */
    public function getQtyField()
    {
        return isset($this->QtyField) ? $this->QtyField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQtyField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQtyField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQtyFieldForArrayConstraintsFromSetQtyField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQtyFieldQtyFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfQtyFieldQtyFieldItem instanceof \StructType\QtyField) {
                $invalidValues[] = is_object($arrayOfQtyFieldQtyFieldItem) ? get_class($arrayOfQtyFieldQtyFieldItem) : sprintf('%s(%s)', gettype($arrayOfQtyFieldQtyFieldItem), var_export($arrayOfQtyFieldQtyFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QtyField property can only contain items of type \StructType\QtyField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QtyField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QtyField[] $qtyField
     * @return \ArrayType\ArrayOfQtyField
     */
    public function setQtyField(array $qtyField = array())
    {
        // validation for constraint: array
        if ('' !== ($qtyFieldArrayErrorMessage = self::validateQtyFieldForArrayConstraintsFromSetQtyField($qtyField))) {
            throw new \InvalidArgumentException($qtyFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($qtyField) || (is_array($qtyField) && empty($qtyField))) {
            unset($this->QtyField);
        } else {
            $this->QtyField = $qtyField;
        }
        return $this;
    }
    /**
     * Add item to QtyField value
     * @throws \InvalidArgumentException
     * @param \StructType\QtyField $item
     * @return \ArrayType\ArrayOfQtyField
     */
    public function addToQtyField(\StructType\QtyField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QtyField) {
            throw new \InvalidArgumentException(sprintf('The QtyField property can only contain items of type \StructType\QtyField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QtyField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QtyField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QtyField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QtyField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QtyField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QtyField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QtyField
     */
    public function getAttributeName()
    {
        return 'QtyField';
    }
}
