<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuantityFieldListQuantityField ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfQuantityFieldListQuantityField
 * @subpackage Arrays
 */
class ArrayOfQuantityFieldListQuantityField extends AbstractStructArrayBase
{
    /**
     * The QuantityFieldListQuantityField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\QuantityFieldListQuantityField[]
     */
    public $QuantityFieldListQuantityField;
    /**
     * Constructor method for ArrayOfQuantityFieldListQuantityField
     * @uses ArrayOfQuantityFieldListQuantityField::setQuantityFieldListQuantityField()
     * @param \StructType\QuantityFieldListQuantityField[] $quantityFieldListQuantityField
     */
    public function __construct(array $quantityFieldListQuantityField = array())
    {
        $this
            ->setQuantityFieldListQuantityField($quantityFieldListQuantityField);
    }
    /**
     * Get QuantityFieldListQuantityField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\QuantityFieldListQuantityField[]|null
     */
    public function getQuantityFieldListQuantityField()
    {
        return isset($this->QuantityFieldListQuantityField) ? $this->QuantityFieldListQuantityField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setQuantityFieldListQuantityField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuantityFieldListQuantityField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuantityFieldListQuantityFieldForArrayConstraintsFromSetQuantityFieldListQuantityField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQuantityFieldListQuantityFieldQuantityFieldListQuantityFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfQuantityFieldListQuantityFieldQuantityFieldListQuantityFieldItem instanceof \StructType\QuantityFieldListQuantityField) {
                $invalidValues[] = is_object($arrayOfQuantityFieldListQuantityFieldQuantityFieldListQuantityFieldItem) ? get_class($arrayOfQuantityFieldListQuantityFieldQuantityFieldListQuantityFieldItem) : sprintf('%s(%s)', gettype($arrayOfQuantityFieldListQuantityFieldQuantityFieldListQuantityFieldItem), var_export($arrayOfQuantityFieldListQuantityFieldQuantityFieldListQuantityFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QuantityFieldListQuantityField property can only contain items of type \StructType\QuantityFieldListQuantityField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QuantityFieldListQuantityField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\QuantityFieldListQuantityField[] $quantityFieldListQuantityField
     * @return \ArrayType\ArrayOfQuantityFieldListQuantityField
     */
    public function setQuantityFieldListQuantityField(array $quantityFieldListQuantityField = array())
    {
        // validation for constraint: array
        if ('' !== ($quantityFieldListQuantityFieldArrayErrorMessage = self::validateQuantityFieldListQuantityFieldForArrayConstraintsFromSetQuantityFieldListQuantityField($quantityFieldListQuantityField))) {
            throw new \InvalidArgumentException($quantityFieldListQuantityFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($quantityFieldListQuantityField) || (is_array($quantityFieldListQuantityField) && empty($quantityFieldListQuantityField))) {
            unset($this->QuantityFieldListQuantityField);
        } else {
            $this->QuantityFieldListQuantityField = $quantityFieldListQuantityField;
        }
        return $this;
    }
    /**
     * Add item to QuantityFieldListQuantityField value
     * @throws \InvalidArgumentException
     * @param \StructType\QuantityFieldListQuantityField $item
     * @return \ArrayType\ArrayOfQuantityFieldListQuantityField
     */
    public function addToQuantityFieldListQuantityField(\StructType\QuantityFieldListQuantityField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuantityFieldListQuantityField) {
            throw new \InvalidArgumentException(sprintf('The QuantityFieldListQuantityField property can only contain items of type \StructType\QuantityFieldListQuantityField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QuantityFieldListQuantityField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuantityFieldListQuantityField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuantityFieldListQuantityField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuantityFieldListQuantityField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuantityFieldListQuantityField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuantityFieldListQuantityField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuantityFieldListQuantityField
     */
    public function getAttributeName()
    {
        return 'QuantityFieldListQuantityField';
    }
}
