<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResponseStatusError ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfResponseStatusError
 * @subpackage Arrays
 */
class ArrayOfResponseStatusError extends AbstractStructArrayBase
{
    /**
     * The ResponseStatusError
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ResponseStatusError[]
     */
    public $ResponseStatusError;
    /**
     * Constructor method for ArrayOfResponseStatusError
     * @uses ArrayOfResponseStatusError::setResponseStatusError()
     * @param \StructType\ResponseStatusError[] $responseStatusError
     */
    public function __construct(array $responseStatusError = array())
    {
        $this
            ->setResponseStatusError($responseStatusError);
    }
    /**
     * Get ResponseStatusError value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ResponseStatusError[]|null
     */
    public function getResponseStatusError()
    {
        return isset($this->ResponseStatusError) ? $this->ResponseStatusError : null;
    }
    /**
     * This method is responsible for validating the values passed to the setResponseStatusError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResponseStatusError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResponseStatusErrorForArrayConstraintsFromSetResponseStatusError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfResponseStatusErrorResponseStatusErrorItem) {
            // validation for constraint: itemType
            if (!$arrayOfResponseStatusErrorResponseStatusErrorItem instanceof \StructType\ResponseStatusError) {
                $invalidValues[] = is_object($arrayOfResponseStatusErrorResponseStatusErrorItem) ? get_class($arrayOfResponseStatusErrorResponseStatusErrorItem) : sprintf('%s(%s)', gettype($arrayOfResponseStatusErrorResponseStatusErrorItem), var_export($arrayOfResponseStatusErrorResponseStatusErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResponseStatusError property can only contain items of type \StructType\ResponseStatusError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResponseStatusError value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ResponseStatusError[] $responseStatusError
     * @return \ArrayType\ArrayOfResponseStatusError
     */
    public function setResponseStatusError(array $responseStatusError = array())
    {
        // validation for constraint: array
        if ('' !== ($responseStatusErrorArrayErrorMessage = self::validateResponseStatusErrorForArrayConstraintsFromSetResponseStatusError($responseStatusError))) {
            throw new \InvalidArgumentException($responseStatusErrorArrayErrorMessage, __LINE__);
        }
        if (is_null($responseStatusError) || (is_array($responseStatusError) && empty($responseStatusError))) {
            unset($this->ResponseStatusError);
        } else {
            $this->ResponseStatusError = $responseStatusError;
        }
        return $this;
    }
    /**
     * Add item to ResponseStatusError value
     * @throws \InvalidArgumentException
     * @param \StructType\ResponseStatusError $item
     * @return \ArrayType\ArrayOfResponseStatusError
     */
    public function addToResponseStatusError(\StructType\ResponseStatusError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResponseStatusError) {
            throw new \InvalidArgumentException(sprintf('The ResponseStatusError property can only contain items of type \StructType\ResponseStatusError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResponseStatusError[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ResponseStatusError|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ResponseStatusError|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ResponseStatusError|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ResponseStatusError|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ResponseStatusError|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResponseStatusError
     */
    public function getAttributeName()
    {
        return 'ResponseStatusError';
    }
}
