<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResponseStatusWarning ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfResponseStatusWarning
 * @subpackage Arrays
 */
class ArrayOfResponseStatusWarning extends AbstractStructArrayBase
{
    /**
     * The ResponseStatusWarning
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ResponseStatusWarning[]
     */
    public $ResponseStatusWarning;
    /**
     * Constructor method for ArrayOfResponseStatusWarning
     * @uses ArrayOfResponseStatusWarning::setResponseStatusWarning()
     * @param \StructType\ResponseStatusWarning[] $responseStatusWarning
     */
    public function __construct(array $responseStatusWarning = array())
    {
        $this
            ->setResponseStatusWarning($responseStatusWarning);
    }
    /**
     * Get ResponseStatusWarning value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ResponseStatusWarning[]|null
     */
    public function getResponseStatusWarning()
    {
        return isset($this->ResponseStatusWarning) ? $this->ResponseStatusWarning : null;
    }
    /**
     * This method is responsible for validating the values passed to the setResponseStatusWarning method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResponseStatusWarning method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResponseStatusWarningForArrayConstraintsFromSetResponseStatusWarning(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfResponseStatusWarningResponseStatusWarningItem) {
            // validation for constraint: itemType
            if (!$arrayOfResponseStatusWarningResponseStatusWarningItem instanceof \StructType\ResponseStatusWarning) {
                $invalidValues[] = is_object($arrayOfResponseStatusWarningResponseStatusWarningItem) ? get_class($arrayOfResponseStatusWarningResponseStatusWarningItem) : sprintf('%s(%s)', gettype($arrayOfResponseStatusWarningResponseStatusWarningItem), var_export($arrayOfResponseStatusWarningResponseStatusWarningItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResponseStatusWarning property can only contain items of type \StructType\ResponseStatusWarning, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResponseStatusWarning value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ResponseStatusWarning[] $responseStatusWarning
     * @return \ArrayType\ArrayOfResponseStatusWarning
     */
    public function setResponseStatusWarning(array $responseStatusWarning = array())
    {
        // validation for constraint: array
        if ('' !== ($responseStatusWarningArrayErrorMessage = self::validateResponseStatusWarningForArrayConstraintsFromSetResponseStatusWarning($responseStatusWarning))) {
            throw new \InvalidArgumentException($responseStatusWarningArrayErrorMessage, __LINE__);
        }
        if (is_null($responseStatusWarning) || (is_array($responseStatusWarning) && empty($responseStatusWarning))) {
            unset($this->ResponseStatusWarning);
        } else {
            $this->ResponseStatusWarning = $responseStatusWarning;
        }
        return $this;
    }
    /**
     * Add item to ResponseStatusWarning value
     * @throws \InvalidArgumentException
     * @param \StructType\ResponseStatusWarning $item
     * @return \ArrayType\ArrayOfResponseStatusWarning
     */
    public function addToResponseStatusWarning(\StructType\ResponseStatusWarning $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResponseStatusWarning) {
            throw new \InvalidArgumentException(sprintf('The ResponseStatusWarning property can only contain items of type \StructType\ResponseStatusWarning, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResponseStatusWarning[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ResponseStatusWarning|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ResponseStatusWarning|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ResponseStatusWarning|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ResponseStatusWarning|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ResponseStatusWarning|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResponseStatusWarning
     */
    public function getAttributeName()
    {
        return 'ResponseStatusWarning';
    }
}
