<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRouteCandidates ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRouteCandidates
 * @subpackage Arrays
 */
class ArrayOfRouteCandidates extends AbstractStructArrayBase
{
    /**
     * The RouteCandidates
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RouteCandidates[]
     */
    public $RouteCandidates;
    /**
     * Constructor method for ArrayOfRouteCandidates
     * @uses ArrayOfRouteCandidates::setRouteCandidates()
     * @param \StructType\RouteCandidates[] $routeCandidates
     */
    public function __construct(array $routeCandidates = array())
    {
        $this
            ->setRouteCandidates($routeCandidates);
    }
    /**
     * Get RouteCandidates value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RouteCandidates[]|null
     */
    public function getRouteCandidates()
    {
        return isset($this->RouteCandidates) ? $this->RouteCandidates : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRouteCandidates method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRouteCandidates method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRouteCandidatesForArrayConstraintsFromSetRouteCandidates(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRouteCandidatesRouteCandidatesItem) {
            // validation for constraint: itemType
            if (!$arrayOfRouteCandidatesRouteCandidatesItem instanceof \StructType\RouteCandidates) {
                $invalidValues[] = is_object($arrayOfRouteCandidatesRouteCandidatesItem) ? get_class($arrayOfRouteCandidatesRouteCandidatesItem) : sprintf('%s(%s)', gettype($arrayOfRouteCandidatesRouteCandidatesItem), var_export($arrayOfRouteCandidatesRouteCandidatesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RouteCandidates property can only contain items of type \StructType\RouteCandidates, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RouteCandidates value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RouteCandidates[] $routeCandidates
     * @return \ArrayType\ArrayOfRouteCandidates
     */
    public function setRouteCandidates(array $routeCandidates = array())
    {
        // validation for constraint: array
        if ('' !== ($routeCandidatesArrayErrorMessage = self::validateRouteCandidatesForArrayConstraintsFromSetRouteCandidates($routeCandidates))) {
            throw new \InvalidArgumentException($routeCandidatesArrayErrorMessage, __LINE__);
        }
        if (is_null($routeCandidates) || (is_array($routeCandidates) && empty($routeCandidates))) {
            unset($this->RouteCandidates);
        } else {
            $this->RouteCandidates = $routeCandidates;
        }
        return $this;
    }
    /**
     * Add item to RouteCandidates value
     * @throws \InvalidArgumentException
     * @param \StructType\RouteCandidates $item
     * @return \ArrayType\ArrayOfRouteCandidates
     */
    public function addToRouteCandidates(\StructType\RouteCandidates $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RouteCandidates) {
            throw new \InvalidArgumentException(sprintf('The RouteCandidates property can only contain items of type \StructType\RouteCandidates, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RouteCandidates[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RouteCandidates|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RouteCandidates|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RouteCandidates|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RouteCandidates|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RouteCandidates|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RouteCandidates
     */
    public function getAttributeName()
    {
        return 'RouteCandidates';
    }
}
