<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoutePlanDetailType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRoutePlanDetailType
 * @subpackage Arrays
 */
class ArrayOfRoutePlanDetailType extends AbstractStructArrayBase
{
    /**
     * The RoutePlanDetailType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RoutePlanDetailType[]
     */
    public $RoutePlanDetailType;
    /**
     * Constructor method for ArrayOfRoutePlanDetailType
     * @uses ArrayOfRoutePlanDetailType::setRoutePlanDetailType()
     * @param \StructType\RoutePlanDetailType[] $routePlanDetailType
     */
    public function __construct(array $routePlanDetailType = array())
    {
        $this
            ->setRoutePlanDetailType($routePlanDetailType);
    }
    /**
     * Get RoutePlanDetailType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RoutePlanDetailType[]|null
     */
    public function getRoutePlanDetailType()
    {
        return isset($this->RoutePlanDetailType) ? $this->RoutePlanDetailType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRoutePlanDetailType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoutePlanDetailType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoutePlanDetailTypeForArrayConstraintsFromSetRoutePlanDetailType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRoutePlanDetailTypeRoutePlanDetailTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoutePlanDetailTypeRoutePlanDetailTypeItem instanceof \StructType\RoutePlanDetailType) {
                $invalidValues[] = is_object($arrayOfRoutePlanDetailTypeRoutePlanDetailTypeItem) ? get_class($arrayOfRoutePlanDetailTypeRoutePlanDetailTypeItem) : sprintf('%s(%s)', gettype($arrayOfRoutePlanDetailTypeRoutePlanDetailTypeItem), var_export($arrayOfRoutePlanDetailTypeRoutePlanDetailTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoutePlanDetailType property can only contain items of type \StructType\RoutePlanDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoutePlanDetailType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RoutePlanDetailType[] $routePlanDetailType
     * @return \ArrayType\ArrayOfRoutePlanDetailType
     */
    public function setRoutePlanDetailType(array $routePlanDetailType = array())
    {
        // validation for constraint: array
        if ('' !== ($routePlanDetailTypeArrayErrorMessage = self::validateRoutePlanDetailTypeForArrayConstraintsFromSetRoutePlanDetailType($routePlanDetailType))) {
            throw new \InvalidArgumentException($routePlanDetailTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($routePlanDetailType) || (is_array($routePlanDetailType) && empty($routePlanDetailType))) {
            unset($this->RoutePlanDetailType);
        } else {
            $this->RoutePlanDetailType = $routePlanDetailType;
        }
        return $this;
    }
    /**
     * Add item to RoutePlanDetailType value
     * @throws \InvalidArgumentException
     * @param \StructType\RoutePlanDetailType $item
     * @return \ArrayType\ArrayOfRoutePlanDetailType
     */
    public function addToRoutePlanDetailType(\StructType\RoutePlanDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoutePlanDetailType) {
            throw new \InvalidArgumentException(sprintf('The RoutePlanDetailType property can only contain items of type \StructType\RoutePlanDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoutePlanDetailType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RoutePlanDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RoutePlanDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RoutePlanDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RoutePlanDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RoutePlanDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoutePlanDetailType
     */
    public function getAttributeName()
    {
        return 'RoutePlanDetailType';
    }
}
