<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfShipToDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfShipToDetails
 * @subpackage Arrays
 */
class ArrayOfShipToDetails extends AbstractStructArrayBase
{
    /**
     * The ShipToDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ShipToDetails[]
     */
    public $ShipToDetails;
    /**
     * Constructor method for ArrayOfShipToDetails
     * @uses ArrayOfShipToDetails::setShipToDetails()
     * @param \StructType\ShipToDetails[] $shipToDetails
     */
    public function __construct(array $shipToDetails = array())
    {
        $this
            ->setShipToDetails($shipToDetails);
    }
    /**
     * Get ShipToDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ShipToDetails[]|null
     */
    public function getShipToDetails()
    {
        return isset($this->ShipToDetails) ? $this->ShipToDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setShipToDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setShipToDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateShipToDetailsForArrayConstraintsFromSetShipToDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfShipToDetailsShipToDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfShipToDetailsShipToDetailsItem instanceof \StructType\ShipToDetails) {
                $invalidValues[] = is_object($arrayOfShipToDetailsShipToDetailsItem) ? get_class($arrayOfShipToDetailsShipToDetailsItem) : sprintf('%s(%s)', gettype($arrayOfShipToDetailsShipToDetailsItem), var_export($arrayOfShipToDetailsShipToDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ShipToDetails property can only contain items of type \StructType\ShipToDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ShipToDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ShipToDetails[] $shipToDetails
     * @return \ArrayType\ArrayOfShipToDetails
     */
    public function setShipToDetails(array $shipToDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($shipToDetailsArrayErrorMessage = self::validateShipToDetailsForArrayConstraintsFromSetShipToDetails($shipToDetails))) {
            throw new \InvalidArgumentException($shipToDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($shipToDetails) || (is_array($shipToDetails) && empty($shipToDetails))) {
            unset($this->ShipToDetails);
        } else {
            $this->ShipToDetails = $shipToDetails;
        }
        return $this;
    }
    /**
     * Add item to ShipToDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\ShipToDetails $item
     * @return \ArrayType\ArrayOfShipToDetails
     */
    public function addToShipToDetails(\StructType\ShipToDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ShipToDetails) {
            throw new \InvalidArgumentException(sprintf('The ShipToDetails property can only contain items of type \StructType\ShipToDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ShipToDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ShipToDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ShipToDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ShipToDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ShipToDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ShipToDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ShipToDetails
     */
    public function getAttributeName()
    {
        return 'ShipToDetails';
    }
}
