<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSignatureResource ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSignatureResource
 * @subpackage Arrays
 */
class ArrayOfSignatureResource extends AbstractStructArrayBase
{
    /**
     * The SignatureResource
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SignatureResource[]
     */
    public $SignatureResource;
    /**
     * Constructor method for ArrayOfSignatureResource
     * @uses ArrayOfSignatureResource::setSignatureResource()
     * @param \StructType\SignatureResource[] $signatureResource
     */
    public function __construct(array $signatureResource = array())
    {
        $this
            ->setSignatureResource($signatureResource);
    }
    /**
     * Get SignatureResource value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SignatureResource[]|null
     */
    public function getSignatureResource()
    {
        return isset($this->SignatureResource) ? $this->SignatureResource : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSignatureResource method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSignatureResource method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSignatureResourceForArrayConstraintsFromSetSignatureResource(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSignatureResourceSignatureResourceItem) {
            // validation for constraint: itemType
            if (!$arrayOfSignatureResourceSignatureResourceItem instanceof \StructType\SignatureResource) {
                $invalidValues[] = is_object($arrayOfSignatureResourceSignatureResourceItem) ? get_class($arrayOfSignatureResourceSignatureResourceItem) : sprintf('%s(%s)', gettype($arrayOfSignatureResourceSignatureResourceItem), var_export($arrayOfSignatureResourceSignatureResourceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SignatureResource property can only contain items of type \StructType\SignatureResource, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SignatureResource value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SignatureResource[] $signatureResource
     * @return \ArrayType\ArrayOfSignatureResource
     */
    public function setSignatureResource(array $signatureResource = array())
    {
        // validation for constraint: array
        if ('' !== ($signatureResourceArrayErrorMessage = self::validateSignatureResourceForArrayConstraintsFromSetSignatureResource($signatureResource))) {
            throw new \InvalidArgumentException($signatureResourceArrayErrorMessage, __LINE__);
        }
        if (is_null($signatureResource) || (is_array($signatureResource) && empty($signatureResource))) {
            unset($this->SignatureResource);
        } else {
            $this->SignatureResource = $signatureResource;
        }
        return $this;
    }
    /**
     * Add item to SignatureResource value
     * @throws \InvalidArgumentException
     * @param \StructType\SignatureResource $item
     * @return \ArrayType\ArrayOfSignatureResource
     */
    public function addToSignatureResource(\StructType\SignatureResource $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SignatureResource) {
            throw new \InvalidArgumentException(sprintf('The SignatureResource property can only contain items of type \StructType\SignatureResource, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SignatureResource[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SignatureResource|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SignatureResource|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SignatureResource|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SignatureResource|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SignatureResource|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SignatureResource
     */
    public function getAttributeName()
    {
        return 'SignatureResource';
    }
}
