<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStopActualDetailType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfStopActualDetailType
 * @subpackage Arrays
 */
class ArrayOfStopActualDetailType extends AbstractStructArrayBase
{
    /**
     * The StopActualDetailType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StopActualDetailType[]
     */
    public $StopActualDetailType;
    /**
     * Constructor method for ArrayOfStopActualDetailType
     * @uses ArrayOfStopActualDetailType::setStopActualDetailType()
     * @param \StructType\StopActualDetailType[] $stopActualDetailType
     */
    public function __construct(array $stopActualDetailType = array())
    {
        $this
            ->setStopActualDetailType($stopActualDetailType);
    }
    /**
     * Get StopActualDetailType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StopActualDetailType[]|null
     */
    public function getStopActualDetailType()
    {
        return isset($this->StopActualDetailType) ? $this->StopActualDetailType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setStopActualDetailType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStopActualDetailType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStopActualDetailTypeForArrayConstraintsFromSetStopActualDetailType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfStopActualDetailTypeStopActualDetailTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfStopActualDetailTypeStopActualDetailTypeItem instanceof \StructType\StopActualDetailType) {
                $invalidValues[] = is_object($arrayOfStopActualDetailTypeStopActualDetailTypeItem) ? get_class($arrayOfStopActualDetailTypeStopActualDetailTypeItem) : sprintf('%s(%s)', gettype($arrayOfStopActualDetailTypeStopActualDetailTypeItem), var_export($arrayOfStopActualDetailTypeStopActualDetailTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StopActualDetailType property can only contain items of type \StructType\StopActualDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StopActualDetailType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StopActualDetailType[] $stopActualDetailType
     * @return \ArrayType\ArrayOfStopActualDetailType
     */
    public function setStopActualDetailType(array $stopActualDetailType = array())
    {
        // validation for constraint: array
        if ('' !== ($stopActualDetailTypeArrayErrorMessage = self::validateStopActualDetailTypeForArrayConstraintsFromSetStopActualDetailType($stopActualDetailType))) {
            throw new \InvalidArgumentException($stopActualDetailTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($stopActualDetailType) || (is_array($stopActualDetailType) && empty($stopActualDetailType))) {
            unset($this->StopActualDetailType);
        } else {
            $this->StopActualDetailType = $stopActualDetailType;
        }
        return $this;
    }
    /**
     * Add item to StopActualDetailType value
     * @throws \InvalidArgumentException
     * @param \StructType\StopActualDetailType $item
     * @return \ArrayType\ArrayOfStopActualDetailType
     */
    public function addToStopActualDetailType(\StructType\StopActualDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StopActualDetailType) {
            throw new \InvalidArgumentException(sprintf('The StopActualDetailType property can only contain items of type \StructType\StopActualDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StopActualDetailType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StopActualDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StopActualDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StopActualDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StopActualDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StopActualDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StopActualDetailType
     */
    public function getAttributeName()
    {
        return 'StopActualDetailType';
    }
}
