<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfStopPlanDetailType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfStopPlanDetailType
 * @subpackage Arrays
 */
class ArrayOfStopPlanDetailType extends AbstractStructArrayBase
{
    /**
     * The StopPlanDetailType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StopPlanDetailType[]
     */
    public $StopPlanDetailType;
    /**
     * Constructor method for ArrayOfStopPlanDetailType
     * @uses ArrayOfStopPlanDetailType::setStopPlanDetailType()
     * @param \StructType\StopPlanDetailType[] $stopPlanDetailType
     */
    public function __construct(array $stopPlanDetailType = array())
    {
        $this
            ->setStopPlanDetailType($stopPlanDetailType);
    }
    /**
     * Get StopPlanDetailType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StopPlanDetailType[]|null
     */
    public function getStopPlanDetailType()
    {
        return isset($this->StopPlanDetailType) ? $this->StopPlanDetailType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setStopPlanDetailType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStopPlanDetailType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateStopPlanDetailTypeForArrayConstraintsFromSetStopPlanDetailType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfStopPlanDetailTypeStopPlanDetailTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfStopPlanDetailTypeStopPlanDetailTypeItem instanceof \StructType\StopPlanDetailType) {
                $invalidValues[] = is_object($arrayOfStopPlanDetailTypeStopPlanDetailTypeItem) ? get_class($arrayOfStopPlanDetailTypeStopPlanDetailTypeItem) : sprintf('%s(%s)', gettype($arrayOfStopPlanDetailTypeStopPlanDetailTypeItem), var_export($arrayOfStopPlanDetailTypeStopPlanDetailTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The StopPlanDetailType property can only contain items of type \StructType\StopPlanDetailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set StopPlanDetailType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\StopPlanDetailType[] $stopPlanDetailType
     * @return \ArrayType\ArrayOfStopPlanDetailType
     */
    public function setStopPlanDetailType(array $stopPlanDetailType = array())
    {
        // validation for constraint: array
        if ('' !== ($stopPlanDetailTypeArrayErrorMessage = self::validateStopPlanDetailTypeForArrayConstraintsFromSetStopPlanDetailType($stopPlanDetailType))) {
            throw new \InvalidArgumentException($stopPlanDetailTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($stopPlanDetailType) || (is_array($stopPlanDetailType) && empty($stopPlanDetailType))) {
            unset($this->StopPlanDetailType);
        } else {
            $this->StopPlanDetailType = $stopPlanDetailType;
        }
        return $this;
    }
    /**
     * Add item to StopPlanDetailType value
     * @throws \InvalidArgumentException
     * @param \StructType\StopPlanDetailType $item
     * @return \ArrayType\ArrayOfStopPlanDetailType
     */
    public function addToStopPlanDetailType(\StructType\StopPlanDetailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\StopPlanDetailType) {
            throw new \InvalidArgumentException(sprintf('The StopPlanDetailType property can only contain items of type \StructType\StopPlanDetailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->StopPlanDetailType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\StopPlanDetailType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\StopPlanDetailType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\StopPlanDetailType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\StopPlanDetailType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\StopPlanDetailType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StopPlanDetailType
     */
    public function getAttributeName()
    {
        return 'StopPlanDetailType';
    }
}
