<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSuggestRoutesOrder ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSuggestRoutesOrder
 * @subpackage Arrays
 */
class ArrayOfSuggestRoutesOrder extends AbstractStructArrayBase
{
    /**
     * The SuggestRoutesOrder
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SuggestRoutesOrder[]
     */
    public $SuggestRoutesOrder;
    /**
     * Constructor method for ArrayOfSuggestRoutesOrder
     * @uses ArrayOfSuggestRoutesOrder::setSuggestRoutesOrder()
     * @param \StructType\SuggestRoutesOrder[] $suggestRoutesOrder
     */
    public function __construct(array $suggestRoutesOrder = array())
    {
        $this
            ->setSuggestRoutesOrder($suggestRoutesOrder);
    }
    /**
     * Get SuggestRoutesOrder value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SuggestRoutesOrder[]|null
     */
    public function getSuggestRoutesOrder()
    {
        return isset($this->SuggestRoutesOrder) ? $this->SuggestRoutesOrder : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSuggestRoutesOrder method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuggestRoutesOrder method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSuggestRoutesOrderForArrayConstraintsFromSetSuggestRoutesOrder(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSuggestRoutesOrderSuggestRoutesOrderItem) {
            // validation for constraint: itemType
            if (!$arrayOfSuggestRoutesOrderSuggestRoutesOrderItem instanceof \StructType\SuggestRoutesOrder) {
                $invalidValues[] = is_object($arrayOfSuggestRoutesOrderSuggestRoutesOrderItem) ? get_class($arrayOfSuggestRoutesOrderSuggestRoutesOrderItem) : sprintf('%s(%s)', gettype($arrayOfSuggestRoutesOrderSuggestRoutesOrderItem), var_export($arrayOfSuggestRoutesOrderSuggestRoutesOrderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SuggestRoutesOrder property can only contain items of type \StructType\SuggestRoutesOrder, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SuggestRoutesOrder value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SuggestRoutesOrder[] $suggestRoutesOrder
     * @return \ArrayType\ArrayOfSuggestRoutesOrder
     */
    public function setSuggestRoutesOrder(array $suggestRoutesOrder = array())
    {
        // validation for constraint: array
        if ('' !== ($suggestRoutesOrderArrayErrorMessage = self::validateSuggestRoutesOrderForArrayConstraintsFromSetSuggestRoutesOrder($suggestRoutesOrder))) {
            throw new \InvalidArgumentException($suggestRoutesOrderArrayErrorMessage, __LINE__);
        }
        if (is_null($suggestRoutesOrder) || (is_array($suggestRoutesOrder) && empty($suggestRoutesOrder))) {
            unset($this->SuggestRoutesOrder);
        } else {
            $this->SuggestRoutesOrder = $suggestRoutesOrder;
        }
        return $this;
    }
    /**
     * Add item to SuggestRoutesOrder value
     * @throws \InvalidArgumentException
     * @param \StructType\SuggestRoutesOrder $item
     * @return \ArrayType\ArrayOfSuggestRoutesOrder
     */
    public function addToSuggestRoutesOrder(\StructType\SuggestRoutesOrder $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SuggestRoutesOrder) {
            throw new \InvalidArgumentException(sprintf('The SuggestRoutesOrder property can only contain items of type \StructType\SuggestRoutesOrder, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SuggestRoutesOrder[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SuggestRoutesOrder|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SuggestRoutesOrder|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SuggestRoutesOrder|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SuggestRoutesOrder|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SuggestRoutesOrder|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SuggestRoutesOrder
     */
    public function getAttributeName()
    {
        return 'SuggestRoutesOrder';
    }
}
