<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTQtyFields ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTQtyFields
 * @subpackage Arrays
 */
class ArrayOfTQtyFields extends AbstractStructArrayBase
{
    /**
     * The TQtyFields
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TQtyFields[]
     */
    public $TQtyFields;
    /**
     * Constructor method for ArrayOfTQtyFields
     * @uses ArrayOfTQtyFields::setTQtyFields()
     * @param \StructType\TQtyFields[] $tQtyFields
     */
    public function __construct(array $tQtyFields = array())
    {
        $this
            ->setTQtyFields($tQtyFields);
    }
    /**
     * Get TQtyFields value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TQtyFields[]|null
     */
    public function getTQtyFields()
    {
        return isset($this->TQtyFields) ? $this->TQtyFields : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTQtyFields method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTQtyFields method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTQtyFieldsForArrayConstraintsFromSetTQtyFields(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTQtyFieldsTQtyFieldsItem) {
            // validation for constraint: itemType
            if (!$arrayOfTQtyFieldsTQtyFieldsItem instanceof \StructType\TQtyFields) {
                $invalidValues[] = is_object($arrayOfTQtyFieldsTQtyFieldsItem) ? get_class($arrayOfTQtyFieldsTQtyFieldsItem) : sprintf('%s(%s)', gettype($arrayOfTQtyFieldsTQtyFieldsItem), var_export($arrayOfTQtyFieldsTQtyFieldsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TQtyFields property can only contain items of type \StructType\TQtyFields, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TQtyFields value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TQtyFields[] $tQtyFields
     * @return \ArrayType\ArrayOfTQtyFields
     */
    public function setTQtyFields(array $tQtyFields = array())
    {
        // validation for constraint: array
        if ('' !== ($tQtyFieldsArrayErrorMessage = self::validateTQtyFieldsForArrayConstraintsFromSetTQtyFields($tQtyFields))) {
            throw new \InvalidArgumentException($tQtyFieldsArrayErrorMessage, __LINE__);
        }
        if (is_null($tQtyFields) || (is_array($tQtyFields) && empty($tQtyFields))) {
            unset($this->TQtyFields);
        } else {
            $this->TQtyFields = $tQtyFields;
        }
        return $this;
    }
    /**
     * Add item to TQtyFields value
     * @throws \InvalidArgumentException
     * @param \StructType\TQtyFields $item
     * @return \ArrayType\ArrayOfTQtyFields
     */
    public function addToTQtyFields(\StructType\TQtyFields $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TQtyFields) {
            throw new \InvalidArgumentException(sprintf('The TQtyFields property can only contain items of type \StructType\TQtyFields, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TQtyFields[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TQtyFields|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TQtyFields|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TQtyFields|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TQtyFields|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TQtyFields|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TQtyFields
     */
    public function getAttributeName()
    {
        return 'TQtyFields';
    }
}
