<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTUserFieldList ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTUserFieldList
 * @subpackage Arrays
 */
class ArrayOfTUserFieldList extends AbstractStructArrayBase
{
    /**
     * The TUserFieldList
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TUserFieldList[]
     */
    public $TUserFieldList;
    /**
     * Constructor method for ArrayOfTUserFieldList
     * @uses ArrayOfTUserFieldList::setTUserFieldList()
     * @param \StructType\TUserFieldList[] $tUserFieldList
     */
    public function __construct(array $tUserFieldList = array())
    {
        $this
            ->setTUserFieldList($tUserFieldList);
    }
    /**
     * Get TUserFieldList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TUserFieldList[]|null
     */
    public function getTUserFieldList()
    {
        return isset($this->TUserFieldList) ? $this->TUserFieldList : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTUserFieldList method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTUserFieldList method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTUserFieldListForArrayConstraintsFromSetTUserFieldList(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTUserFieldListTUserFieldListItem) {
            // validation for constraint: itemType
            if (!$arrayOfTUserFieldListTUserFieldListItem instanceof \StructType\TUserFieldList) {
                $invalidValues[] = is_object($arrayOfTUserFieldListTUserFieldListItem) ? get_class($arrayOfTUserFieldListTUserFieldListItem) : sprintf('%s(%s)', gettype($arrayOfTUserFieldListTUserFieldListItem), var_export($arrayOfTUserFieldListTUserFieldListItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TUserFieldList property can only contain items of type \StructType\TUserFieldList, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TUserFieldList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TUserFieldList[] $tUserFieldList
     * @return \ArrayType\ArrayOfTUserFieldList
     */
    public function setTUserFieldList(array $tUserFieldList = array())
    {
        // validation for constraint: array
        if ('' !== ($tUserFieldListArrayErrorMessage = self::validateTUserFieldListForArrayConstraintsFromSetTUserFieldList($tUserFieldList))) {
            throw new \InvalidArgumentException($tUserFieldListArrayErrorMessage, __LINE__);
        }
        if (is_null($tUserFieldList) || (is_array($tUserFieldList) && empty($tUserFieldList))) {
            unset($this->TUserFieldList);
        } else {
            $this->TUserFieldList = $tUserFieldList;
        }
        return $this;
    }
    /**
     * Add item to TUserFieldList value
     * @throws \InvalidArgumentException
     * @param \StructType\TUserFieldList $item
     * @return \ArrayType\ArrayOfTUserFieldList
     */
    public function addToTUserFieldList(\StructType\TUserFieldList $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TUserFieldList) {
            throw new \InvalidArgumentException(sprintf('The TUserFieldList property can only contain items of type \StructType\TUserFieldList, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TUserFieldList[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TUserFieldList|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TUserFieldList|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TUserFieldList|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TUserFieldList|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TUserFieldList|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TUserFieldList
     */
    public function getAttributeName()
    {
        return 'TUserFieldList';
    }
}
