<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTimeWindowType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTimeWindowType
 * @subpackage Arrays
 */
class ArrayOfTimeWindowType extends AbstractStructArrayBase
{
    /**
     * The TimeWindowType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TimeWindowType[]
     */
    public $TimeWindowType;
    /**
     * Constructor method for ArrayOfTimeWindowType
     * @uses ArrayOfTimeWindowType::setTimeWindowType()
     * @param \StructType\TimeWindowType[] $timeWindowType
     */
    public function __construct(array $timeWindowType = array())
    {
        $this
            ->setTimeWindowType($timeWindowType);
    }
    /**
     * Get TimeWindowType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TimeWindowType[]|null
     */
    public function getTimeWindowType()
    {
        return isset($this->TimeWindowType) ? $this->TimeWindowType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTimeWindowType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTimeWindowType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTimeWindowTypeForArrayConstraintsFromSetTimeWindowType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTimeWindowTypeTimeWindowTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfTimeWindowTypeTimeWindowTypeItem instanceof \StructType\TimeWindowType) {
                $invalidValues[] = is_object($arrayOfTimeWindowTypeTimeWindowTypeItem) ? get_class($arrayOfTimeWindowTypeTimeWindowTypeItem) : sprintf('%s(%s)', gettype($arrayOfTimeWindowTypeTimeWindowTypeItem), var_export($arrayOfTimeWindowTypeTimeWindowTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TimeWindowType property can only contain items of type \StructType\TimeWindowType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TimeWindowType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TimeWindowType[] $timeWindowType
     * @return \ArrayType\ArrayOfTimeWindowType
     */
    public function setTimeWindowType(array $timeWindowType = array())
    {
        // validation for constraint: array
        if ('' !== ($timeWindowTypeArrayErrorMessage = self::validateTimeWindowTypeForArrayConstraintsFromSetTimeWindowType($timeWindowType))) {
            throw new \InvalidArgumentException($timeWindowTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($timeWindowType) || (is_array($timeWindowType) && empty($timeWindowType))) {
            unset($this->TimeWindowType);
        } else {
            $this->TimeWindowType = $timeWindowType;
        }
        return $this;
    }
    /**
     * Add item to TimeWindowType value
     * @throws \InvalidArgumentException
     * @param \StructType\TimeWindowType $item
     * @return \ArrayType\ArrayOfTimeWindowType
     */
    public function addToTimeWindowType(\StructType\TimeWindowType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TimeWindowType) {
            throw new \InvalidArgumentException(sprintf('The TimeWindowType property can only contain items of type \StructType\TimeWindowType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TimeWindowType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TimeWindowType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TimeWindowType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TimeWindowType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TimeWindowType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TimeWindowType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TimeWindowType
     */
    public function getAttributeName()
    {
        return 'TimeWindowType';
    }
}
