<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTruckMasterType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTruckMasterType
 * @subpackage Arrays
 */
class ArrayOfTruckMasterType extends AbstractStructArrayBase
{
    /**
     * The TruckMasterType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TruckMasterType[]
     */
    public $TruckMasterType;
    /**
     * Constructor method for ArrayOfTruckMasterType
     * @uses ArrayOfTruckMasterType::setTruckMasterType()
     * @param \StructType\TruckMasterType[] $truckMasterType
     */
    public function __construct(array $truckMasterType = array())
    {
        $this
            ->setTruckMasterType($truckMasterType);
    }
    /**
     * Get TruckMasterType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TruckMasterType[]|null
     */
    public function getTruckMasterType()
    {
        return isset($this->TruckMasterType) ? $this->TruckMasterType : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTruckMasterType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTruckMasterType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTruckMasterTypeForArrayConstraintsFromSetTruckMasterType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTruckMasterTypeTruckMasterTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfTruckMasterTypeTruckMasterTypeItem instanceof \StructType\TruckMasterType) {
                $invalidValues[] = is_object($arrayOfTruckMasterTypeTruckMasterTypeItem) ? get_class($arrayOfTruckMasterTypeTruckMasterTypeItem) : sprintf('%s(%s)', gettype($arrayOfTruckMasterTypeTruckMasterTypeItem), var_export($arrayOfTruckMasterTypeTruckMasterTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TruckMasterType property can only contain items of type \StructType\TruckMasterType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TruckMasterType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TruckMasterType[] $truckMasterType
     * @return \ArrayType\ArrayOfTruckMasterType
     */
    public function setTruckMasterType(array $truckMasterType = array())
    {
        // validation for constraint: array
        if ('' !== ($truckMasterTypeArrayErrorMessage = self::validateTruckMasterTypeForArrayConstraintsFromSetTruckMasterType($truckMasterType))) {
            throw new \InvalidArgumentException($truckMasterTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($truckMasterType) || (is_array($truckMasterType) && empty($truckMasterType))) {
            unset($this->TruckMasterType);
        } else {
            $this->TruckMasterType = $truckMasterType;
        }
        return $this;
    }
    /**
     * Add item to TruckMasterType value
     * @throws \InvalidArgumentException
     * @param \StructType\TruckMasterType $item
     * @return \ArrayType\ArrayOfTruckMasterType
     */
    public function addToTruckMasterType(\StructType\TruckMasterType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TruckMasterType) {
            throw new \InvalidArgumentException(sprintf('The TruckMasterType property can only contain items of type \StructType\TruckMasterType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TruckMasterType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TruckMasterType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TruckMasterType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TruckMasterType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TruckMasterType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TruckMasterType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TruckMasterType
     */
    public function getAttributeName()
    {
        return 'TruckMasterType';
    }
}
