<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUserFieldListUserField ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUserFieldListUserField
 * @subpackage Arrays
 */
class ArrayOfUserFieldListUserField extends AbstractStructArrayBase
{
    /**
     * The UserFieldListUserField
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UserFieldListUserField[]
     */
    public $UserFieldListUserField;
    /**
     * Constructor method for ArrayOfUserFieldListUserField
     * @uses ArrayOfUserFieldListUserField::setUserFieldListUserField()
     * @param \StructType\UserFieldListUserField[] $userFieldListUserField
     */
    public function __construct(array $userFieldListUserField = array())
    {
        $this
            ->setUserFieldListUserField($userFieldListUserField);
    }
    /**
     * Get UserFieldListUserField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UserFieldListUserField[]|null
     */
    public function getUserFieldListUserField()
    {
        return isset($this->UserFieldListUserField) ? $this->UserFieldListUserField : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUserFieldListUserField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserFieldListUserField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserFieldListUserFieldForArrayConstraintsFromSetUserFieldListUserField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUserFieldListUserFieldUserFieldListUserFieldItem) {
            // validation for constraint: itemType
            if (!$arrayOfUserFieldListUserFieldUserFieldListUserFieldItem instanceof \StructType\UserFieldListUserField) {
                $invalidValues[] = is_object($arrayOfUserFieldListUserFieldUserFieldListUserFieldItem) ? get_class($arrayOfUserFieldListUserFieldUserFieldListUserFieldItem) : sprintf('%s(%s)', gettype($arrayOfUserFieldListUserFieldUserFieldListUserFieldItem), var_export($arrayOfUserFieldListUserFieldUserFieldListUserFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserFieldListUserField property can only contain items of type \StructType\UserFieldListUserField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserFieldListUserField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UserFieldListUserField[] $userFieldListUserField
     * @return \ArrayType\ArrayOfUserFieldListUserField
     */
    public function setUserFieldListUserField(array $userFieldListUserField = array())
    {
        // validation for constraint: array
        if ('' !== ($userFieldListUserFieldArrayErrorMessage = self::validateUserFieldListUserFieldForArrayConstraintsFromSetUserFieldListUserField($userFieldListUserField))) {
            throw new \InvalidArgumentException($userFieldListUserFieldArrayErrorMessage, __LINE__);
        }
        if (is_null($userFieldListUserField) || (is_array($userFieldListUserField) && empty($userFieldListUserField))) {
            unset($this->UserFieldListUserField);
        } else {
            $this->UserFieldListUserField = $userFieldListUserField;
        }
        return $this;
    }
    /**
     * Add item to UserFieldListUserField value
     * @throws \InvalidArgumentException
     * @param \StructType\UserFieldListUserField $item
     * @return \ArrayType\ArrayOfUserFieldListUserField
     */
    public function addToUserFieldListUserField(\StructType\UserFieldListUserField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UserFieldListUserField) {
            throw new \InvalidArgumentException(sprintf('The UserFieldListUserField property can only contain items of type \StructType\UserFieldListUserField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserFieldListUserField[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UserFieldListUserField|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UserFieldListUserField|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UserFieldListUserField|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UserFieldListUserField|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UserFieldListUserField|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UserFieldListUserField
     */
    public function getAttributeName()
    {
        return 'UserFieldListUserField';
    }
}
