<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViolationsTypeLeg ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViolationsTypeLeg
 * @subpackage Arrays
 */
class ArrayOfViolationsTypeLeg extends AbstractStructArrayBase
{
    /**
     * The ViolationsTypeLeg
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViolationsTypeLeg[]
     */
    public $ViolationsTypeLeg;
    /**
     * Constructor method for ArrayOfViolationsTypeLeg
     * @uses ArrayOfViolationsTypeLeg::setViolationsTypeLeg()
     * @param \StructType\ViolationsTypeLeg[] $violationsTypeLeg
     */
    public function __construct(array $violationsTypeLeg = array())
    {
        $this
            ->setViolationsTypeLeg($violationsTypeLeg);
    }
    /**
     * Get ViolationsTypeLeg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViolationsTypeLeg[]|null
     */
    public function getViolationsTypeLeg()
    {
        return isset($this->ViolationsTypeLeg) ? $this->ViolationsTypeLeg : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViolationsTypeLeg method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViolationsTypeLeg method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViolationsTypeLegForArrayConstraintsFromSetViolationsTypeLeg(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViolationsTypeLegViolationsTypeLegItem) {
            // validation for constraint: itemType
            if (!$arrayOfViolationsTypeLegViolationsTypeLegItem instanceof \StructType\ViolationsTypeLeg) {
                $invalidValues[] = is_object($arrayOfViolationsTypeLegViolationsTypeLegItem) ? get_class($arrayOfViolationsTypeLegViolationsTypeLegItem) : sprintf('%s(%s)', gettype($arrayOfViolationsTypeLegViolationsTypeLegItem), var_export($arrayOfViolationsTypeLegViolationsTypeLegItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViolationsTypeLeg property can only contain items of type \StructType\ViolationsTypeLeg, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViolationsTypeLeg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViolationsTypeLeg[] $violationsTypeLeg
     * @return \ArrayType\ArrayOfViolationsTypeLeg
     */
    public function setViolationsTypeLeg(array $violationsTypeLeg = array())
    {
        // validation for constraint: array
        if ('' !== ($violationsTypeLegArrayErrorMessage = self::validateViolationsTypeLegForArrayConstraintsFromSetViolationsTypeLeg($violationsTypeLeg))) {
            throw new \InvalidArgumentException($violationsTypeLegArrayErrorMessage, __LINE__);
        }
        if (is_null($violationsTypeLeg) || (is_array($violationsTypeLeg) && empty($violationsTypeLeg))) {
            unset($this->ViolationsTypeLeg);
        } else {
            $this->ViolationsTypeLeg = $violationsTypeLeg;
        }
        return $this;
    }
    /**
     * Add item to ViolationsTypeLeg value
     * @throws \InvalidArgumentException
     * @param \StructType\ViolationsTypeLeg $item
     * @return \ArrayType\ArrayOfViolationsTypeLeg
     */
    public function addToViolationsTypeLeg(\StructType\ViolationsTypeLeg $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViolationsTypeLeg) {
            throw new \InvalidArgumentException(sprintf('The ViolationsTypeLeg property can only contain items of type \StructType\ViolationsTypeLeg, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViolationsTypeLeg[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViolationsTypeLeg|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViolationsTypeLeg|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViolationsTypeLeg|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViolationsTypeLeg|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViolationsTypeLeg|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViolationsTypeLeg
     */
    public function getAttributeName()
    {
        return 'ViolationsTypeLeg';
    }
}
