<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetAuthenticationToken' => '\\StructType\\GetAuthenticationToken',
            'GetAuthenticationTokenResponse' => '\\StructType\\GetAuthenticationTokenResponse',
            'GetBranches' => '\\StructType\\GetBranches',
            'GetBranchesResponse' => '\\StructType\\GetBranchesResponse',
            'GetForms' => '\\StructType\\GetForms',
            'GetFormsResponse' => '\\StructType\\GetFormsResponse',
            'GetRouteSummaryByPlannedStartDate' => '\\StructType\\GetRouteSummaryByPlannedStartDate',
            'GetRouteSummaryByPlannedStartDateResponse' => '\\StructType\\GetRouteSummaryByPlannedStartDateResponse',
            'GetRouteDetailByPlannedStartDate' => '\\StructType\\GetRouteDetailByPlannedStartDate',
            'GetRouteDetailByPlannedStartDateResponse' => '\\StructType\\GetRouteDetailByPlannedStartDateResponse',
            'GetRouteDetailByModifiedDate' => '\\StructType\\GetRouteDetailByModifiedDate',
            'GetRouteDetailByModifiedDateResponse' => '\\StructType\\GetRouteDetailByModifiedDateResponse',
            'GetRouteDetailAndBranchIdByModifiedDate' => '\\StructType\\GetRouteDetailAndBranchIdByModifiedDate',
            'GetRouteDetailAndBranchIdByModifiedDateResponse' => '\\StructType\\GetRouteDetailAndBranchIdByModifiedDateResponse',
            'GetRouteDetailByDateRange' => '\\StructType\\GetRouteDetailByDateRange',
            'GetRouteDetailByDateRangeResponse' => '\\StructType\\GetRouteDetailByDateRangeResponse',
            'GetOrderDetailByDate' => '\\StructType\\GetOrderDetailByDate',
            'GetOrderDetailByDateResponse' => '\\StructType\\GetOrderDetailByDateResponse',
            'GetOrderDetailByModifiedDate' => '\\StructType\\GetOrderDetailByModifiedDate',
            'GetOrderDetailByModifiedDateResponse' => '\\StructType\\GetOrderDetailByModifiedDateResponse',
            'GetOrderDetailsByModifiedDateAndBranchIds' => '\\StructType\\GetOrderDetailsByModifiedDateAndBranchIds',
            'GetOrderDetailsByModifiedDateAndBranchIdsResponse' => '\\StructType\\GetOrderDetailsByModifiedDateAndBranchIdsResponse',
            'GetUserAndQuantityFields' => '\\StructType\\GetUserAndQuantityFields',
            'GetUserAndQuantityFieldsResponse' => '\\StructType\\GetUserAndQuantityFieldsResponse',
            'ImportActuals' => '\\StructType\\ImportActuals',
            'ImportActualsResponse' => '\\StructType\\ImportActualsResponse',
            'ImportActualsFromMultipleBranches' => '\\StructType\\ImportActualsFromMultipleBranches',
            'ImportActualsFromMultipleBranchesResponse' => '\\StructType\\ImportActualsFromMultipleBranchesResponse',
            'GetAccountDetailsByBranch' => '\\StructType\\GetAccountDetailsByBranch',
            'GetAccountDetailsByBranchResponse' => '\\StructType\\GetAccountDetailsByBranchResponse',
            'BuildRouteFromOrderIds' => '\\StructType\\BuildRouteFromOrderIds',
            'BuildRouteFromOrderIdsResponse' => '\\StructType\\BuildRouteFromOrderIdsResponse',
            'UnloadOrders' => '\\StructType\\UnloadOrders',
            'UnloadOrdersResponse' => '\\StructType\\UnloadOrdersResponse',
            'AddOrders' => '\\StructType\\AddOrders',
            'AddOrdersResponse' => '\\StructType\\AddOrdersResponse',
            'LockStops' => '\\StructType\\LockStops',
            'LockStopsResponse' => '\\StructType\\LockStopsResponse',
            'UnlockStops' => '\\StructType\\UnlockStops',
            'UnlockStopsResponse' => '\\StructType\\UnlockStopsResponse',
            'GetAccountDetailsByModifiedDateAndBranch' => '\\StructType\\GetAccountDetailsByModifiedDateAndBranch',
            'GetAccountDetailsByModifiedDateAndBranchResponse' => '\\StructType\\GetAccountDetailsByModifiedDateAndBranchResponse',
            'ImportOrders' => '\\StructType\\ImportOrders',
            'ImportOrdersResponse' => '\\StructType\\ImportOrdersResponse',
            'ImportExtractFile' => '\\StructType\\ImportExtractFile',
            'ImportExtractFileResponse' => '\\StructType\\ImportExtractFileResponse',
            'ImportRoutes' => '\\StructType\\ImportRoutes',
            'ImportRoutesResponse' => '\\StructType\\ImportRoutesResponse',
            'ImportDrivers' => '\\StructType\\ImportDrivers',
            'ImportDriversResponse' => '\\StructType\\ImportDriversResponse',
            'ImportDevices' => '\\StructType\\ImportDevices',
            'ImportDevicesResponse' => '\\StructType\\ImportDevicesResponse',
            'SuggestRoutes' => '\\StructType\\SuggestRoutes',
            'SuggestRoutesResponse' => '\\StructType\\SuggestRoutesResponse',
            'GetOrderDetailsByOrderIds' => '\\StructType\\GetOrderDetailsByOrderIds',
            'GetOrderDetailsByOrderIdsResponse' => '\\StructType\\GetOrderDetailsByOrderIdsResponse',
            'GetOrderDetailsAndEventsByOrderIDs' => '\\StructType\\GetOrderDetailsAndEventsByOrderIDs',
            'GetOrderDetailsAndEventsByOrderIDsResponse' => '\\StructType\\GetOrderDetailsAndEventsByOrderIDsResponse',
            'GetOrderEventsByTypeAndDate' => '\\StructType\\GetOrderEventsByTypeAndDate',
            'GetOrderEventsByTypeAndDateResponse' => '\\StructType\\GetOrderEventsByTypeAndDateResponse',
            'ImportAccounts' => '\\StructType\\ImportAccounts',
            'ImportAccountsResponse' => '\\StructType\\ImportAccountsResponse',
            'ExportAccounts' => '\\StructType\\ExportAccounts',
            'ExportAccountsResponse' => '\\StructType\\ExportAccountsResponse',
            'ChangeAccountFrequency' => '\\StructType\\ChangeAccountFrequency',
            'ChangeAccountFrequencyResponse' => '\\StructType\\ChangeAccountFrequencyResponse',
            'GetMasterRoutes' => '\\StructType\\GetMasterRoutes',
            'GetMasterRoutesResponse' => '\\StructType\\GetMasterRoutesResponse',
            'ImportBranches' => '\\StructType\\ImportBranches',
            'ImportBranchesResponse' => '\\StructType\\ImportBranchesResponse',
            'GetTruckProfiles' => '\\StructType\\GetTruckProfiles',
            'GetTruckProfilesResponse' => '\\StructType\\GetTruckProfilesResponse',
            'GetMaxRouteDetailByBranchAndDispatchDate' => '\\StructType\\GetMaxRouteDetailByBranchAndDispatchDate',
            'GetMaxRouteDetailByBranchAndDispatchDateResponse' => '\\StructType\\GetMaxRouteDetailByBranchAndDispatchDateResponse',
            'ImportAssets' => '\\StructType\\ImportAssets',
            'ImportAssetsResponse' => '\\StructType\\ImportAssetsResponse',
            'TransferAssets' => '\\StructType\\TransferAssets',
            'TransferAssetsResponse' => '\\StructType\\TransferAssetsResponse',
            'DecommissionAssets' => '\\StructType\\DecommissionAssets',
            'DecommissionAssetsResponse' => '\\StructType\\DecommissionAssetsResponse',
            'ImportCostingRules' => '\\StructType\\ImportCostingRules',
            'ImportCostingRulesResponse' => '\\StructType\\ImportCostingRulesResponse',
            'GetCostingRulesByBranch' => '\\StructType\\GetCostingRulesByBranch',
            'GetCostingRulesByBranchResponse' => '\\StructType\\GetCostingRulesByBranchResponse',
            'UpdateAccountEmailEvents' => '\\StructType\\UpdateAccountEmailEvents',
            'UpdateAccountEmailEventsResponse' => '\\StructType\\UpdateAccountEmailEventsResponse',
            'AuthenticationResponseEnvelope' => '\\StructType\\AuthenticationResponseEnvelope',
            'Authentication' => '\\StructType\\Authentication',
            'ResponseStatus' => '\\StructType\\ResponseStatus',
            'ArrayOfResponseStatusError' => '\\ArrayType\\ArrayOfResponseStatusError',
            'ResponseStatusError' => '\\StructType\\ResponseStatusError',
            'ArrayOfResponseStatusWarning' => '\\ArrayType\\ArrayOfResponseStatusWarning',
            'ResponseStatusWarning' => '\\StructType\\ResponseStatusWarning',
            'BranchResponseEnvelope' => '\\StructType\\BranchResponseEnvelope',
            'ArrayOfBranchListBranch' => '\\ArrayType\\ArrayOfBranchListBranch',
            'BranchListBranch' => '\\StructType\\BranchListBranch',
            'FormResponseEnvelope' => '\\StructType\\FormResponseEnvelope',
            'ArrayOfFormDetailListFormDetail' => '\\ArrayType\\ArrayOfFormDetailListFormDetail',
            'FormDetailListFormDetail' => '\\StructType\\FormDetailListFormDetail',
            'ArrayOfFormItemType' => '\\ArrayType\\ArrayOfFormItemType',
            'FormItemType' => '\\StructType\\FormItemType',
            'RouteSummaryRequestEnvelope' => '\\StructType\\RouteSummaryRequestEnvelope',
            'RouteSummaryReturnOptions' => '\\StructType\\RouteSummaryReturnOptions',
            'RouteSummaryReturnOptionsFilters' => '\\StructType\\RouteSummaryReturnOptionsFilters',
            'RouteSummaryResponseEnvelope' => '\\StructType\\RouteSummaryResponseEnvelope',
            'PaginationByDateRange' => '\\StructType\\PaginationByDateRange',
            'ArrayOfRouteSummaryResponseEnvelopeRouteSummary' => '\\ArrayType\\ArrayOfRouteSummaryResponseEnvelopeRouteSummary',
            'RouteSummaryResponseEnvelopeRouteSummary' => '\\StructType\\RouteSummaryResponseEnvelopeRouteSummary',
            'RouteActualSummaryType' => '\\StructType\\RouteActualSummaryType',
            'RoutePlanSummaryType' => '\\StructType\\RoutePlanSummaryType',
            'RoutePreassignmentSummaryType' => '\\StructType\\RoutePreassignmentSummaryType',
            'RouteDetailRequestEnvelope' => '\\StructType\\RouteDetailRequestEnvelope',
            'RouteDetailReturnOptions' => '\\StructType\\RouteDetailReturnOptions',
            'RouteDetailReturnOptionsFilters' => '\\StructType\\RouteDetailReturnOptionsFilters',
            'RouteDetailResponseEnvelope' => '\\StructType\\RouteDetailResponseEnvelope',
            'ArrayOfRouteDetailResponseEnvelopeRouteDetail' => '\\ArrayType\\ArrayOfRouteDetailResponseEnvelopeRouteDetail',
            'RouteDetailResponseEnvelopeRouteDetail' => '\\StructType\\RouteDetailResponseEnvelopeRouteDetail',
            'RouteActualDetailType' => '\\StructType\\RouteActualDetailType',
            'ArrayOfGPSPointDetailType' => '\\ArrayType\\ArrayOfGPSPointDetailType',
            'GPSPointDetailType' => '\\StructType\\GPSPointDetailType',
            'Coordinates' => '\\StructType\\Coordinates',
            'ArrayOfRouteFormsDetailType' => '\\ArrayType\\ArrayOfRouteFormsDetailType',
            'RouteFormsDetailType' => '\\StructType\\RouteFormsDetailType',
            'ArrayOfStopActualDetailType' => '\\ArrayType\\ArrayOfStopActualDetailType',
            'StopActualDetailType' => '\\StructType\\StopActualDetailType',
            'ArrayOfOrderDetailActualDetailType' => '\\ArrayType\\ArrayOfOrderDetailActualDetailType',
            'OrderDetailActualDetailType' => '\\StructType\\OrderDetailActualDetailType',
            'ArrayOfLineItemDetailActualType' => '\\ArrayType\\ArrayOfLineItemDetailActualType',
            'LineItemDetailActualType' => '\\StructType\\LineItemDetailActualType',
            'LineItemActualType' => '\\StructType\\LineItemActualType',
            'LineItemBaseType' => '\\StructType\\LineItemBaseType',
            'ArrayOfQuantityFieldListQuantityField' => '\\ArrayType\\ArrayOfQuantityFieldListQuantityField',
            'QuantityFieldListQuantityField' => '\\StructType\\QuantityFieldListQuantityField',
            'ArrayOfFormListForm' => '\\ArrayType\\ArrayOfFormListForm',
            'FormListForm' => '\\StructType\\FormListForm',
            'ArrayOfPhotoResource' => '\\ArrayType\\ArrayOfPhotoResource',
            'PhotoResource' => '\\StructType\\PhotoResource',
            'Resource' => '\\StructType\\_Resource',
            'ArrayOfSignatureResource' => '\\ArrayType\\ArrayOfSignatureResource',
            'SignatureResource' => '\\StructType\\SignatureResource',
            'RoutePlanDetailType' => '\\StructType\\RoutePlanDetailType',
            'ArrayOfStopPlanDetailType' => '\\ArrayType\\ArrayOfStopPlanDetailType',
            'StopPlanDetailType' => '\\StructType\\StopPlanDetailType',
            'ArrayOfTimeWindowType' => '\\ArrayType\\ArrayOfTimeWindowType',
            'TimeWindowType' => '\\StructType\\TimeWindowType',
            'ArrayOfOrderDetailPlanDetailType' => '\\ArrayType\\ArrayOfOrderDetailPlanDetailType',
            'OrderDetailPlanDetailType' => '\\StructType\\OrderDetailPlanDetailType',
            'ArrayOfLineItemDetailPlanType' => '\\ArrayType\\ArrayOfLineItemDetailPlanType',
            'LineItemDetailPlanType' => '\\StructType\\LineItemDetailPlanType',
            'LineItemPlanType' => '\\StructType\\LineItemPlanType',
            'ArrayOfUserFieldListUserField' => '\\ArrayType\\ArrayOfUserFieldListUserField',
            'UserFieldListUserField' => '\\StructType\\UserFieldListUserField',
            'AddressType' => '\\StructType\\AddressType',
            'ArrayOfViolationsTypeLeg' => '\\ArrayType\\ArrayOfViolationsTypeLeg',
            'ViolationsTypeLeg' => '\\StructType\\ViolationsTypeLeg',
            'Truck' => '\\StructType\\Truck',
            'ArrayOfBreakTime' => '\\ArrayType\\ArrayOfBreakTime',
            'BreakTime' => '\\StructType\\BreakTime',
            'ArrayOfOverTime' => '\\ArrayType\\ArrayOfOverTime',
            'OverTime' => '\\StructType\\OverTime',
            'ArrayOfUserField' => '\\ArrayType\\ArrayOfUserField',
            'UserField' => '\\StructType\\UserField',
            'ArrayOfVolume' => '\\ArrayType\\ArrayOfVolume',
            'Volume' => '\\StructType\\Volume',
            'AllRouteDetailRequestEnvelope' => '\\StructType\\AllRouteDetailRequestEnvelope',
            'OrderDetailRequestEnvelope' => '\\StructType\\OrderDetailRequestEnvelope',
            'OrderDetailReturnOptions' => '\\StructType\\OrderDetailReturnOptions',
            'OrderDetailReturnOptionsFilters' => '\\StructType\\OrderDetailReturnOptionsFilters',
            'ArrayOfOrderEventType' => '\\ArrayType\\ArrayOfOrderEventType',
            'OrderDetailResponseEnvelope' => '\\StructType\\OrderDetailResponseEnvelope',
            'ArrayOfOrderDetailType' => '\\ArrayType\\ArrayOfOrderDetailType',
            'OrderDetailType' => '\\StructType\\OrderDetailType',
            'OrderBaseType' => '\\StructType\\OrderBaseType',
            'ArrayOfLineItemType' => '\\ArrayType\\ArrayOfLineItemType',
            'LineItemType' => '\\StructType\\LineItemType',
            'OrderDetailActualType' => '\\StructType\\OrderDetailActualType',
            'ArrayOfEventDetail' => '\\ArrayType\\ArrayOfEventDetail',
            'EventDetail' => '\\StructType\\EventDetail',
            'OrderDetailPlanType' => '\\StructType\\OrderDetailPlanType',
            'AccountMasterDetails' => '\\StructType\\AccountMasterDetails',
            'ArrayOfAccountEventDetail' => '\\ArrayType\\ArrayOfAccountEventDetail',
            'AccountEventDetail' => '\\StructType\\AccountEventDetail',
            'ArrayOfAccountMasterDetailsAccountFixedRoutes' => '\\ArrayType\\ArrayOfAccountMasterDetailsAccountFixedRoutes',
            'AccountMasterDetailsAccountFixedRoutes' => '\\StructType\\AccountMasterDetailsAccountFixedRoutes',
            'AccountMasterDetailsAccountInfo' => '\\StructType\\AccountMasterDetailsAccountInfo',
            'ArrayOfTimeWindow' => '\\ArrayType\\ArrayOfTimeWindow',
            'TimeWindow' => '\\StructType\\TimeWindow',
            'ArrayOfAccountMasterDetailsAccountUserFlds' => '\\ArrayType\\ArrayOfAccountMasterDetailsAccountUserFlds',
            'AccountMasterDetailsAccountUserFlds' => '\\StructType\\AccountMasterDetailsAccountUserFlds',
            'ArrayOfMasterRoute' => '\\ArrayType\\ArrayOfMasterRoute',
            'MasterRoute' => '\\StructType\\MasterRoute',
            'ShipToDetails' => '\\StructType\\ShipToDetails',
            'PaginationByDateRangeAndPage' => '\\StructType\\PaginationByDateRangeAndPage',
            'MultiBranchOrderDetailRequestEnvelope' => '\\StructType\\MultiBranchOrderDetailRequestEnvelope',
            'QuantityAndUserFieldsResponseEnvelope' => '\\StructType\\QuantityAndUserFieldsResponseEnvelope',
            'GPSDataRequestEnvelope' => '\\StructType\\GPSDataRequestEnvelope',
            'ArrayOfDeviceData' => '\\ArrayType\\ArrayOfDeviceData',
            'DeviceData' => '\\StructType\\DeviceData',
            'ArrayOfDeviceDataEvent' => '\\ArrayType\\ArrayOfDeviceDataEvent',
            'DeviceDataEvent' => '\\StructType\\DeviceDataEvent',
            'ArrayOfDeviceDataEventOrders' => '\\ArrayType\\ArrayOfDeviceDataEventOrders',
            'DeviceDataEventOrders' => '\\StructType\\DeviceDataEventOrders',
            'ArrayOfDeviceDataGPS1' => '\\ArrayType\\ArrayOfDeviceDataGPS1',
            'DeviceDataGPS1' => '\\StructType\\DeviceDataGPS1',
            'ArrayOfDeviceDataGPS' => '\\ArrayType\\ArrayOfDeviceDataGPS',
            'DeviceDataGPS' => '\\StructType\\DeviceDataGPS',
            'ArrayOfDeviceDataStop' => '\\ArrayType\\ArrayOfDeviceDataStop',
            'DeviceDataStop' => '\\StructType\\DeviceDataStop',
            'ArrayOfForm' => '\\ArrayType\\ArrayOfForm',
            'Form' => '\\StructType\\Form',
            'ArrayOfActivity' => '\\ArrayType\\ArrayOfActivity',
            'Activity' => '\\StructType\\Activity',
            'ArrayOfOrderFormInfo' => '\\ArrayType\\ArrayOfOrderFormInfo',
            'OrderFormInfo' => '\\StructType\\OrderFormInfo',
            'ArrayOfQtyField' => '\\ArrayType\\ArrayOfQtyField',
            'QtyField' => '\\StructType\\QtyField',
            'GPSDataResponseEnvelope' => '\\StructType\\GPSDataResponseEnvelope',
            'GPSDataRequestParentEnvelope' => '\\StructType\\GPSDataRequestParentEnvelope',
            'ArrayOfGPSDataRequestEnvelope' => '\\ArrayType\\ArrayOfGPSDataRequestEnvelope',
            'AccountDetailRequestEnvelope' => '\\StructType\\AccountDetailRequestEnvelope',
            'AccountDetailReturnOptions' => '\\StructType\\AccountDetailReturnOptions',
            'AccountDetailResponseEnvelope' => '\\StructType\\AccountDetailResponseEnvelope',
            'ArrayOfAccountMasterDetails' => '\\ArrayType\\ArrayOfAccountMasterDetails',
            'ArrayOfShipToDetails' => '\\ArrayType\\ArrayOfShipToDetails',
            'BuildRouteRequestEnvelope' => '\\StructType\\BuildRouteRequestEnvelope',
            'BuildRouteResponseEnvelope' => '\\StructType\\BuildRouteResponseEnvelope',
            'ArrayOfRoutePlanDetailType' => '\\ArrayType\\ArrayOfRoutePlanDetailType',
            'UnloadOrdersRequestEnvelope' => '\\StructType\\UnloadOrdersRequestEnvelope',
            'UnloadOrdersResponseEnvelope' => '\\StructType\\UnloadOrdersResponseEnvelope',
            'AddOrdersRequestEnvelope' => '\\StructType\\AddOrdersRequestEnvelope',
            'AddOrdersResponseEnvelope' => '\\StructType\\AddOrdersResponseEnvelope',
            'LockStopsRequestEnvelope' => '\\StructType\\LockStopsRequestEnvelope',
            'LockStopsResponseEnvelope' => '\\StructType\\LockStopsResponseEnvelope',
            'UnlockStopsRequestEnvelope' => '\\StructType\\UnlockStopsRequestEnvelope',
            'UnlockStopsResponseEnvelope' => '\\StructType\\UnlockStopsResponseEnvelope',
            'AccountDetailRequestByDateRangeEnvelope' => '\\StructType\\AccountDetailRequestByDateRangeEnvelope',
            'ImportOrdersRequestEnvelope' => '\\StructType\\ImportOrdersRequestEnvelope',
            'ArrayOfDRStop' => '\\ArrayType\\ArrayOfDRStop',
            'DRStop' => '\\StructType\\DRStop',
            'DRLineItemType' => '\\StructType\\DRLineItemType',
            'DROrderType' => '\\StructType\\DROrderType',
            'DRStopType' => '\\StructType\\DRStopType',
            'DRAccountType' => '\\StructType\\DRAccountType',
            'DRAccountSchedule' => '\\StructType\\DRAccountSchedule',
            'ArrayOfDRTimeWindow' => '\\ArrayType\\ArrayOfDRTimeWindow',
            'DRTimeWindow' => '\\StructType\\DRTimeWindow',
            'ArrayOfDRUserField' => '\\ArrayType\\ArrayOfDRUserField',
            'DRUserField' => '\\StructType\\DRUserField',
            'ArrayOfDRVolume' => '\\ArrayType\\ArrayOfDRVolume',
            'DRVolume' => '\\StructType\\DRVolume',
            'ArrayOfInsertShipToDetails' => '\\ArrayType\\ArrayOfInsertShipToDetails',
            'InsertShipToDetails' => '\\StructType\\InsertShipToDetails',
            'ImportOrdersResponseEnvelope' => '\\StructType\\ImportOrdersResponseEnvelope',
            'ImportExtractFileRequestEnvelope' => '\\StructType\\ImportExtractFileRequestEnvelope',
            'ImportExtractFileResponseEnvelope' => '\\StructType\\ImportExtractFileResponseEnvelope',
            'ImportRoutesRequestEnvelope' => '\\StructType\\ImportRoutesRequestEnvelope',
            'DRSolutionSummaryStatistics' => '\\StructType\\DRSolutionSummaryStatistics',
            'Statistics' => '\\StructType\\Statistics',
            'ArrayOfViolation' => '\\ArrayType\\ArrayOfViolation',
            'DRTrackPreferences' => '\\StructType\\DRTrackPreferences',
            'DRTrackPreferencesDaysAssigned' => '\\StructType\\DRTrackPreferencesDaysAssigned',
            'Parameters' => '\\StructType\\Parameters',
            'ArrayOfImportRoutesRoute' => '\\ArrayType\\ArrayOfImportRoutesRoute',
            'ImportRoutesRoute' => '\\StructType\\ImportRoutesRoute',
            'ArrayOfLeg' => '\\ArrayType\\ArrayOfLeg',
            'Leg' => '\\StructType\\Leg',
            'ArrayOfEventRecords' => '\\ArrayType\\ArrayOfEventRecords',
            'EventRecords' => '\\StructType\\EventRecords',
            'ArrayOfStop' => '\\ArrayType\\ArrayOfStop',
            'Stop' => '\\StructType\\Stop',
            'ArrayOfOrder' => '\\ArrayType\\ArrayOfOrder',
            'Order' => '\\StructType\\Order',
            'ArrayOfLineItem' => '\\ArrayType\\ArrayOfLineItem',
            'LineItem' => '\\StructType\\LineItem',
            'ArrayOfImportRoutesRouteNextRt' => '\\ArrayType\\ArrayOfImportRoutesRouteNextRt',
            'ImportRoutesRouteNextRt' => '\\StructType\\ImportRoutesRouteNextRt',
            'ArrayOfImportRoutesRoutePrevRt' => '\\ArrayType\\ArrayOfImportRoutesRoutePrevRt',
            'ImportRoutesRoutePrevRt' => '\\StructType\\ImportRoutesRoutePrevRt',
            'ArrayOfKeyValuePair' => '\\ArrayType\\ArrayOfKeyValuePair',
            'KeyValuePair' => '\\StructType\\KeyValuePair',
            'UserSolutionSummaryStatistics' => '\\StructType\\UserSolutionSummaryStatistics',
            'ImportRoutesResponseEnvelope' => '\\StructType\\ImportRoutesResponseEnvelope',
            'ImportRoutesStatistics' => '\\StructType\\ImportRoutesStatistics',
            'ImportDriversRequestEnvelope' => '\\StructType\\ImportDriversRequestEnvelope',
            'ArrayOfDriverDetails' => '\\ArrayType\\ArrayOfDriverDetails',
            'DriverDetails' => '\\StructType\\DriverDetails',
            'ImportDriversResponseEnvelope' => '\\StructType\\ImportDriversResponseEnvelope',
            'ImportDevicesRequestEnvelope' => '\\StructType\\ImportDevicesRequestEnvelope',
            'ArrayOfDeviceDetails' => '\\ArrayType\\ArrayOfDeviceDetails',
            'DeviceDetails' => '\\StructType\\DeviceDetails',
            'ImportDevicesResponseEnvelope' => '\\StructType\\ImportDevicesResponseEnvelope',
            'SuggestRoutesRequestEnvelope' => '\\StructType\\SuggestRoutesRequestEnvelope',
            'ArrayOfSuggestRoutesOrder' => '\\ArrayType\\ArrayOfSuggestRoutesOrder',
            'SuggestRoutesOrder' => '\\StructType\\SuggestRoutesOrder',
            'ArrayOfSuggestRoutesOrderQuantityField' => '\\ArrayType\\ArrayOfSuggestRoutesOrderQuantityField',
            'SuggestRoutesOrderQuantityField' => '\\StructType\\SuggestRoutesOrderQuantityField',
            'SuggestRoutesResponseEnvelope' => '\\StructType\\SuggestRoutesResponseEnvelope',
            'ArrayOfSuggestRoutesOrderResponseEnvelope' => '\\ArrayType\\ArrayOfSuggestRoutesOrderResponseEnvelope',
            'SuggestRoutesOrderResponseEnvelope' => '\\StructType\\SuggestRoutesOrderResponseEnvelope',
            'ArrayOfRouteCandidates' => '\\ArrayType\\ArrayOfRouteCandidates',
            'RouteCandidates' => '\\StructType\\RouteCandidates',
            'OrderDetailsRequestEnvelope' => '\\StructType\\OrderDetailsRequestEnvelope',
            'OrderDetailsResponseEnvelope' => '\\StructType\\OrderDetailsResponseEnvelope',
            'OrderEventRequestEnvelope' => '\\StructType\\OrderEventRequestEnvelope',
            'OrderEventResponseEnvelope' => '\\StructType\\OrderEventResponseEnvelope',
            'ImportAccountMasterRequestEnvelope' => '\\StructType\\ImportAccountMasterRequestEnvelope',
            'ArrayOfDRAccountMaster' => '\\ArrayType\\ArrayOfDRAccountMaster',
            'DRAccountMaster' => '\\StructType\\DRAccountMaster',
            'ImportAccontMasterResponseEnvelope' => '\\StructType\\ImportAccontMasterResponseEnvelope',
            'ExportAccountMasterRequestEnvelope' => '\\StructType\\ExportAccountMasterRequestEnvelope',
            'ExportAccontMasterResponseEnvelope' => '\\StructType\\ExportAccontMasterResponseEnvelope',
            'ChangeAccountFrequencyRequestEnvelope' => '\\StructType\\ChangeAccountFrequencyRequestEnvelope',
            'ChangeAccountFrequencyResponseEnvelope' => '\\StructType\\ChangeAccountFrequencyResponseEnvelope',
            'MasterRouteDetailRequestEnvelope' => '\\StructType\\MasterRouteDetailRequestEnvelope',
            'MasterRouteDetailReturnOptions' => '\\StructType\\MasterRouteDetailReturnOptions',
            'MasterRouteDetailReturnOptionsFilters' => '\\StructType\\MasterRouteDetailReturnOptionsFilters',
            'MasterRouteResponseEnvelope' => '\\StructType\\MasterRouteResponseEnvelope',
            'ArrayOfMasterRouteResponse' => '\\ArrayType\\ArrayOfMasterRouteResponse',
            'MasterRouteResponse' => '\\StructType\\MasterRouteResponse',
            'ImportBranchesRequestEnvelope' => '\\StructType\\ImportBranchesRequestEnvelope',
            'ArrayOfBranchType' => '\\ArrayType\\ArrayOfBranchType',
            'BranchType' => '\\StructType\\BranchType',
            'ImportBranchesResponseEnvelope' => '\\StructType\\ImportBranchesResponseEnvelope',
            'TruckProfileRequestEnvelope' => '\\StructType\\TruckProfileRequestEnvelope',
            'TruckProfileResponseEnvelope' => '\\StructType\\TruckProfileResponseEnvelope',
            'ArrayOfTruckMasterType' => '\\ArrayType\\ArrayOfTruckMasterType',
            'TruckMasterType' => '\\StructType\\TruckMasterType',
            'TAssets' => '\\StructType\\TAssets',
            'TAssetTypes' => '\\StructType\\TAssetTypes',
            'ArrayOfwsTruckMasterQtyFldValue' => '\\ArrayType\\ArrayOfwsTruckMasterQtyFldValue',
            'wsTruckMasterQtyFldValue' => '\\StructType\\WsTruckMasterQtyFldValue',
            'ArrayOfwsTruckMasterUserFldValue' => '\\ArrayType\\ArrayOfwsTruckMasterUserFldValue',
            'wsTruckMasterUserFldValue' => '\\StructType\\WsTruckMasterUserFldValue',
            'MaxRouteDetailsRequestEnvelope' => '\\StructType\\MaxRouteDetailsRequestEnvelope',
            'MaxRouteByBranchResponseEnvelope' => '\\StructType\\MaxRouteByBranchResponseEnvelope',
            'ImportAssetsRequestEnvelope' => '\\StructType\\ImportAssetsRequestEnvelope',
            'ArrayOfAssetDetails' => '\\ArrayType\\ArrayOfAssetDetails',
            'AssetDetails' => '\\StructType\\AssetDetails',
            'TruckDetails' => '\\StructType\\TruckDetails',
            'ResponseEnvelope' => '\\StructType\\ResponseEnvelope',
            'TransferAssetsRequestEnvelope' => '\\StructType\\TransferAssetsRequestEnvelope',
            'ArrayOfAssetTransferDetails' => '\\ArrayType\\ArrayOfAssetTransferDetails',
            'AssetTransferDetails' => '\\StructType\\AssetTransferDetails',
            'DecommissionAssetsRequestEnvelope' => '\\StructType\\DecommissionAssetsRequestEnvelope',
            'ArrayOfAssetDecommissionDetails' => '\\ArrayType\\ArrayOfAssetDecommissionDetails',
            'AssetDecommissionDetails' => '\\StructType\\AssetDecommissionDetails',
            'ImportCostingRulesRequestEnvelope' => '\\StructType\\ImportCostingRulesRequestEnvelope',
            'ArrayOfConstingRulesDetails' => '\\ArrayType\\ArrayOfConstingRulesDetails',
            'ConstingRulesDetails' => '\\StructType\\ConstingRulesDetails',
            'CostingRulesRequestEnvelope' => '\\StructType\\CostingRulesRequestEnvelope',
            'CostingRulesResponseEnvelope' => '\\StructType\\CostingRulesResponseEnvelope',
            'UpdateAccountEmailEventRequestEnvelope' => '\\StructType\\UpdateAccountEmailEventRequestEnvelope',
            'ArrayOfAccountEmailEvent' => '\\ArrayType\\ArrayOfAccountEmailEvent',
            'AccountEmailEvent' => '\\StructType\\AccountEmailEvent',
            'ArrayOfEmailPerson' => '\\ArrayType\\ArrayOfEmailPerson',
            'EmailPerson' => '\\StructType\\EmailPerson',
            'UpdateAccountEmailEventResponseEnvelope' => '\\StructType\\UpdateAccountEmailEventResponseEnvelope',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'ArrayOfTQtyFields' => '\\ArrayType\\ArrayOfTQtyFields',
            'TQtyFields' => '\\StructType\\TQtyFields',
            'ArrayOfTUserFieldList' => '\\ArrayType\\ArrayOfTUserFieldList',
            'TUserFieldList' => '\\StructType\\TUserFieldList',
            'ArrayOfOrderEvent' => '\\ArrayType\\ArrayOfOrderEvent',
            'OrderEvent' => '\\StructType\\OrderEvent',
        );
    }
}
