<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for EventID EnumType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EventID
 * @subpackage Enumerations
 */
class EventID extends AbstractStructEnumBase
{
    /**
     * Constant for value 'StopArrival'
     * @return string 'StopArrival'
     */
    const VALUE_STOP_ARRIVAL = 'StopArrival';
    /**
     * Constant for value 'StopDeparture'
     * @return string 'StopDeparture'
     */
    const VALUE_STOP_DEPARTURE = 'StopDeparture';
    /**
     * Constant for value 'BreakTime'
     * @return string 'BreakTime'
     */
    const VALUE_BREAK_TIME = 'BreakTime';
    /**
     * Constant for value 'Lunch'
     * @return string 'Lunch'
     */
    const VALUE_LUNCH = 'Lunch';
    /**
     * Constant for value 'ArriveStopEvent'
     * @return string 'ArriveStopEvent'
     */
    const VALUE_ARRIVE_STOP_EVENT = 'ArriveStopEvent';
    /**
     * Constant for value 'DeliveryAndCollect'
     * @return string 'DeliveryAndCollect'
     */
    const VALUE_DELIVERY_AND_COLLECT = 'DeliveryAndCollect';
    /**
     * Constant for value 'LoadVehicleDriver'
     * @return string 'LoadVehicleDriver'
     */
    const VALUE_LOAD_VEHICLE_DRIVER = 'LoadVehicleDriver';
    /**
     * Return allowed values
     * @uses self::VALUE_STOP_ARRIVAL
     * @uses self::VALUE_STOP_DEPARTURE
     * @uses self::VALUE_BREAK_TIME
     * @uses self::VALUE_LUNCH
     * @uses self::VALUE_ARRIVE_STOP_EVENT
     * @uses self::VALUE_DELIVERY_AND_COLLECT
     * @uses self::VALUE_LOAD_VEHICLE_DRIVER
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_STOP_ARRIVAL,
            self::VALUE_STOP_DEPARTURE,
            self::VALUE_BREAK_TIME,
            self::VALUE_LUNCH,
            self::VALUE_ARRIVE_STOP_EVENT,
            self::VALUE_DELIVERY_AND_COLLECT,
            self::VALUE_LOAD_VEHICLE_DRIVER,
        );
    }
}
