<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for TripEvent EnumType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TripEvent
 * @subpackage Enumerations
 */
class TripEvent extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Drive'
     * @return string 'Drive'
     */
    const VALUE_DRIVE = 'Drive';
    /**
     * Constant for value 'Stop'
     * @return string 'Stop'
     */
    const VALUE_STOP = 'Stop';
    /**
     * Constant for value 'Layover'
     * @return string 'Layover'
     */
    const VALUE_LAYOVER = 'Layover';
    /**
     * Constant for value 'Break'
     * @return string 'Break'
     */
    const VALUE_BREAK = 'Break';
    /**
     * Constant for value 'Pretrip'
     * @return string 'Pretrip'
     */
    const VALUE_PRETRIP = 'Pretrip';
    /**
     * Constant for value 'PostTrip'
     * @return string 'PostTrip'
     */
    const VALUE_POST_TRIP = 'PostTrip';
    /**
     * Constant for value 'Wait'
     * @return string 'Wait'
     */
    const VALUE_WAIT = 'Wait';
    /**
     * Constant for value 'StartOfDay'
     * @return string 'StartOfDay'
     */
    const VALUE_START_OF_DAY = 'StartOfDay';
    /**
     * Return allowed values
     * @uses self::VALUE_DRIVE
     * @uses self::VALUE_STOP
     * @uses self::VALUE_LAYOVER
     * @uses self::VALUE_BREAK
     * @uses self::VALUE_PRETRIP
     * @uses self::VALUE_POST_TRIP
     * @uses self::VALUE_WAIT
     * @uses self::VALUE_START_OF_DAY
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_DRIVE,
            self::VALUE_STOP,
            self::VALUE_LAYOVER,
            self::VALUE_BREAK,
            self::VALUE_PRETRIP,
            self::VALUE_POST_TRIP,
            self::VALUE_WAIT,
            self::VALUE_START_OF_DAY,
        );
    }
}
