<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountDetailReturnOptions StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AccountDetailReturnOptions
 * @subpackage Structs
 */
class AccountDetailReturnOptions extends AbstractStructBase
{
    /**
     * The populateAccountFixedRoutesField
     * @var bool
     */
    public $populateAccountFixedRoutesField;
    /**
     * The populateAccountInfoField
     * @var bool
     */
    public $populateAccountInfoField;
    /**
     * The populateAccountMasterField
     * @var bool
     */
    public $populateAccountMasterField;
    /**
     * The populateAccountUserFldsField
     * @var bool
     */
    public $populateAccountUserFldsField;
    /**
     * The populateEventsField
     * @var bool
     */
    public $populateEventsField;
    /**
     * The populateMasterRoutesField
     * @var bool
     */
    public $populateMasterRoutesField;
    /**
     * The populateShipToField
     * @var bool
     */
    public $populateShipToField;
    /**
     * The populateTimeWindowsField
     * @var bool
     */
    public $populateTimeWindowsField;
    /**
     * Constructor method for AccountDetailReturnOptions
     * @uses AccountDetailReturnOptions::setPopulateAccountFixedRoutesField()
     * @uses AccountDetailReturnOptions::setPopulateAccountInfoField()
     * @uses AccountDetailReturnOptions::setPopulateAccountMasterField()
     * @uses AccountDetailReturnOptions::setPopulateAccountUserFldsField()
     * @uses AccountDetailReturnOptions::setPopulateEventsField()
     * @uses AccountDetailReturnOptions::setPopulateMasterRoutesField()
     * @uses AccountDetailReturnOptions::setPopulateShipToField()
     * @uses AccountDetailReturnOptions::setPopulateTimeWindowsField()
     * @param bool $populateAccountFixedRoutesField
     * @param bool $populateAccountInfoField
     * @param bool $populateAccountMasterField
     * @param bool $populateAccountUserFldsField
     * @param bool $populateEventsField
     * @param bool $populateMasterRoutesField
     * @param bool $populateShipToField
     * @param bool $populateTimeWindowsField
     */
    public function __construct($populateAccountFixedRoutesField = null, $populateAccountInfoField = null, $populateAccountMasterField = null, $populateAccountUserFldsField = null, $populateEventsField = null, $populateMasterRoutesField = null, $populateShipToField = null, $populateTimeWindowsField = null)
    {
        $this
            ->setPopulateAccountFixedRoutesField($populateAccountFixedRoutesField)
            ->setPopulateAccountInfoField($populateAccountInfoField)
            ->setPopulateAccountMasterField($populateAccountMasterField)
            ->setPopulateAccountUserFldsField($populateAccountUserFldsField)
            ->setPopulateEventsField($populateEventsField)
            ->setPopulateMasterRoutesField($populateMasterRoutesField)
            ->setPopulateShipToField($populateShipToField)
            ->setPopulateTimeWindowsField($populateTimeWindowsField);
    }
    /**
     * Get populateAccountFixedRoutesField value
     * @return bool|null
     */
    public function getPopulateAccountFixedRoutesField()
    {
        return $this->populateAccountFixedRoutesField;
    }
    /**
     * Set populateAccountFixedRoutesField value
     * @param bool $populateAccountFixedRoutesField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateAccountFixedRoutesField($populateAccountFixedRoutesField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateAccountFixedRoutesField) && !is_bool($populateAccountFixedRoutesField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateAccountFixedRoutesField, true), gettype($populateAccountFixedRoutesField)), __LINE__);
        }
        $this->populateAccountFixedRoutesField = $populateAccountFixedRoutesField;
        return $this;
    }
    /**
     * Get populateAccountInfoField value
     * @return bool|null
     */
    public function getPopulateAccountInfoField()
    {
        return $this->populateAccountInfoField;
    }
    /**
     * Set populateAccountInfoField value
     * @param bool $populateAccountInfoField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateAccountInfoField($populateAccountInfoField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateAccountInfoField) && !is_bool($populateAccountInfoField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateAccountInfoField, true), gettype($populateAccountInfoField)), __LINE__);
        }
        $this->populateAccountInfoField = $populateAccountInfoField;
        return $this;
    }
    /**
     * Get populateAccountMasterField value
     * @return bool|null
     */
    public function getPopulateAccountMasterField()
    {
        return $this->populateAccountMasterField;
    }
    /**
     * Set populateAccountMasterField value
     * @param bool $populateAccountMasterField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateAccountMasterField($populateAccountMasterField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateAccountMasterField) && !is_bool($populateAccountMasterField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateAccountMasterField, true), gettype($populateAccountMasterField)), __LINE__);
        }
        $this->populateAccountMasterField = $populateAccountMasterField;
        return $this;
    }
    /**
     * Get populateAccountUserFldsField value
     * @return bool|null
     */
    public function getPopulateAccountUserFldsField()
    {
        return $this->populateAccountUserFldsField;
    }
    /**
     * Set populateAccountUserFldsField value
     * @param bool $populateAccountUserFldsField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateAccountUserFldsField($populateAccountUserFldsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateAccountUserFldsField) && !is_bool($populateAccountUserFldsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateAccountUserFldsField, true), gettype($populateAccountUserFldsField)), __LINE__);
        }
        $this->populateAccountUserFldsField = $populateAccountUserFldsField;
        return $this;
    }
    /**
     * Get populateEventsField value
     * @return bool|null
     */
    public function getPopulateEventsField()
    {
        return $this->populateEventsField;
    }
    /**
     * Set populateEventsField value
     * @param bool $populateEventsField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateEventsField($populateEventsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateEventsField) && !is_bool($populateEventsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateEventsField, true), gettype($populateEventsField)), __LINE__);
        }
        $this->populateEventsField = $populateEventsField;
        return $this;
    }
    /**
     * Get populateMasterRoutesField value
     * @return bool|null
     */
    public function getPopulateMasterRoutesField()
    {
        return $this->populateMasterRoutesField;
    }
    /**
     * Set populateMasterRoutesField value
     * @param bool $populateMasterRoutesField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateMasterRoutesField($populateMasterRoutesField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateMasterRoutesField) && !is_bool($populateMasterRoutesField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateMasterRoutesField, true), gettype($populateMasterRoutesField)), __LINE__);
        }
        $this->populateMasterRoutesField = $populateMasterRoutesField;
        return $this;
    }
    /**
     * Get populateShipToField value
     * @return bool|null
     */
    public function getPopulateShipToField()
    {
        return $this->populateShipToField;
    }
    /**
     * Set populateShipToField value
     * @param bool $populateShipToField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateShipToField($populateShipToField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateShipToField) && !is_bool($populateShipToField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateShipToField, true), gettype($populateShipToField)), __LINE__);
        }
        $this->populateShipToField = $populateShipToField;
        return $this;
    }
    /**
     * Get populateTimeWindowsField value
     * @return bool|null
     */
    public function getPopulateTimeWindowsField()
    {
        return $this->populateTimeWindowsField;
    }
    /**
     * Set populateTimeWindowsField value
     * @param bool $populateTimeWindowsField
     * @return \StructType\AccountDetailReturnOptions
     */
    public function setPopulateTimeWindowsField($populateTimeWindowsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateTimeWindowsField) && !is_bool($populateTimeWindowsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateTimeWindowsField, true), gettype($populateTimeWindowsField)), __LINE__);
        }
        $this->populateTimeWindowsField = $populateTimeWindowsField;
        return $this;
    }
}
