<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountMasterDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AccountMasterDetails
 * @subpackage Structs
 */
class AccountMasterDetails extends AbstractStructBase
{
    /**
     * The accountEventDetailField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfAccountEventDetail
     */
    public $accountEventDetailField;
    /**
     * The accountFixedRoutesField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes
     */
    public $accountFixedRoutesField;
    /**
     * The accountIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $accountIDField;
    /**
     * The accountInfoField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\AccountMasterDetailsAccountInfo
     */
    public $accountInfoField;
    /**
     * The accountKeyIdField
     * @var int
     */
    public $accountKeyIdField;
    /**
     * The accountNameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $accountNameField;
    /**
     * The accountTimeWindowsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfTimeWindow
     */
    public $accountTimeWindowsField;
    /**
     * The accountUserFldsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfAccountMasterDetailsAccountUserFlds
     */
    public $accountUserFldsField;
    /**
     * The address2Field
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $address2Field;
    /**
     * The addressField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $addressField;
    /**
     * The cityField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $cityField;
    /**
     * The geoResultField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $geoResultField;
    /**
     * The latitudeField
     * @var float
     */
    public $latitudeField;
    /**
     * The longitudeField
     * @var float
     */
    public $longitudeField;
    /**
     * The masterRoutesField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfMasterRoute
     */
    public $masterRoutesField;
    /**
     * The priorityBumpField
     * @var int
     */
    public $priorityBumpField;
    /**
     * The priorityField
     * @var int
     */
    public $priorityField;
    /**
     * The stateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $stateField;
    /**
     * The typeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $typeField;
    /**
     * The zipCodeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $zipCodeField;
    /**
     * Constructor method for AccountMasterDetails
     * @uses AccountMasterDetails::setAccountEventDetailField()
     * @uses AccountMasterDetails::setAccountFixedRoutesField()
     * @uses AccountMasterDetails::setAccountIDField()
     * @uses AccountMasterDetails::setAccountInfoField()
     * @uses AccountMasterDetails::setAccountKeyIdField()
     * @uses AccountMasterDetails::setAccountNameField()
     * @uses AccountMasterDetails::setAccountTimeWindowsField()
     * @uses AccountMasterDetails::setAccountUserFldsField()
     * @uses AccountMasterDetails::setAddress2Field()
     * @uses AccountMasterDetails::setAddressField()
     * @uses AccountMasterDetails::setCityField()
     * @uses AccountMasterDetails::setGeoResultField()
     * @uses AccountMasterDetails::setLatitudeField()
     * @uses AccountMasterDetails::setLongitudeField()
     * @uses AccountMasterDetails::setMasterRoutesField()
     * @uses AccountMasterDetails::setPriorityBumpField()
     * @uses AccountMasterDetails::setPriorityField()
     * @uses AccountMasterDetails::setStateField()
     * @uses AccountMasterDetails::setTypeField()
     * @uses AccountMasterDetails::setZipCodeField()
     * @param \ArrayType\ArrayOfAccountEventDetail $accountEventDetailField
     * @param \ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes $accountFixedRoutesField
     * @param string $accountIDField
     * @param \StructType\AccountMasterDetailsAccountInfo $accountInfoField
     * @param int $accountKeyIdField
     * @param string $accountNameField
     * @param \ArrayType\ArrayOfTimeWindow $accountTimeWindowsField
     * @param \ArrayType\ArrayOfAccountMasterDetailsAccountUserFlds $accountUserFldsField
     * @param string $address2Field
     * @param string $addressField
     * @param string $cityField
     * @param string $geoResultField
     * @param float $latitudeField
     * @param float $longitudeField
     * @param \ArrayType\ArrayOfMasterRoute $masterRoutesField
     * @param int $priorityBumpField
     * @param int $priorityField
     * @param string $stateField
     * @param string $typeField
     * @param string $zipCodeField
     */
    public function __construct(\ArrayType\ArrayOfAccountEventDetail $accountEventDetailField = null, \ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes $accountFixedRoutesField = null, $accountIDField = null, \StructType\AccountMasterDetailsAccountInfo $accountInfoField = null, $accountKeyIdField = null, $accountNameField = null, \ArrayType\ArrayOfTimeWindow $accountTimeWindowsField = null, \ArrayType\ArrayOfAccountMasterDetailsAccountUserFlds $accountUserFldsField = null, $address2Field = null, $addressField = null, $cityField = null, $geoResultField = null, $latitudeField = null, $longitudeField = null, \ArrayType\ArrayOfMasterRoute $masterRoutesField = null, $priorityBumpField = null, $priorityField = null, $stateField = null, $typeField = null, $zipCodeField = null)
    {
        $this
            ->setAccountEventDetailField($accountEventDetailField)
            ->setAccountFixedRoutesField($accountFixedRoutesField)
            ->setAccountIDField($accountIDField)
            ->setAccountInfoField($accountInfoField)
            ->setAccountKeyIdField($accountKeyIdField)
            ->setAccountNameField($accountNameField)
            ->setAccountTimeWindowsField($accountTimeWindowsField)
            ->setAccountUserFldsField($accountUserFldsField)
            ->setAddress2Field($address2Field)
            ->setAddressField($addressField)
            ->setCityField($cityField)
            ->setGeoResultField($geoResultField)
            ->setLatitudeField($latitudeField)
            ->setLongitudeField($longitudeField)
            ->setMasterRoutesField($masterRoutesField)
            ->setPriorityBumpField($priorityBumpField)
            ->setPriorityField($priorityField)
            ->setStateField($stateField)
            ->setTypeField($typeField)
            ->setZipCodeField($zipCodeField);
    }
    /**
     * Get accountEventDetailField value
     * @return \ArrayType\ArrayOfAccountEventDetail|null
     */
    public function getAccountEventDetailField()
    {
        return $this->accountEventDetailField;
    }
    /**
     * Set accountEventDetailField value
     * @param \ArrayType\ArrayOfAccountEventDetail $accountEventDetailField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountEventDetailField(\ArrayType\ArrayOfAccountEventDetail $accountEventDetailField = null)
    {
        $this->accountEventDetailField = $accountEventDetailField;
        return $this;
    }
    /**
     * Get accountFixedRoutesField value
     * @return \ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes|null
     */
    public function getAccountFixedRoutesField()
    {
        return $this->accountFixedRoutesField;
    }
    /**
     * Set accountFixedRoutesField value
     * @param \ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes $accountFixedRoutesField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountFixedRoutesField(\ArrayType\ArrayOfAccountMasterDetailsAccountFixedRoutes $accountFixedRoutesField = null)
    {
        $this->accountFixedRoutesField = $accountFixedRoutesField;
        return $this;
    }
    /**
     * Get accountIDField value
     * @return string|null
     */
    public function getAccountIDField()
    {
        return $this->accountIDField;
    }
    /**
     * Set accountIDField value
     * @param string $accountIDField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountIDField($accountIDField = null)
    {
        // validation for constraint: string
        if (!is_null($accountIDField) && !is_string($accountIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accountIDField, true), gettype($accountIDField)), __LINE__);
        }
        $this->accountIDField = $accountIDField;
        return $this;
    }
    /**
     * Get accountInfoField value
     * @return \StructType\AccountMasterDetailsAccountInfo|null
     */
    public function getAccountInfoField()
    {
        return $this->accountInfoField;
    }
    /**
     * Set accountInfoField value
     * @param \StructType\AccountMasterDetailsAccountInfo $accountInfoField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountInfoField(\StructType\AccountMasterDetailsAccountInfo $accountInfoField = null)
    {
        $this->accountInfoField = $accountInfoField;
        return $this;
    }
    /**
     * Get accountKeyIdField value
     * @return int|null
     */
    public function getAccountKeyIdField()
    {
        return $this->accountKeyIdField;
    }
    /**
     * Set accountKeyIdField value
     * @param int $accountKeyIdField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountKeyIdField($accountKeyIdField = null)
    {
        // validation for constraint: int
        if (!is_null($accountKeyIdField) && !(is_int($accountKeyIdField) || ctype_digit($accountKeyIdField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($accountKeyIdField, true), gettype($accountKeyIdField)), __LINE__);
        }
        $this->accountKeyIdField = $accountKeyIdField;
        return $this;
    }
    /**
     * Get accountNameField value
     * @return string|null
     */
    public function getAccountNameField()
    {
        return $this->accountNameField;
    }
    /**
     * Set accountNameField value
     * @param string $accountNameField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountNameField($accountNameField = null)
    {
        // validation for constraint: string
        if (!is_null($accountNameField) && !is_string($accountNameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accountNameField, true), gettype($accountNameField)), __LINE__);
        }
        $this->accountNameField = $accountNameField;
        return $this;
    }
    /**
     * Get accountTimeWindowsField value
     * @return \ArrayType\ArrayOfTimeWindow|null
     */
    public function getAccountTimeWindowsField()
    {
        return $this->accountTimeWindowsField;
    }
    /**
     * Set accountTimeWindowsField value
     * @param \ArrayType\ArrayOfTimeWindow $accountTimeWindowsField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountTimeWindowsField(\ArrayType\ArrayOfTimeWindow $accountTimeWindowsField = null)
    {
        $this->accountTimeWindowsField = $accountTimeWindowsField;
        return $this;
    }
    /**
     * Get accountUserFldsField value
     * @return \ArrayType\ArrayOfAccountMasterDetailsAccountUserFlds|null
     */
    public function getAccountUserFldsField()
    {
        return $this->accountUserFldsField;
    }
    /**
     * Set accountUserFldsField value
     * @param \ArrayType\ArrayOfAccountMasterDetailsAccountUserFlds $accountUserFldsField
     * @return \StructType\AccountMasterDetails
     */
    public function setAccountUserFldsField(\ArrayType\ArrayOfAccountMasterDetailsAccountUserFlds $accountUserFldsField = null)
    {
        $this->accountUserFldsField = $accountUserFldsField;
        return $this;
    }
    /**
     * Get address2Field value
     * @return string|null
     */
    public function getAddress2Field()
    {
        return $this->address2Field;
    }
    /**
     * Set address2Field value
     * @param string $address2Field
     * @return \StructType\AccountMasterDetails
     */
    public function setAddress2Field($address2Field = null)
    {
        // validation for constraint: string
        if (!is_null($address2Field) && !is_string($address2Field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address2Field, true), gettype($address2Field)), __LINE__);
        }
        $this->address2Field = $address2Field;
        return $this;
    }
    /**
     * Get addressField value
     * @return string|null
     */
    public function getAddressField()
    {
        return $this->addressField;
    }
    /**
     * Set addressField value
     * @param string $addressField
     * @return \StructType\AccountMasterDetails
     */
    public function setAddressField($addressField = null)
    {
        // validation for constraint: string
        if (!is_null($addressField) && !is_string($addressField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addressField, true), gettype($addressField)), __LINE__);
        }
        $this->addressField = $addressField;
        return $this;
    }
    /**
     * Get cityField value
     * @return string|null
     */
    public function getCityField()
    {
        return $this->cityField;
    }
    /**
     * Set cityField value
     * @param string $cityField
     * @return \StructType\AccountMasterDetails
     */
    public function setCityField($cityField = null)
    {
        // validation for constraint: string
        if (!is_null($cityField) && !is_string($cityField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cityField, true), gettype($cityField)), __LINE__);
        }
        $this->cityField = $cityField;
        return $this;
    }
    /**
     * Get geoResultField value
     * @return string|null
     */
    public function getGeoResultField()
    {
        return $this->geoResultField;
    }
    /**
     * Set geoResultField value
     * @param string $geoResultField
     * @return \StructType\AccountMasterDetails
     */
    public function setGeoResultField($geoResultField = null)
    {
        // validation for constraint: string
        if (!is_null($geoResultField) && !is_string($geoResultField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($geoResultField, true), gettype($geoResultField)), __LINE__);
        }
        $this->geoResultField = $geoResultField;
        return $this;
    }
    /**
     * Get latitudeField value
     * @return float|null
     */
    public function getLatitudeField()
    {
        return $this->latitudeField;
    }
    /**
     * Set latitudeField value
     * @param float $latitudeField
     * @return \StructType\AccountMasterDetails
     */
    public function setLatitudeField($latitudeField = null)
    {
        // validation for constraint: float
        if (!is_null($latitudeField) && !(is_float($latitudeField) || is_numeric($latitudeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($latitudeField, true), gettype($latitudeField)), __LINE__);
        }
        $this->latitudeField = $latitudeField;
        return $this;
    }
    /**
     * Get longitudeField value
     * @return float|null
     */
    public function getLongitudeField()
    {
        return $this->longitudeField;
    }
    /**
     * Set longitudeField value
     * @param float $longitudeField
     * @return \StructType\AccountMasterDetails
     */
    public function setLongitudeField($longitudeField = null)
    {
        // validation for constraint: float
        if (!is_null($longitudeField) && !(is_float($longitudeField) || is_numeric($longitudeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($longitudeField, true), gettype($longitudeField)), __LINE__);
        }
        $this->longitudeField = $longitudeField;
        return $this;
    }
    /**
     * Get masterRoutesField value
     * @return \ArrayType\ArrayOfMasterRoute|null
     */
    public function getMasterRoutesField()
    {
        return $this->masterRoutesField;
    }
    /**
     * Set masterRoutesField value
     * @param \ArrayType\ArrayOfMasterRoute $masterRoutesField
     * @return \StructType\AccountMasterDetails
     */
    public function setMasterRoutesField(\ArrayType\ArrayOfMasterRoute $masterRoutesField = null)
    {
        $this->masterRoutesField = $masterRoutesField;
        return $this;
    }
    /**
     * Get priorityBumpField value
     * @return int|null
     */
    public function getPriorityBumpField()
    {
        return $this->priorityBumpField;
    }
    /**
     * Set priorityBumpField value
     * @param int $priorityBumpField
     * @return \StructType\AccountMasterDetails
     */
    public function setPriorityBumpField($priorityBumpField = null)
    {
        // validation for constraint: int
        if (!is_null($priorityBumpField) && !(is_int($priorityBumpField) || ctype_digit($priorityBumpField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($priorityBumpField, true), gettype($priorityBumpField)), __LINE__);
        }
        $this->priorityBumpField = $priorityBumpField;
        return $this;
    }
    /**
     * Get priorityField value
     * @return int|null
     */
    public function getPriorityField()
    {
        return $this->priorityField;
    }
    /**
     * Set priorityField value
     * @param int $priorityField
     * @return \StructType\AccountMasterDetails
     */
    public function setPriorityField($priorityField = null)
    {
        // validation for constraint: int
        if (!is_null($priorityField) && !(is_int($priorityField) || ctype_digit($priorityField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($priorityField, true), gettype($priorityField)), __LINE__);
        }
        $this->priorityField = $priorityField;
        return $this;
    }
    /**
     * Get stateField value
     * @return string|null
     */
    public function getStateField()
    {
        return $this->stateField;
    }
    /**
     * Set stateField value
     * @param string $stateField
     * @return \StructType\AccountMasterDetails
     */
    public function setStateField($stateField = null)
    {
        // validation for constraint: string
        if (!is_null($stateField) && !is_string($stateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateField, true), gettype($stateField)), __LINE__);
        }
        $this->stateField = $stateField;
        return $this;
    }
    /**
     * Get typeField value
     * @return string|null
     */
    public function getTypeField()
    {
        return $this->typeField;
    }
    /**
     * Set typeField value
     * @param string $typeField
     * @return \StructType\AccountMasterDetails
     */
    public function setTypeField($typeField = null)
    {
        // validation for constraint: string
        if (!is_null($typeField) && !is_string($typeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($typeField, true), gettype($typeField)), __LINE__);
        }
        $this->typeField = $typeField;
        return $this;
    }
    /**
     * Get zipCodeField value
     * @return string|null
     */
    public function getZipCodeField()
    {
        return $this->zipCodeField;
    }
    /**
     * Set zipCodeField value
     * @param string $zipCodeField
     * @return \StructType\AccountMasterDetails
     */
    public function setZipCodeField($zipCodeField = null)
    {
        // validation for constraint: string
        if (!is_null($zipCodeField) && !is_string($zipCodeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipCodeField, true), gettype($zipCodeField)), __LINE__);
        }
        $this->zipCodeField = $zipCodeField;
        return $this;
    }
}
