<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddOrdersRequestEnvelope StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AddOrdersRequestEnvelope
 * @subpackage Structs
 */
class AddOrdersRequestEnvelope extends AbstractStructBase
{
    /**
     * The branchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $branchIDField;
    /**
     * The externalIdListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $externalIdListField;
    /**
     * The internalRTIDField
     * @var int
     */
    public $internalRTIDField;
    /**
     * The legNoField
     * @var int
     */
    public $legNoField;
    /**
     * The orderIdListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $orderIdListField;
    /**
     * The seqNoField
     * @var int
     */
    public $seqNoField;
    /**
     * Constructor method for AddOrdersRequestEnvelope
     * @uses AddOrdersRequestEnvelope::setBranchIDField()
     * @uses AddOrdersRequestEnvelope::setExternalIdListField()
     * @uses AddOrdersRequestEnvelope::setInternalRTIDField()
     * @uses AddOrdersRequestEnvelope::setLegNoField()
     * @uses AddOrdersRequestEnvelope::setOrderIdListField()
     * @uses AddOrdersRequestEnvelope::setSeqNoField()
     * @param string $branchIDField
     * @param \ArrayType\ArrayOfstring $externalIdListField
     * @param int $internalRTIDField
     * @param int $legNoField
     * @param \ArrayType\ArrayOfstring $orderIdListField
     * @param int $seqNoField
     */
    public function __construct($branchIDField = null, \ArrayType\ArrayOfstring $externalIdListField = null, $internalRTIDField = null, $legNoField = null, \ArrayType\ArrayOfstring $orderIdListField = null, $seqNoField = null)
    {
        $this
            ->setBranchIDField($branchIDField)
            ->setExternalIdListField($externalIdListField)
            ->setInternalRTIDField($internalRTIDField)
            ->setLegNoField($legNoField)
            ->setOrderIdListField($orderIdListField)
            ->setSeqNoField($seqNoField);
    }
    /**
     * Get branchIDField value
     * @return string|null
     */
    public function getBranchIDField()
    {
        return $this->branchIDField;
    }
    /**
     * Set branchIDField value
     * @param string $branchIDField
     * @return \StructType\AddOrdersRequestEnvelope
     */
    public function setBranchIDField($branchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($branchIDField) && !is_string($branchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($branchIDField, true), gettype($branchIDField)), __LINE__);
        }
        $this->branchIDField = $branchIDField;
        return $this;
    }
    /**
     * Get externalIdListField value
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getExternalIdListField()
    {
        return $this->externalIdListField;
    }
    /**
     * Set externalIdListField value
     * @param \ArrayType\ArrayOfstring $externalIdListField
     * @return \StructType\AddOrdersRequestEnvelope
     */
    public function setExternalIdListField(\ArrayType\ArrayOfstring $externalIdListField = null)
    {
        $this->externalIdListField = $externalIdListField;
        return $this;
    }
    /**
     * Get internalRTIDField value
     * @return int|null
     */
    public function getInternalRTIDField()
    {
        return $this->internalRTIDField;
    }
    /**
     * Set internalRTIDField value
     * @param int $internalRTIDField
     * @return \StructType\AddOrdersRequestEnvelope
     */
    public function setInternalRTIDField($internalRTIDField = null)
    {
        // validation for constraint: int
        if (!is_null($internalRTIDField) && !(is_int($internalRTIDField) || ctype_digit($internalRTIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($internalRTIDField, true), gettype($internalRTIDField)), __LINE__);
        }
        $this->internalRTIDField = $internalRTIDField;
        return $this;
    }
    /**
     * Get legNoField value
     * @return int|null
     */
    public function getLegNoField()
    {
        return $this->legNoField;
    }
    /**
     * Set legNoField value
     * @param int $legNoField
     * @return \StructType\AddOrdersRequestEnvelope
     */
    public function setLegNoField($legNoField = null)
    {
        // validation for constraint: int
        if (!is_null($legNoField) && !(is_int($legNoField) || ctype_digit($legNoField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($legNoField, true), gettype($legNoField)), __LINE__);
        }
        $this->legNoField = $legNoField;
        return $this;
    }
    /**
     * Get orderIdListField value
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getOrderIdListField()
    {
        return $this->orderIdListField;
    }
    /**
     * Set orderIdListField value
     * @param \ArrayType\ArrayOfstring $orderIdListField
     * @return \StructType\AddOrdersRequestEnvelope
     */
    public function setOrderIdListField(\ArrayType\ArrayOfstring $orderIdListField = null)
    {
        $this->orderIdListField = $orderIdListField;
        return $this;
    }
    /**
     * Get seqNoField value
     * @return int|null
     */
    public function getSeqNoField()
    {
        return $this->seqNoField;
    }
    /**
     * Set seqNoField value
     * @param int $seqNoField
     * @return \StructType\AddOrdersRequestEnvelope
     */
    public function setSeqNoField($seqNoField = null)
    {
        // validation for constraint: int
        if (!is_null($seqNoField) && !(is_int($seqNoField) || ctype_digit($seqNoField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($seqNoField, true), gettype($seqNoField)), __LINE__);
        }
        $this->seqNoField = $seqNoField;
        return $this;
    }
}
