<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AssetDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AssetDetails
 * @subpackage Structs
 */
class AssetDetails extends AbstractStructBase
{
    /**
     * The activationDateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $activationDateField;
    /**
     * The assetIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $assetIDField;
    /**
     * The assetTypeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $assetTypeField;
    /**
     * The branchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $branchIDField;
    /**
     * The colorField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $colorField;
    /**
     * The displayOrderField
     * @var int
     */
    public $displayOrderField;
    /**
     * The isDefaultField
     * @var bool
     */
    public $isDefaultField;
    /**
     * The showOnRouteCalendarField
     * @var bool
     */
    public $showOnRouteCalendarField;
    /**
     * The terminationDateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $terminationDateField;
    /**
     * The truckField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\TruckDetails
     */
    public $truckField;
    /**
     * The volumeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfVolume
     */
    public $volumeField;
    /**
     * Constructor method for AssetDetails
     * @uses AssetDetails::setActivationDateField()
     * @uses AssetDetails::setAssetIDField()
     * @uses AssetDetails::setAssetTypeField()
     * @uses AssetDetails::setBranchIDField()
     * @uses AssetDetails::setColorField()
     * @uses AssetDetails::setDisplayOrderField()
     * @uses AssetDetails::setIsDefaultField()
     * @uses AssetDetails::setShowOnRouteCalendarField()
     * @uses AssetDetails::setTerminationDateField()
     * @uses AssetDetails::setTruckField()
     * @uses AssetDetails::setVolumeField()
     * @param string $activationDateField
     * @param string $assetIDField
     * @param string $assetTypeField
     * @param string $branchIDField
     * @param string $colorField
     * @param int $displayOrderField
     * @param bool $isDefaultField
     * @param bool $showOnRouteCalendarField
     * @param string $terminationDateField
     * @param \StructType\TruckDetails $truckField
     * @param \ArrayType\ArrayOfVolume $volumeField
     */
    public function __construct($activationDateField = null, $assetIDField = null, $assetTypeField = null, $branchIDField = null, $colorField = null, $displayOrderField = null, $isDefaultField = null, $showOnRouteCalendarField = null, $terminationDateField = null, \StructType\TruckDetails $truckField = null, \ArrayType\ArrayOfVolume $volumeField = null)
    {
        $this
            ->setActivationDateField($activationDateField)
            ->setAssetIDField($assetIDField)
            ->setAssetTypeField($assetTypeField)
            ->setBranchIDField($branchIDField)
            ->setColorField($colorField)
            ->setDisplayOrderField($displayOrderField)
            ->setIsDefaultField($isDefaultField)
            ->setShowOnRouteCalendarField($showOnRouteCalendarField)
            ->setTerminationDateField($terminationDateField)
            ->setTruckField($truckField)
            ->setVolumeField($volumeField);
    }
    /**
     * Get activationDateField value
     * @return string|null
     */
    public function getActivationDateField()
    {
        return $this->activationDateField;
    }
    /**
     * Set activationDateField value
     * @param string $activationDateField
     * @return \StructType\AssetDetails
     */
    public function setActivationDateField($activationDateField = null)
    {
        // validation for constraint: string
        if (!is_null($activationDateField) && !is_string($activationDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($activationDateField, true), gettype($activationDateField)), __LINE__);
        }
        $this->activationDateField = $activationDateField;
        return $this;
    }
    /**
     * Get assetIDField value
     * @return string|null
     */
    public function getAssetIDField()
    {
        return $this->assetIDField;
    }
    /**
     * Set assetIDField value
     * @param string $assetIDField
     * @return \StructType\AssetDetails
     */
    public function setAssetIDField($assetIDField = null)
    {
        // validation for constraint: string
        if (!is_null($assetIDField) && !is_string($assetIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($assetIDField, true), gettype($assetIDField)), __LINE__);
        }
        $this->assetIDField = $assetIDField;
        return $this;
    }
    /**
     * Get assetTypeField value
     * @return string|null
     */
    public function getAssetTypeField()
    {
        return $this->assetTypeField;
    }
    /**
     * Set assetTypeField value
     * @param string $assetTypeField
     * @return \StructType\AssetDetails
     */
    public function setAssetTypeField($assetTypeField = null)
    {
        // validation for constraint: string
        if (!is_null($assetTypeField) && !is_string($assetTypeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($assetTypeField, true), gettype($assetTypeField)), __LINE__);
        }
        $this->assetTypeField = $assetTypeField;
        return $this;
    }
    /**
     * Get branchIDField value
     * @return string|null
     */
    public function getBranchIDField()
    {
        return $this->branchIDField;
    }
    /**
     * Set branchIDField value
     * @param string $branchIDField
     * @return \StructType\AssetDetails
     */
    public function setBranchIDField($branchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($branchIDField) && !is_string($branchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($branchIDField, true), gettype($branchIDField)), __LINE__);
        }
        $this->branchIDField = $branchIDField;
        return $this;
    }
    /**
     * Get colorField value
     * @return string|null
     */
    public function getColorField()
    {
        return $this->colorField;
    }
    /**
     * Set colorField value
     * @param string $colorField
     * @return \StructType\AssetDetails
     */
    public function setColorField($colorField = null)
    {
        // validation for constraint: string
        if (!is_null($colorField) && !is_string($colorField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($colorField, true), gettype($colorField)), __LINE__);
        }
        $this->colorField = $colorField;
        return $this;
    }
    /**
     * Get displayOrderField value
     * @return int|null
     */
    public function getDisplayOrderField()
    {
        return $this->displayOrderField;
    }
    /**
     * Set displayOrderField value
     * @param int $displayOrderField
     * @return \StructType\AssetDetails
     */
    public function setDisplayOrderField($displayOrderField = null)
    {
        // validation for constraint: int
        if (!is_null($displayOrderField) && !(is_int($displayOrderField) || ctype_digit($displayOrderField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($displayOrderField, true), gettype($displayOrderField)), __LINE__);
        }
        $this->displayOrderField = $displayOrderField;
        return $this;
    }
    /**
     * Get isDefaultField value
     * @return bool|null
     */
    public function getIsDefaultField()
    {
        return $this->isDefaultField;
    }
    /**
     * Set isDefaultField value
     * @param bool $isDefaultField
     * @return \StructType\AssetDetails
     */
    public function setIsDefaultField($isDefaultField = null)
    {
        // validation for constraint: boolean
        if (!is_null($isDefaultField) && !is_bool($isDefaultField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isDefaultField, true), gettype($isDefaultField)), __LINE__);
        }
        $this->isDefaultField = $isDefaultField;
        return $this;
    }
    /**
     * Get showOnRouteCalendarField value
     * @return bool|null
     */
    public function getShowOnRouteCalendarField()
    {
        return $this->showOnRouteCalendarField;
    }
    /**
     * Set showOnRouteCalendarField value
     * @param bool $showOnRouteCalendarField
     * @return \StructType\AssetDetails
     */
    public function setShowOnRouteCalendarField($showOnRouteCalendarField = null)
    {
        // validation for constraint: boolean
        if (!is_null($showOnRouteCalendarField) && !is_bool($showOnRouteCalendarField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($showOnRouteCalendarField, true), gettype($showOnRouteCalendarField)), __LINE__);
        }
        $this->showOnRouteCalendarField = $showOnRouteCalendarField;
        return $this;
    }
    /**
     * Get terminationDateField value
     * @return string|null
     */
    public function getTerminationDateField()
    {
        return $this->terminationDateField;
    }
    /**
     * Set terminationDateField value
     * @param string $terminationDateField
     * @return \StructType\AssetDetails
     */
    public function setTerminationDateField($terminationDateField = null)
    {
        // validation for constraint: string
        if (!is_null($terminationDateField) && !is_string($terminationDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($terminationDateField, true), gettype($terminationDateField)), __LINE__);
        }
        $this->terminationDateField = $terminationDateField;
        return $this;
    }
    /**
     * Get truckField value
     * @return \StructType\TruckDetails|null
     */
    public function getTruckField()
    {
        return $this->truckField;
    }
    /**
     * Set truckField value
     * @param \StructType\TruckDetails $truckField
     * @return \StructType\AssetDetails
     */
    public function setTruckField(\StructType\TruckDetails $truckField = null)
    {
        $this->truckField = $truckField;
        return $this;
    }
    /**
     * Get volumeField value
     * @return \ArrayType\ArrayOfVolume|null
     */
    public function getVolumeField()
    {
        return $this->volumeField;
    }
    /**
     * Set volumeField value
     * @param \ArrayType\ArrayOfVolume $volumeField
     * @return \StructType\AssetDetails
     */
    public function setVolumeField(\ArrayType\ArrayOfVolume $volumeField = null)
    {
        $this->volumeField = $volumeField;
        return $this;
    }
}
