<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BuildRouteRequestEnvelope StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:BuildRouteRequestEnvelope
 * @subpackage Structs
 */
class BuildRouteRequestEnvelope extends AbstractStructBase
{
    /**
     * The branchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $branchIDField;
    /**
     * The externalIdListField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $externalIdListField;
    /**
     * The loadIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $loadIDField;
    /**
     * The orderIdListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $orderIdListField;
    /**
     * The profileNameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $profileNameField;
    /**
     * The startDateField
     * @var string
     */
    public $startDateField;
    /**
     * The truckIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $truckIDField;
    /**
     * Constructor method for BuildRouteRequestEnvelope
     * @uses BuildRouteRequestEnvelope::setBranchIDField()
     * @uses BuildRouteRequestEnvelope::setExternalIdListField()
     * @uses BuildRouteRequestEnvelope::setLoadIDField()
     * @uses BuildRouteRequestEnvelope::setOrderIdListField()
     * @uses BuildRouteRequestEnvelope::setProfileNameField()
     * @uses BuildRouteRequestEnvelope::setStartDateField()
     * @uses BuildRouteRequestEnvelope::setTruckIDField()
     * @param string $branchIDField
     * @param \ArrayType\ArrayOfstring $externalIdListField
     * @param string $loadIDField
     * @param \ArrayType\ArrayOfstring $orderIdListField
     * @param string $profileNameField
     * @param string $startDateField
     * @param string $truckIDField
     */
    public function __construct($branchIDField = null, \ArrayType\ArrayOfstring $externalIdListField = null, $loadIDField = null, \ArrayType\ArrayOfstring $orderIdListField = null, $profileNameField = null, $startDateField = null, $truckIDField = null)
    {
        $this
            ->setBranchIDField($branchIDField)
            ->setExternalIdListField($externalIdListField)
            ->setLoadIDField($loadIDField)
            ->setOrderIdListField($orderIdListField)
            ->setProfileNameField($profileNameField)
            ->setStartDateField($startDateField)
            ->setTruckIDField($truckIDField);
    }
    /**
     * Get branchIDField value
     * @return string|null
     */
    public function getBranchIDField()
    {
        return $this->branchIDField;
    }
    /**
     * Set branchIDField value
     * @param string $branchIDField
     * @return \StructType\BuildRouteRequestEnvelope
     */
    public function setBranchIDField($branchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($branchIDField) && !is_string($branchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($branchIDField, true), gettype($branchIDField)), __LINE__);
        }
        $this->branchIDField = $branchIDField;
        return $this;
    }
    /**
     * Get externalIdListField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getExternalIdListField()
    {
        return isset($this->externalIdListField) ? $this->externalIdListField : null;
    }
    /**
     * Set externalIdListField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $externalIdListField
     * @return \StructType\BuildRouteRequestEnvelope
     */
    public function setExternalIdListField(\ArrayType\ArrayOfstring $externalIdListField = null)
    {
        if (is_null($externalIdListField) || (is_array($externalIdListField) && empty($externalIdListField))) {
            unset($this->externalIdListField);
        } else {
            $this->externalIdListField = $externalIdListField;
        }
        return $this;
    }
    /**
     * Get loadIDField value
     * @return string|null
     */
    public function getLoadIDField()
    {
        return $this->loadIDField;
    }
    /**
     * Set loadIDField value
     * @param string $loadIDField
     * @return \StructType\BuildRouteRequestEnvelope
     */
    public function setLoadIDField($loadIDField = null)
    {
        // validation for constraint: string
        if (!is_null($loadIDField) && !is_string($loadIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadIDField, true), gettype($loadIDField)), __LINE__);
        }
        $this->loadIDField = $loadIDField;
        return $this;
    }
    /**
     * Get orderIdListField value
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getOrderIdListField()
    {
        return $this->orderIdListField;
    }
    /**
     * Set orderIdListField value
     * @param \ArrayType\ArrayOfstring $orderIdListField
     * @return \StructType\BuildRouteRequestEnvelope
     */
    public function setOrderIdListField(\ArrayType\ArrayOfstring $orderIdListField = null)
    {
        $this->orderIdListField = $orderIdListField;
        return $this;
    }
    /**
     * Get profileNameField value
     * @return string|null
     */
    public function getProfileNameField()
    {
        return $this->profileNameField;
    }
    /**
     * Set profileNameField value
     * @param string $profileNameField
     * @return \StructType\BuildRouteRequestEnvelope
     */
    public function setProfileNameField($profileNameField = null)
    {
        // validation for constraint: string
        if (!is_null($profileNameField) && !is_string($profileNameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($profileNameField, true), gettype($profileNameField)), __LINE__);
        }
        $this->profileNameField = $profileNameField;
        return $this;
    }
    /**
     * Get startDateField value
     * @return string|null
     */
    public function getStartDateField()
    {
        return $this->startDateField;
    }
    /**
     * Set startDateField value
     * @param string $startDateField
     * @return \StructType\BuildRouteRequestEnvelope
     */
    public function setStartDateField($startDateField = null)
    {
        // validation for constraint: string
        if (!is_null($startDateField) && !is_string($startDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startDateField, true), gettype($startDateField)), __LINE__);
        }
        $this->startDateField = $startDateField;
        return $this;
    }
    /**
     * Get truckIDField value
     * @return string|null
     */
    public function getTruckIDField()
    {
        return $this->truckIDField;
    }
    /**
     * Set truckIDField value
     * @param string $truckIDField
     * @return \StructType\BuildRouteRequestEnvelope
     */
    public function setTruckIDField($truckIDField = null)
    {
        // validation for constraint: string
        if (!is_null($truckIDField) && !is_string($truckIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($truckIDField, true), gettype($truckIDField)), __LINE__);
        }
        $this->truckIDField = $truckIDField;
        return $this;
    }
}
