<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChangeAccountFrequencyRequestEnvelope StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ChangeAccountFrequencyRequestEnvelope
 * @subpackage Structs
 */
class ChangeAccountFrequencyRequestEnvelope extends AbstractStructBase
{
    /**
     * The accountIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $accountIDField;
    /**
     * The branchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $branchIDField;
    /**
     * The effectiveDateField
     * @var string
     */
    public $effectiveDateField;
    /**
     * The frequencyField
     * @var float
     */
    public $frequencyField;
    /**
     * Constructor method for ChangeAccountFrequencyRequestEnvelope
     * @uses ChangeAccountFrequencyRequestEnvelope::setAccountIDField()
     * @uses ChangeAccountFrequencyRequestEnvelope::setBranchIDField()
     * @uses ChangeAccountFrequencyRequestEnvelope::setEffectiveDateField()
     * @uses ChangeAccountFrequencyRequestEnvelope::setFrequencyField()
     * @param string $accountIDField
     * @param string $branchIDField
     * @param string $effectiveDateField
     * @param float $frequencyField
     */
    public function __construct($accountIDField = null, $branchIDField = null, $effectiveDateField = null, $frequencyField = null)
    {
        $this
            ->setAccountIDField($accountIDField)
            ->setBranchIDField($branchIDField)
            ->setEffectiveDateField($effectiveDateField)
            ->setFrequencyField($frequencyField);
    }
    /**
     * Get accountIDField value
     * @return string|null
     */
    public function getAccountIDField()
    {
        return $this->accountIDField;
    }
    /**
     * Set accountIDField value
     * @param string $accountIDField
     * @return \StructType\ChangeAccountFrequencyRequestEnvelope
     */
    public function setAccountIDField($accountIDField = null)
    {
        // validation for constraint: string
        if (!is_null($accountIDField) && !is_string($accountIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accountIDField, true), gettype($accountIDField)), __LINE__);
        }
        $this->accountIDField = $accountIDField;
        return $this;
    }
    /**
     * Get branchIDField value
     * @return string|null
     */
    public function getBranchIDField()
    {
        return $this->branchIDField;
    }
    /**
     * Set branchIDField value
     * @param string $branchIDField
     * @return \StructType\ChangeAccountFrequencyRequestEnvelope
     */
    public function setBranchIDField($branchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($branchIDField) && !is_string($branchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($branchIDField, true), gettype($branchIDField)), __LINE__);
        }
        $this->branchIDField = $branchIDField;
        return $this;
    }
    /**
     * Get effectiveDateField value
     * @return string|null
     */
    public function getEffectiveDateField()
    {
        return $this->effectiveDateField;
    }
    /**
     * Set effectiveDateField value
     * @param string $effectiveDateField
     * @return \StructType\ChangeAccountFrequencyRequestEnvelope
     */
    public function setEffectiveDateField($effectiveDateField = null)
    {
        // validation for constraint: string
        if (!is_null($effectiveDateField) && !is_string($effectiveDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($effectiveDateField, true), gettype($effectiveDateField)), __LINE__);
        }
        $this->effectiveDateField = $effectiveDateField;
        return $this;
    }
    /**
     * Get frequencyField value
     * @return float|null
     */
    public function getFrequencyField()
    {
        return $this->frequencyField;
    }
    /**
     * Set frequencyField value
     * @param float $frequencyField
     * @return \StructType\ChangeAccountFrequencyRequestEnvelope
     */
    public function setFrequencyField($frequencyField = null)
    {
        // validation for constraint: float
        if (!is_null($frequencyField) && !(is_float($frequencyField) || is_numeric($frequencyField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($frequencyField, true), gettype($frequencyField)), __LINE__);
        }
        $this->frequencyField = $frequencyField;
        return $this;
    }
}
