<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DRTimeWindow StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DRTimeWindow
 * @subpackage Structs
 */
class DRTimeWindow extends AbstractStructBase
{
    /**
     * The closeField
     * @var string
     */
    public $closeField;
    /**
     * The openField
     * @var string
     */
    public $openField;
    /**
     * The patternField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $patternField;
    /**
     * Constructor method for DRTimeWindow
     * @uses DRTimeWindow::setCloseField()
     * @uses DRTimeWindow::setOpenField()
     * @uses DRTimeWindow::setPatternField()
     * @param string $closeField
     * @param string $openField
     * @param string $patternField
     */
    public function __construct($closeField = null, $openField = null, $patternField = null)
    {
        $this
            ->setCloseField($closeField)
            ->setOpenField($openField)
            ->setPatternField($patternField);
    }
    /**
     * Get closeField value
     * @return string|null
     */
    public function getCloseField()
    {
        return $this->closeField;
    }
    /**
     * Set closeField value
     * @param string $closeField
     * @return \StructType\DRTimeWindow
     */
    public function setCloseField($closeField = null)
    {
        // validation for constraint: string
        if (!is_null($closeField) && !is_string($closeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($closeField, true), gettype($closeField)), __LINE__);
        }
        $this->closeField = $closeField;
        return $this;
    }
    /**
     * Get openField value
     * @return string|null
     */
    public function getOpenField()
    {
        return $this->openField;
    }
    /**
     * Set openField value
     * @param string $openField
     * @return \StructType\DRTimeWindow
     */
    public function setOpenField($openField = null)
    {
        // validation for constraint: string
        if (!is_null($openField) && !is_string($openField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($openField, true), gettype($openField)), __LINE__);
        }
        $this->openField = $openField;
        return $this;
    }
    /**
     * Get patternField value
     * @return string|null
     */
    public function getPatternField()
    {
        return $this->patternField;
    }
    /**
     * Set patternField value
     * @param string $patternField
     * @return \StructType\DRTimeWindow
     */
    public function setPatternField($patternField = null)
    {
        // validation for constraint: string
        if (!is_null($patternField) && !is_string($patternField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($patternField, true), gettype($patternField)), __LINE__);
        }
        $this->patternField = $patternField;
        return $this;
    }
}
