<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DRTrackPreferences StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DRTrackPreferences
 * @subpackage Structs
 */
class DRTrackPreferences extends AbstractStructBase
{
    /**
     * The daysAssignedField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\DRTrackPreferencesDaysAssigned
     */
    public $daysAssignedField;
    /**
     * The finalizeRoutesField
     * @var bool
     */
    public $finalizeRoutesField;
    /**
     * The finalizeRoutesFieldSpecified
     * @var bool
     */
    public $finalizeRoutesFieldSpecified;
    /**
     * The noOfWeeksClonedField
     * @var int
     */
    public $noOfWeeksClonedField;
    /**
     * The overWriteExistingRoutesField
     * @var bool
     */
    public $overWriteExistingRoutesField;
    /**
     * The updateAccountMasterField
     * @var bool
     */
    public $updateAccountMasterField;
    /**
     * Constructor method for DRTrackPreferences
     * @uses DRTrackPreferences::setDaysAssignedField()
     * @uses DRTrackPreferences::setFinalizeRoutesField()
     * @uses DRTrackPreferences::setFinalizeRoutesFieldSpecified()
     * @uses DRTrackPreferences::setNoOfWeeksClonedField()
     * @uses DRTrackPreferences::setOverWriteExistingRoutesField()
     * @uses DRTrackPreferences::setUpdateAccountMasterField()
     * @param \StructType\DRTrackPreferencesDaysAssigned $daysAssignedField
     * @param bool $finalizeRoutesField
     * @param bool $finalizeRoutesFieldSpecified
     * @param int $noOfWeeksClonedField
     * @param bool $overWriteExistingRoutesField
     * @param bool $updateAccountMasterField
     */
    public function __construct(\StructType\DRTrackPreferencesDaysAssigned $daysAssignedField = null, $finalizeRoutesField = null, $finalizeRoutesFieldSpecified = null, $noOfWeeksClonedField = null, $overWriteExistingRoutesField = null, $updateAccountMasterField = null)
    {
        $this
            ->setDaysAssignedField($daysAssignedField)
            ->setFinalizeRoutesField($finalizeRoutesField)
            ->setFinalizeRoutesFieldSpecified($finalizeRoutesFieldSpecified)
            ->setNoOfWeeksClonedField($noOfWeeksClonedField)
            ->setOverWriteExistingRoutesField($overWriteExistingRoutesField)
            ->setUpdateAccountMasterField($updateAccountMasterField);
    }
    /**
     * Get daysAssignedField value
     * @return \StructType\DRTrackPreferencesDaysAssigned|null
     */
    public function getDaysAssignedField()
    {
        return $this->daysAssignedField;
    }
    /**
     * Set daysAssignedField value
     * @param \StructType\DRTrackPreferencesDaysAssigned $daysAssignedField
     * @return \StructType\DRTrackPreferences
     */
    public function setDaysAssignedField(\StructType\DRTrackPreferencesDaysAssigned $daysAssignedField = null)
    {
        $this->daysAssignedField = $daysAssignedField;
        return $this;
    }
    /**
     * Get finalizeRoutesField value
     * @return bool|null
     */
    public function getFinalizeRoutesField()
    {
        return $this->finalizeRoutesField;
    }
    /**
     * Set finalizeRoutesField value
     * @param bool $finalizeRoutesField
     * @return \StructType\DRTrackPreferences
     */
    public function setFinalizeRoutesField($finalizeRoutesField = null)
    {
        // validation for constraint: boolean
        if (!is_null($finalizeRoutesField) && !is_bool($finalizeRoutesField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($finalizeRoutesField, true), gettype($finalizeRoutesField)), __LINE__);
        }
        $this->finalizeRoutesField = $finalizeRoutesField;
        return $this;
    }
    /**
     * Get finalizeRoutesFieldSpecified value
     * @return bool|null
     */
    public function getFinalizeRoutesFieldSpecified()
    {
        return $this->finalizeRoutesFieldSpecified;
    }
    /**
     * Set finalizeRoutesFieldSpecified value
     * @param bool $finalizeRoutesFieldSpecified
     * @return \StructType\DRTrackPreferences
     */
    public function setFinalizeRoutesFieldSpecified($finalizeRoutesFieldSpecified = null)
    {
        // validation for constraint: boolean
        if (!is_null($finalizeRoutesFieldSpecified) && !is_bool($finalizeRoutesFieldSpecified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($finalizeRoutesFieldSpecified, true), gettype($finalizeRoutesFieldSpecified)), __LINE__);
        }
        $this->finalizeRoutesFieldSpecified = $finalizeRoutesFieldSpecified;
        return $this;
    }
    /**
     * Get noOfWeeksClonedField value
     * @return int|null
     */
    public function getNoOfWeeksClonedField()
    {
        return $this->noOfWeeksClonedField;
    }
    /**
     * Set noOfWeeksClonedField value
     * @param int $noOfWeeksClonedField
     * @return \StructType\DRTrackPreferences
     */
    public function setNoOfWeeksClonedField($noOfWeeksClonedField = null)
    {
        // validation for constraint: int
        if (!is_null($noOfWeeksClonedField) && !(is_int($noOfWeeksClonedField) || ctype_digit($noOfWeeksClonedField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($noOfWeeksClonedField, true), gettype($noOfWeeksClonedField)), __LINE__);
        }
        $this->noOfWeeksClonedField = $noOfWeeksClonedField;
        return $this;
    }
    /**
     * Get overWriteExistingRoutesField value
     * @return bool|null
     */
    public function getOverWriteExistingRoutesField()
    {
        return $this->overWriteExistingRoutesField;
    }
    /**
     * Set overWriteExistingRoutesField value
     * @param bool $overWriteExistingRoutesField
     * @return \StructType\DRTrackPreferences
     */
    public function setOverWriteExistingRoutesField($overWriteExistingRoutesField = null)
    {
        // validation for constraint: boolean
        if (!is_null($overWriteExistingRoutesField) && !is_bool($overWriteExistingRoutesField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($overWriteExistingRoutesField, true), gettype($overWriteExistingRoutesField)), __LINE__);
        }
        $this->overWriteExistingRoutesField = $overWriteExistingRoutesField;
        return $this;
    }
    /**
     * Get updateAccountMasterField value
     * @return bool|null
     */
    public function getUpdateAccountMasterField()
    {
        return $this->updateAccountMasterField;
    }
    /**
     * Set updateAccountMasterField value
     * @param bool $updateAccountMasterField
     * @return \StructType\DRTrackPreferences
     */
    public function setUpdateAccountMasterField($updateAccountMasterField = null)
    {
        // validation for constraint: boolean
        if (!is_null($updateAccountMasterField) && !is_bool($updateAccountMasterField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($updateAccountMasterField, true), gettype($updateAccountMasterField)), __LINE__);
        }
        $this->updateAccountMasterField = $updateAccountMasterField;
        return $this;
    }
}
