<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeviceDataStop StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DeviceDataStop
 * @subpackage Structs
 */
class DeviceDataStop extends AbstractStructBase
{
    /**
     * The acctIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $acctIDField;
    /**
     * The arrivalTimeField
     * @var string
     */
    public $arrivalTimeField;
    /**
     * The departureTimeField
     * @var string
     */
    public $departureTimeField;
    /**
     * The deviceFormListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfForm
     */
    public $deviceFormListField;
    /**
     * The dispatchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dispatchIDField;
    /**
     * The driverIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $driverIDField;
    /**
     * The inprogressField
     * @var bool
     */
    public $inprogressField;
    /**
     * The internalRouteIDField
     * @var int
     */
    public $internalRouteIDField;
    /**
     * The isTerminalField
     * @var bool
     */
    public $isTerminalField;
    /**
     * The latitudeField
     * @var float
     */
    public $latitudeField;
    /**
     * The legField
     * @var string
     */
    public $legField;
    /**
     * The longitudeField
     * @var float
     */
    public $longitudeField;
    /**
     * The odometerField
     * @var float
     */
    public $odometerField;
    /**
     * The odometerFieldSpecified
     * @var bool
     */
    public $odometerFieldSpecified;
    /**
     * The orderListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfOrderFormInfo
     */
    public $orderListField;
    /**
     * The qtyFieldListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfQtyField
     */
    public $qtyFieldListField;
    /**
     * The sequenceField
     * @var string
     */
    public $sequenceField;
    /**
     * The userFieldListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfUserField
     */
    public $userFieldListField;
    /**
     * Constructor method for DeviceDataStop
     * @uses DeviceDataStop::setAcctIDField()
     * @uses DeviceDataStop::setArrivalTimeField()
     * @uses DeviceDataStop::setDepartureTimeField()
     * @uses DeviceDataStop::setDeviceFormListField()
     * @uses DeviceDataStop::setDispatchIDField()
     * @uses DeviceDataStop::setDriverIDField()
     * @uses DeviceDataStop::setInprogressField()
     * @uses DeviceDataStop::setInternalRouteIDField()
     * @uses DeviceDataStop::setIsTerminalField()
     * @uses DeviceDataStop::setLatitudeField()
     * @uses DeviceDataStop::setLegField()
     * @uses DeviceDataStop::setLongitudeField()
     * @uses DeviceDataStop::setOdometerField()
     * @uses DeviceDataStop::setOdometerFieldSpecified()
     * @uses DeviceDataStop::setOrderListField()
     * @uses DeviceDataStop::setQtyFieldListField()
     * @uses DeviceDataStop::setSequenceField()
     * @uses DeviceDataStop::setUserFieldListField()
     * @param string $acctIDField
     * @param string $arrivalTimeField
     * @param string $departureTimeField
     * @param \ArrayType\ArrayOfForm $deviceFormListField
     * @param string $dispatchIDField
     * @param string $driverIDField
     * @param bool $inprogressField
     * @param int $internalRouteIDField
     * @param bool $isTerminalField
     * @param float $latitudeField
     * @param string $legField
     * @param float $longitudeField
     * @param float $odometerField
     * @param bool $odometerFieldSpecified
     * @param \ArrayType\ArrayOfOrderFormInfo $orderListField
     * @param \ArrayType\ArrayOfQtyField $qtyFieldListField
     * @param string $sequenceField
     * @param \ArrayType\ArrayOfUserField $userFieldListField
     */
    public function __construct($acctIDField = null, $arrivalTimeField = null, $departureTimeField = null, \ArrayType\ArrayOfForm $deviceFormListField = null, $dispatchIDField = null, $driverIDField = null, $inprogressField = null, $internalRouteIDField = null, $isTerminalField = null, $latitudeField = null, $legField = null, $longitudeField = null, $odometerField = null, $odometerFieldSpecified = null, \ArrayType\ArrayOfOrderFormInfo $orderListField = null, \ArrayType\ArrayOfQtyField $qtyFieldListField = null, $sequenceField = null, \ArrayType\ArrayOfUserField $userFieldListField = null)
    {
        $this
            ->setAcctIDField($acctIDField)
            ->setArrivalTimeField($arrivalTimeField)
            ->setDepartureTimeField($departureTimeField)
            ->setDeviceFormListField($deviceFormListField)
            ->setDispatchIDField($dispatchIDField)
            ->setDriverIDField($driverIDField)
            ->setInprogressField($inprogressField)
            ->setInternalRouteIDField($internalRouteIDField)
            ->setIsTerminalField($isTerminalField)
            ->setLatitudeField($latitudeField)
            ->setLegField($legField)
            ->setLongitudeField($longitudeField)
            ->setOdometerField($odometerField)
            ->setOdometerFieldSpecified($odometerFieldSpecified)
            ->setOrderListField($orderListField)
            ->setQtyFieldListField($qtyFieldListField)
            ->setSequenceField($sequenceField)
            ->setUserFieldListField($userFieldListField);
    }
    /**
     * Get acctIDField value
     * @return string|null
     */
    public function getAcctIDField()
    {
        return $this->acctIDField;
    }
    /**
     * Set acctIDField value
     * @param string $acctIDField
     * @return \StructType\DeviceDataStop
     */
    public function setAcctIDField($acctIDField = null)
    {
        // validation for constraint: string
        if (!is_null($acctIDField) && !is_string($acctIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($acctIDField, true), gettype($acctIDField)), __LINE__);
        }
        $this->acctIDField = $acctIDField;
        return $this;
    }
    /**
     * Get arrivalTimeField value
     * @return string|null
     */
    public function getArrivalTimeField()
    {
        return $this->arrivalTimeField;
    }
    /**
     * Set arrivalTimeField value
     * @param string $arrivalTimeField
     * @return \StructType\DeviceDataStop
     */
    public function setArrivalTimeField($arrivalTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalTimeField) && !is_string($arrivalTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($arrivalTimeField, true), gettype($arrivalTimeField)), __LINE__);
        }
        $this->arrivalTimeField = $arrivalTimeField;
        return $this;
    }
    /**
     * Get departureTimeField value
     * @return string|null
     */
    public function getDepartureTimeField()
    {
        return $this->departureTimeField;
    }
    /**
     * Set departureTimeField value
     * @param string $departureTimeField
     * @return \StructType\DeviceDataStop
     */
    public function setDepartureTimeField($departureTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($departureTimeField) && !is_string($departureTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($departureTimeField, true), gettype($departureTimeField)), __LINE__);
        }
        $this->departureTimeField = $departureTimeField;
        return $this;
    }
    /**
     * Get deviceFormListField value
     * @return \ArrayType\ArrayOfForm|null
     */
    public function getDeviceFormListField()
    {
        return $this->deviceFormListField;
    }
    /**
     * Set deviceFormListField value
     * @param \ArrayType\ArrayOfForm $deviceFormListField
     * @return \StructType\DeviceDataStop
     */
    public function setDeviceFormListField(\ArrayType\ArrayOfForm $deviceFormListField = null)
    {
        $this->deviceFormListField = $deviceFormListField;
        return $this;
    }
    /**
     * Get dispatchIDField value
     * @return string|null
     */
    public function getDispatchIDField()
    {
        return $this->dispatchIDField;
    }
    /**
     * Set dispatchIDField value
     * @param string $dispatchIDField
     * @return \StructType\DeviceDataStop
     */
    public function setDispatchIDField($dispatchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($dispatchIDField) && !is_string($dispatchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dispatchIDField, true), gettype($dispatchIDField)), __LINE__);
        }
        $this->dispatchIDField = $dispatchIDField;
        return $this;
    }
    /**
     * Get driverIDField value
     * @return string|null
     */
    public function getDriverIDField()
    {
        return $this->driverIDField;
    }
    /**
     * Set driverIDField value
     * @param string $driverIDField
     * @return \StructType\DeviceDataStop
     */
    public function setDriverIDField($driverIDField = null)
    {
        // validation for constraint: string
        if (!is_null($driverIDField) && !is_string($driverIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverIDField, true), gettype($driverIDField)), __LINE__);
        }
        $this->driverIDField = $driverIDField;
        return $this;
    }
    /**
     * Get inprogressField value
     * @return bool|null
     */
    public function getInprogressField()
    {
        return $this->inprogressField;
    }
    /**
     * Set inprogressField value
     * @param bool $inprogressField
     * @return \StructType\DeviceDataStop
     */
    public function setInprogressField($inprogressField = null)
    {
        // validation for constraint: boolean
        if (!is_null($inprogressField) && !is_bool($inprogressField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($inprogressField, true), gettype($inprogressField)), __LINE__);
        }
        $this->inprogressField = $inprogressField;
        return $this;
    }
    /**
     * Get internalRouteIDField value
     * @return int|null
     */
    public function getInternalRouteIDField()
    {
        return $this->internalRouteIDField;
    }
    /**
     * Set internalRouteIDField value
     * @param int $internalRouteIDField
     * @return \StructType\DeviceDataStop
     */
    public function setInternalRouteIDField($internalRouteIDField = null)
    {
        // validation for constraint: int
        if (!is_null($internalRouteIDField) && !(is_int($internalRouteIDField) || ctype_digit($internalRouteIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($internalRouteIDField, true), gettype($internalRouteIDField)), __LINE__);
        }
        $this->internalRouteIDField = $internalRouteIDField;
        return $this;
    }
    /**
     * Get isTerminalField value
     * @return bool|null
     */
    public function getIsTerminalField()
    {
        return $this->isTerminalField;
    }
    /**
     * Set isTerminalField value
     * @param bool $isTerminalField
     * @return \StructType\DeviceDataStop
     */
    public function setIsTerminalField($isTerminalField = null)
    {
        // validation for constraint: boolean
        if (!is_null($isTerminalField) && !is_bool($isTerminalField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isTerminalField, true), gettype($isTerminalField)), __LINE__);
        }
        $this->isTerminalField = $isTerminalField;
        return $this;
    }
    /**
     * Get latitudeField value
     * @return float|null
     */
    public function getLatitudeField()
    {
        return $this->latitudeField;
    }
    /**
     * Set latitudeField value
     * @param float $latitudeField
     * @return \StructType\DeviceDataStop
     */
    public function setLatitudeField($latitudeField = null)
    {
        // validation for constraint: float
        if (!is_null($latitudeField) && !(is_float($latitudeField) || is_numeric($latitudeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($latitudeField, true), gettype($latitudeField)), __LINE__);
        }
        $this->latitudeField = $latitudeField;
        return $this;
    }
    /**
     * Get legField value
     * @return string|null
     */
    public function getLegField()
    {
        return $this->legField;
    }
    /**
     * Set legField value
     * @param string $legField
     * @return \StructType\DeviceDataStop
     */
    public function setLegField($legField = null)
    {
        // validation for constraint: string
        if (!is_null($legField) && !is_string($legField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legField, true), gettype($legField)), __LINE__);
        }
        $this->legField = $legField;
        return $this;
    }
    /**
     * Get longitudeField value
     * @return float|null
     */
    public function getLongitudeField()
    {
        return $this->longitudeField;
    }
    /**
     * Set longitudeField value
     * @param float $longitudeField
     * @return \StructType\DeviceDataStop
     */
    public function setLongitudeField($longitudeField = null)
    {
        // validation for constraint: float
        if (!is_null($longitudeField) && !(is_float($longitudeField) || is_numeric($longitudeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($longitudeField, true), gettype($longitudeField)), __LINE__);
        }
        $this->longitudeField = $longitudeField;
        return $this;
    }
    /**
     * Get odometerField value
     * @return float|null
     */
    public function getOdometerField()
    {
        return $this->odometerField;
    }
    /**
     * Set odometerField value
     * @param float $odometerField
     * @return \StructType\DeviceDataStop
     */
    public function setOdometerField($odometerField = null)
    {
        // validation for constraint: float
        if (!is_null($odometerField) && !(is_float($odometerField) || is_numeric($odometerField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($odometerField, true), gettype($odometerField)), __LINE__);
        }
        $this->odometerField = $odometerField;
        return $this;
    }
    /**
     * Get odometerFieldSpecified value
     * @return bool|null
     */
    public function getOdometerFieldSpecified()
    {
        return $this->odometerFieldSpecified;
    }
    /**
     * Set odometerFieldSpecified value
     * @param bool $odometerFieldSpecified
     * @return \StructType\DeviceDataStop
     */
    public function setOdometerFieldSpecified($odometerFieldSpecified = null)
    {
        // validation for constraint: boolean
        if (!is_null($odometerFieldSpecified) && !is_bool($odometerFieldSpecified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($odometerFieldSpecified, true), gettype($odometerFieldSpecified)), __LINE__);
        }
        $this->odometerFieldSpecified = $odometerFieldSpecified;
        return $this;
    }
    /**
     * Get orderListField value
     * @return \ArrayType\ArrayOfOrderFormInfo|null
     */
    public function getOrderListField()
    {
        return $this->orderListField;
    }
    /**
     * Set orderListField value
     * @param \ArrayType\ArrayOfOrderFormInfo $orderListField
     * @return \StructType\DeviceDataStop
     */
    public function setOrderListField(\ArrayType\ArrayOfOrderFormInfo $orderListField = null)
    {
        $this->orderListField = $orderListField;
        return $this;
    }
    /**
     * Get qtyFieldListField value
     * @return \ArrayType\ArrayOfQtyField|null
     */
    public function getQtyFieldListField()
    {
        return $this->qtyFieldListField;
    }
    /**
     * Set qtyFieldListField value
     * @param \ArrayType\ArrayOfQtyField $qtyFieldListField
     * @return \StructType\DeviceDataStop
     */
    public function setQtyFieldListField(\ArrayType\ArrayOfQtyField $qtyFieldListField = null)
    {
        $this->qtyFieldListField = $qtyFieldListField;
        return $this;
    }
    /**
     * Get sequenceField value
     * @return string|null
     */
    public function getSequenceField()
    {
        return $this->sequenceField;
    }
    /**
     * Set sequenceField value
     * @param string $sequenceField
     * @return \StructType\DeviceDataStop
     */
    public function setSequenceField($sequenceField = null)
    {
        // validation for constraint: string
        if (!is_null($sequenceField) && !is_string($sequenceField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sequenceField, true), gettype($sequenceField)), __LINE__);
        }
        $this->sequenceField = $sequenceField;
        return $this;
    }
    /**
     * Get userFieldListField value
     * @return \ArrayType\ArrayOfUserField|null
     */
    public function getUserFieldListField()
    {
        return $this->userFieldListField;
    }
    /**
     * Set userFieldListField value
     * @param \ArrayType\ArrayOfUserField $userFieldListField
     * @return \StructType\DeviceDataStop
     */
    public function setUserFieldListField(\ArrayType\ArrayOfUserField $userFieldListField = null)
    {
        $this->userFieldListField = $userFieldListField;
        return $this;
    }
}
