<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DriverDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:DriverDetails
 * @subpackage Structs
 */
class DriverDetails extends AbstractStructBase
{
    /**
     * The address1Field
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $address1Field;
    /**
     * The address2Field
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $address2Field;
    /**
     * The branchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $branchIDField;
    /**
     * The cellPhoneField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $cellPhoneField;
    /**
     * The cityField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $cityField;
    /**
     * The deviceIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $deviceIDField;
    /**
     * The driverIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $driverIDField;
    /**
     * The driverTypeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $driverTypeField;
    /**
     * The emailAddressField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $emailAddressField;
    /**
     * The firstNameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $firstNameField;
    /**
     * The homePhoneField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $homePhoneField;
    /**
     * The lastNameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $lastNameField;
    /**
     * The officePhoneField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $officePhoneField;
    /**
     * The showOnCalendarField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var bool
     */
    public $showOnCalendarField;
    /**
     * The stateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $stateField;
    /**
     * The teamDriverField
     * @var bool
     */
    public $teamDriverField;
    /**
     * The temporaryDriverField
     * @var bool
     */
    public $temporaryDriverField;
    /**
     * The zipField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $zipField;
    /**
     * Constructor method for DriverDetails
     * @uses DriverDetails::setAddress1Field()
     * @uses DriverDetails::setAddress2Field()
     * @uses DriverDetails::setBranchIDField()
     * @uses DriverDetails::setCellPhoneField()
     * @uses DriverDetails::setCityField()
     * @uses DriverDetails::setDeviceIDField()
     * @uses DriverDetails::setDriverIDField()
     * @uses DriverDetails::setDriverTypeField()
     * @uses DriverDetails::setEmailAddressField()
     * @uses DriverDetails::setFirstNameField()
     * @uses DriverDetails::setHomePhoneField()
     * @uses DriverDetails::setLastNameField()
     * @uses DriverDetails::setOfficePhoneField()
     * @uses DriverDetails::setShowOnCalendarField()
     * @uses DriverDetails::setStateField()
     * @uses DriverDetails::setTeamDriverField()
     * @uses DriverDetails::setTemporaryDriverField()
     * @uses DriverDetails::setZipField()
     * @param string $address1Field
     * @param string $address2Field
     * @param string $branchIDField
     * @param string $cellPhoneField
     * @param string $cityField
     * @param string $deviceIDField
     * @param string $driverIDField
     * @param string $driverTypeField
     * @param string $emailAddressField
     * @param string $firstNameField
     * @param string $homePhoneField
     * @param string $lastNameField
     * @param string $officePhoneField
     * @param bool $showOnCalendarField
     * @param string $stateField
     * @param bool $teamDriverField
     * @param bool $temporaryDriverField
     * @param string $zipField
     */
    public function __construct($address1Field = null, $address2Field = null, $branchIDField = null, $cellPhoneField = null, $cityField = null, $deviceIDField = null, $driverIDField = null, $driverTypeField = null, $emailAddressField = null, $firstNameField = null, $homePhoneField = null, $lastNameField = null, $officePhoneField = null, $showOnCalendarField = null, $stateField = null, $teamDriverField = null, $temporaryDriverField = null, $zipField = null)
    {
        $this
            ->setAddress1Field($address1Field)
            ->setAddress2Field($address2Field)
            ->setBranchIDField($branchIDField)
            ->setCellPhoneField($cellPhoneField)
            ->setCityField($cityField)
            ->setDeviceIDField($deviceIDField)
            ->setDriverIDField($driverIDField)
            ->setDriverTypeField($driverTypeField)
            ->setEmailAddressField($emailAddressField)
            ->setFirstNameField($firstNameField)
            ->setHomePhoneField($homePhoneField)
            ->setLastNameField($lastNameField)
            ->setOfficePhoneField($officePhoneField)
            ->setShowOnCalendarField($showOnCalendarField)
            ->setStateField($stateField)
            ->setTeamDriverField($teamDriverField)
            ->setTemporaryDriverField($temporaryDriverField)
            ->setZipField($zipField);
    }
    /**
     * Get address1Field value
     * @return string|null
     */
    public function getAddress1Field()
    {
        return $this->address1Field;
    }
    /**
     * Set address1Field value
     * @param string $address1Field
     * @return \StructType\DriverDetails
     */
    public function setAddress1Field($address1Field = null)
    {
        // validation for constraint: string
        if (!is_null($address1Field) && !is_string($address1Field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address1Field, true), gettype($address1Field)), __LINE__);
        }
        $this->address1Field = $address1Field;
        return $this;
    }
    /**
     * Get address2Field value
     * @return string|null
     */
    public function getAddress2Field()
    {
        return $this->address2Field;
    }
    /**
     * Set address2Field value
     * @param string $address2Field
     * @return \StructType\DriverDetails
     */
    public function setAddress2Field($address2Field = null)
    {
        // validation for constraint: string
        if (!is_null($address2Field) && !is_string($address2Field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address2Field, true), gettype($address2Field)), __LINE__);
        }
        $this->address2Field = $address2Field;
        return $this;
    }
    /**
     * Get branchIDField value
     * @return string|null
     */
    public function getBranchIDField()
    {
        return $this->branchIDField;
    }
    /**
     * Set branchIDField value
     * @param string $branchIDField
     * @return \StructType\DriverDetails
     */
    public function setBranchIDField($branchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($branchIDField) && !is_string($branchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($branchIDField, true), gettype($branchIDField)), __LINE__);
        }
        $this->branchIDField = $branchIDField;
        return $this;
    }
    /**
     * Get cellPhoneField value
     * @return string|null
     */
    public function getCellPhoneField()
    {
        return $this->cellPhoneField;
    }
    /**
     * Set cellPhoneField value
     * @param string $cellPhoneField
     * @return \StructType\DriverDetails
     */
    public function setCellPhoneField($cellPhoneField = null)
    {
        // validation for constraint: string
        if (!is_null($cellPhoneField) && !is_string($cellPhoneField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cellPhoneField, true), gettype($cellPhoneField)), __LINE__);
        }
        $this->cellPhoneField = $cellPhoneField;
        return $this;
    }
    /**
     * Get cityField value
     * @return string|null
     */
    public function getCityField()
    {
        return $this->cityField;
    }
    /**
     * Set cityField value
     * @param string $cityField
     * @return \StructType\DriverDetails
     */
    public function setCityField($cityField = null)
    {
        // validation for constraint: string
        if (!is_null($cityField) && !is_string($cityField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cityField, true), gettype($cityField)), __LINE__);
        }
        $this->cityField = $cityField;
        return $this;
    }
    /**
     * Get deviceIDField value
     * @return string|null
     */
    public function getDeviceIDField()
    {
        return $this->deviceIDField;
    }
    /**
     * Set deviceIDField value
     * @param string $deviceIDField
     * @return \StructType\DriverDetails
     */
    public function setDeviceIDField($deviceIDField = null)
    {
        // validation for constraint: string
        if (!is_null($deviceIDField) && !is_string($deviceIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceIDField, true), gettype($deviceIDField)), __LINE__);
        }
        $this->deviceIDField = $deviceIDField;
        return $this;
    }
    /**
     * Get driverIDField value
     * @return string|null
     */
    public function getDriverIDField()
    {
        return $this->driverIDField;
    }
    /**
     * Set driverIDField value
     * @param string $driverIDField
     * @return \StructType\DriverDetails
     */
    public function setDriverIDField($driverIDField = null)
    {
        // validation for constraint: string
        if (!is_null($driverIDField) && !is_string($driverIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverIDField, true), gettype($driverIDField)), __LINE__);
        }
        $this->driverIDField = $driverIDField;
        return $this;
    }
    /**
     * Get driverTypeField value
     * @return string|null
     */
    public function getDriverTypeField()
    {
        return $this->driverTypeField;
    }
    /**
     * Set driverTypeField value
     * @param string $driverTypeField
     * @return \StructType\DriverDetails
     */
    public function setDriverTypeField($driverTypeField = null)
    {
        // validation for constraint: string
        if (!is_null($driverTypeField) && !is_string($driverTypeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverTypeField, true), gettype($driverTypeField)), __LINE__);
        }
        $this->driverTypeField = $driverTypeField;
        return $this;
    }
    /**
     * Get emailAddressField value
     * @return string|null
     */
    public function getEmailAddressField()
    {
        return $this->emailAddressField;
    }
    /**
     * Set emailAddressField value
     * @param string $emailAddressField
     * @return \StructType\DriverDetails
     */
    public function setEmailAddressField($emailAddressField = null)
    {
        // validation for constraint: string
        if (!is_null($emailAddressField) && !is_string($emailAddressField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emailAddressField, true), gettype($emailAddressField)), __LINE__);
        }
        $this->emailAddressField = $emailAddressField;
        return $this;
    }
    /**
     * Get firstNameField value
     * @return string|null
     */
    public function getFirstNameField()
    {
        return $this->firstNameField;
    }
    /**
     * Set firstNameField value
     * @param string $firstNameField
     * @return \StructType\DriverDetails
     */
    public function setFirstNameField($firstNameField = null)
    {
        // validation for constraint: string
        if (!is_null($firstNameField) && !is_string($firstNameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstNameField, true), gettype($firstNameField)), __LINE__);
        }
        $this->firstNameField = $firstNameField;
        return $this;
    }
    /**
     * Get homePhoneField value
     * @return string|null
     */
    public function getHomePhoneField()
    {
        return $this->homePhoneField;
    }
    /**
     * Set homePhoneField value
     * @param string $homePhoneField
     * @return \StructType\DriverDetails
     */
    public function setHomePhoneField($homePhoneField = null)
    {
        // validation for constraint: string
        if (!is_null($homePhoneField) && !is_string($homePhoneField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($homePhoneField, true), gettype($homePhoneField)), __LINE__);
        }
        $this->homePhoneField = $homePhoneField;
        return $this;
    }
    /**
     * Get lastNameField value
     * @return string|null
     */
    public function getLastNameField()
    {
        return $this->lastNameField;
    }
    /**
     * Set lastNameField value
     * @param string $lastNameField
     * @return \StructType\DriverDetails
     */
    public function setLastNameField($lastNameField = null)
    {
        // validation for constraint: string
        if (!is_null($lastNameField) && !is_string($lastNameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastNameField, true), gettype($lastNameField)), __LINE__);
        }
        $this->lastNameField = $lastNameField;
        return $this;
    }
    /**
     * Get officePhoneField value
     * @return string|null
     */
    public function getOfficePhoneField()
    {
        return $this->officePhoneField;
    }
    /**
     * Set officePhoneField value
     * @param string $officePhoneField
     * @return \StructType\DriverDetails
     */
    public function setOfficePhoneField($officePhoneField = null)
    {
        // validation for constraint: string
        if (!is_null($officePhoneField) && !is_string($officePhoneField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($officePhoneField, true), gettype($officePhoneField)), __LINE__);
        }
        $this->officePhoneField = $officePhoneField;
        return $this;
    }
    /**
     * Get showOnCalendarField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return bool|null
     */
    public function getShowOnCalendarField()
    {
        return isset($this->showOnCalendarField) ? $this->showOnCalendarField : null;
    }
    /**
     * Set showOnCalendarField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param bool $showOnCalendarField
     * @return \StructType\DriverDetails
     */
    public function setShowOnCalendarField($showOnCalendarField = null)
    {
        // validation for constraint: boolean
        if (!is_null($showOnCalendarField) && !is_bool($showOnCalendarField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($showOnCalendarField, true), gettype($showOnCalendarField)), __LINE__);
        }
        if (is_null($showOnCalendarField) || (is_array($showOnCalendarField) && empty($showOnCalendarField))) {
            unset($this->showOnCalendarField);
        } else {
            $this->showOnCalendarField = $showOnCalendarField;
        }
        return $this;
    }
    /**
     * Get stateField value
     * @return string|null
     */
    public function getStateField()
    {
        return $this->stateField;
    }
    /**
     * Set stateField value
     * @param string $stateField
     * @return \StructType\DriverDetails
     */
    public function setStateField($stateField = null)
    {
        // validation for constraint: string
        if (!is_null($stateField) && !is_string($stateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateField, true), gettype($stateField)), __LINE__);
        }
        $this->stateField = $stateField;
        return $this;
    }
    /**
     * Get teamDriverField value
     * @return bool|null
     */
    public function getTeamDriverField()
    {
        return $this->teamDriverField;
    }
    /**
     * Set teamDriverField value
     * @param bool $teamDriverField
     * @return \StructType\DriverDetails
     */
    public function setTeamDriverField($teamDriverField = null)
    {
        // validation for constraint: boolean
        if (!is_null($teamDriverField) && !is_bool($teamDriverField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($teamDriverField, true), gettype($teamDriverField)), __LINE__);
        }
        $this->teamDriverField = $teamDriverField;
        return $this;
    }
    /**
     * Get temporaryDriverField value
     * @return bool|null
     */
    public function getTemporaryDriverField()
    {
        return $this->temporaryDriverField;
    }
    /**
     * Set temporaryDriverField value
     * @param bool $temporaryDriverField
     * @return \StructType\DriverDetails
     */
    public function setTemporaryDriverField($temporaryDriverField = null)
    {
        // validation for constraint: boolean
        if (!is_null($temporaryDriverField) && !is_bool($temporaryDriverField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($temporaryDriverField, true), gettype($temporaryDriverField)), __LINE__);
        }
        $this->temporaryDriverField = $temporaryDriverField;
        return $this;
    }
    /**
     * Get zipField value
     * @return string|null
     */
    public function getZipField()
    {
        return $this->zipField;
    }
    /**
     * Set zipField value
     * @param string $zipField
     * @return \StructType\DriverDetails
     */
    public function setZipField($zipField = null)
    {
        // validation for constraint: string
        if (!is_null($zipField) && !is_string($zipField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipField, true), gettype($zipField)), __LINE__);
        }
        $this->zipField = $zipField;
        return $this;
    }
}
