<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EventDetail StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:EventDetail
 * @subpackage Structs
 */
class EventDetail extends AbstractStructBase
{
    /**
     * The commentsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $commentsField;
    /**
     * The eventDateField
     * @var string
     */
    public $eventDateField;
    /**
     * The eventField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $eventField;
    /**
     * Constructor method for EventDetail
     * @uses EventDetail::setCommentsField()
     * @uses EventDetail::setEventDateField()
     * @uses EventDetail::setEventField()
     * @param string $commentsField
     * @param string $eventDateField
     * @param string $eventField
     */
    public function __construct($commentsField = null, $eventDateField = null, $eventField = null)
    {
        $this
            ->setCommentsField($commentsField)
            ->setEventDateField($eventDateField)
            ->setEventField($eventField);
    }
    /**
     * Get commentsField value
     * @return string|null
     */
    public function getCommentsField()
    {
        return $this->commentsField;
    }
    /**
     * Set commentsField value
     * @param string $commentsField
     * @return \StructType\EventDetail
     */
    public function setCommentsField($commentsField = null)
    {
        // validation for constraint: string
        if (!is_null($commentsField) && !is_string($commentsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commentsField, true), gettype($commentsField)), __LINE__);
        }
        $this->commentsField = $commentsField;
        return $this;
    }
    /**
     * Get eventDateField value
     * @return string|null
     */
    public function getEventDateField()
    {
        return $this->eventDateField;
    }
    /**
     * Set eventDateField value
     * @param string $eventDateField
     * @return \StructType\EventDetail
     */
    public function setEventDateField($eventDateField = null)
    {
        // validation for constraint: string
        if (!is_null($eventDateField) && !is_string($eventDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventDateField, true), gettype($eventDateField)), __LINE__);
        }
        $this->eventDateField = $eventDateField;
        return $this;
    }
    /**
     * Get eventField value
     * @return string|null
     */
    public function getEventField()
    {
        return $this->eventField;
    }
    /**
     * Set eventField value
     * @param string $eventField
     * @return \StructType\EventDetail
     */
    public function setEventField($eventField = null)
    {
        // validation for constraint: string
        if (!is_null($eventField) && !is_string($eventField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventField, true), gettype($eventField)), __LINE__);
        }
        $this->eventField = $eventField;
        return $this;
    }
}
