<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTruckProfiles StructType
 * @subpackage Structs
 */
class GetTruckProfiles extends AbstractStructBase
{
    /**
     * The auth
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Authentication
     */
    public $auth;
    /**
     * The requestEnvelope
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TruckProfileRequestEnvelope
     */
    public $requestEnvelope;
    /**
     * Constructor method for GetTruckProfiles
     * @uses GetTruckProfiles::setAuth()
     * @uses GetTruckProfiles::setRequestEnvelope()
     * @param \StructType\Authentication $auth
     * @param \StructType\TruckProfileRequestEnvelope $requestEnvelope
     */
    public function __construct(\StructType\Authentication $auth = null, \StructType\TruckProfileRequestEnvelope $requestEnvelope = null)
    {
        $this
            ->setAuth($auth)
            ->setRequestEnvelope($requestEnvelope);
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Authentication|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Authentication $auth
     * @return \StructType\GetTruckProfiles
     */
    public function setAuth(\StructType\Authentication $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Get requestEnvelope value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TruckProfileRequestEnvelope|null
     */
    public function getRequestEnvelope()
    {
        return isset($this->requestEnvelope) ? $this->requestEnvelope : null;
    }
    /**
     * Set requestEnvelope value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\TruckProfileRequestEnvelope $requestEnvelope
     * @return \StructType\GetTruckProfiles
     */
    public function setRequestEnvelope(\StructType\TruckProfileRequestEnvelope $requestEnvelope = null)
    {
        if (is_null($requestEnvelope) || (is_array($requestEnvelope) && empty($requestEnvelope))) {
            unset($this->requestEnvelope);
        } else {
            $this->requestEnvelope = $requestEnvelope;
        }
        return $this;
    }
}
