<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImportRoutesRoute StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ImportRoutesRoute
 * @subpackage Structs
 */
class ImportRoutesRoute extends AbstractStructBase
{
    /**
     * The dispatchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dispatchIDField;
    /**
     * The internalRouteIDField
     * @var int
     */
    public $internalRouteIDField;
    /**
     * The legField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfLeg
     */
    public $legField;
    /**
     * The loadIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $loadIDField;
    /**
     * The lockStatusField
     * @var int
     */
    public $lockStatusField;
    /**
     * The nextRtField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfImportRoutesRouteNextRt
     */
    public $nextRtField;
    /**
     * The prevRtField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfImportRoutesRoutePrevRt
     */
    public $prevRtField;
    /**
     * The rtNumField
     * @var int
     */
    public $rtNumField;
    /**
     * The rtNumFieldSpecified
     * @var bool
     */
    public $rtNumFieldSpecified;
    /**
     * The truckField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Truck
     */
    public $truckField;
    /**
     * Constructor method for ImportRoutesRoute
     * @uses ImportRoutesRoute::setDispatchIDField()
     * @uses ImportRoutesRoute::setInternalRouteIDField()
     * @uses ImportRoutesRoute::setLegField()
     * @uses ImportRoutesRoute::setLoadIDField()
     * @uses ImportRoutesRoute::setLockStatusField()
     * @uses ImportRoutesRoute::setNextRtField()
     * @uses ImportRoutesRoute::setPrevRtField()
     * @uses ImportRoutesRoute::setRtNumField()
     * @uses ImportRoutesRoute::setRtNumFieldSpecified()
     * @uses ImportRoutesRoute::setTruckField()
     * @param string $dispatchIDField
     * @param int $internalRouteIDField
     * @param \ArrayType\ArrayOfLeg $legField
     * @param string $loadIDField
     * @param int $lockStatusField
     * @param \ArrayType\ArrayOfImportRoutesRouteNextRt $nextRtField
     * @param \ArrayType\ArrayOfImportRoutesRoutePrevRt $prevRtField
     * @param int $rtNumField
     * @param bool $rtNumFieldSpecified
     * @param \StructType\Truck $truckField
     */
    public function __construct($dispatchIDField = null, $internalRouteIDField = null, \ArrayType\ArrayOfLeg $legField = null, $loadIDField = null, $lockStatusField = null, \ArrayType\ArrayOfImportRoutesRouteNextRt $nextRtField = null, \ArrayType\ArrayOfImportRoutesRoutePrevRt $prevRtField = null, $rtNumField = null, $rtNumFieldSpecified = null, \StructType\Truck $truckField = null)
    {
        $this
            ->setDispatchIDField($dispatchIDField)
            ->setInternalRouteIDField($internalRouteIDField)
            ->setLegField($legField)
            ->setLoadIDField($loadIDField)
            ->setLockStatusField($lockStatusField)
            ->setNextRtField($nextRtField)
            ->setPrevRtField($prevRtField)
            ->setRtNumField($rtNumField)
            ->setRtNumFieldSpecified($rtNumFieldSpecified)
            ->setTruckField($truckField);
    }
    /**
     * Get dispatchIDField value
     * @return string|null
     */
    public function getDispatchIDField()
    {
        return $this->dispatchIDField;
    }
    /**
     * Set dispatchIDField value
     * @param string $dispatchIDField
     * @return \StructType\ImportRoutesRoute
     */
    public function setDispatchIDField($dispatchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($dispatchIDField) && !is_string($dispatchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dispatchIDField, true), gettype($dispatchIDField)), __LINE__);
        }
        $this->dispatchIDField = $dispatchIDField;
        return $this;
    }
    /**
     * Get internalRouteIDField value
     * @return int|null
     */
    public function getInternalRouteIDField()
    {
        return $this->internalRouteIDField;
    }
    /**
     * Set internalRouteIDField value
     * @param int $internalRouteIDField
     * @return \StructType\ImportRoutesRoute
     */
    public function setInternalRouteIDField($internalRouteIDField = null)
    {
        // validation for constraint: int
        if (!is_null($internalRouteIDField) && !(is_int($internalRouteIDField) || ctype_digit($internalRouteIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($internalRouteIDField, true), gettype($internalRouteIDField)), __LINE__);
        }
        $this->internalRouteIDField = $internalRouteIDField;
        return $this;
    }
    /**
     * Get legField value
     * @return \ArrayType\ArrayOfLeg|null
     */
    public function getLegField()
    {
        return $this->legField;
    }
    /**
     * Set legField value
     * @param \ArrayType\ArrayOfLeg $legField
     * @return \StructType\ImportRoutesRoute
     */
    public function setLegField(\ArrayType\ArrayOfLeg $legField = null)
    {
        $this->legField = $legField;
        return $this;
    }
    /**
     * Get loadIDField value
     * @return string|null
     */
    public function getLoadIDField()
    {
        return $this->loadIDField;
    }
    /**
     * Set loadIDField value
     * @param string $loadIDField
     * @return \StructType\ImportRoutesRoute
     */
    public function setLoadIDField($loadIDField = null)
    {
        // validation for constraint: string
        if (!is_null($loadIDField) && !is_string($loadIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadIDField, true), gettype($loadIDField)), __LINE__);
        }
        $this->loadIDField = $loadIDField;
        return $this;
    }
    /**
     * Get lockStatusField value
     * @return int|null
     */
    public function getLockStatusField()
    {
        return $this->lockStatusField;
    }
    /**
     * Set lockStatusField value
     * @param int $lockStatusField
     * @return \StructType\ImportRoutesRoute
     */
    public function setLockStatusField($lockStatusField = null)
    {
        // validation for constraint: int
        if (!is_null($lockStatusField) && !(is_int($lockStatusField) || ctype_digit($lockStatusField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($lockStatusField, true), gettype($lockStatusField)), __LINE__);
        }
        $this->lockStatusField = $lockStatusField;
        return $this;
    }
    /**
     * Get nextRtField value
     * @return \ArrayType\ArrayOfImportRoutesRouteNextRt|null
     */
    public function getNextRtField()
    {
        return $this->nextRtField;
    }
    /**
     * Set nextRtField value
     * @param \ArrayType\ArrayOfImportRoutesRouteNextRt $nextRtField
     * @return \StructType\ImportRoutesRoute
     */
    public function setNextRtField(\ArrayType\ArrayOfImportRoutesRouteNextRt $nextRtField = null)
    {
        $this->nextRtField = $nextRtField;
        return $this;
    }
    /**
     * Get prevRtField value
     * @return \ArrayType\ArrayOfImportRoutesRoutePrevRt|null
     */
    public function getPrevRtField()
    {
        return $this->prevRtField;
    }
    /**
     * Set prevRtField value
     * @param \ArrayType\ArrayOfImportRoutesRoutePrevRt $prevRtField
     * @return \StructType\ImportRoutesRoute
     */
    public function setPrevRtField(\ArrayType\ArrayOfImportRoutesRoutePrevRt $prevRtField = null)
    {
        $this->prevRtField = $prevRtField;
        return $this;
    }
    /**
     * Get rtNumField value
     * @return int|null
     */
    public function getRtNumField()
    {
        return $this->rtNumField;
    }
    /**
     * Set rtNumField value
     * @param int $rtNumField
     * @return \StructType\ImportRoutesRoute
     */
    public function setRtNumField($rtNumField = null)
    {
        // validation for constraint: int
        if (!is_null($rtNumField) && !(is_int($rtNumField) || ctype_digit($rtNumField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rtNumField, true), gettype($rtNumField)), __LINE__);
        }
        $this->rtNumField = $rtNumField;
        return $this;
    }
    /**
     * Get rtNumFieldSpecified value
     * @return bool|null
     */
    public function getRtNumFieldSpecified()
    {
        return $this->rtNumFieldSpecified;
    }
    /**
     * Set rtNumFieldSpecified value
     * @param bool $rtNumFieldSpecified
     * @return \StructType\ImportRoutesRoute
     */
    public function setRtNumFieldSpecified($rtNumFieldSpecified = null)
    {
        // validation for constraint: boolean
        if (!is_null($rtNumFieldSpecified) && !is_bool($rtNumFieldSpecified)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($rtNumFieldSpecified, true), gettype($rtNumFieldSpecified)), __LINE__);
        }
        $this->rtNumFieldSpecified = $rtNumFieldSpecified;
        return $this;
    }
    /**
     * Get truckField value
     * @return \StructType\Truck|null
     */
    public function getTruckField()
    {
        return $this->truckField;
    }
    /**
     * Set truckField value
     * @param \StructType\Truck $truckField
     * @return \StructType\ImportRoutesRoute
     */
    public function setTruckField(\StructType\Truck $truckField = null)
    {
        $this->truckField = $truckField;
        return $this;
    }
}
