<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImportRoutesStatistics StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ImportRoutesStatistics
 * @subpackage Structs
 */
class ImportRoutesStatistics extends AbstractStructBase
{
    /**
     * The importRouteStatisticsWarningsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $importRouteStatisticsWarningsField;
    /**
     * The numPreassignmentsField
     * @var int
     */
    public $numPreassignmentsField;
    /**
     * The numPriorityRoutesField
     * @var int
     */
    public $numPriorityRoutesField;
    /**
     * The numRoutesCreatedField
     * @var int
     */
    public $numRoutesCreatedField;
    /**
     * The numRoutesSentToPeopleNetField
     * @var int
     */
    public $numRoutesSentToPeopleNetField;
    /**
     * The numRoutesUpdatedField
     * @var int
     */
    public $numRoutesUpdatedField;
    /**
     * The routesFinalizedField
     * @var bool
     */
    public $routesFinalizedField;
    /**
     * The sentOrderScheduledEmailsField
     * @var bool
     */
    public $sentOrderScheduledEmailsField;
    /**
     * The sentRouteManifestEmailsField
     * @var bool
     */
    public $sentRouteManifestEmailsField;
    /**
     * The uploadedToPeopleNetField
     * @var bool
     */
    public $uploadedToPeopleNetField;
    /**
     * Constructor method for ImportRoutesStatistics
     * @uses ImportRoutesStatistics::setImportRouteStatisticsWarningsField()
     * @uses ImportRoutesStatistics::setNumPreassignmentsField()
     * @uses ImportRoutesStatistics::setNumPriorityRoutesField()
     * @uses ImportRoutesStatistics::setNumRoutesCreatedField()
     * @uses ImportRoutesStatistics::setNumRoutesSentToPeopleNetField()
     * @uses ImportRoutesStatistics::setNumRoutesUpdatedField()
     * @uses ImportRoutesStatistics::setRoutesFinalizedField()
     * @uses ImportRoutesStatistics::setSentOrderScheduledEmailsField()
     * @uses ImportRoutesStatistics::setSentRouteManifestEmailsField()
     * @uses ImportRoutesStatistics::setUploadedToPeopleNetField()
     * @param \ArrayType\ArrayOfstring $importRouteStatisticsWarningsField
     * @param int $numPreassignmentsField
     * @param int $numPriorityRoutesField
     * @param int $numRoutesCreatedField
     * @param int $numRoutesSentToPeopleNetField
     * @param int $numRoutesUpdatedField
     * @param bool $routesFinalizedField
     * @param bool $sentOrderScheduledEmailsField
     * @param bool $sentRouteManifestEmailsField
     * @param bool $uploadedToPeopleNetField
     */
    public function __construct(\ArrayType\ArrayOfstring $importRouteStatisticsWarningsField = null, $numPreassignmentsField = null, $numPriorityRoutesField = null, $numRoutesCreatedField = null, $numRoutesSentToPeopleNetField = null, $numRoutesUpdatedField = null, $routesFinalizedField = null, $sentOrderScheduledEmailsField = null, $sentRouteManifestEmailsField = null, $uploadedToPeopleNetField = null)
    {
        $this
            ->setImportRouteStatisticsWarningsField($importRouteStatisticsWarningsField)
            ->setNumPreassignmentsField($numPreassignmentsField)
            ->setNumPriorityRoutesField($numPriorityRoutesField)
            ->setNumRoutesCreatedField($numRoutesCreatedField)
            ->setNumRoutesSentToPeopleNetField($numRoutesSentToPeopleNetField)
            ->setNumRoutesUpdatedField($numRoutesUpdatedField)
            ->setRoutesFinalizedField($routesFinalizedField)
            ->setSentOrderScheduledEmailsField($sentOrderScheduledEmailsField)
            ->setSentRouteManifestEmailsField($sentRouteManifestEmailsField)
            ->setUploadedToPeopleNetField($uploadedToPeopleNetField);
    }
    /**
     * Get importRouteStatisticsWarningsField value
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getImportRouteStatisticsWarningsField()
    {
        return $this->importRouteStatisticsWarningsField;
    }
    /**
     * Set importRouteStatisticsWarningsField value
     * @param \ArrayType\ArrayOfstring $importRouteStatisticsWarningsField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setImportRouteStatisticsWarningsField(\ArrayType\ArrayOfstring $importRouteStatisticsWarningsField = null)
    {
        $this->importRouteStatisticsWarningsField = $importRouteStatisticsWarningsField;
        return $this;
    }
    /**
     * Get numPreassignmentsField value
     * @return int|null
     */
    public function getNumPreassignmentsField()
    {
        return $this->numPreassignmentsField;
    }
    /**
     * Set numPreassignmentsField value
     * @param int $numPreassignmentsField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setNumPreassignmentsField($numPreassignmentsField = null)
    {
        // validation for constraint: int
        if (!is_null($numPreassignmentsField) && !(is_int($numPreassignmentsField) || ctype_digit($numPreassignmentsField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numPreassignmentsField, true), gettype($numPreassignmentsField)), __LINE__);
        }
        $this->numPreassignmentsField = $numPreassignmentsField;
        return $this;
    }
    /**
     * Get numPriorityRoutesField value
     * @return int|null
     */
    public function getNumPriorityRoutesField()
    {
        return $this->numPriorityRoutesField;
    }
    /**
     * Set numPriorityRoutesField value
     * @param int $numPriorityRoutesField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setNumPriorityRoutesField($numPriorityRoutesField = null)
    {
        // validation for constraint: int
        if (!is_null($numPriorityRoutesField) && !(is_int($numPriorityRoutesField) || ctype_digit($numPriorityRoutesField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numPriorityRoutesField, true), gettype($numPriorityRoutesField)), __LINE__);
        }
        $this->numPriorityRoutesField = $numPriorityRoutesField;
        return $this;
    }
    /**
     * Get numRoutesCreatedField value
     * @return int|null
     */
    public function getNumRoutesCreatedField()
    {
        return $this->numRoutesCreatedField;
    }
    /**
     * Set numRoutesCreatedField value
     * @param int $numRoutesCreatedField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setNumRoutesCreatedField($numRoutesCreatedField = null)
    {
        // validation for constraint: int
        if (!is_null($numRoutesCreatedField) && !(is_int($numRoutesCreatedField) || ctype_digit($numRoutesCreatedField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numRoutesCreatedField, true), gettype($numRoutesCreatedField)), __LINE__);
        }
        $this->numRoutesCreatedField = $numRoutesCreatedField;
        return $this;
    }
    /**
     * Get numRoutesSentToPeopleNetField value
     * @return int|null
     */
    public function getNumRoutesSentToPeopleNetField()
    {
        return $this->numRoutesSentToPeopleNetField;
    }
    /**
     * Set numRoutesSentToPeopleNetField value
     * @param int $numRoutesSentToPeopleNetField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setNumRoutesSentToPeopleNetField($numRoutesSentToPeopleNetField = null)
    {
        // validation for constraint: int
        if (!is_null($numRoutesSentToPeopleNetField) && !(is_int($numRoutesSentToPeopleNetField) || ctype_digit($numRoutesSentToPeopleNetField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numRoutesSentToPeopleNetField, true), gettype($numRoutesSentToPeopleNetField)), __LINE__);
        }
        $this->numRoutesSentToPeopleNetField = $numRoutesSentToPeopleNetField;
        return $this;
    }
    /**
     * Get numRoutesUpdatedField value
     * @return int|null
     */
    public function getNumRoutesUpdatedField()
    {
        return $this->numRoutesUpdatedField;
    }
    /**
     * Set numRoutesUpdatedField value
     * @param int $numRoutesUpdatedField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setNumRoutesUpdatedField($numRoutesUpdatedField = null)
    {
        // validation for constraint: int
        if (!is_null($numRoutesUpdatedField) && !(is_int($numRoutesUpdatedField) || ctype_digit($numRoutesUpdatedField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($numRoutesUpdatedField, true), gettype($numRoutesUpdatedField)), __LINE__);
        }
        $this->numRoutesUpdatedField = $numRoutesUpdatedField;
        return $this;
    }
    /**
     * Get routesFinalizedField value
     * @return bool|null
     */
    public function getRoutesFinalizedField()
    {
        return $this->routesFinalizedField;
    }
    /**
     * Set routesFinalizedField value
     * @param bool $routesFinalizedField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setRoutesFinalizedField($routesFinalizedField = null)
    {
        // validation for constraint: boolean
        if (!is_null($routesFinalizedField) && !is_bool($routesFinalizedField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($routesFinalizedField, true), gettype($routesFinalizedField)), __LINE__);
        }
        $this->routesFinalizedField = $routesFinalizedField;
        return $this;
    }
    /**
     * Get sentOrderScheduledEmailsField value
     * @return bool|null
     */
    public function getSentOrderScheduledEmailsField()
    {
        return $this->sentOrderScheduledEmailsField;
    }
    /**
     * Set sentOrderScheduledEmailsField value
     * @param bool $sentOrderScheduledEmailsField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setSentOrderScheduledEmailsField($sentOrderScheduledEmailsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($sentOrderScheduledEmailsField) && !is_bool($sentOrderScheduledEmailsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sentOrderScheduledEmailsField, true), gettype($sentOrderScheduledEmailsField)), __LINE__);
        }
        $this->sentOrderScheduledEmailsField = $sentOrderScheduledEmailsField;
        return $this;
    }
    /**
     * Get sentRouteManifestEmailsField value
     * @return bool|null
     */
    public function getSentRouteManifestEmailsField()
    {
        return $this->sentRouteManifestEmailsField;
    }
    /**
     * Set sentRouteManifestEmailsField value
     * @param bool $sentRouteManifestEmailsField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setSentRouteManifestEmailsField($sentRouteManifestEmailsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($sentRouteManifestEmailsField) && !is_bool($sentRouteManifestEmailsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sentRouteManifestEmailsField, true), gettype($sentRouteManifestEmailsField)), __LINE__);
        }
        $this->sentRouteManifestEmailsField = $sentRouteManifestEmailsField;
        return $this;
    }
    /**
     * Get uploadedToPeopleNetField value
     * @return bool|null
     */
    public function getUploadedToPeopleNetField()
    {
        return $this->uploadedToPeopleNetField;
    }
    /**
     * Set uploadedToPeopleNetField value
     * @param bool $uploadedToPeopleNetField
     * @return \StructType\ImportRoutesStatistics
     */
    public function setUploadedToPeopleNetField($uploadedToPeopleNetField = null)
    {
        // validation for constraint: boolean
        if (!is_null($uploadedToPeopleNetField) && !is_bool($uploadedToPeopleNetField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($uploadedToPeopleNetField, true), gettype($uploadedToPeopleNetField)), __LINE__);
        }
        $this->uploadedToPeopleNetField = $uploadedToPeopleNetField;
        return $this;
    }
}
