<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InsertShipToDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:InsertShipToDetails
 * @subpackage Structs
 */
class InsertShipToDetails extends AbstractStructBase
{
    /**
     * The address2Field
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $address2Field;
    /**
     * The addressField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $addressField;
    /**
     * The amAdjField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $amAdjField;
    /**
     * The amEndField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $amEndField;
    /**
     * The amStartField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $amStartField;
    /**
     * The cityField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $cityField;
    /**
     * The countryField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $countryField;
    /**
     * The geoResultField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $geoResultField;
    /**
     * The latitudeField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $latitudeField;
    /**
     * The longitudeField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var float
     */
    public $longitudeField;
    /**
     * The pmAdjField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $pmAdjField;
    /**
     * The pmEndField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $pmEndField;
    /**
     * The pmStartField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $pmStartField;
    /**
     * The stateField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $stateField;
    /**
     * The zipField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $zipField;
    /**
     * The zoneField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $zoneField;
    /**
     * Constructor method for InsertShipToDetails
     * @uses InsertShipToDetails::setAddress2Field()
     * @uses InsertShipToDetails::setAddressField()
     * @uses InsertShipToDetails::setAmAdjField()
     * @uses InsertShipToDetails::setAmEndField()
     * @uses InsertShipToDetails::setAmStartField()
     * @uses InsertShipToDetails::setCityField()
     * @uses InsertShipToDetails::setCountryField()
     * @uses InsertShipToDetails::setGeoResultField()
     * @uses InsertShipToDetails::setLatitudeField()
     * @uses InsertShipToDetails::setLongitudeField()
     * @uses InsertShipToDetails::setPmAdjField()
     * @uses InsertShipToDetails::setPmEndField()
     * @uses InsertShipToDetails::setPmStartField()
     * @uses InsertShipToDetails::setStateField()
     * @uses InsertShipToDetails::setZipField()
     * @uses InsertShipToDetails::setZoneField()
     * @param string $address2Field
     * @param string $addressField
     * @param int $amAdjField
     * @param int $amEndField
     * @param int $amStartField
     * @param string $cityField
     * @param string $countryField
     * @param string $geoResultField
     * @param float $latitudeField
     * @param float $longitudeField
     * @param int $pmAdjField
     * @param int $pmEndField
     * @param int $pmStartField
     * @param string $stateField
     * @param string $zipField
     * @param int $zoneField
     */
    public function __construct($address2Field = null, $addressField = null, $amAdjField = null, $amEndField = null, $amStartField = null, $cityField = null, $countryField = null, $geoResultField = null, $latitudeField = null, $longitudeField = null, $pmAdjField = null, $pmEndField = null, $pmStartField = null, $stateField = null, $zipField = null, $zoneField = null)
    {
        $this
            ->setAddress2Field($address2Field)
            ->setAddressField($addressField)
            ->setAmAdjField($amAdjField)
            ->setAmEndField($amEndField)
            ->setAmStartField($amStartField)
            ->setCityField($cityField)
            ->setCountryField($countryField)
            ->setGeoResultField($geoResultField)
            ->setLatitudeField($latitudeField)
            ->setLongitudeField($longitudeField)
            ->setPmAdjField($pmAdjField)
            ->setPmEndField($pmEndField)
            ->setPmStartField($pmStartField)
            ->setStateField($stateField)
            ->setZipField($zipField)
            ->setZoneField($zoneField);
    }
    /**
     * Get address2Field value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAddress2Field()
    {
        return isset($this->address2Field) ? $this->address2Field : null;
    }
    /**
     * Set address2Field value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $address2Field
     * @return \StructType\InsertShipToDetails
     */
    public function setAddress2Field($address2Field = null)
    {
        // validation for constraint: string
        if (!is_null($address2Field) && !is_string($address2Field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address2Field, true), gettype($address2Field)), __LINE__);
        }
        if (is_null($address2Field) || (is_array($address2Field) && empty($address2Field))) {
            unset($this->address2Field);
        } else {
            $this->address2Field = $address2Field;
        }
        return $this;
    }
    /**
     * Get addressField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAddressField()
    {
        return isset($this->addressField) ? $this->addressField : null;
    }
    /**
     * Set addressField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $addressField
     * @return \StructType\InsertShipToDetails
     */
    public function setAddressField($addressField = null)
    {
        // validation for constraint: string
        if (!is_null($addressField) && !is_string($addressField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addressField, true), gettype($addressField)), __LINE__);
        }
        if (is_null($addressField) || (is_array($addressField) && empty($addressField))) {
            unset($this->addressField);
        } else {
            $this->addressField = $addressField;
        }
        return $this;
    }
    /**
     * Get amAdjField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAmAdjField()
    {
        return isset($this->amAdjField) ? $this->amAdjField : null;
    }
    /**
     * Set amAdjField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $amAdjField
     * @return \StructType\InsertShipToDetails
     */
    public function setAmAdjField($amAdjField = null)
    {
        // validation for constraint: int
        if (!is_null($amAdjField) && !(is_int($amAdjField) || ctype_digit($amAdjField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amAdjField, true), gettype($amAdjField)), __LINE__);
        }
        if (is_null($amAdjField) || (is_array($amAdjField) && empty($amAdjField))) {
            unset($this->amAdjField);
        } else {
            $this->amAdjField = $amAdjField;
        }
        return $this;
    }
    /**
     * Get amEndField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAmEndField()
    {
        return isset($this->amEndField) ? $this->amEndField : null;
    }
    /**
     * Set amEndField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $amEndField
     * @return \StructType\InsertShipToDetails
     */
    public function setAmEndField($amEndField = null)
    {
        // validation for constraint: int
        if (!is_null($amEndField) && !(is_int($amEndField) || ctype_digit($amEndField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amEndField, true), gettype($amEndField)), __LINE__);
        }
        if (is_null($amEndField) || (is_array($amEndField) && empty($amEndField))) {
            unset($this->amEndField);
        } else {
            $this->amEndField = $amEndField;
        }
        return $this;
    }
    /**
     * Get amStartField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getAmStartField()
    {
        return isset($this->amStartField) ? $this->amStartField : null;
    }
    /**
     * Set amStartField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $amStartField
     * @return \StructType\InsertShipToDetails
     */
    public function setAmStartField($amStartField = null)
    {
        // validation for constraint: int
        if (!is_null($amStartField) && !(is_int($amStartField) || ctype_digit($amStartField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amStartField, true), gettype($amStartField)), __LINE__);
        }
        if (is_null($amStartField) || (is_array($amStartField) && empty($amStartField))) {
            unset($this->amStartField);
        } else {
            $this->amStartField = $amStartField;
        }
        return $this;
    }
    /**
     * Get cityField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCityField()
    {
        return isset($this->cityField) ? $this->cityField : null;
    }
    /**
     * Set cityField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $cityField
     * @return \StructType\InsertShipToDetails
     */
    public function setCityField($cityField = null)
    {
        // validation for constraint: string
        if (!is_null($cityField) && !is_string($cityField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cityField, true), gettype($cityField)), __LINE__);
        }
        if (is_null($cityField) || (is_array($cityField) && empty($cityField))) {
            unset($this->cityField);
        } else {
            $this->cityField = $cityField;
        }
        return $this;
    }
    /**
     * Get countryField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCountryField()
    {
        return isset($this->countryField) ? $this->countryField : null;
    }
    /**
     * Set countryField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $countryField
     * @return \StructType\InsertShipToDetails
     */
    public function setCountryField($countryField = null)
    {
        // validation for constraint: string
        if (!is_null($countryField) && !is_string($countryField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryField, true), gettype($countryField)), __LINE__);
        }
        if (is_null($countryField) || (is_array($countryField) && empty($countryField))) {
            unset($this->countryField);
        } else {
            $this->countryField = $countryField;
        }
        return $this;
    }
    /**
     * Get geoResultField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getGeoResultField()
    {
        return isset($this->geoResultField) ? $this->geoResultField : null;
    }
    /**
     * Set geoResultField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $geoResultField
     * @return \StructType\InsertShipToDetails
     */
    public function setGeoResultField($geoResultField = null)
    {
        // validation for constraint: string
        if (!is_null($geoResultField) && !is_string($geoResultField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($geoResultField, true), gettype($geoResultField)), __LINE__);
        }
        if (is_null($geoResultField) || (is_array($geoResultField) && empty($geoResultField))) {
            unset($this->geoResultField);
        } else {
            $this->geoResultField = $geoResultField;
        }
        return $this;
    }
    /**
     * Get latitudeField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getLatitudeField()
    {
        return isset($this->latitudeField) ? $this->latitudeField : null;
    }
    /**
     * Set latitudeField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $latitudeField
     * @return \StructType\InsertShipToDetails
     */
    public function setLatitudeField($latitudeField = null)
    {
        // validation for constraint: float
        if (!is_null($latitudeField) && !(is_float($latitudeField) || is_numeric($latitudeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($latitudeField, true), gettype($latitudeField)), __LINE__);
        }
        if (is_null($latitudeField) || (is_array($latitudeField) && empty($latitudeField))) {
            unset($this->latitudeField);
        } else {
            $this->latitudeField = $latitudeField;
        }
        return $this;
    }
    /**
     * Get longitudeField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return float|null
     */
    public function getLongitudeField()
    {
        return isset($this->longitudeField) ? $this->longitudeField : null;
    }
    /**
     * Set longitudeField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param float $longitudeField
     * @return \StructType\InsertShipToDetails
     */
    public function setLongitudeField($longitudeField = null)
    {
        // validation for constraint: float
        if (!is_null($longitudeField) && !(is_float($longitudeField) || is_numeric($longitudeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($longitudeField, true), gettype($longitudeField)), __LINE__);
        }
        if (is_null($longitudeField) || (is_array($longitudeField) && empty($longitudeField))) {
            unset($this->longitudeField);
        } else {
            $this->longitudeField = $longitudeField;
        }
        return $this;
    }
    /**
     * Get pmAdjField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getPmAdjField()
    {
        return isset($this->pmAdjField) ? $this->pmAdjField : null;
    }
    /**
     * Set pmAdjField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $pmAdjField
     * @return \StructType\InsertShipToDetails
     */
    public function setPmAdjField($pmAdjField = null)
    {
        // validation for constraint: int
        if (!is_null($pmAdjField) && !(is_int($pmAdjField) || ctype_digit($pmAdjField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pmAdjField, true), gettype($pmAdjField)), __LINE__);
        }
        if (is_null($pmAdjField) || (is_array($pmAdjField) && empty($pmAdjField))) {
            unset($this->pmAdjField);
        } else {
            $this->pmAdjField = $pmAdjField;
        }
        return $this;
    }
    /**
     * Get pmEndField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getPmEndField()
    {
        return isset($this->pmEndField) ? $this->pmEndField : null;
    }
    /**
     * Set pmEndField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $pmEndField
     * @return \StructType\InsertShipToDetails
     */
    public function setPmEndField($pmEndField = null)
    {
        // validation for constraint: int
        if (!is_null($pmEndField) && !(is_int($pmEndField) || ctype_digit($pmEndField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pmEndField, true), gettype($pmEndField)), __LINE__);
        }
        if (is_null($pmEndField) || (is_array($pmEndField) && empty($pmEndField))) {
            unset($this->pmEndField);
        } else {
            $this->pmEndField = $pmEndField;
        }
        return $this;
    }
    /**
     * Get pmStartField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getPmStartField()
    {
        return isset($this->pmStartField) ? $this->pmStartField : null;
    }
    /**
     * Set pmStartField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $pmStartField
     * @return \StructType\InsertShipToDetails
     */
    public function setPmStartField($pmStartField = null)
    {
        // validation for constraint: int
        if (!is_null($pmStartField) && !(is_int($pmStartField) || ctype_digit($pmStartField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pmStartField, true), gettype($pmStartField)), __LINE__);
        }
        if (is_null($pmStartField) || (is_array($pmStartField) && empty($pmStartField))) {
            unset($this->pmStartField);
        } else {
            $this->pmStartField = $pmStartField;
        }
        return $this;
    }
    /**
     * Get stateField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getStateField()
    {
        return isset($this->stateField) ? $this->stateField : null;
    }
    /**
     * Set stateField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $stateField
     * @return \StructType\InsertShipToDetails
     */
    public function setStateField($stateField = null)
    {
        // validation for constraint: string
        if (!is_null($stateField) && !is_string($stateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateField, true), gettype($stateField)), __LINE__);
        }
        if (is_null($stateField) || (is_array($stateField) && empty($stateField))) {
            unset($this->stateField);
        } else {
            $this->stateField = $stateField;
        }
        return $this;
    }
    /**
     * Get zipField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getZipField()
    {
        return isset($this->zipField) ? $this->zipField : null;
    }
    /**
     * Set zipField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $zipField
     * @return \StructType\InsertShipToDetails
     */
    public function setZipField($zipField = null)
    {
        // validation for constraint: string
        if (!is_null($zipField) && !is_string($zipField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipField, true), gettype($zipField)), __LINE__);
        }
        if (is_null($zipField) || (is_array($zipField) && empty($zipField))) {
            unset($this->zipField);
        } else {
            $this->zipField = $zipField;
        }
        return $this;
    }
    /**
     * Get zoneField value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getZoneField()
    {
        return isset($this->zoneField) ? $this->zoneField : null;
    }
    /**
     * Set zoneField value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $zoneField
     * @return \StructType\InsertShipToDetails
     */
    public function setZoneField($zoneField = null)
    {
        // validation for constraint: int
        if (!is_null($zoneField) && !(is_int($zoneField) || ctype_digit($zoneField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($zoneField, true), gettype($zoneField)), __LINE__);
        }
        if (is_null($zoneField) || (is_array($zoneField) && empty($zoneField))) {
            unset($this->zoneField);
        } else {
            $this->zoneField = $zoneField;
        }
        return $this;
    }
}
