<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MasterRoute StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MasterRoute
 * @subpackage Structs
 */
class MasterRoute extends AbstractStructBase
{
    /**
     * The dispatchDateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dispatchDateField;
    /**
     * The lastCloneDateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $lastCloneDateField;
    /**
     * The legField
     * @var int
     */
    public $legField;
    /**
     * The loadDateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $loadDateField;
    /**
     * The loadIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $loadIDField;
    /**
     * The nextCloneDateField
     * @var string
     */
    public $nextCloneDateField;
    /**
     * The plannedEndField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $plannedEndField;
    /**
     * The plannedStartField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $plannedStartField;
    /**
     * The profileField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $profileField;
    /**
     * The rTNumberField
     * @var int
     */
    public $rTNumberField;
    /**
     * The sequenceField
     * @var int
     */
    public $sequenceField;
    /**
     * Constructor method for MasterRoute
     * @uses MasterRoute::setDispatchDateField()
     * @uses MasterRoute::setLastCloneDateField()
     * @uses MasterRoute::setLegField()
     * @uses MasterRoute::setLoadDateField()
     * @uses MasterRoute::setLoadIDField()
     * @uses MasterRoute::setNextCloneDateField()
     * @uses MasterRoute::setPlannedEndField()
     * @uses MasterRoute::setPlannedStartField()
     * @uses MasterRoute::setProfileField()
     * @uses MasterRoute::setRTNumberField()
     * @uses MasterRoute::setSequenceField()
     * @param string $dispatchDateField
     * @param string $lastCloneDateField
     * @param int $legField
     * @param string $loadDateField
     * @param string $loadIDField
     * @param string $nextCloneDateField
     * @param string $plannedEndField
     * @param string $plannedStartField
     * @param string $profileField
     * @param int $rTNumberField
     * @param int $sequenceField
     */
    public function __construct($dispatchDateField = null, $lastCloneDateField = null, $legField = null, $loadDateField = null, $loadIDField = null, $nextCloneDateField = null, $plannedEndField = null, $plannedStartField = null, $profileField = null, $rTNumberField = null, $sequenceField = null)
    {
        $this
            ->setDispatchDateField($dispatchDateField)
            ->setLastCloneDateField($lastCloneDateField)
            ->setLegField($legField)
            ->setLoadDateField($loadDateField)
            ->setLoadIDField($loadIDField)
            ->setNextCloneDateField($nextCloneDateField)
            ->setPlannedEndField($plannedEndField)
            ->setPlannedStartField($plannedStartField)
            ->setProfileField($profileField)
            ->setRTNumberField($rTNumberField)
            ->setSequenceField($sequenceField);
    }
    /**
     * Get dispatchDateField value
     * @return string|null
     */
    public function getDispatchDateField()
    {
        return $this->dispatchDateField;
    }
    /**
     * Set dispatchDateField value
     * @param string $dispatchDateField
     * @return \StructType\MasterRoute
     */
    public function setDispatchDateField($dispatchDateField = null)
    {
        // validation for constraint: string
        if (!is_null($dispatchDateField) && !is_string($dispatchDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dispatchDateField, true), gettype($dispatchDateField)), __LINE__);
        }
        $this->dispatchDateField = $dispatchDateField;
        return $this;
    }
    /**
     * Get lastCloneDateField value
     * @return string|null
     */
    public function getLastCloneDateField()
    {
        return $this->lastCloneDateField;
    }
    /**
     * Set lastCloneDateField value
     * @param string $lastCloneDateField
     * @return \StructType\MasterRoute
     */
    public function setLastCloneDateField($lastCloneDateField = null)
    {
        // validation for constraint: string
        if (!is_null($lastCloneDateField) && !is_string($lastCloneDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastCloneDateField, true), gettype($lastCloneDateField)), __LINE__);
        }
        $this->lastCloneDateField = $lastCloneDateField;
        return $this;
    }
    /**
     * Get legField value
     * @return int|null
     */
    public function getLegField()
    {
        return $this->legField;
    }
    /**
     * Set legField value
     * @param int $legField
     * @return \StructType\MasterRoute
     */
    public function setLegField($legField = null)
    {
        // validation for constraint: int
        if (!is_null($legField) && !(is_int($legField) || ctype_digit($legField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($legField, true), gettype($legField)), __LINE__);
        }
        $this->legField = $legField;
        return $this;
    }
    /**
     * Get loadDateField value
     * @return string|null
     */
    public function getLoadDateField()
    {
        return $this->loadDateField;
    }
    /**
     * Set loadDateField value
     * @param string $loadDateField
     * @return \StructType\MasterRoute
     */
    public function setLoadDateField($loadDateField = null)
    {
        // validation for constraint: string
        if (!is_null($loadDateField) && !is_string($loadDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadDateField, true), gettype($loadDateField)), __LINE__);
        }
        $this->loadDateField = $loadDateField;
        return $this;
    }
    /**
     * Get loadIDField value
     * @return string|null
     */
    public function getLoadIDField()
    {
        return $this->loadIDField;
    }
    /**
     * Set loadIDField value
     * @param string $loadIDField
     * @return \StructType\MasterRoute
     */
    public function setLoadIDField($loadIDField = null)
    {
        // validation for constraint: string
        if (!is_null($loadIDField) && !is_string($loadIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadIDField, true), gettype($loadIDField)), __LINE__);
        }
        $this->loadIDField = $loadIDField;
        return $this;
    }
    /**
     * Get nextCloneDateField value
     * @return string|null
     */
    public function getNextCloneDateField()
    {
        return $this->nextCloneDateField;
    }
    /**
     * Set nextCloneDateField value
     * @param string $nextCloneDateField
     * @return \StructType\MasterRoute
     */
    public function setNextCloneDateField($nextCloneDateField = null)
    {
        // validation for constraint: string
        if (!is_null($nextCloneDateField) && !is_string($nextCloneDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nextCloneDateField, true), gettype($nextCloneDateField)), __LINE__);
        }
        $this->nextCloneDateField = $nextCloneDateField;
        return $this;
    }
    /**
     * Get plannedEndField value
     * @return string|null
     */
    public function getPlannedEndField()
    {
        return $this->plannedEndField;
    }
    /**
     * Set plannedEndField value
     * @param string $plannedEndField
     * @return \StructType\MasterRoute
     */
    public function setPlannedEndField($plannedEndField = null)
    {
        // validation for constraint: string
        if (!is_null($plannedEndField) && !is_string($plannedEndField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plannedEndField, true), gettype($plannedEndField)), __LINE__);
        }
        $this->plannedEndField = $plannedEndField;
        return $this;
    }
    /**
     * Get plannedStartField value
     * @return string|null
     */
    public function getPlannedStartField()
    {
        return $this->plannedStartField;
    }
    /**
     * Set plannedStartField value
     * @param string $plannedStartField
     * @return \StructType\MasterRoute
     */
    public function setPlannedStartField($plannedStartField = null)
    {
        // validation for constraint: string
        if (!is_null($plannedStartField) && !is_string($plannedStartField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plannedStartField, true), gettype($plannedStartField)), __LINE__);
        }
        $this->plannedStartField = $plannedStartField;
        return $this;
    }
    /**
     * Get profileField value
     * @return string|null
     */
    public function getProfileField()
    {
        return $this->profileField;
    }
    /**
     * Set profileField value
     * @param string $profileField
     * @return \StructType\MasterRoute
     */
    public function setProfileField($profileField = null)
    {
        // validation for constraint: string
        if (!is_null($profileField) && !is_string($profileField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($profileField, true), gettype($profileField)), __LINE__);
        }
        $this->profileField = $profileField;
        return $this;
    }
    /**
     * Get rTNumberField value
     * @return int|null
     */
    public function getRTNumberField()
    {
        return $this->rTNumberField;
    }
    /**
     * Set rTNumberField value
     * @param int $rTNumberField
     * @return \StructType\MasterRoute
     */
    public function setRTNumberField($rTNumberField = null)
    {
        // validation for constraint: int
        if (!is_null($rTNumberField) && !(is_int($rTNumberField) || ctype_digit($rTNumberField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rTNumberField, true), gettype($rTNumberField)), __LINE__);
        }
        $this->rTNumberField = $rTNumberField;
        return $this;
    }
    /**
     * Get sequenceField value
     * @return int|null
     */
    public function getSequenceField()
    {
        return $this->sequenceField;
    }
    /**
     * Set sequenceField value
     * @param int $sequenceField
     * @return \StructType\MasterRoute
     */
    public function setSequenceField($sequenceField = null)
    {
        // validation for constraint: int
        if (!is_null($sequenceField) && !(is_int($sequenceField) || ctype_digit($sequenceField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sequenceField, true), gettype($sequenceField)), __LINE__);
        }
        $this->sequenceField = $sequenceField;
        return $this;
    }
}
