<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MasterRouteDetailRequestEnvelope StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MasterRouteDetailRequestEnvelope
 * @subpackage Structs
 */
class MasterRouteDetailRequestEnvelope extends AbstractStructBase
{
    /**
     * The branchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $branchIDField;
    /**
     * The dayCodeField
     * @var int
     */
    public $dayCodeField;
    /**
     * The masterRouteDetailReturnOptionsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\MasterRouteDetailReturnOptions
     */
    public $masterRouteDetailReturnOptionsField;
    /**
     * The profileNameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $profileNameField;
    /**
     * Constructor method for MasterRouteDetailRequestEnvelope
     * @uses MasterRouteDetailRequestEnvelope::setBranchIDField()
     * @uses MasterRouteDetailRequestEnvelope::setDayCodeField()
     * @uses MasterRouteDetailRequestEnvelope::setMasterRouteDetailReturnOptionsField()
     * @uses MasterRouteDetailRequestEnvelope::setProfileNameField()
     * @param string $branchIDField
     * @param int $dayCodeField
     * @param \StructType\MasterRouteDetailReturnOptions $masterRouteDetailReturnOptionsField
     * @param string $profileNameField
     */
    public function __construct($branchIDField = null, $dayCodeField = null, \StructType\MasterRouteDetailReturnOptions $masterRouteDetailReturnOptionsField = null, $profileNameField = null)
    {
        $this
            ->setBranchIDField($branchIDField)
            ->setDayCodeField($dayCodeField)
            ->setMasterRouteDetailReturnOptionsField($masterRouteDetailReturnOptionsField)
            ->setProfileNameField($profileNameField);
    }
    /**
     * Get branchIDField value
     * @return string|null
     */
    public function getBranchIDField()
    {
        return $this->branchIDField;
    }
    /**
     * Set branchIDField value
     * @param string $branchIDField
     * @return \StructType\MasterRouteDetailRequestEnvelope
     */
    public function setBranchIDField($branchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($branchIDField) && !is_string($branchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($branchIDField, true), gettype($branchIDField)), __LINE__);
        }
        $this->branchIDField = $branchIDField;
        return $this;
    }
    /**
     * Get dayCodeField value
     * @return int|null
     */
    public function getDayCodeField()
    {
        return $this->dayCodeField;
    }
    /**
     * Set dayCodeField value
     * @param int $dayCodeField
     * @return \StructType\MasterRouteDetailRequestEnvelope
     */
    public function setDayCodeField($dayCodeField = null)
    {
        // validation for constraint: int
        if (!is_null($dayCodeField) && !(is_int($dayCodeField) || ctype_digit($dayCodeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($dayCodeField, true), gettype($dayCodeField)), __LINE__);
        }
        $this->dayCodeField = $dayCodeField;
        return $this;
    }
    /**
     * Get masterRouteDetailReturnOptionsField value
     * @return \StructType\MasterRouteDetailReturnOptions|null
     */
    public function getMasterRouteDetailReturnOptionsField()
    {
        return $this->masterRouteDetailReturnOptionsField;
    }
    /**
     * Set masterRouteDetailReturnOptionsField value
     * @param \StructType\MasterRouteDetailReturnOptions $masterRouteDetailReturnOptionsField
     * @return \StructType\MasterRouteDetailRequestEnvelope
     */
    public function setMasterRouteDetailReturnOptionsField(\StructType\MasterRouteDetailReturnOptions $masterRouteDetailReturnOptionsField = null)
    {
        $this->masterRouteDetailReturnOptionsField = $masterRouteDetailReturnOptionsField;
        return $this;
    }
    /**
     * Get profileNameField value
     * @return string|null
     */
    public function getProfileNameField()
    {
        return $this->profileNameField;
    }
    /**
     * Set profileNameField value
     * @param string $profileNameField
     * @return \StructType\MasterRouteDetailRequestEnvelope
     */
    public function setProfileNameField($profileNameField = null)
    {
        // validation for constraint: string
        if (!is_null($profileNameField) && !is_string($profileNameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($profileNameField, true), gettype($profileNameField)), __LINE__);
        }
        $this->profileNameField = $profileNameField;
        return $this;
    }
}
