<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MasterRouteResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MasterRouteResponse
 * @subpackage Structs
 */
class MasterRouteResponse extends RoutePlanDetailType
{
    /**
     * The accountDetailResponseEnvelopeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\AccountDetailResponseEnvelope
     */
    public $accountDetailResponseEnvelopeField;
    /**
     * The nextCloneDateField
     * @var string
     */
    public $nextCloneDateField;
    /**
     * The orderDetailResponseEnvelopeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\OrderDetailResponseEnvelope
     */
    public $orderDetailResponseEnvelopeField;
    /**
     * The responseStatusField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ResponseStatus
     */
    public $responseStatusField;
    /**
     * The routeSummaryResponseEnvelopeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\RouteSummaryResponseEnvelope
     */
    public $routeSummaryResponseEnvelopeField;
    /**
     * Constructor method for MasterRouteResponse
     * @uses MasterRouteResponse::setAccountDetailResponseEnvelopeField()
     * @uses MasterRouteResponse::setNextCloneDateField()
     * @uses MasterRouteResponse::setOrderDetailResponseEnvelopeField()
     * @uses MasterRouteResponse::setResponseStatusField()
     * @uses MasterRouteResponse::setRouteSummaryResponseEnvelopeField()
     * @param \StructType\AccountDetailResponseEnvelope $accountDetailResponseEnvelopeField
     * @param string $nextCloneDateField
     * @param \StructType\OrderDetailResponseEnvelope $orderDetailResponseEnvelopeField
     * @param \StructType\ResponseStatus $responseStatusField
     * @param \StructType\RouteSummaryResponseEnvelope $routeSummaryResponseEnvelopeField
     */
    public function __construct(\StructType\AccountDetailResponseEnvelope $accountDetailResponseEnvelopeField = null, $nextCloneDateField = null, \StructType\OrderDetailResponseEnvelope $orderDetailResponseEnvelopeField = null, \StructType\ResponseStatus $responseStatusField = null, \StructType\RouteSummaryResponseEnvelope $routeSummaryResponseEnvelopeField = null)
    {
        $this
            ->setAccountDetailResponseEnvelopeField($accountDetailResponseEnvelopeField)
            ->setNextCloneDateField($nextCloneDateField)
            ->setOrderDetailResponseEnvelopeField($orderDetailResponseEnvelopeField)
            ->setResponseStatusField($responseStatusField)
            ->setRouteSummaryResponseEnvelopeField($routeSummaryResponseEnvelopeField);
    }
    /**
     * Get accountDetailResponseEnvelopeField value
     * @return \StructType\AccountDetailResponseEnvelope|null
     */
    public function getAccountDetailResponseEnvelopeField()
    {
        return $this->accountDetailResponseEnvelopeField;
    }
    /**
     * Set accountDetailResponseEnvelopeField value
     * @param \StructType\AccountDetailResponseEnvelope $accountDetailResponseEnvelopeField
     * @return \StructType\MasterRouteResponse
     */
    public function setAccountDetailResponseEnvelopeField(\StructType\AccountDetailResponseEnvelope $accountDetailResponseEnvelopeField = null)
    {
        $this->accountDetailResponseEnvelopeField = $accountDetailResponseEnvelopeField;
        return $this;
    }
    /**
     * Get nextCloneDateField value
     * @return string|null
     */
    public function getNextCloneDateField()
    {
        return $this->nextCloneDateField;
    }
    /**
     * Set nextCloneDateField value
     * @param string $nextCloneDateField
     * @return \StructType\MasterRouteResponse
     */
    public function setNextCloneDateField($nextCloneDateField = null)
    {
        // validation for constraint: string
        if (!is_null($nextCloneDateField) && !is_string($nextCloneDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nextCloneDateField, true), gettype($nextCloneDateField)), __LINE__);
        }
        $this->nextCloneDateField = $nextCloneDateField;
        return $this;
    }
    /**
     * Get orderDetailResponseEnvelopeField value
     * @return \StructType\OrderDetailResponseEnvelope|null
     */
    public function getOrderDetailResponseEnvelopeField()
    {
        return $this->orderDetailResponseEnvelopeField;
    }
    /**
     * Set orderDetailResponseEnvelopeField value
     * @param \StructType\OrderDetailResponseEnvelope $orderDetailResponseEnvelopeField
     * @return \StructType\MasterRouteResponse
     */
    public function setOrderDetailResponseEnvelopeField(\StructType\OrderDetailResponseEnvelope $orderDetailResponseEnvelopeField = null)
    {
        $this->orderDetailResponseEnvelopeField = $orderDetailResponseEnvelopeField;
        return $this;
    }
    /**
     * Get responseStatusField value
     * @return \StructType\ResponseStatus|null
     */
    public function getResponseStatusField()
    {
        return $this->responseStatusField;
    }
    /**
     * Set responseStatusField value
     * @param \StructType\ResponseStatus $responseStatusField
     * @return \StructType\MasterRouteResponse
     */
    public function setResponseStatusField(\StructType\ResponseStatus $responseStatusField = null)
    {
        $this->responseStatusField = $responseStatusField;
        return $this;
    }
    /**
     * Get routeSummaryResponseEnvelopeField value
     * @return \StructType\RouteSummaryResponseEnvelope|null
     */
    public function getRouteSummaryResponseEnvelopeField()
    {
        return $this->routeSummaryResponseEnvelopeField;
    }
    /**
     * Set routeSummaryResponseEnvelopeField value
     * @param \StructType\RouteSummaryResponseEnvelope $routeSummaryResponseEnvelopeField
     * @return \StructType\MasterRouteResponse
     */
    public function setRouteSummaryResponseEnvelopeField(\StructType\RouteSummaryResponseEnvelope $routeSummaryResponseEnvelopeField = null)
    {
        $this->routeSummaryResponseEnvelopeField = $routeSummaryResponseEnvelopeField;
        return $this;
    }
}
