<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Order StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Order
 * @subpackage Structs
 */
class Order extends AbstractStructBase
{
    /**
     * The address2Field
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $address2Field;
    /**
     * The addressField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $addressField;
    /**
     * The cityField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $cityField;
    /**
     * The contactField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $contactField;
    /**
     * The countryField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $countryField;
    /**
     * The geoResultField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $geoResultField;
    /**
     * The iD1Field
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $iD1Field;
    /**
     * The iD2Field
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $iD2Field;
    /**
     * The lineItemField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfLineItem
     */
    public $lineItemField;
    /**
     * The nameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $nameField;
    /**
     * The onFinalizeField
     * @var string
     */
    public $onFinalizeField;
    /**
     * The phoneField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $phoneField;
    /**
     * The stateField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $stateField;
    /**
     * The zipField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $zipField;
    /**
     * Constructor method for Order
     * @uses Order::setAddress2Field()
     * @uses Order::setAddressField()
     * @uses Order::setCityField()
     * @uses Order::setContactField()
     * @uses Order::setCountryField()
     * @uses Order::setGeoResultField()
     * @uses Order::setID1Field()
     * @uses Order::setID2Field()
     * @uses Order::setLineItemField()
     * @uses Order::setNameField()
     * @uses Order::setOnFinalizeField()
     * @uses Order::setPhoneField()
     * @uses Order::setStateField()
     * @uses Order::setZipField()
     * @param string $address2Field
     * @param string $addressField
     * @param string $cityField
     * @param string $contactField
     * @param string $countryField
     * @param string $geoResultField
     * @param string $iD1Field
     * @param string $iD2Field
     * @param \ArrayType\ArrayOfLineItem $lineItemField
     * @param string $nameField
     * @param string $onFinalizeField
     * @param string $phoneField
     * @param string $stateField
     * @param string $zipField
     */
    public function __construct($address2Field = null, $addressField = null, $cityField = null, $contactField = null, $countryField = null, $geoResultField = null, $iD1Field = null, $iD2Field = null, \ArrayType\ArrayOfLineItem $lineItemField = null, $nameField = null, $onFinalizeField = null, $phoneField = null, $stateField = null, $zipField = null)
    {
        $this
            ->setAddress2Field($address2Field)
            ->setAddressField($addressField)
            ->setCityField($cityField)
            ->setContactField($contactField)
            ->setCountryField($countryField)
            ->setGeoResultField($geoResultField)
            ->setID1Field($iD1Field)
            ->setID2Field($iD2Field)
            ->setLineItemField($lineItemField)
            ->setNameField($nameField)
            ->setOnFinalizeField($onFinalizeField)
            ->setPhoneField($phoneField)
            ->setStateField($stateField)
            ->setZipField($zipField);
    }
    /**
     * Get address2Field value
     * @return string|null
     */
    public function getAddress2Field()
    {
        return $this->address2Field;
    }
    /**
     * Set address2Field value
     * @param string $address2Field
     * @return \StructType\Order
     */
    public function setAddress2Field($address2Field = null)
    {
        // validation for constraint: string
        if (!is_null($address2Field) && !is_string($address2Field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($address2Field, true), gettype($address2Field)), __LINE__);
        }
        $this->address2Field = $address2Field;
        return $this;
    }
    /**
     * Get addressField value
     * @return string|null
     */
    public function getAddressField()
    {
        return $this->addressField;
    }
    /**
     * Set addressField value
     * @param string $addressField
     * @return \StructType\Order
     */
    public function setAddressField($addressField = null)
    {
        // validation for constraint: string
        if (!is_null($addressField) && !is_string($addressField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($addressField, true), gettype($addressField)), __LINE__);
        }
        $this->addressField = $addressField;
        return $this;
    }
    /**
     * Get cityField value
     * @return string|null
     */
    public function getCityField()
    {
        return $this->cityField;
    }
    /**
     * Set cityField value
     * @param string $cityField
     * @return \StructType\Order
     */
    public function setCityField($cityField = null)
    {
        // validation for constraint: string
        if (!is_null($cityField) && !is_string($cityField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cityField, true), gettype($cityField)), __LINE__);
        }
        $this->cityField = $cityField;
        return $this;
    }
    /**
     * Get contactField value
     * @return string|null
     */
    public function getContactField()
    {
        return $this->contactField;
    }
    /**
     * Set contactField value
     * @param string $contactField
     * @return \StructType\Order
     */
    public function setContactField($contactField = null)
    {
        // validation for constraint: string
        if (!is_null($contactField) && !is_string($contactField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contactField, true), gettype($contactField)), __LINE__);
        }
        $this->contactField = $contactField;
        return $this;
    }
    /**
     * Get countryField value
     * @return string|null
     */
    public function getCountryField()
    {
        return $this->countryField;
    }
    /**
     * Set countryField value
     * @param string $countryField
     * @return \StructType\Order
     */
    public function setCountryField($countryField = null)
    {
        // validation for constraint: string
        if (!is_null($countryField) && !is_string($countryField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryField, true), gettype($countryField)), __LINE__);
        }
        $this->countryField = $countryField;
        return $this;
    }
    /**
     * Get geoResultField value
     * @return string|null
     */
    public function getGeoResultField()
    {
        return $this->geoResultField;
    }
    /**
     * Set geoResultField value
     * @param string $geoResultField
     * @return \StructType\Order
     */
    public function setGeoResultField($geoResultField = null)
    {
        // validation for constraint: string
        if (!is_null($geoResultField) && !is_string($geoResultField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($geoResultField, true), gettype($geoResultField)), __LINE__);
        }
        $this->geoResultField = $geoResultField;
        return $this;
    }
    /**
     * Get iD1Field value
     * @return string|null
     */
    public function getID1Field()
    {
        return $this->iD1Field;
    }
    /**
     * Set iD1Field value
     * @param string $iD1Field
     * @return \StructType\Order
     */
    public function setID1Field($iD1Field = null)
    {
        // validation for constraint: string
        if (!is_null($iD1Field) && !is_string($iD1Field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD1Field, true), gettype($iD1Field)), __LINE__);
        }
        $this->iD1Field = $iD1Field;
        return $this;
    }
    /**
     * Get iD2Field value
     * @return string|null
     */
    public function getID2Field()
    {
        return $this->iD2Field;
    }
    /**
     * Set iD2Field value
     * @param string $iD2Field
     * @return \StructType\Order
     */
    public function setID2Field($iD2Field = null)
    {
        // validation for constraint: string
        if (!is_null($iD2Field) && !is_string($iD2Field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD2Field, true), gettype($iD2Field)), __LINE__);
        }
        $this->iD2Field = $iD2Field;
        return $this;
    }
    /**
     * Get lineItemField value
     * @return \ArrayType\ArrayOfLineItem|null
     */
    public function getLineItemField()
    {
        return $this->lineItemField;
    }
    /**
     * Set lineItemField value
     * @param \ArrayType\ArrayOfLineItem $lineItemField
     * @return \StructType\Order
     */
    public function setLineItemField(\ArrayType\ArrayOfLineItem $lineItemField = null)
    {
        $this->lineItemField = $lineItemField;
        return $this;
    }
    /**
     * Get nameField value
     * @return string|null
     */
    public function getNameField()
    {
        return $this->nameField;
    }
    /**
     * Set nameField value
     * @param string $nameField
     * @return \StructType\Order
     */
    public function setNameField($nameField = null)
    {
        // validation for constraint: string
        if (!is_null($nameField) && !is_string($nameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nameField, true), gettype($nameField)), __LINE__);
        }
        $this->nameField = $nameField;
        return $this;
    }
    /**
     * Get onFinalizeField value
     * @return string|null
     */
    public function getOnFinalizeField()
    {
        return $this->onFinalizeField;
    }
    /**
     * Set onFinalizeField value
     * @uses \EnumType\OnFinalize::valueIsValid()
     * @uses \EnumType\OnFinalize::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $onFinalizeField
     * @return \StructType\Order
     */
    public function setOnFinalizeField($onFinalizeField = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\OnFinalize::valueIsValid($onFinalizeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\OnFinalize', is_array($onFinalizeField) ? implode(', ', $onFinalizeField) : var_export($onFinalizeField, true), implode(', ', \EnumType\OnFinalize::getValidValues())), __LINE__);
        }
        $this->onFinalizeField = $onFinalizeField;
        return $this;
    }
    /**
     * Get phoneField value
     * @return string|null
     */
    public function getPhoneField()
    {
        return $this->phoneField;
    }
    /**
     * Set phoneField value
     * @param string $phoneField
     * @return \StructType\Order
     */
    public function setPhoneField($phoneField = null)
    {
        // validation for constraint: string
        if (!is_null($phoneField) && !is_string($phoneField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phoneField, true), gettype($phoneField)), __LINE__);
        }
        $this->phoneField = $phoneField;
        return $this;
    }
    /**
     * Get stateField value
     * @return string|null
     */
    public function getStateField()
    {
        return $this->stateField;
    }
    /**
     * Set stateField value
     * @param string $stateField
     * @return \StructType\Order
     */
    public function setStateField($stateField = null)
    {
        // validation for constraint: string
        if (!is_null($stateField) && !is_string($stateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($stateField, true), gettype($stateField)), __LINE__);
        }
        $this->stateField = $stateField;
        return $this;
    }
    /**
     * Get zipField value
     * @return string|null
     */
    public function getZipField()
    {
        return $this->zipField;
    }
    /**
     * Set zipField value
     * @param string $zipField
     * @return \StructType\Order
     */
    public function setZipField($zipField = null)
    {
        // validation for constraint: string
        if (!is_null($zipField) && !is_string($zipField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipField, true), gettype($zipField)), __LINE__);
        }
        $this->zipField = $zipField;
        return $this;
    }
}
