<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderDetailActualType StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OrderDetailActualType
 * @subpackage Structs
 */
class OrderDetailActualType extends AbstractStructBase
{
    /**
     * The actualArrivalField
     * @var string
     */
    public $actualArrivalField;
    /**
     * The actualDepartureField
     * @var string
     */
    public $actualDepartureField;
    /**
     * The coordinatesField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Coordinates
     */
    public $coordinatesField;
    /**
     * The delayField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $delayField;
    /**
     * The deviceIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $deviceIDField;
    /**
     * The driverIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $driverIDField;
    /**
     * The formListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfFormListForm
     */
    public $formListField;
    /**
     * The inProgressField
     * @var bool
     */
    public $inProgressField;
    /**
     * The isTimeWindowViolatedField
     * @var bool
     */
    public $isTimeWindowViolatedField;
    /**
     * The vehicleIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $vehicleIDField;
    /**
     * Constructor method for OrderDetailActualType
     * @uses OrderDetailActualType::setActualArrivalField()
     * @uses OrderDetailActualType::setActualDepartureField()
     * @uses OrderDetailActualType::setCoordinatesField()
     * @uses OrderDetailActualType::setDelayField()
     * @uses OrderDetailActualType::setDeviceIDField()
     * @uses OrderDetailActualType::setDriverIDField()
     * @uses OrderDetailActualType::setFormListField()
     * @uses OrderDetailActualType::setInProgressField()
     * @uses OrderDetailActualType::setIsTimeWindowViolatedField()
     * @uses OrderDetailActualType::setVehicleIDField()
     * @param string $actualArrivalField
     * @param string $actualDepartureField
     * @param \StructType\Coordinates $coordinatesField
     * @param string $delayField
     * @param string $deviceIDField
     * @param string $driverIDField
     * @param \ArrayType\ArrayOfFormListForm $formListField
     * @param bool $inProgressField
     * @param bool $isTimeWindowViolatedField
     * @param string $vehicleIDField
     */
    public function __construct($actualArrivalField = null, $actualDepartureField = null, \StructType\Coordinates $coordinatesField = null, $delayField = null, $deviceIDField = null, $driverIDField = null, \ArrayType\ArrayOfFormListForm $formListField = null, $inProgressField = null, $isTimeWindowViolatedField = null, $vehicleIDField = null)
    {
        $this
            ->setActualArrivalField($actualArrivalField)
            ->setActualDepartureField($actualDepartureField)
            ->setCoordinatesField($coordinatesField)
            ->setDelayField($delayField)
            ->setDeviceIDField($deviceIDField)
            ->setDriverIDField($driverIDField)
            ->setFormListField($formListField)
            ->setInProgressField($inProgressField)
            ->setIsTimeWindowViolatedField($isTimeWindowViolatedField)
            ->setVehicleIDField($vehicleIDField);
    }
    /**
     * Get actualArrivalField value
     * @return string|null
     */
    public function getActualArrivalField()
    {
        return $this->actualArrivalField;
    }
    /**
     * Set actualArrivalField value
     * @param string $actualArrivalField
     * @return \StructType\OrderDetailActualType
     */
    public function setActualArrivalField($actualArrivalField = null)
    {
        // validation for constraint: string
        if (!is_null($actualArrivalField) && !is_string($actualArrivalField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualArrivalField, true), gettype($actualArrivalField)), __LINE__);
        }
        $this->actualArrivalField = $actualArrivalField;
        return $this;
    }
    /**
     * Get actualDepartureField value
     * @return string|null
     */
    public function getActualDepartureField()
    {
        return $this->actualDepartureField;
    }
    /**
     * Set actualDepartureField value
     * @param string $actualDepartureField
     * @return \StructType\OrderDetailActualType
     */
    public function setActualDepartureField($actualDepartureField = null)
    {
        // validation for constraint: string
        if (!is_null($actualDepartureField) && !is_string($actualDepartureField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualDepartureField, true), gettype($actualDepartureField)), __LINE__);
        }
        $this->actualDepartureField = $actualDepartureField;
        return $this;
    }
    /**
     * Get coordinatesField value
     * @return \StructType\Coordinates|null
     */
    public function getCoordinatesField()
    {
        return $this->coordinatesField;
    }
    /**
     * Set coordinatesField value
     * @param \StructType\Coordinates $coordinatesField
     * @return \StructType\OrderDetailActualType
     */
    public function setCoordinatesField(\StructType\Coordinates $coordinatesField = null)
    {
        $this->coordinatesField = $coordinatesField;
        return $this;
    }
    /**
     * Get delayField value
     * @return string|null
     */
    public function getDelayField()
    {
        return $this->delayField;
    }
    /**
     * Set delayField value
     * @param string $delayField
     * @return \StructType\OrderDetailActualType
     */
    public function setDelayField($delayField = null)
    {
        // validation for constraint: string
        if (!is_null($delayField) && !is_string($delayField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($delayField, true), gettype($delayField)), __LINE__);
        }
        $this->delayField = $delayField;
        return $this;
    }
    /**
     * Get deviceIDField value
     * @return string|null
     */
    public function getDeviceIDField()
    {
        return $this->deviceIDField;
    }
    /**
     * Set deviceIDField value
     * @param string $deviceIDField
     * @return \StructType\OrderDetailActualType
     */
    public function setDeviceIDField($deviceIDField = null)
    {
        // validation for constraint: string
        if (!is_null($deviceIDField) && !is_string($deviceIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceIDField, true), gettype($deviceIDField)), __LINE__);
        }
        $this->deviceIDField = $deviceIDField;
        return $this;
    }
    /**
     * Get driverIDField value
     * @return string|null
     */
    public function getDriverIDField()
    {
        return $this->driverIDField;
    }
    /**
     * Set driverIDField value
     * @param string $driverIDField
     * @return \StructType\OrderDetailActualType
     */
    public function setDriverIDField($driverIDField = null)
    {
        // validation for constraint: string
        if (!is_null($driverIDField) && !is_string($driverIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverIDField, true), gettype($driverIDField)), __LINE__);
        }
        $this->driverIDField = $driverIDField;
        return $this;
    }
    /**
     * Get formListField value
     * @return \ArrayType\ArrayOfFormListForm|null
     */
    public function getFormListField()
    {
        return $this->formListField;
    }
    /**
     * Set formListField value
     * @param \ArrayType\ArrayOfFormListForm $formListField
     * @return \StructType\OrderDetailActualType
     */
    public function setFormListField(\ArrayType\ArrayOfFormListForm $formListField = null)
    {
        $this->formListField = $formListField;
        return $this;
    }
    /**
     * Get inProgressField value
     * @return bool|null
     */
    public function getInProgressField()
    {
        return $this->inProgressField;
    }
    /**
     * Set inProgressField value
     * @param bool $inProgressField
     * @return \StructType\OrderDetailActualType
     */
    public function setInProgressField($inProgressField = null)
    {
        // validation for constraint: boolean
        if (!is_null($inProgressField) && !is_bool($inProgressField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($inProgressField, true), gettype($inProgressField)), __LINE__);
        }
        $this->inProgressField = $inProgressField;
        return $this;
    }
    /**
     * Get isTimeWindowViolatedField value
     * @return bool|null
     */
    public function getIsTimeWindowViolatedField()
    {
        return $this->isTimeWindowViolatedField;
    }
    /**
     * Set isTimeWindowViolatedField value
     * @param bool $isTimeWindowViolatedField
     * @return \StructType\OrderDetailActualType
     */
    public function setIsTimeWindowViolatedField($isTimeWindowViolatedField = null)
    {
        // validation for constraint: boolean
        if (!is_null($isTimeWindowViolatedField) && !is_bool($isTimeWindowViolatedField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isTimeWindowViolatedField, true), gettype($isTimeWindowViolatedField)), __LINE__);
        }
        $this->isTimeWindowViolatedField = $isTimeWindowViolatedField;
        return $this;
    }
    /**
     * Get vehicleIDField value
     * @return string|null
     */
    public function getVehicleIDField()
    {
        return $this->vehicleIDField;
    }
    /**
     * Set vehicleIDField value
     * @param string $vehicleIDField
     * @return \StructType\OrderDetailActualType
     */
    public function setVehicleIDField($vehicleIDField = null)
    {
        // validation for constraint: string
        if (!is_null($vehicleIDField) && !is_string($vehicleIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vehicleIDField, true), gettype($vehicleIDField)), __LINE__);
        }
        $this->vehicleIDField = $vehicleIDField;
        return $this;
    }
}
