<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderDetailPlanType StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OrderDetailPlanType
 * @subpackage Structs
 */
class OrderDetailPlanType extends AbstractStructBase
{
    /**
     * The accountMasterDetailsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\AccountMasterDetails
     */
    public $accountMasterDetailsField;
    /**
     * The dispatchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dispatchIDField;
    /**
     * The estimatedArrivalField
     * @var string
     */
    public $estimatedArrivalField;
    /**
     * The estimatedDepartureField
     * @var string
     */
    public $estimatedDepartureField;
    /**
     * The legNoField
     * @var int
     */
    public $legNoField;
    /**
     * The loadIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $loadIDField;
    /**
     * The plannedArrivalField
     * @var string
     */
    public $plannedArrivalField;
    /**
     * The plannedDepartureField
     * @var string
     */
    public $plannedDepartureField;
    /**
     * The routeIDField
     * @var int
     */
    public $routeIDField;
    /**
     * The rtNumberField
     * @var int
     */
    public $rtNumberField;
    /**
     * The sequenceNoField
     * @var int
     */
    public $sequenceNoField;
    /**
     * The shipToDetailsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ShipToDetails
     */
    public $shipToDetailsField;
    /**
     * The stopIDField
     * @var int
     */
    public $stopIDField;
    /**
     * Constructor method for OrderDetailPlanType
     * @uses OrderDetailPlanType::setAccountMasterDetailsField()
     * @uses OrderDetailPlanType::setDispatchIDField()
     * @uses OrderDetailPlanType::setEstimatedArrivalField()
     * @uses OrderDetailPlanType::setEstimatedDepartureField()
     * @uses OrderDetailPlanType::setLegNoField()
     * @uses OrderDetailPlanType::setLoadIDField()
     * @uses OrderDetailPlanType::setPlannedArrivalField()
     * @uses OrderDetailPlanType::setPlannedDepartureField()
     * @uses OrderDetailPlanType::setRouteIDField()
     * @uses OrderDetailPlanType::setRtNumberField()
     * @uses OrderDetailPlanType::setSequenceNoField()
     * @uses OrderDetailPlanType::setShipToDetailsField()
     * @uses OrderDetailPlanType::setStopIDField()
     * @param \StructType\AccountMasterDetails $accountMasterDetailsField
     * @param string $dispatchIDField
     * @param string $estimatedArrivalField
     * @param string $estimatedDepartureField
     * @param int $legNoField
     * @param string $loadIDField
     * @param string $plannedArrivalField
     * @param string $plannedDepartureField
     * @param int $routeIDField
     * @param int $rtNumberField
     * @param int $sequenceNoField
     * @param \StructType\ShipToDetails $shipToDetailsField
     * @param int $stopIDField
     */
    public function __construct(\StructType\AccountMasterDetails $accountMasterDetailsField = null, $dispatchIDField = null, $estimatedArrivalField = null, $estimatedDepartureField = null, $legNoField = null, $loadIDField = null, $plannedArrivalField = null, $plannedDepartureField = null, $routeIDField = null, $rtNumberField = null, $sequenceNoField = null, \StructType\ShipToDetails $shipToDetailsField = null, $stopIDField = null)
    {
        $this
            ->setAccountMasterDetailsField($accountMasterDetailsField)
            ->setDispatchIDField($dispatchIDField)
            ->setEstimatedArrivalField($estimatedArrivalField)
            ->setEstimatedDepartureField($estimatedDepartureField)
            ->setLegNoField($legNoField)
            ->setLoadIDField($loadIDField)
            ->setPlannedArrivalField($plannedArrivalField)
            ->setPlannedDepartureField($plannedDepartureField)
            ->setRouteIDField($routeIDField)
            ->setRtNumberField($rtNumberField)
            ->setSequenceNoField($sequenceNoField)
            ->setShipToDetailsField($shipToDetailsField)
            ->setStopIDField($stopIDField);
    }
    /**
     * Get accountMasterDetailsField value
     * @return \StructType\AccountMasterDetails|null
     */
    public function getAccountMasterDetailsField()
    {
        return $this->accountMasterDetailsField;
    }
    /**
     * Set accountMasterDetailsField value
     * @param \StructType\AccountMasterDetails $accountMasterDetailsField
     * @return \StructType\OrderDetailPlanType
     */
    public function setAccountMasterDetailsField(\StructType\AccountMasterDetails $accountMasterDetailsField = null)
    {
        $this->accountMasterDetailsField = $accountMasterDetailsField;
        return $this;
    }
    /**
     * Get dispatchIDField value
     * @return string|null
     */
    public function getDispatchIDField()
    {
        return $this->dispatchIDField;
    }
    /**
     * Set dispatchIDField value
     * @param string $dispatchIDField
     * @return \StructType\OrderDetailPlanType
     */
    public function setDispatchIDField($dispatchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($dispatchIDField) && !is_string($dispatchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dispatchIDField, true), gettype($dispatchIDField)), __LINE__);
        }
        $this->dispatchIDField = $dispatchIDField;
        return $this;
    }
    /**
     * Get estimatedArrivalField value
     * @return string|null
     */
    public function getEstimatedArrivalField()
    {
        return $this->estimatedArrivalField;
    }
    /**
     * Set estimatedArrivalField value
     * @param string $estimatedArrivalField
     * @return \StructType\OrderDetailPlanType
     */
    public function setEstimatedArrivalField($estimatedArrivalField = null)
    {
        // validation for constraint: string
        if (!is_null($estimatedArrivalField) && !is_string($estimatedArrivalField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estimatedArrivalField, true), gettype($estimatedArrivalField)), __LINE__);
        }
        $this->estimatedArrivalField = $estimatedArrivalField;
        return $this;
    }
    /**
     * Get estimatedDepartureField value
     * @return string|null
     */
    public function getEstimatedDepartureField()
    {
        return $this->estimatedDepartureField;
    }
    /**
     * Set estimatedDepartureField value
     * @param string $estimatedDepartureField
     * @return \StructType\OrderDetailPlanType
     */
    public function setEstimatedDepartureField($estimatedDepartureField = null)
    {
        // validation for constraint: string
        if (!is_null($estimatedDepartureField) && !is_string($estimatedDepartureField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estimatedDepartureField, true), gettype($estimatedDepartureField)), __LINE__);
        }
        $this->estimatedDepartureField = $estimatedDepartureField;
        return $this;
    }
    /**
     * Get legNoField value
     * @return int|null
     */
    public function getLegNoField()
    {
        return $this->legNoField;
    }
    /**
     * Set legNoField value
     * @param int $legNoField
     * @return \StructType\OrderDetailPlanType
     */
    public function setLegNoField($legNoField = null)
    {
        // validation for constraint: int
        if (!is_null($legNoField) && !(is_int($legNoField) || ctype_digit($legNoField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($legNoField, true), gettype($legNoField)), __LINE__);
        }
        $this->legNoField = $legNoField;
        return $this;
    }
    /**
     * Get loadIDField value
     * @return string|null
     */
    public function getLoadIDField()
    {
        return $this->loadIDField;
    }
    /**
     * Set loadIDField value
     * @param string $loadIDField
     * @return \StructType\OrderDetailPlanType
     */
    public function setLoadIDField($loadIDField = null)
    {
        // validation for constraint: string
        if (!is_null($loadIDField) && !is_string($loadIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadIDField, true), gettype($loadIDField)), __LINE__);
        }
        $this->loadIDField = $loadIDField;
        return $this;
    }
    /**
     * Get plannedArrivalField value
     * @return string|null
     */
    public function getPlannedArrivalField()
    {
        return $this->plannedArrivalField;
    }
    /**
     * Set plannedArrivalField value
     * @param string $plannedArrivalField
     * @return \StructType\OrderDetailPlanType
     */
    public function setPlannedArrivalField($plannedArrivalField = null)
    {
        // validation for constraint: string
        if (!is_null($plannedArrivalField) && !is_string($plannedArrivalField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plannedArrivalField, true), gettype($plannedArrivalField)), __LINE__);
        }
        $this->plannedArrivalField = $plannedArrivalField;
        return $this;
    }
    /**
     * Get plannedDepartureField value
     * @return string|null
     */
    public function getPlannedDepartureField()
    {
        return $this->plannedDepartureField;
    }
    /**
     * Set plannedDepartureField value
     * @param string $plannedDepartureField
     * @return \StructType\OrderDetailPlanType
     */
    public function setPlannedDepartureField($plannedDepartureField = null)
    {
        // validation for constraint: string
        if (!is_null($plannedDepartureField) && !is_string($plannedDepartureField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($plannedDepartureField, true), gettype($plannedDepartureField)), __LINE__);
        }
        $this->plannedDepartureField = $plannedDepartureField;
        return $this;
    }
    /**
     * Get routeIDField value
     * @return int|null
     */
    public function getRouteIDField()
    {
        return $this->routeIDField;
    }
    /**
     * Set routeIDField value
     * @param int $routeIDField
     * @return \StructType\OrderDetailPlanType
     */
    public function setRouteIDField($routeIDField = null)
    {
        // validation for constraint: int
        if (!is_null($routeIDField) && !(is_int($routeIDField) || ctype_digit($routeIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($routeIDField, true), gettype($routeIDField)), __LINE__);
        }
        $this->routeIDField = $routeIDField;
        return $this;
    }
    /**
     * Get rtNumberField value
     * @return int|null
     */
    public function getRtNumberField()
    {
        return $this->rtNumberField;
    }
    /**
     * Set rtNumberField value
     * @param int $rtNumberField
     * @return \StructType\OrderDetailPlanType
     */
    public function setRtNumberField($rtNumberField = null)
    {
        // validation for constraint: int
        if (!is_null($rtNumberField) && !(is_int($rtNumberField) || ctype_digit($rtNumberField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rtNumberField, true), gettype($rtNumberField)), __LINE__);
        }
        $this->rtNumberField = $rtNumberField;
        return $this;
    }
    /**
     * Get sequenceNoField value
     * @return int|null
     */
    public function getSequenceNoField()
    {
        return $this->sequenceNoField;
    }
    /**
     * Set sequenceNoField value
     * @param int $sequenceNoField
     * @return \StructType\OrderDetailPlanType
     */
    public function setSequenceNoField($sequenceNoField = null)
    {
        // validation for constraint: int
        if (!is_null($sequenceNoField) && !(is_int($sequenceNoField) || ctype_digit($sequenceNoField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sequenceNoField, true), gettype($sequenceNoField)), __LINE__);
        }
        $this->sequenceNoField = $sequenceNoField;
        return $this;
    }
    /**
     * Get shipToDetailsField value
     * @return \StructType\ShipToDetails|null
     */
    public function getShipToDetailsField()
    {
        return $this->shipToDetailsField;
    }
    /**
     * Set shipToDetailsField value
     * @param \StructType\ShipToDetails $shipToDetailsField
     * @return \StructType\OrderDetailPlanType
     */
    public function setShipToDetailsField(\StructType\ShipToDetails $shipToDetailsField = null)
    {
        $this->shipToDetailsField = $shipToDetailsField;
        return $this;
    }
    /**
     * Get stopIDField value
     * @return int|null
     */
    public function getStopIDField()
    {
        return $this->stopIDField;
    }
    /**
     * Set stopIDField value
     * @param int $stopIDField
     * @return \StructType\OrderDetailPlanType
     */
    public function setStopIDField($stopIDField = null)
    {
        // validation for constraint: int
        if (!is_null($stopIDField) && !(is_int($stopIDField) || ctype_digit($stopIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($stopIDField, true), gettype($stopIDField)), __LINE__);
        }
        $this->stopIDField = $stopIDField;
        return $this;
    }
}
