<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderDetailReturnOptions StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OrderDetailReturnOptions
 * @subpackage Structs
 */
class OrderDetailReturnOptions extends AbstractStructBase
{
    /**
     * The filtersField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\OrderDetailReturnOptionsFilters
     */
    public $filtersField;
    /**
     * The populateAccountDetailsField
     * @var bool
     */
    public $populateAccountDetailsField;
    /**
     * The populateActualsDataField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $populateActualsDataField;
    /**
     * The populateLineItemField
     * @var bool
     */
    public $populateLineItemField;
    /**
     * The populateLineItemFormsField
     * @var bool
     */
    public $populateLineItemFormsField;
    /**
     * The populateOrderFormsField
     * @var bool
     */
    public $populateOrderFormsField;
    /**
     * The populatePlannedDataField
     * @var bool
     */
    public $populatePlannedDataField;
    /**
     * The populateQuantityFieldField
     * @var bool
     */
    public $populateQuantityFieldField;
    /**
     * The populateShipToDetailsField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $populateShipToDetailsField;
    /**
     * The populateStopNotesField
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $populateStopNotesField;
    /**
     * The populateUserFieldField
     * @var bool
     */
    public $populateUserFieldField;
    /**
     * Constructor method for OrderDetailReturnOptions
     * @uses OrderDetailReturnOptions::setFiltersField()
     * @uses OrderDetailReturnOptions::setPopulateAccountDetailsField()
     * @uses OrderDetailReturnOptions::setPopulateActualsDataField()
     * @uses OrderDetailReturnOptions::setPopulateLineItemField()
     * @uses OrderDetailReturnOptions::setPopulateLineItemFormsField()
     * @uses OrderDetailReturnOptions::setPopulateOrderFormsField()
     * @uses OrderDetailReturnOptions::setPopulatePlannedDataField()
     * @uses OrderDetailReturnOptions::setPopulateQuantityFieldField()
     * @uses OrderDetailReturnOptions::setPopulateShipToDetailsField()
     * @uses OrderDetailReturnOptions::setPopulateStopNotesField()
     * @uses OrderDetailReturnOptions::setPopulateUserFieldField()
     * @param \StructType\OrderDetailReturnOptionsFilters $filtersField
     * @param bool $populateAccountDetailsField
     * @param bool $populateActualsDataField
     * @param bool $populateLineItemField
     * @param bool $populateLineItemFormsField
     * @param bool $populateOrderFormsField
     * @param bool $populatePlannedDataField
     * @param bool $populateQuantityFieldField
     * @param bool $populateShipToDetailsField
     * @param bool $populateStopNotesField
     * @param bool $populateUserFieldField
     */
    public function __construct(\StructType\OrderDetailReturnOptionsFilters $filtersField = null, $populateAccountDetailsField = null, $populateActualsDataField = null, $populateLineItemField = null, $populateLineItemFormsField = null, $populateOrderFormsField = null, $populatePlannedDataField = null, $populateQuantityFieldField = null, $populateShipToDetailsField = null, $populateStopNotesField = null, $populateUserFieldField = null)
    {
        $this
            ->setFiltersField($filtersField)
            ->setPopulateAccountDetailsField($populateAccountDetailsField)
            ->setPopulateActualsDataField($populateActualsDataField)
            ->setPopulateLineItemField($populateLineItemField)
            ->setPopulateLineItemFormsField($populateLineItemFormsField)
            ->setPopulateOrderFormsField($populateOrderFormsField)
            ->setPopulatePlannedDataField($populatePlannedDataField)
            ->setPopulateQuantityFieldField($populateQuantityFieldField)
            ->setPopulateShipToDetailsField($populateShipToDetailsField)
            ->setPopulateStopNotesField($populateStopNotesField)
            ->setPopulateUserFieldField($populateUserFieldField);
    }
    /**
     * Get filtersField value
     * @return \StructType\OrderDetailReturnOptionsFilters|null
     */
    public function getFiltersField()
    {
        return $this->filtersField;
    }
    /**
     * Set filtersField value
     * @param \StructType\OrderDetailReturnOptionsFilters $filtersField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setFiltersField(\StructType\OrderDetailReturnOptionsFilters $filtersField = null)
    {
        $this->filtersField = $filtersField;
        return $this;
    }
    /**
     * Get populateAccountDetailsField value
     * @return bool|null
     */
    public function getPopulateAccountDetailsField()
    {
        return $this->populateAccountDetailsField;
    }
    /**
     * Set populateAccountDetailsField value
     * @param bool $populateAccountDetailsField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateAccountDetailsField($populateAccountDetailsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateAccountDetailsField) && !is_bool($populateAccountDetailsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateAccountDetailsField, true), gettype($populateAccountDetailsField)), __LINE__);
        }
        $this->populateAccountDetailsField = $populateAccountDetailsField;
        return $this;
    }
    /**
     * Get populateActualsDataField value
     * @return bool|null
     */
    public function getPopulateActualsDataField()
    {
        return $this->populateActualsDataField;
    }
    /**
     * Set populateActualsDataField value
     * @param bool $populateActualsDataField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateActualsDataField($populateActualsDataField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateActualsDataField) && !is_bool($populateActualsDataField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateActualsDataField, true), gettype($populateActualsDataField)), __LINE__);
        }
        $this->populateActualsDataField = $populateActualsDataField;
        return $this;
    }
    /**
     * Get populateLineItemField value
     * @return bool|null
     */
    public function getPopulateLineItemField()
    {
        return $this->populateLineItemField;
    }
    /**
     * Set populateLineItemField value
     * @param bool $populateLineItemField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateLineItemField($populateLineItemField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateLineItemField) && !is_bool($populateLineItemField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateLineItemField, true), gettype($populateLineItemField)), __LINE__);
        }
        $this->populateLineItemField = $populateLineItemField;
        return $this;
    }
    /**
     * Get populateLineItemFormsField value
     * @return bool|null
     */
    public function getPopulateLineItemFormsField()
    {
        return $this->populateLineItemFormsField;
    }
    /**
     * Set populateLineItemFormsField value
     * @param bool $populateLineItemFormsField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateLineItemFormsField($populateLineItemFormsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateLineItemFormsField) && !is_bool($populateLineItemFormsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateLineItemFormsField, true), gettype($populateLineItemFormsField)), __LINE__);
        }
        $this->populateLineItemFormsField = $populateLineItemFormsField;
        return $this;
    }
    /**
     * Get populateOrderFormsField value
     * @return bool|null
     */
    public function getPopulateOrderFormsField()
    {
        return $this->populateOrderFormsField;
    }
    /**
     * Set populateOrderFormsField value
     * @param bool $populateOrderFormsField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateOrderFormsField($populateOrderFormsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateOrderFormsField) && !is_bool($populateOrderFormsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateOrderFormsField, true), gettype($populateOrderFormsField)), __LINE__);
        }
        $this->populateOrderFormsField = $populateOrderFormsField;
        return $this;
    }
    /**
     * Get populatePlannedDataField value
     * @return bool|null
     */
    public function getPopulatePlannedDataField()
    {
        return $this->populatePlannedDataField;
    }
    /**
     * Set populatePlannedDataField value
     * @param bool $populatePlannedDataField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulatePlannedDataField($populatePlannedDataField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populatePlannedDataField) && !is_bool($populatePlannedDataField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populatePlannedDataField, true), gettype($populatePlannedDataField)), __LINE__);
        }
        $this->populatePlannedDataField = $populatePlannedDataField;
        return $this;
    }
    /**
     * Get populateQuantityFieldField value
     * @return bool|null
     */
    public function getPopulateQuantityFieldField()
    {
        return $this->populateQuantityFieldField;
    }
    /**
     * Set populateQuantityFieldField value
     * @param bool $populateQuantityFieldField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateQuantityFieldField($populateQuantityFieldField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateQuantityFieldField) && !is_bool($populateQuantityFieldField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateQuantityFieldField, true), gettype($populateQuantityFieldField)), __LINE__);
        }
        $this->populateQuantityFieldField = $populateQuantityFieldField;
        return $this;
    }
    /**
     * Get populateShipToDetailsField value
     * @return bool|null
     */
    public function getPopulateShipToDetailsField()
    {
        return $this->populateShipToDetailsField;
    }
    /**
     * Set populateShipToDetailsField value
     * @param bool $populateShipToDetailsField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateShipToDetailsField($populateShipToDetailsField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateShipToDetailsField) && !is_bool($populateShipToDetailsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateShipToDetailsField, true), gettype($populateShipToDetailsField)), __LINE__);
        }
        $this->populateShipToDetailsField = $populateShipToDetailsField;
        return $this;
    }
    /**
     * Get populateStopNotesField value
     * @return bool|null
     */
    public function getPopulateStopNotesField()
    {
        return $this->populateStopNotesField;
    }
    /**
     * Set populateStopNotesField value
     * @param bool $populateStopNotesField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateStopNotesField($populateStopNotesField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateStopNotesField) && !is_bool($populateStopNotesField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateStopNotesField, true), gettype($populateStopNotesField)), __LINE__);
        }
        $this->populateStopNotesField = $populateStopNotesField;
        return $this;
    }
    /**
     * Get populateUserFieldField value
     * @return bool|null
     */
    public function getPopulateUserFieldField()
    {
        return $this->populateUserFieldField;
    }
    /**
     * Set populateUserFieldField value
     * @param bool $populateUserFieldField
     * @return \StructType\OrderDetailReturnOptions
     */
    public function setPopulateUserFieldField($populateUserFieldField = null)
    {
        // validation for constraint: boolean
        if (!is_null($populateUserFieldField) && !is_bool($populateUserFieldField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($populateUserFieldField, true), gettype($populateUserFieldField)), __LINE__);
        }
        $this->populateUserFieldField = $populateUserFieldField;
        return $this;
    }
}
