<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderEventResponseEnvelope StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:OrderEventResponseEnvelope
 * @subpackage Structs
 */
class OrderEventResponseEnvelope extends AbstractStructBase
{
    /**
     * The PaginationByDateRange
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PaginationByDateRange
     */
    public $PaginationByDateRange;
    /**
     * The ResponseDetails
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfOrderEvent
     */
    public $ResponseDetails;
    /**
     * The ResponseStatus
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ResponseStatus
     */
    public $ResponseStatus;
    /**
     * Constructor method for OrderEventResponseEnvelope
     * @uses OrderEventResponseEnvelope::setPaginationByDateRange()
     * @uses OrderEventResponseEnvelope::setResponseDetails()
     * @uses OrderEventResponseEnvelope::setResponseStatus()
     * @param \StructType\PaginationByDateRange $paginationByDateRange
     * @param \ArrayType\ArrayOfOrderEvent $responseDetails
     * @param \StructType\ResponseStatus $responseStatus
     */
    public function __construct(\StructType\PaginationByDateRange $paginationByDateRange = null, \ArrayType\ArrayOfOrderEvent $responseDetails = null, \StructType\ResponseStatus $responseStatus = null)
    {
        $this
            ->setPaginationByDateRange($paginationByDateRange)
            ->setResponseDetails($responseDetails)
            ->setResponseStatus($responseStatus);
    }
    /**
     * Get PaginationByDateRange value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PaginationByDateRange|null
     */
    public function getPaginationByDateRange()
    {
        return isset($this->PaginationByDateRange) ? $this->PaginationByDateRange : null;
    }
    /**
     * Set PaginationByDateRange value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PaginationByDateRange $paginationByDateRange
     * @return \StructType\OrderEventResponseEnvelope
     */
    public function setPaginationByDateRange(\StructType\PaginationByDateRange $paginationByDateRange = null)
    {
        if (is_null($paginationByDateRange) || (is_array($paginationByDateRange) && empty($paginationByDateRange))) {
            unset($this->PaginationByDateRange);
        } else {
            $this->PaginationByDateRange = $paginationByDateRange;
        }
        return $this;
    }
    /**
     * Get ResponseDetails value
     * @return \ArrayType\ArrayOfOrderEvent|null
     */
    public function getResponseDetails()
    {
        return $this->ResponseDetails;
    }
    /**
     * Set ResponseDetails value
     * @param \ArrayType\ArrayOfOrderEvent $responseDetails
     * @return \StructType\OrderEventResponseEnvelope
     */
    public function setResponseDetails(\ArrayType\ArrayOfOrderEvent $responseDetails = null)
    {
        $this->ResponseDetails = $responseDetails;
        return $this;
    }
    /**
     * Get ResponseStatus value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ResponseStatus|null
     */
    public function getResponseStatus()
    {
        return isset($this->ResponseStatus) ? $this->ResponseStatus : null;
    }
    /**
     * Set ResponseStatus value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ResponseStatus $responseStatus
     * @return \StructType\OrderEventResponseEnvelope
     */
    public function setResponseStatus(\StructType\ResponseStatus $responseStatus = null)
    {
        if (is_null($responseStatus) || (is_array($responseStatus) && empty($responseStatus))) {
            unset($this->ResponseStatus);
        } else {
            $this->ResponseStatus = $responseStatus;
        }
        return $this;
    }
}
