<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Parameters StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Parameters
 * @subpackage Structs
 */
class Parameters extends AbstractStructBase
{
    /**
     * The miAdjField
     * @var float
     */
    public $miAdjField;
    /**
     * The minTmBetweenStopsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $minTmBetweenStopsField;
    /**
     * The speedAdjField
     * @var float
     */
    public $speedAdjField;
    /**
     * Constructor method for Parameters
     * @uses Parameters::setMiAdjField()
     * @uses Parameters::setMinTmBetweenStopsField()
     * @uses Parameters::setSpeedAdjField()
     * @param float $miAdjField
     * @param string $minTmBetweenStopsField
     * @param float $speedAdjField
     */
    public function __construct($miAdjField = null, $minTmBetweenStopsField = null, $speedAdjField = null)
    {
        $this
            ->setMiAdjField($miAdjField)
            ->setMinTmBetweenStopsField($minTmBetweenStopsField)
            ->setSpeedAdjField($speedAdjField);
    }
    /**
     * Get miAdjField value
     * @return float|null
     */
    public function getMiAdjField()
    {
        return $this->miAdjField;
    }
    /**
     * Set miAdjField value
     * @param float $miAdjField
     * @return \StructType\Parameters
     */
    public function setMiAdjField($miAdjField = null)
    {
        // validation for constraint: float
        if (!is_null($miAdjField) && !(is_float($miAdjField) || is_numeric($miAdjField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($miAdjField, true), gettype($miAdjField)), __LINE__);
        }
        $this->miAdjField = $miAdjField;
        return $this;
    }
    /**
     * Get minTmBetweenStopsField value
     * @return string|null
     */
    public function getMinTmBetweenStopsField()
    {
        return $this->minTmBetweenStopsField;
    }
    /**
     * Set minTmBetweenStopsField value
     * @param string $minTmBetweenStopsField
     * @return \StructType\Parameters
     */
    public function setMinTmBetweenStopsField($minTmBetweenStopsField = null)
    {
        // validation for constraint: string
        if (!is_null($minTmBetweenStopsField) && !is_string($minTmBetweenStopsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($minTmBetweenStopsField, true), gettype($minTmBetweenStopsField)), __LINE__);
        }
        $this->minTmBetweenStopsField = $minTmBetweenStopsField;
        return $this;
    }
    /**
     * Get speedAdjField value
     * @return float|null
     */
    public function getSpeedAdjField()
    {
        return $this->speedAdjField;
    }
    /**
     * Set speedAdjField value
     * @param float $speedAdjField
     * @return \StructType\Parameters
     */
    public function setSpeedAdjField($speedAdjField = null)
    {
        // validation for constraint: float
        if (!is_null($speedAdjField) && !(is_float($speedAdjField) || is_numeric($speedAdjField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($speedAdjField, true), gettype($speedAdjField)), __LINE__);
        }
        $this->speedAdjField = $speedAdjField;
        return $this;
    }
}
