<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for QtyField StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:QtyField
 * @subpackage Structs
 */
class QtyField extends AbstractStructBase
{
    /**
     * The nameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $nameField;
    /**
     * The valueField
     * @var float
     */
    public $valueField;
    /**
     * Constructor method for QtyField
     * @uses QtyField::setNameField()
     * @uses QtyField::setValueField()
     * @param string $nameField
     * @param float $valueField
     */
    public function __construct($nameField = null, $valueField = null)
    {
        $this
            ->setNameField($nameField)
            ->setValueField($valueField);
    }
    /**
     * Get nameField value
     * @return string|null
     */
    public function getNameField()
    {
        return $this->nameField;
    }
    /**
     * Set nameField value
     * @param string $nameField
     * @return \StructType\QtyField
     */
    public function setNameField($nameField = null)
    {
        // validation for constraint: string
        if (!is_null($nameField) && !is_string($nameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nameField, true), gettype($nameField)), __LINE__);
        }
        $this->nameField = $nameField;
        return $this;
    }
    /**
     * Get valueField value
     * @return float|null
     */
    public function getValueField()
    {
        return $this->valueField;
    }
    /**
     * Set valueField value
     * @param float $valueField
     * @return \StructType\QtyField
     */
    public function setValueField($valueField = null)
    {
        // validation for constraint: float
        if (!is_null($valueField) && !(is_float($valueField) || is_numeric($valueField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($valueField, true), gettype($valueField)), __LINE__);
        }
        $this->valueField = $valueField;
        return $this;
    }
}
