<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RouteActualSummaryType StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RouteActualSummaryType
 * @subpackage Structs
 */
class RouteActualSummaryType extends AbstractStructBase
{
    /**
     * The deviceIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $deviceIDField;
    /**
     * The driverIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $driverIDField;
    /**
     * The driverNameField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $driverNameField;
    /**
     * The endOdometerField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $endOdometerField;
    /**
     * The endTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $endTimeField;
    /**
     * The lastGPSTransmissionTimeField
     * @var string
     */
    public $lastGPSTransmissionTimeField;
    /**
     * The routeIDField
     * @var int
     */
    public $routeIDField;
    /**
     * The startOdometerField
     * @var int
     */
    public $startOdometerField;
    /**
     * The startTimeField
     * @var string
     */
    public $startTimeField;
    /**
     * The vehicleIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $vehicleIDField;
    /**
     * Constructor method for RouteActualSummaryType
     * @uses RouteActualSummaryType::setDeviceIDField()
     * @uses RouteActualSummaryType::setDriverIDField()
     * @uses RouteActualSummaryType::setDriverNameField()
     * @uses RouteActualSummaryType::setEndOdometerField()
     * @uses RouteActualSummaryType::setEndTimeField()
     * @uses RouteActualSummaryType::setLastGPSTransmissionTimeField()
     * @uses RouteActualSummaryType::setRouteIDField()
     * @uses RouteActualSummaryType::setStartOdometerField()
     * @uses RouteActualSummaryType::setStartTimeField()
     * @uses RouteActualSummaryType::setVehicleIDField()
     * @param string $deviceIDField
     * @param string $driverIDField
     * @param string $driverNameField
     * @param int $endOdometerField
     * @param string $endTimeField
     * @param string $lastGPSTransmissionTimeField
     * @param int $routeIDField
     * @param int $startOdometerField
     * @param string $startTimeField
     * @param string $vehicleIDField
     */
    public function __construct($deviceIDField = null, $driverIDField = null, $driverNameField = null, $endOdometerField = null, $endTimeField = null, $lastGPSTransmissionTimeField = null, $routeIDField = null, $startOdometerField = null, $startTimeField = null, $vehicleIDField = null)
    {
        $this
            ->setDeviceIDField($deviceIDField)
            ->setDriverIDField($driverIDField)
            ->setDriverNameField($driverNameField)
            ->setEndOdometerField($endOdometerField)
            ->setEndTimeField($endTimeField)
            ->setLastGPSTransmissionTimeField($lastGPSTransmissionTimeField)
            ->setRouteIDField($routeIDField)
            ->setStartOdometerField($startOdometerField)
            ->setStartTimeField($startTimeField)
            ->setVehicleIDField($vehicleIDField);
    }
    /**
     * Get deviceIDField value
     * @return string|null
     */
    public function getDeviceIDField()
    {
        return $this->deviceIDField;
    }
    /**
     * Set deviceIDField value
     * @param string $deviceIDField
     * @return \StructType\RouteActualSummaryType
     */
    public function setDeviceIDField($deviceIDField = null)
    {
        // validation for constraint: string
        if (!is_null($deviceIDField) && !is_string($deviceIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deviceIDField, true), gettype($deviceIDField)), __LINE__);
        }
        $this->deviceIDField = $deviceIDField;
        return $this;
    }
    /**
     * Get driverIDField value
     * @return string|null
     */
    public function getDriverIDField()
    {
        return $this->driverIDField;
    }
    /**
     * Set driverIDField value
     * @param string $driverIDField
     * @return \StructType\RouteActualSummaryType
     */
    public function setDriverIDField($driverIDField = null)
    {
        // validation for constraint: string
        if (!is_null($driverIDField) && !is_string($driverIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverIDField, true), gettype($driverIDField)), __LINE__);
        }
        $this->driverIDField = $driverIDField;
        return $this;
    }
    /**
     * Get driverNameField value
     * @return string|null
     */
    public function getDriverNameField()
    {
        return $this->driverNameField;
    }
    /**
     * Set driverNameField value
     * @param string $driverNameField
     * @return \StructType\RouteActualSummaryType
     */
    public function setDriverNameField($driverNameField = null)
    {
        // validation for constraint: string
        if (!is_null($driverNameField) && !is_string($driverNameField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverNameField, true), gettype($driverNameField)), __LINE__);
        }
        $this->driverNameField = $driverNameField;
        return $this;
    }
    /**
     * Get endOdometerField value
     * @return int|null
     */
    public function getEndOdometerField()
    {
        return $this->endOdometerField;
    }
    /**
     * Set endOdometerField value
     * @param int $endOdometerField
     * @return \StructType\RouteActualSummaryType
     */
    public function setEndOdometerField($endOdometerField = null)
    {
        // validation for constraint: int
        if (!is_null($endOdometerField) && !(is_int($endOdometerField) || ctype_digit($endOdometerField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($endOdometerField, true), gettype($endOdometerField)), __LINE__);
        }
        $this->endOdometerField = $endOdometerField;
        return $this;
    }
    /**
     * Get endTimeField value
     * @return string|null
     */
    public function getEndTimeField()
    {
        return $this->endTimeField;
    }
    /**
     * Set endTimeField value
     * @param string $endTimeField
     * @return \StructType\RouteActualSummaryType
     */
    public function setEndTimeField($endTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($endTimeField) && !is_string($endTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endTimeField, true), gettype($endTimeField)), __LINE__);
        }
        $this->endTimeField = $endTimeField;
        return $this;
    }
    /**
     * Get lastGPSTransmissionTimeField value
     * @return string|null
     */
    public function getLastGPSTransmissionTimeField()
    {
        return $this->lastGPSTransmissionTimeField;
    }
    /**
     * Set lastGPSTransmissionTimeField value
     * @param string $lastGPSTransmissionTimeField
     * @return \StructType\RouteActualSummaryType
     */
    public function setLastGPSTransmissionTimeField($lastGPSTransmissionTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($lastGPSTransmissionTimeField) && !is_string($lastGPSTransmissionTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastGPSTransmissionTimeField, true), gettype($lastGPSTransmissionTimeField)), __LINE__);
        }
        $this->lastGPSTransmissionTimeField = $lastGPSTransmissionTimeField;
        return $this;
    }
    /**
     * Get routeIDField value
     * @return int|null
     */
    public function getRouteIDField()
    {
        return $this->routeIDField;
    }
    /**
     * Set routeIDField value
     * @param int $routeIDField
     * @return \StructType\RouteActualSummaryType
     */
    public function setRouteIDField($routeIDField = null)
    {
        // validation for constraint: int
        if (!is_null($routeIDField) && !(is_int($routeIDField) || ctype_digit($routeIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($routeIDField, true), gettype($routeIDField)), __LINE__);
        }
        $this->routeIDField = $routeIDField;
        return $this;
    }
    /**
     * Get startOdometerField value
     * @return int|null
     */
    public function getStartOdometerField()
    {
        return $this->startOdometerField;
    }
    /**
     * Set startOdometerField value
     * @param int $startOdometerField
     * @return \StructType\RouteActualSummaryType
     */
    public function setStartOdometerField($startOdometerField = null)
    {
        // validation for constraint: int
        if (!is_null($startOdometerField) && !(is_int($startOdometerField) || ctype_digit($startOdometerField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($startOdometerField, true), gettype($startOdometerField)), __LINE__);
        }
        $this->startOdometerField = $startOdometerField;
        return $this;
    }
    /**
     * Get startTimeField value
     * @return string|null
     */
    public function getStartTimeField()
    {
        return $this->startTimeField;
    }
    /**
     * Set startTimeField value
     * @param string $startTimeField
     * @return \StructType\RouteActualSummaryType
     */
    public function setStartTimeField($startTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($startTimeField) && !is_string($startTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startTimeField, true), gettype($startTimeField)), __LINE__);
        }
        $this->startTimeField = $startTimeField;
        return $this;
    }
    /**
     * Get vehicleIDField value
     * @return string|null
     */
    public function getVehicleIDField()
    {
        return $this->vehicleIDField;
    }
    /**
     * Set vehicleIDField value
     * @param string $vehicleIDField
     * @return \StructType\RouteActualSummaryType
     */
    public function setVehicleIDField($vehicleIDField = null)
    {
        // validation for constraint: string
        if (!is_null($vehicleIDField) && !is_string($vehicleIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($vehicleIDField, true), gettype($vehicleIDField)), __LINE__);
        }
        $this->vehicleIDField = $vehicleIDField;
        return $this;
    }
}
