<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoutePlanSummaryType StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RoutePlanSummaryType
 * @subpackage Structs
 */
class RoutePlanSummaryType extends AbstractStructBase
{
    /**
     * The delayTimeField
     * @var int
     */
    public $delayTimeField;
    /**
     * The dispatchDateField
     * @var string
     */
    public $dispatchDateField;
    /**
     * The dispatchIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $dispatchIDField;
    /**
     * The endTimeField
     * @var string
     */
    public $endTimeField;
    /**
     * The loadDateField
     * @var string
     */
    public $loadDateField;
    /**
     * The routeIDField
     * @var int
     */
    public $routeIDField;
    /**
     * The rtNumberField
     * @var int
     */
    public $rtNumberField;
    /**
     * The startTimeField
     * @var string
     */
    public $startTimeField;
    /**
     * The totalDistanceCostField
     * @var float
     */
    public $totalDistanceCostField;
    /**
     * The totalDistanceField
     * @var float
     */
    public $totalDistanceField;
    /**
     * The totalDriveHrsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $totalDriveHrsField;
    /**
     * The totalStopsField
     * @var int
     */
    public $totalStopsField;
    /**
     * The totalWorkHrsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $totalWorkHrsField;
    /**
     * Constructor method for RoutePlanSummaryType
     * @uses RoutePlanSummaryType::setDelayTimeField()
     * @uses RoutePlanSummaryType::setDispatchDateField()
     * @uses RoutePlanSummaryType::setDispatchIDField()
     * @uses RoutePlanSummaryType::setEndTimeField()
     * @uses RoutePlanSummaryType::setLoadDateField()
     * @uses RoutePlanSummaryType::setRouteIDField()
     * @uses RoutePlanSummaryType::setRtNumberField()
     * @uses RoutePlanSummaryType::setStartTimeField()
     * @uses RoutePlanSummaryType::setTotalDistanceCostField()
     * @uses RoutePlanSummaryType::setTotalDistanceField()
     * @uses RoutePlanSummaryType::setTotalDriveHrsField()
     * @uses RoutePlanSummaryType::setTotalStopsField()
     * @uses RoutePlanSummaryType::setTotalWorkHrsField()
     * @param int $delayTimeField
     * @param string $dispatchDateField
     * @param string $dispatchIDField
     * @param string $endTimeField
     * @param string $loadDateField
     * @param int $routeIDField
     * @param int $rtNumberField
     * @param string $startTimeField
     * @param float $totalDistanceCostField
     * @param float $totalDistanceField
     * @param string $totalDriveHrsField
     * @param int $totalStopsField
     * @param string $totalWorkHrsField
     */
    public function __construct($delayTimeField = null, $dispatchDateField = null, $dispatchIDField = null, $endTimeField = null, $loadDateField = null, $routeIDField = null, $rtNumberField = null, $startTimeField = null, $totalDistanceCostField = null, $totalDistanceField = null, $totalDriveHrsField = null, $totalStopsField = null, $totalWorkHrsField = null)
    {
        $this
            ->setDelayTimeField($delayTimeField)
            ->setDispatchDateField($dispatchDateField)
            ->setDispatchIDField($dispatchIDField)
            ->setEndTimeField($endTimeField)
            ->setLoadDateField($loadDateField)
            ->setRouteIDField($routeIDField)
            ->setRtNumberField($rtNumberField)
            ->setStartTimeField($startTimeField)
            ->setTotalDistanceCostField($totalDistanceCostField)
            ->setTotalDistanceField($totalDistanceField)
            ->setTotalDriveHrsField($totalDriveHrsField)
            ->setTotalStopsField($totalStopsField)
            ->setTotalWorkHrsField($totalWorkHrsField);
    }
    /**
     * Get delayTimeField value
     * @return int|null
     */
    public function getDelayTimeField()
    {
        return $this->delayTimeField;
    }
    /**
     * Set delayTimeField value
     * @param int $delayTimeField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setDelayTimeField($delayTimeField = null)
    {
        // validation for constraint: int
        if (!is_null($delayTimeField) && !(is_int($delayTimeField) || ctype_digit($delayTimeField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($delayTimeField, true), gettype($delayTimeField)), __LINE__);
        }
        $this->delayTimeField = $delayTimeField;
        return $this;
    }
    /**
     * Get dispatchDateField value
     * @return string|null
     */
    public function getDispatchDateField()
    {
        return $this->dispatchDateField;
    }
    /**
     * Set dispatchDateField value
     * @param string $dispatchDateField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setDispatchDateField($dispatchDateField = null)
    {
        // validation for constraint: string
        if (!is_null($dispatchDateField) && !is_string($dispatchDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dispatchDateField, true), gettype($dispatchDateField)), __LINE__);
        }
        $this->dispatchDateField = $dispatchDateField;
        return $this;
    }
    /**
     * Get dispatchIDField value
     * @return string|null
     */
    public function getDispatchIDField()
    {
        return $this->dispatchIDField;
    }
    /**
     * Set dispatchIDField value
     * @param string $dispatchIDField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setDispatchIDField($dispatchIDField = null)
    {
        // validation for constraint: string
        if (!is_null($dispatchIDField) && !is_string($dispatchIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dispatchIDField, true), gettype($dispatchIDField)), __LINE__);
        }
        $this->dispatchIDField = $dispatchIDField;
        return $this;
    }
    /**
     * Get endTimeField value
     * @return string|null
     */
    public function getEndTimeField()
    {
        return $this->endTimeField;
    }
    /**
     * Set endTimeField value
     * @param string $endTimeField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setEndTimeField($endTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($endTimeField) && !is_string($endTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endTimeField, true), gettype($endTimeField)), __LINE__);
        }
        $this->endTimeField = $endTimeField;
        return $this;
    }
    /**
     * Get loadDateField value
     * @return string|null
     */
    public function getLoadDateField()
    {
        return $this->loadDateField;
    }
    /**
     * Set loadDateField value
     * @param string $loadDateField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setLoadDateField($loadDateField = null)
    {
        // validation for constraint: string
        if (!is_null($loadDateField) && !is_string($loadDateField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loadDateField, true), gettype($loadDateField)), __LINE__);
        }
        $this->loadDateField = $loadDateField;
        return $this;
    }
    /**
     * Get routeIDField value
     * @return int|null
     */
    public function getRouteIDField()
    {
        return $this->routeIDField;
    }
    /**
     * Set routeIDField value
     * @param int $routeIDField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setRouteIDField($routeIDField = null)
    {
        // validation for constraint: int
        if (!is_null($routeIDField) && !(is_int($routeIDField) || ctype_digit($routeIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($routeIDField, true), gettype($routeIDField)), __LINE__);
        }
        $this->routeIDField = $routeIDField;
        return $this;
    }
    /**
     * Get rtNumberField value
     * @return int|null
     */
    public function getRtNumberField()
    {
        return $this->rtNumberField;
    }
    /**
     * Set rtNumberField value
     * @param int $rtNumberField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setRtNumberField($rtNumberField = null)
    {
        // validation for constraint: int
        if (!is_null($rtNumberField) && !(is_int($rtNumberField) || ctype_digit($rtNumberField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($rtNumberField, true), gettype($rtNumberField)), __LINE__);
        }
        $this->rtNumberField = $rtNumberField;
        return $this;
    }
    /**
     * Get startTimeField value
     * @return string|null
     */
    public function getStartTimeField()
    {
        return $this->startTimeField;
    }
    /**
     * Set startTimeField value
     * @param string $startTimeField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setStartTimeField($startTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($startTimeField) && !is_string($startTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startTimeField, true), gettype($startTimeField)), __LINE__);
        }
        $this->startTimeField = $startTimeField;
        return $this;
    }
    /**
     * Get totalDistanceCostField value
     * @return float|null
     */
    public function getTotalDistanceCostField()
    {
        return $this->totalDistanceCostField;
    }
    /**
     * Set totalDistanceCostField value
     * @param float $totalDistanceCostField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setTotalDistanceCostField($totalDistanceCostField = null)
    {
        // validation for constraint: float
        if (!is_null($totalDistanceCostField) && !(is_float($totalDistanceCostField) || is_numeric($totalDistanceCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($totalDistanceCostField, true), gettype($totalDistanceCostField)), __LINE__);
        }
        $this->totalDistanceCostField = $totalDistanceCostField;
        return $this;
    }
    /**
     * Get totalDistanceField value
     * @return float|null
     */
    public function getTotalDistanceField()
    {
        return $this->totalDistanceField;
    }
    /**
     * Set totalDistanceField value
     * @param float $totalDistanceField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setTotalDistanceField($totalDistanceField = null)
    {
        // validation for constraint: float
        if (!is_null($totalDistanceField) && !(is_float($totalDistanceField) || is_numeric($totalDistanceField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($totalDistanceField, true), gettype($totalDistanceField)), __LINE__);
        }
        $this->totalDistanceField = $totalDistanceField;
        return $this;
    }
    /**
     * Get totalDriveHrsField value
     * @return string|null
     */
    public function getTotalDriveHrsField()
    {
        return $this->totalDriveHrsField;
    }
    /**
     * Set totalDriveHrsField value
     * @param string $totalDriveHrsField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setTotalDriveHrsField($totalDriveHrsField = null)
    {
        // validation for constraint: string
        if (!is_null($totalDriveHrsField) && !is_string($totalDriveHrsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($totalDriveHrsField, true), gettype($totalDriveHrsField)), __LINE__);
        }
        $this->totalDriveHrsField = $totalDriveHrsField;
        return $this;
    }
    /**
     * Get totalStopsField value
     * @return int|null
     */
    public function getTotalStopsField()
    {
        return $this->totalStopsField;
    }
    /**
     * Set totalStopsField value
     * @param int $totalStopsField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setTotalStopsField($totalStopsField = null)
    {
        // validation for constraint: int
        if (!is_null($totalStopsField) && !(is_int($totalStopsField) || ctype_digit($totalStopsField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($totalStopsField, true), gettype($totalStopsField)), __LINE__);
        }
        $this->totalStopsField = $totalStopsField;
        return $this;
    }
    /**
     * Get totalWorkHrsField value
     * @return string|null
     */
    public function getTotalWorkHrsField()
    {
        return $this->totalWorkHrsField;
    }
    /**
     * Set totalWorkHrsField value
     * @param string $totalWorkHrsField
     * @return \StructType\RoutePlanSummaryType
     */
    public function setTotalWorkHrsField($totalWorkHrsField = null)
    {
        // validation for constraint: string
        if (!is_null($totalWorkHrsField) && !is_string($totalWorkHrsField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($totalWorkHrsField, true), gettype($totalWorkHrsField)), __LINE__);
        }
        $this->totalWorkHrsField = $totalWorkHrsField;
        return $this;
    }
}
