<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SignatureResource StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SignatureResource
 * @subpackage Structs
 */
class SignatureResource extends _Resource
{
    /**
     * The descriptionField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $descriptionField;
    /**
     * The mimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $mimeField;
    /**
     * The subjectField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $subjectField;
    /**
     * Constructor method for SignatureResource
     * @uses SignatureResource::setDescriptionField()
     * @uses SignatureResource::setMimeField()
     * @uses SignatureResource::setSubjectField()
     * @param string $descriptionField
     * @param string $mimeField
     * @param string $subjectField
     */
    public function __construct($descriptionField = null, $mimeField = null, $subjectField = null)
    {
        $this
            ->setDescriptionField($descriptionField)
            ->setMimeField($mimeField)
            ->setSubjectField($subjectField);
    }
    /**
     * Get descriptionField value
     * @return string|null
     */
    public function getDescriptionField()
    {
        return $this->descriptionField;
    }
    /**
     * Set descriptionField value
     * @param string $descriptionField
     * @return \StructType\SignatureResource
     */
    public function setDescriptionField($descriptionField = null)
    {
        // validation for constraint: string
        if (!is_null($descriptionField) && !is_string($descriptionField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descriptionField, true), gettype($descriptionField)), __LINE__);
        }
        $this->descriptionField = $descriptionField;
        return $this;
    }
    /**
     * Get mimeField value
     * @return string|null
     */
    public function getMimeField()
    {
        return $this->mimeField;
    }
    /**
     * Set mimeField value
     * @param string $mimeField
     * @return \StructType\SignatureResource
     */
    public function setMimeField($mimeField = null)
    {
        // validation for constraint: string
        if (!is_null($mimeField) && !is_string($mimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mimeField, true), gettype($mimeField)), __LINE__);
        }
        $this->mimeField = $mimeField;
        return $this;
    }
    /**
     * Get subjectField value
     * @return string|null
     */
    public function getSubjectField()
    {
        return $this->subjectField;
    }
    /**
     * Set subjectField value
     * @param string $subjectField
     * @return \StructType\SignatureResource
     */
    public function setSubjectField($subjectField = null)
    {
        // validation for constraint: string
        if (!is_null($subjectField) && !is_string($subjectField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($subjectField, true), gettype($subjectField)), __LINE__);
        }
        $this->subjectField = $subjectField;
        return $this;
    }
}
