<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Statistics StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Statistics
 * @subpackage Structs
 */
class Statistics extends AbstractStructBase
{
    /**
     * The daysField
     * @var int
     */
    public $daysField;
    /**
     * The distField
     * @var float
     */
    public $distField;
    /**
     * The dropCostField
     * @var float
     */
    public $dropCostField;
    /**
     * The drvTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $drvTimeField;
    /**
     * The elapsedTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $elapsedTimeField;
    /**
     * The endTimeField
     * @var string
     */
    public $endTimeField;
    /**
     * The farthestStopDistanceField
     * @var float
     */
    public $farthestStopDistanceField;
    /**
     * The fixedCostField
     * @var float
     */
    public $fixedCostField;
    /**
     * The hrCostField
     * @var float
     */
    public $hrCostField;
    /**
     * The incrementalCostField
     * @var float
     */
    public $incrementalCostField;
    /**
     * The layoverCostField
     * @var float
     */
    public $layoverCostField;
    /**
     * The layoverTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $layoverTimeField;
    /**
     * The miCostField
     * @var float
     */
    public $miCostField;
    /**
     * The noOfViolationsField
     * @var int
     */
    public $noOfViolationsField;
    /**
     * The oTCostField
     * @var float
     */
    public $oTCostField;
    /**
     * The penaltyCostField
     * @var float
     */
    public $penaltyCostField;
    /**
     * The startTimeField
     * @var string
     */
    public $startTimeField;
    /**
     * The stemDistField
     * @var float
     */
    public $stemDistField;
    /**
     * The stopsPerHourField
     * @var float
     */
    public $stopsPerHourField;
    /**
     * The stopsPerMileField
     * @var float
     */
    public $stopsPerMileField;
    /**
     * The totalCostField
     * @var float
     */
    public $totalCostField;
    /**
     * The totalCostPlusPenaltyCostField
     * @var float
     */
    public $totalCostPlusPenaltyCostField;
    /**
     * The totalStopsField
     * @var int
     */
    public $totalStopsField;
    /**
     * The unitCostField
     * @var float
     */
    public $unitCostField;
    /**
     * The unldCostField
     * @var float
     */
    public $unldCostField;
    /**
     * The unldHrCostField
     * @var float
     */
    public $unldHrCostField;
    /**
     * The unldTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $unldTimeField;
    /**
     * The violationsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfViolation
     */
    public $violationsField;
    /**
     * The waitCostField
     * @var float
     */
    public $waitCostField;
    /**
     * The waitTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $waitTimeField;
    /**
     * The wrkTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $wrkTimeField;
    /**
     * Constructor method for Statistics
     * @uses Statistics::setDaysField()
     * @uses Statistics::setDistField()
     * @uses Statistics::setDropCostField()
     * @uses Statistics::setDrvTimeField()
     * @uses Statistics::setElapsedTimeField()
     * @uses Statistics::setEndTimeField()
     * @uses Statistics::setFarthestStopDistanceField()
     * @uses Statistics::setFixedCostField()
     * @uses Statistics::setHrCostField()
     * @uses Statistics::setIncrementalCostField()
     * @uses Statistics::setLayoverCostField()
     * @uses Statistics::setLayoverTimeField()
     * @uses Statistics::setMiCostField()
     * @uses Statistics::setNoOfViolationsField()
     * @uses Statistics::setOTCostField()
     * @uses Statistics::setPenaltyCostField()
     * @uses Statistics::setStartTimeField()
     * @uses Statistics::setStemDistField()
     * @uses Statistics::setStopsPerHourField()
     * @uses Statistics::setStopsPerMileField()
     * @uses Statistics::setTotalCostField()
     * @uses Statistics::setTotalCostPlusPenaltyCostField()
     * @uses Statistics::setTotalStopsField()
     * @uses Statistics::setUnitCostField()
     * @uses Statistics::setUnldCostField()
     * @uses Statistics::setUnldHrCostField()
     * @uses Statistics::setUnldTimeField()
     * @uses Statistics::setViolationsField()
     * @uses Statistics::setWaitCostField()
     * @uses Statistics::setWaitTimeField()
     * @uses Statistics::setWrkTimeField()
     * @param int $daysField
     * @param float $distField
     * @param float $dropCostField
     * @param string $drvTimeField
     * @param string $elapsedTimeField
     * @param string $endTimeField
     * @param float $farthestStopDistanceField
     * @param float $fixedCostField
     * @param float $hrCostField
     * @param float $incrementalCostField
     * @param float $layoverCostField
     * @param string $layoverTimeField
     * @param float $miCostField
     * @param int $noOfViolationsField
     * @param float $oTCostField
     * @param float $penaltyCostField
     * @param string $startTimeField
     * @param float $stemDistField
     * @param float $stopsPerHourField
     * @param float $stopsPerMileField
     * @param float $totalCostField
     * @param float $totalCostPlusPenaltyCostField
     * @param int $totalStopsField
     * @param float $unitCostField
     * @param float $unldCostField
     * @param float $unldHrCostField
     * @param string $unldTimeField
     * @param \ArrayType\ArrayOfViolation $violationsField
     * @param float $waitCostField
     * @param string $waitTimeField
     * @param string $wrkTimeField
     */
    public function __construct($daysField = null, $distField = null, $dropCostField = null, $drvTimeField = null, $elapsedTimeField = null, $endTimeField = null, $farthestStopDistanceField = null, $fixedCostField = null, $hrCostField = null, $incrementalCostField = null, $layoverCostField = null, $layoverTimeField = null, $miCostField = null, $noOfViolationsField = null, $oTCostField = null, $penaltyCostField = null, $startTimeField = null, $stemDistField = null, $stopsPerHourField = null, $stopsPerMileField = null, $totalCostField = null, $totalCostPlusPenaltyCostField = null, $totalStopsField = null, $unitCostField = null, $unldCostField = null, $unldHrCostField = null, $unldTimeField = null, \ArrayType\ArrayOfViolation $violationsField = null, $waitCostField = null, $waitTimeField = null, $wrkTimeField = null)
    {
        $this
            ->setDaysField($daysField)
            ->setDistField($distField)
            ->setDropCostField($dropCostField)
            ->setDrvTimeField($drvTimeField)
            ->setElapsedTimeField($elapsedTimeField)
            ->setEndTimeField($endTimeField)
            ->setFarthestStopDistanceField($farthestStopDistanceField)
            ->setFixedCostField($fixedCostField)
            ->setHrCostField($hrCostField)
            ->setIncrementalCostField($incrementalCostField)
            ->setLayoverCostField($layoverCostField)
            ->setLayoverTimeField($layoverTimeField)
            ->setMiCostField($miCostField)
            ->setNoOfViolationsField($noOfViolationsField)
            ->setOTCostField($oTCostField)
            ->setPenaltyCostField($penaltyCostField)
            ->setStartTimeField($startTimeField)
            ->setStemDistField($stemDistField)
            ->setStopsPerHourField($stopsPerHourField)
            ->setStopsPerMileField($stopsPerMileField)
            ->setTotalCostField($totalCostField)
            ->setTotalCostPlusPenaltyCostField($totalCostPlusPenaltyCostField)
            ->setTotalStopsField($totalStopsField)
            ->setUnitCostField($unitCostField)
            ->setUnldCostField($unldCostField)
            ->setUnldHrCostField($unldHrCostField)
            ->setUnldTimeField($unldTimeField)
            ->setViolationsField($violationsField)
            ->setWaitCostField($waitCostField)
            ->setWaitTimeField($waitTimeField)
            ->setWrkTimeField($wrkTimeField);
    }
    /**
     * Get daysField value
     * @return int|null
     */
    public function getDaysField()
    {
        return $this->daysField;
    }
    /**
     * Set daysField value
     * @param int $daysField
     * @return \StructType\Statistics
     */
    public function setDaysField($daysField = null)
    {
        // validation for constraint: int
        if (!is_null($daysField) && !(is_int($daysField) || ctype_digit($daysField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($daysField, true), gettype($daysField)), __LINE__);
        }
        $this->daysField = $daysField;
        return $this;
    }
    /**
     * Get distField value
     * @return float|null
     */
    public function getDistField()
    {
        return $this->distField;
    }
    /**
     * Set distField value
     * @param float $distField
     * @return \StructType\Statistics
     */
    public function setDistField($distField = null)
    {
        // validation for constraint: float
        if (!is_null($distField) && !(is_float($distField) || is_numeric($distField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($distField, true), gettype($distField)), __LINE__);
        }
        $this->distField = $distField;
        return $this;
    }
    /**
     * Get dropCostField value
     * @return float|null
     */
    public function getDropCostField()
    {
        return $this->dropCostField;
    }
    /**
     * Set dropCostField value
     * @param float $dropCostField
     * @return \StructType\Statistics
     */
    public function setDropCostField($dropCostField = null)
    {
        // validation for constraint: float
        if (!is_null($dropCostField) && !(is_float($dropCostField) || is_numeric($dropCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($dropCostField, true), gettype($dropCostField)), __LINE__);
        }
        $this->dropCostField = $dropCostField;
        return $this;
    }
    /**
     * Get drvTimeField value
     * @return string|null
     */
    public function getDrvTimeField()
    {
        return $this->drvTimeField;
    }
    /**
     * Set drvTimeField value
     * @param string $drvTimeField
     * @return \StructType\Statistics
     */
    public function setDrvTimeField($drvTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($drvTimeField) && !is_string($drvTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($drvTimeField, true), gettype($drvTimeField)), __LINE__);
        }
        $this->drvTimeField = $drvTimeField;
        return $this;
    }
    /**
     * Get elapsedTimeField value
     * @return string|null
     */
    public function getElapsedTimeField()
    {
        return $this->elapsedTimeField;
    }
    /**
     * Set elapsedTimeField value
     * @param string $elapsedTimeField
     * @return \StructType\Statistics
     */
    public function setElapsedTimeField($elapsedTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($elapsedTimeField) && !is_string($elapsedTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($elapsedTimeField, true), gettype($elapsedTimeField)), __LINE__);
        }
        $this->elapsedTimeField = $elapsedTimeField;
        return $this;
    }
    /**
     * Get endTimeField value
     * @return string|null
     */
    public function getEndTimeField()
    {
        return $this->endTimeField;
    }
    /**
     * Set endTimeField value
     * @param string $endTimeField
     * @return \StructType\Statistics
     */
    public function setEndTimeField($endTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($endTimeField) && !is_string($endTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endTimeField, true), gettype($endTimeField)), __LINE__);
        }
        $this->endTimeField = $endTimeField;
        return $this;
    }
    /**
     * Get farthestStopDistanceField value
     * @return float|null
     */
    public function getFarthestStopDistanceField()
    {
        return $this->farthestStopDistanceField;
    }
    /**
     * Set farthestStopDistanceField value
     * @param float $farthestStopDistanceField
     * @return \StructType\Statistics
     */
    public function setFarthestStopDistanceField($farthestStopDistanceField = null)
    {
        // validation for constraint: float
        if (!is_null($farthestStopDistanceField) && !(is_float($farthestStopDistanceField) || is_numeric($farthestStopDistanceField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($farthestStopDistanceField, true), gettype($farthestStopDistanceField)), __LINE__);
        }
        $this->farthestStopDistanceField = $farthestStopDistanceField;
        return $this;
    }
    /**
     * Get fixedCostField value
     * @return float|null
     */
    public function getFixedCostField()
    {
        return $this->fixedCostField;
    }
    /**
     * Set fixedCostField value
     * @param float $fixedCostField
     * @return \StructType\Statistics
     */
    public function setFixedCostField($fixedCostField = null)
    {
        // validation for constraint: float
        if (!is_null($fixedCostField) && !(is_float($fixedCostField) || is_numeric($fixedCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($fixedCostField, true), gettype($fixedCostField)), __LINE__);
        }
        $this->fixedCostField = $fixedCostField;
        return $this;
    }
    /**
     * Get hrCostField value
     * @return float|null
     */
    public function getHrCostField()
    {
        return $this->hrCostField;
    }
    /**
     * Set hrCostField value
     * @param float $hrCostField
     * @return \StructType\Statistics
     */
    public function setHrCostField($hrCostField = null)
    {
        // validation for constraint: float
        if (!is_null($hrCostField) && !(is_float($hrCostField) || is_numeric($hrCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($hrCostField, true), gettype($hrCostField)), __LINE__);
        }
        $this->hrCostField = $hrCostField;
        return $this;
    }
    /**
     * Get incrementalCostField value
     * @return float|null
     */
    public function getIncrementalCostField()
    {
        return $this->incrementalCostField;
    }
    /**
     * Set incrementalCostField value
     * @param float $incrementalCostField
     * @return \StructType\Statistics
     */
    public function setIncrementalCostField($incrementalCostField = null)
    {
        // validation for constraint: float
        if (!is_null($incrementalCostField) && !(is_float($incrementalCostField) || is_numeric($incrementalCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($incrementalCostField, true), gettype($incrementalCostField)), __LINE__);
        }
        $this->incrementalCostField = $incrementalCostField;
        return $this;
    }
    /**
     * Get layoverCostField value
     * @return float|null
     */
    public function getLayoverCostField()
    {
        return $this->layoverCostField;
    }
    /**
     * Set layoverCostField value
     * @param float $layoverCostField
     * @return \StructType\Statistics
     */
    public function setLayoverCostField($layoverCostField = null)
    {
        // validation for constraint: float
        if (!is_null($layoverCostField) && !(is_float($layoverCostField) || is_numeric($layoverCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($layoverCostField, true), gettype($layoverCostField)), __LINE__);
        }
        $this->layoverCostField = $layoverCostField;
        return $this;
    }
    /**
     * Get layoverTimeField value
     * @return string|null
     */
    public function getLayoverTimeField()
    {
        return $this->layoverTimeField;
    }
    /**
     * Set layoverTimeField value
     * @param string $layoverTimeField
     * @return \StructType\Statistics
     */
    public function setLayoverTimeField($layoverTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($layoverTimeField) && !is_string($layoverTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($layoverTimeField, true), gettype($layoverTimeField)), __LINE__);
        }
        $this->layoverTimeField = $layoverTimeField;
        return $this;
    }
    /**
     * Get miCostField value
     * @return float|null
     */
    public function getMiCostField()
    {
        return $this->miCostField;
    }
    /**
     * Set miCostField value
     * @param float $miCostField
     * @return \StructType\Statistics
     */
    public function setMiCostField($miCostField = null)
    {
        // validation for constraint: float
        if (!is_null($miCostField) && !(is_float($miCostField) || is_numeric($miCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($miCostField, true), gettype($miCostField)), __LINE__);
        }
        $this->miCostField = $miCostField;
        return $this;
    }
    /**
     * Get noOfViolationsField value
     * @return int|null
     */
    public function getNoOfViolationsField()
    {
        return $this->noOfViolationsField;
    }
    /**
     * Set noOfViolationsField value
     * @param int $noOfViolationsField
     * @return \StructType\Statistics
     */
    public function setNoOfViolationsField($noOfViolationsField = null)
    {
        // validation for constraint: int
        if (!is_null($noOfViolationsField) && !(is_int($noOfViolationsField) || ctype_digit($noOfViolationsField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($noOfViolationsField, true), gettype($noOfViolationsField)), __LINE__);
        }
        $this->noOfViolationsField = $noOfViolationsField;
        return $this;
    }
    /**
     * Get oTCostField value
     * @return float|null
     */
    public function getOTCostField()
    {
        return $this->oTCostField;
    }
    /**
     * Set oTCostField value
     * @param float $oTCostField
     * @return \StructType\Statistics
     */
    public function setOTCostField($oTCostField = null)
    {
        // validation for constraint: float
        if (!is_null($oTCostField) && !(is_float($oTCostField) || is_numeric($oTCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($oTCostField, true), gettype($oTCostField)), __LINE__);
        }
        $this->oTCostField = $oTCostField;
        return $this;
    }
    /**
     * Get penaltyCostField value
     * @return float|null
     */
    public function getPenaltyCostField()
    {
        return $this->penaltyCostField;
    }
    /**
     * Set penaltyCostField value
     * @param float $penaltyCostField
     * @return \StructType\Statistics
     */
    public function setPenaltyCostField($penaltyCostField = null)
    {
        // validation for constraint: float
        if (!is_null($penaltyCostField) && !(is_float($penaltyCostField) || is_numeric($penaltyCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($penaltyCostField, true), gettype($penaltyCostField)), __LINE__);
        }
        $this->penaltyCostField = $penaltyCostField;
        return $this;
    }
    /**
     * Get startTimeField value
     * @return string|null
     */
    public function getStartTimeField()
    {
        return $this->startTimeField;
    }
    /**
     * Set startTimeField value
     * @param string $startTimeField
     * @return \StructType\Statistics
     */
    public function setStartTimeField($startTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($startTimeField) && !is_string($startTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startTimeField, true), gettype($startTimeField)), __LINE__);
        }
        $this->startTimeField = $startTimeField;
        return $this;
    }
    /**
     * Get stemDistField value
     * @return float|null
     */
    public function getStemDistField()
    {
        return $this->stemDistField;
    }
    /**
     * Set stemDistField value
     * @param float $stemDistField
     * @return \StructType\Statistics
     */
    public function setStemDistField($stemDistField = null)
    {
        // validation for constraint: float
        if (!is_null($stemDistField) && !(is_float($stemDistField) || is_numeric($stemDistField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($stemDistField, true), gettype($stemDistField)), __LINE__);
        }
        $this->stemDistField = $stemDistField;
        return $this;
    }
    /**
     * Get stopsPerHourField value
     * @return float|null
     */
    public function getStopsPerHourField()
    {
        return $this->stopsPerHourField;
    }
    /**
     * Set stopsPerHourField value
     * @param float $stopsPerHourField
     * @return \StructType\Statistics
     */
    public function setStopsPerHourField($stopsPerHourField = null)
    {
        // validation for constraint: float
        if (!is_null($stopsPerHourField) && !(is_float($stopsPerHourField) || is_numeric($stopsPerHourField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($stopsPerHourField, true), gettype($stopsPerHourField)), __LINE__);
        }
        $this->stopsPerHourField = $stopsPerHourField;
        return $this;
    }
    /**
     * Get stopsPerMileField value
     * @return float|null
     */
    public function getStopsPerMileField()
    {
        return $this->stopsPerMileField;
    }
    /**
     * Set stopsPerMileField value
     * @param float $stopsPerMileField
     * @return \StructType\Statistics
     */
    public function setStopsPerMileField($stopsPerMileField = null)
    {
        // validation for constraint: float
        if (!is_null($stopsPerMileField) && !(is_float($stopsPerMileField) || is_numeric($stopsPerMileField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($stopsPerMileField, true), gettype($stopsPerMileField)), __LINE__);
        }
        $this->stopsPerMileField = $stopsPerMileField;
        return $this;
    }
    /**
     * Get totalCostField value
     * @return float|null
     */
    public function getTotalCostField()
    {
        return $this->totalCostField;
    }
    /**
     * Set totalCostField value
     * @param float $totalCostField
     * @return \StructType\Statistics
     */
    public function setTotalCostField($totalCostField = null)
    {
        // validation for constraint: float
        if (!is_null($totalCostField) && !(is_float($totalCostField) || is_numeric($totalCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($totalCostField, true), gettype($totalCostField)), __LINE__);
        }
        $this->totalCostField = $totalCostField;
        return $this;
    }
    /**
     * Get totalCostPlusPenaltyCostField value
     * @return float|null
     */
    public function getTotalCostPlusPenaltyCostField()
    {
        return $this->totalCostPlusPenaltyCostField;
    }
    /**
     * Set totalCostPlusPenaltyCostField value
     * @param float $totalCostPlusPenaltyCostField
     * @return \StructType\Statistics
     */
    public function setTotalCostPlusPenaltyCostField($totalCostPlusPenaltyCostField = null)
    {
        // validation for constraint: float
        if (!is_null($totalCostPlusPenaltyCostField) && !(is_float($totalCostPlusPenaltyCostField) || is_numeric($totalCostPlusPenaltyCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($totalCostPlusPenaltyCostField, true), gettype($totalCostPlusPenaltyCostField)), __LINE__);
        }
        $this->totalCostPlusPenaltyCostField = $totalCostPlusPenaltyCostField;
        return $this;
    }
    /**
     * Get totalStopsField value
     * @return int|null
     */
    public function getTotalStopsField()
    {
        return $this->totalStopsField;
    }
    /**
     * Set totalStopsField value
     * @param int $totalStopsField
     * @return \StructType\Statistics
     */
    public function setTotalStopsField($totalStopsField = null)
    {
        // validation for constraint: int
        if (!is_null($totalStopsField) && !(is_int($totalStopsField) || ctype_digit($totalStopsField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($totalStopsField, true), gettype($totalStopsField)), __LINE__);
        }
        $this->totalStopsField = $totalStopsField;
        return $this;
    }
    /**
     * Get unitCostField value
     * @return float|null
     */
    public function getUnitCostField()
    {
        return $this->unitCostField;
    }
    /**
     * Set unitCostField value
     * @param float $unitCostField
     * @return \StructType\Statistics
     */
    public function setUnitCostField($unitCostField = null)
    {
        // validation for constraint: float
        if (!is_null($unitCostField) && !(is_float($unitCostField) || is_numeric($unitCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($unitCostField, true), gettype($unitCostField)), __LINE__);
        }
        $this->unitCostField = $unitCostField;
        return $this;
    }
    /**
     * Get unldCostField value
     * @return float|null
     */
    public function getUnldCostField()
    {
        return $this->unldCostField;
    }
    /**
     * Set unldCostField value
     * @param float $unldCostField
     * @return \StructType\Statistics
     */
    public function setUnldCostField($unldCostField = null)
    {
        // validation for constraint: float
        if (!is_null($unldCostField) && !(is_float($unldCostField) || is_numeric($unldCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($unldCostField, true), gettype($unldCostField)), __LINE__);
        }
        $this->unldCostField = $unldCostField;
        return $this;
    }
    /**
     * Get unldHrCostField value
     * @return float|null
     */
    public function getUnldHrCostField()
    {
        return $this->unldHrCostField;
    }
    /**
     * Set unldHrCostField value
     * @param float $unldHrCostField
     * @return \StructType\Statistics
     */
    public function setUnldHrCostField($unldHrCostField = null)
    {
        // validation for constraint: float
        if (!is_null($unldHrCostField) && !(is_float($unldHrCostField) || is_numeric($unldHrCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($unldHrCostField, true), gettype($unldHrCostField)), __LINE__);
        }
        $this->unldHrCostField = $unldHrCostField;
        return $this;
    }
    /**
     * Get unldTimeField value
     * @return string|null
     */
    public function getUnldTimeField()
    {
        return $this->unldTimeField;
    }
    /**
     * Set unldTimeField value
     * @param string $unldTimeField
     * @return \StructType\Statistics
     */
    public function setUnldTimeField($unldTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($unldTimeField) && !is_string($unldTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unldTimeField, true), gettype($unldTimeField)), __LINE__);
        }
        $this->unldTimeField = $unldTimeField;
        return $this;
    }
    /**
     * Get violationsField value
     * @return \ArrayType\ArrayOfViolation|null
     */
    public function getViolationsField()
    {
        return $this->violationsField;
    }
    /**
     * Set violationsField value
     * @param \ArrayType\ArrayOfViolation $violationsField
     * @return \StructType\Statistics
     */
    public function setViolationsField(\ArrayType\ArrayOfViolation $violationsField = null)
    {
        $this->violationsField = $violationsField;
        return $this;
    }
    /**
     * Get waitCostField value
     * @return float|null
     */
    public function getWaitCostField()
    {
        return $this->waitCostField;
    }
    /**
     * Set waitCostField value
     * @param float $waitCostField
     * @return \StructType\Statistics
     */
    public function setWaitCostField($waitCostField = null)
    {
        // validation for constraint: float
        if (!is_null($waitCostField) && !(is_float($waitCostField) || is_numeric($waitCostField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($waitCostField, true), gettype($waitCostField)), __LINE__);
        }
        $this->waitCostField = $waitCostField;
        return $this;
    }
    /**
     * Get waitTimeField value
     * @return string|null
     */
    public function getWaitTimeField()
    {
        return $this->waitTimeField;
    }
    /**
     * Set waitTimeField value
     * @param string $waitTimeField
     * @return \StructType\Statistics
     */
    public function setWaitTimeField($waitTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($waitTimeField) && !is_string($waitTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($waitTimeField, true), gettype($waitTimeField)), __LINE__);
        }
        $this->waitTimeField = $waitTimeField;
        return $this;
    }
    /**
     * Get wrkTimeField value
     * @return string|null
     */
    public function getWrkTimeField()
    {
        return $this->wrkTimeField;
    }
    /**
     * Set wrkTimeField value
     * @param string $wrkTimeField
     * @return \StructType\Statistics
     */
    public function setWrkTimeField($wrkTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($wrkTimeField) && !is_string($wrkTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($wrkTimeField, true), gettype($wrkTimeField)), __LINE__);
        }
        $this->wrkTimeField = $wrkTimeField;
        return $this;
    }
}
