<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StopActualDetailType StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:StopActualDetailType
 * @subpackage Structs
 */
class StopActualDetailType extends AbstractStructBase
{
    /**
     * The actualStopIDField
     * @var int
     */
    public $actualStopIDField;
    /**
     * The coordinatesField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\Coordinates
     */
    public $coordinatesField;
    /**
     * The delayTimeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $delayTimeField;
    /**
     * The durationField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $durationField;
    /**
     * The endTimeField
     * @var string
     */
    public $endTimeField;
    /**
     * The inprogressField
     * @var bool
     */
    public $inprogressField;
    /**
     * The legField
     * @var int
     */
    public $legField;
    /**
     * The odometerField
     * @var float
     */
    public $odometerField;
    /**
     * The orderField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfOrderDetailActualDetailType
     */
    public $orderField;
    /**
     * The sequenceField
     * @var int
     */
    public $sequenceField;
    /**
     * The startTimeField
     * @var string
     */
    public $startTimeField;
    /**
     * The stopIDField
     * @var int
     */
    public $stopIDField;
    /**
     * Constructor method for StopActualDetailType
     * @uses StopActualDetailType::setActualStopIDField()
     * @uses StopActualDetailType::setCoordinatesField()
     * @uses StopActualDetailType::setDelayTimeField()
     * @uses StopActualDetailType::setDurationField()
     * @uses StopActualDetailType::setEndTimeField()
     * @uses StopActualDetailType::setInprogressField()
     * @uses StopActualDetailType::setLegField()
     * @uses StopActualDetailType::setOdometerField()
     * @uses StopActualDetailType::setOrderField()
     * @uses StopActualDetailType::setSequenceField()
     * @uses StopActualDetailType::setStartTimeField()
     * @uses StopActualDetailType::setStopIDField()
     * @param int $actualStopIDField
     * @param \StructType\Coordinates $coordinatesField
     * @param string $delayTimeField
     * @param string $durationField
     * @param string $endTimeField
     * @param bool $inprogressField
     * @param int $legField
     * @param float $odometerField
     * @param \ArrayType\ArrayOfOrderDetailActualDetailType $orderField
     * @param int $sequenceField
     * @param string $startTimeField
     * @param int $stopIDField
     */
    public function __construct($actualStopIDField = null, \StructType\Coordinates $coordinatesField = null, $delayTimeField = null, $durationField = null, $endTimeField = null, $inprogressField = null, $legField = null, $odometerField = null, \ArrayType\ArrayOfOrderDetailActualDetailType $orderField = null, $sequenceField = null, $startTimeField = null, $stopIDField = null)
    {
        $this
            ->setActualStopIDField($actualStopIDField)
            ->setCoordinatesField($coordinatesField)
            ->setDelayTimeField($delayTimeField)
            ->setDurationField($durationField)
            ->setEndTimeField($endTimeField)
            ->setInprogressField($inprogressField)
            ->setLegField($legField)
            ->setOdometerField($odometerField)
            ->setOrderField($orderField)
            ->setSequenceField($sequenceField)
            ->setStartTimeField($startTimeField)
            ->setStopIDField($stopIDField);
    }
    /**
     * Get actualStopIDField value
     * @return int|null
     */
    public function getActualStopIDField()
    {
        return $this->actualStopIDField;
    }
    /**
     * Set actualStopIDField value
     * @param int $actualStopIDField
     * @return \StructType\StopActualDetailType
     */
    public function setActualStopIDField($actualStopIDField = null)
    {
        // validation for constraint: int
        if (!is_null($actualStopIDField) && !(is_int($actualStopIDField) || ctype_digit($actualStopIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($actualStopIDField, true), gettype($actualStopIDField)), __LINE__);
        }
        $this->actualStopIDField = $actualStopIDField;
        return $this;
    }
    /**
     * Get coordinatesField value
     * @return \StructType\Coordinates|null
     */
    public function getCoordinatesField()
    {
        return $this->coordinatesField;
    }
    /**
     * Set coordinatesField value
     * @param \StructType\Coordinates $coordinatesField
     * @return \StructType\StopActualDetailType
     */
    public function setCoordinatesField(\StructType\Coordinates $coordinatesField = null)
    {
        $this->coordinatesField = $coordinatesField;
        return $this;
    }
    /**
     * Get delayTimeField value
     * @return string|null
     */
    public function getDelayTimeField()
    {
        return $this->delayTimeField;
    }
    /**
     * Set delayTimeField value
     * @param string $delayTimeField
     * @return \StructType\StopActualDetailType
     */
    public function setDelayTimeField($delayTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($delayTimeField) && !is_string($delayTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($delayTimeField, true), gettype($delayTimeField)), __LINE__);
        }
        $this->delayTimeField = $delayTimeField;
        return $this;
    }
    /**
     * Get durationField value
     * @return string|null
     */
    public function getDurationField()
    {
        return $this->durationField;
    }
    /**
     * Set durationField value
     * @param string $durationField
     * @return \StructType\StopActualDetailType
     */
    public function setDurationField($durationField = null)
    {
        // validation for constraint: string
        if (!is_null($durationField) && !is_string($durationField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($durationField, true), gettype($durationField)), __LINE__);
        }
        $this->durationField = $durationField;
        return $this;
    }
    /**
     * Get endTimeField value
     * @return string|null
     */
    public function getEndTimeField()
    {
        return $this->endTimeField;
    }
    /**
     * Set endTimeField value
     * @param string $endTimeField
     * @return \StructType\StopActualDetailType
     */
    public function setEndTimeField($endTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($endTimeField) && !is_string($endTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($endTimeField, true), gettype($endTimeField)), __LINE__);
        }
        $this->endTimeField = $endTimeField;
        return $this;
    }
    /**
     * Get inprogressField value
     * @return bool|null
     */
    public function getInprogressField()
    {
        return $this->inprogressField;
    }
    /**
     * Set inprogressField value
     * @param bool $inprogressField
     * @return \StructType\StopActualDetailType
     */
    public function setInprogressField($inprogressField = null)
    {
        // validation for constraint: boolean
        if (!is_null($inprogressField) && !is_bool($inprogressField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($inprogressField, true), gettype($inprogressField)), __LINE__);
        }
        $this->inprogressField = $inprogressField;
        return $this;
    }
    /**
     * Get legField value
     * @return int|null
     */
    public function getLegField()
    {
        return $this->legField;
    }
    /**
     * Set legField value
     * @param int $legField
     * @return \StructType\StopActualDetailType
     */
    public function setLegField($legField = null)
    {
        // validation for constraint: int
        if (!is_null($legField) && !(is_int($legField) || ctype_digit($legField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($legField, true), gettype($legField)), __LINE__);
        }
        $this->legField = $legField;
        return $this;
    }
    /**
     * Get odometerField value
     * @return float|null
     */
    public function getOdometerField()
    {
        return $this->odometerField;
    }
    /**
     * Set odometerField value
     * @param float $odometerField
     * @return \StructType\StopActualDetailType
     */
    public function setOdometerField($odometerField = null)
    {
        // validation for constraint: float
        if (!is_null($odometerField) && !(is_float($odometerField) || is_numeric($odometerField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($odometerField, true), gettype($odometerField)), __LINE__);
        }
        $this->odometerField = $odometerField;
        return $this;
    }
    /**
     * Get orderField value
     * @return \ArrayType\ArrayOfOrderDetailActualDetailType|null
     */
    public function getOrderField()
    {
        return $this->orderField;
    }
    /**
     * Set orderField value
     * @param \ArrayType\ArrayOfOrderDetailActualDetailType $orderField
     * @return \StructType\StopActualDetailType
     */
    public function setOrderField(\ArrayType\ArrayOfOrderDetailActualDetailType $orderField = null)
    {
        $this->orderField = $orderField;
        return $this;
    }
    /**
     * Get sequenceField value
     * @return int|null
     */
    public function getSequenceField()
    {
        return $this->sequenceField;
    }
    /**
     * Set sequenceField value
     * @param int $sequenceField
     * @return \StructType\StopActualDetailType
     */
    public function setSequenceField($sequenceField = null)
    {
        // validation for constraint: int
        if (!is_null($sequenceField) && !(is_int($sequenceField) || ctype_digit($sequenceField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($sequenceField, true), gettype($sequenceField)), __LINE__);
        }
        $this->sequenceField = $sequenceField;
        return $this;
    }
    /**
     * Get startTimeField value
     * @return string|null
     */
    public function getStartTimeField()
    {
        return $this->startTimeField;
    }
    /**
     * Set startTimeField value
     * @param string $startTimeField
     * @return \StructType\StopActualDetailType
     */
    public function setStartTimeField($startTimeField = null)
    {
        // validation for constraint: string
        if (!is_null($startTimeField) && !is_string($startTimeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($startTimeField, true), gettype($startTimeField)), __LINE__);
        }
        $this->startTimeField = $startTimeField;
        return $this;
    }
    /**
     * Get stopIDField value
     * @return int|null
     */
    public function getStopIDField()
    {
        return $this->stopIDField;
    }
    /**
     * Set stopIDField value
     * @param int $stopIDField
     * @return \StructType\StopActualDetailType
     */
    public function setStopIDField($stopIDField = null)
    {
        // validation for constraint: int
        if (!is_null($stopIDField) && !(is_int($stopIDField) || ctype_digit($stopIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($stopIDField, true), gettype($stopIDField)), __LINE__);
        }
        $this->stopIDField = $stopIDField;
        return $this;
    }
}
