<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SuggestRoutesOrder StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SuggestRoutesOrder
 * @subpackage Structs
 */
class SuggestRoutesOrder extends AbstractStructBase
{
    /**
     * The accountMasterDetailsField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\AccountMasterDetails
     */
    public $accountMasterDetailsField;
    /**
     * The accountTimeWindowField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\TimeWindowType
     */
    public $accountTimeWindowField;
    /**
     * The eqCodeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $eqCodeField;
    /**
     * The orderIDField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $orderIDField;
    /**
     * The quantityFieldListField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfSuggestRoutesOrderQuantityField
     */
    public $quantityFieldListField;
    /**
     * The suggestRoutesOrderTimeWindowField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfTimeWindowType
     */
    public $suggestRoutesOrderTimeWindowField;
    /**
     * Constructor method for SuggestRoutesOrder
     * @uses SuggestRoutesOrder::setAccountMasterDetailsField()
     * @uses SuggestRoutesOrder::setAccountTimeWindowField()
     * @uses SuggestRoutesOrder::setEqCodeField()
     * @uses SuggestRoutesOrder::setOrderIDField()
     * @uses SuggestRoutesOrder::setQuantityFieldListField()
     * @uses SuggestRoutesOrder::setSuggestRoutesOrderTimeWindowField()
     * @param \StructType\AccountMasterDetails $accountMasterDetailsField
     * @param \StructType\TimeWindowType $accountTimeWindowField
     * @param string $eqCodeField
     * @param string $orderIDField
     * @param \ArrayType\ArrayOfSuggestRoutesOrderQuantityField $quantityFieldListField
     * @param \ArrayType\ArrayOfTimeWindowType $suggestRoutesOrderTimeWindowField
     */
    public function __construct(\StructType\AccountMasterDetails $accountMasterDetailsField = null, \StructType\TimeWindowType $accountTimeWindowField = null, $eqCodeField = null, $orderIDField = null, \ArrayType\ArrayOfSuggestRoutesOrderQuantityField $quantityFieldListField = null, \ArrayType\ArrayOfTimeWindowType $suggestRoutesOrderTimeWindowField = null)
    {
        $this
            ->setAccountMasterDetailsField($accountMasterDetailsField)
            ->setAccountTimeWindowField($accountTimeWindowField)
            ->setEqCodeField($eqCodeField)
            ->setOrderIDField($orderIDField)
            ->setQuantityFieldListField($quantityFieldListField)
            ->setSuggestRoutesOrderTimeWindowField($suggestRoutesOrderTimeWindowField);
    }
    /**
     * Get accountMasterDetailsField value
     * @return \StructType\AccountMasterDetails|null
     */
    public function getAccountMasterDetailsField()
    {
        return $this->accountMasterDetailsField;
    }
    /**
     * Set accountMasterDetailsField value
     * @param \StructType\AccountMasterDetails $accountMasterDetailsField
     * @return \StructType\SuggestRoutesOrder
     */
    public function setAccountMasterDetailsField(\StructType\AccountMasterDetails $accountMasterDetailsField = null)
    {
        $this->accountMasterDetailsField = $accountMasterDetailsField;
        return $this;
    }
    /**
     * Get accountTimeWindowField value
     * @return \StructType\TimeWindowType|null
     */
    public function getAccountTimeWindowField()
    {
        return $this->accountTimeWindowField;
    }
    /**
     * Set accountTimeWindowField value
     * @param \StructType\TimeWindowType $accountTimeWindowField
     * @return \StructType\SuggestRoutesOrder
     */
    public function setAccountTimeWindowField(\StructType\TimeWindowType $accountTimeWindowField = null)
    {
        $this->accountTimeWindowField = $accountTimeWindowField;
        return $this;
    }
    /**
     * Get eqCodeField value
     * @return string|null
     */
    public function getEqCodeField()
    {
        return $this->eqCodeField;
    }
    /**
     * Set eqCodeField value
     * @param string $eqCodeField
     * @return \StructType\SuggestRoutesOrder
     */
    public function setEqCodeField($eqCodeField = null)
    {
        // validation for constraint: string
        if (!is_null($eqCodeField) && !is_string($eqCodeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eqCodeField, true), gettype($eqCodeField)), __LINE__);
        }
        $this->eqCodeField = $eqCodeField;
        return $this;
    }
    /**
     * Get orderIDField value
     * @return string|null
     */
    public function getOrderIDField()
    {
        return $this->orderIDField;
    }
    /**
     * Set orderIDField value
     * @param string $orderIDField
     * @return \StructType\SuggestRoutesOrder
     */
    public function setOrderIDField($orderIDField = null)
    {
        // validation for constraint: string
        if (!is_null($orderIDField) && !is_string($orderIDField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($orderIDField, true), gettype($orderIDField)), __LINE__);
        }
        $this->orderIDField = $orderIDField;
        return $this;
    }
    /**
     * Get quantityFieldListField value
     * @return \ArrayType\ArrayOfSuggestRoutesOrderQuantityField|null
     */
    public function getQuantityFieldListField()
    {
        return $this->quantityFieldListField;
    }
    /**
     * Set quantityFieldListField value
     * @param \ArrayType\ArrayOfSuggestRoutesOrderQuantityField $quantityFieldListField
     * @return \StructType\SuggestRoutesOrder
     */
    public function setQuantityFieldListField(\ArrayType\ArrayOfSuggestRoutesOrderQuantityField $quantityFieldListField = null)
    {
        $this->quantityFieldListField = $quantityFieldListField;
        return $this;
    }
    /**
     * Get suggestRoutesOrderTimeWindowField value
     * @return \ArrayType\ArrayOfTimeWindowType|null
     */
    public function getSuggestRoutesOrderTimeWindowField()
    {
        return $this->suggestRoutesOrderTimeWindowField;
    }
    /**
     * Set suggestRoutesOrderTimeWindowField value
     * @param \ArrayType\ArrayOfTimeWindowType $suggestRoutesOrderTimeWindowField
     * @return \StructType\SuggestRoutesOrder
     */
    public function setSuggestRoutesOrderTimeWindowField(\ArrayType\ArrayOfTimeWindowType $suggestRoutesOrderTimeWindowField = null)
    {
        $this->suggestRoutesOrderTimeWindowField = $suggestRoutesOrderTimeWindowField;
        return $this;
    }
}
