<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TAssetTypes StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TAssetTypes
 * @subpackage Structs
 */
class TAssetTypes extends AbstractStructBase
{
    /**
     * The assetTypeKeyIDField
     * @var int
     */
    public $assetTypeKeyIDField;
    /**
     * The routableField
     * @var bool
     */
    public $routableField;
    /**
     * The typeField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $typeField;
    /**
     * Constructor method for TAssetTypes
     * @uses TAssetTypes::setAssetTypeKeyIDField()
     * @uses TAssetTypes::setRoutableField()
     * @uses TAssetTypes::setTypeField()
     * @param int $assetTypeKeyIDField
     * @param bool $routableField
     * @param string $typeField
     */
    public function __construct($assetTypeKeyIDField = null, $routableField = null, $typeField = null)
    {
        $this
            ->setAssetTypeKeyIDField($assetTypeKeyIDField)
            ->setRoutableField($routableField)
            ->setTypeField($typeField);
    }
    /**
     * Get assetTypeKeyIDField value
     * @return int|null
     */
    public function getAssetTypeKeyIDField()
    {
        return $this->assetTypeKeyIDField;
    }
    /**
     * Set assetTypeKeyIDField value
     * @param int $assetTypeKeyIDField
     * @return \StructType\TAssetTypes
     */
    public function setAssetTypeKeyIDField($assetTypeKeyIDField = null)
    {
        // validation for constraint: int
        if (!is_null($assetTypeKeyIDField) && !(is_int($assetTypeKeyIDField) || ctype_digit($assetTypeKeyIDField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($assetTypeKeyIDField, true), gettype($assetTypeKeyIDField)), __LINE__);
        }
        $this->assetTypeKeyIDField = $assetTypeKeyIDField;
        return $this;
    }
    /**
     * Get routableField value
     * @return bool|null
     */
    public function getRoutableField()
    {
        return $this->routableField;
    }
    /**
     * Set routableField value
     * @param bool $routableField
     * @return \StructType\TAssetTypes
     */
    public function setRoutableField($routableField = null)
    {
        // validation for constraint: boolean
        if (!is_null($routableField) && !is_bool($routableField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($routableField, true), gettype($routableField)), __LINE__);
        }
        $this->routableField = $routableField;
        return $this;
    }
    /**
     * Get typeField value
     * @return string|null
     */
    public function getTypeField()
    {
        return $this->typeField;
    }
    /**
     * Set typeField value
     * @param string $typeField
     * @return \StructType\TAssetTypes
     */
    public function setTypeField($typeField = null)
    {
        // validation for constraint: string
        if (!is_null($typeField) && !is_string($typeField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($typeField, true), gettype($typeField)), __LINE__);
        }
        $this->typeField = $typeField;
        return $this;
    }
}
