<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TUserFieldList StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TUserFieldList
 * @subpackage Structs
 */
class TUserFieldList extends AbstractStructBase
{
    /**
     * The _alias
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $_alias;
    /**
     * The _displayOrder
     * @var int
     */
    public $_displayOrder;
    /**
     * The _overWriteMaster
     * @var int
     */
    public $_overWriteMaster;
    /**
     * The _sendToPhone
     * @var bool
     */
    public $_sendToPhone;
    /**
     * The _tableName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $_tableName;
    /**
     * The _userFeildKeyId
     * @var int
     */
    public $_userFeildKeyId;
    /**
     * The _userFieldType
     * @var int
     */
    public $_userFieldType;
    /**
     * Constructor method for TUserFieldList
     * @uses TUserFieldList::set_alias()
     * @uses TUserFieldList::set_displayOrder()
     * @uses TUserFieldList::set_overWriteMaster()
     * @uses TUserFieldList::set_sendToPhone()
     * @uses TUserFieldList::set_tableName()
     * @uses TUserFieldList::set_userFeildKeyId()
     * @uses TUserFieldList::set_userFieldType()
     * @param string $_alias
     * @param int $_displayOrder
     * @param int $_overWriteMaster
     * @param bool $_sendToPhone
     * @param string $_tableName
     * @param int $_userFeildKeyId
     * @param int $_userFieldType
     */
    public function __construct($_alias = null, $_displayOrder = null, $_overWriteMaster = null, $_sendToPhone = null, $_tableName = null, $_userFeildKeyId = null, $_userFieldType = null)
    {
        $this
            ->set_alias($_alias)
            ->set_displayOrder($_displayOrder)
            ->set_overWriteMaster($_overWriteMaster)
            ->set_sendToPhone($_sendToPhone)
            ->set_tableName($_tableName)
            ->set_userFeildKeyId($_userFeildKeyId)
            ->set_userFieldType($_userFieldType);
    }
    /**
     * Get _alias value
     * @return string|null
     */
    public function get_alias()
    {
        return $this->_alias;
    }
    /**
     * Set _alias value
     * @param string $_alias
     * @return \StructType\TUserFieldList
     */
    public function set_alias($_alias = null)
    {
        // validation for constraint: string
        if (!is_null($_alias) && !is_string($_alias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_alias, true), gettype($_alias)), __LINE__);
        }
        $this->_alias = $_alias;
        return $this;
    }
    /**
     * Get _displayOrder value
     * @return int|null
     */
    public function get_displayOrder()
    {
        return $this->_displayOrder;
    }
    /**
     * Set _displayOrder value
     * @param int $_displayOrder
     * @return \StructType\TUserFieldList
     */
    public function set_displayOrder($_displayOrder = null)
    {
        // validation for constraint: int
        if (!is_null($_displayOrder) && !(is_int($_displayOrder) || ctype_digit($_displayOrder))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_displayOrder, true), gettype($_displayOrder)), __LINE__);
        }
        $this->_displayOrder = $_displayOrder;
        return $this;
    }
    /**
     * Get _overWriteMaster value
     * @return int|null
     */
    public function get_overWriteMaster()
    {
        return $this->_overWriteMaster;
    }
    /**
     * Set _overWriteMaster value
     * @param int $_overWriteMaster
     * @return \StructType\TUserFieldList
     */
    public function set_overWriteMaster($_overWriteMaster = null)
    {
        // validation for constraint: int
        if (!is_null($_overWriteMaster) && !(is_int($_overWriteMaster) || ctype_digit($_overWriteMaster))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_overWriteMaster, true), gettype($_overWriteMaster)), __LINE__);
        }
        $this->_overWriteMaster = $_overWriteMaster;
        return $this;
    }
    /**
     * Get _sendToPhone value
     * @return bool|null
     */
    public function get_sendToPhone()
    {
        return $this->_sendToPhone;
    }
    /**
     * Set _sendToPhone value
     * @param bool $_sendToPhone
     * @return \StructType\TUserFieldList
     */
    public function set_sendToPhone($_sendToPhone = null)
    {
        // validation for constraint: boolean
        if (!is_null($_sendToPhone) && !is_bool($_sendToPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($_sendToPhone, true), gettype($_sendToPhone)), __LINE__);
        }
        $this->_sendToPhone = $_sendToPhone;
        return $this;
    }
    /**
     * Get _tableName value
     * @return string|null
     */
    public function get_tableName()
    {
        return $this->_tableName;
    }
    /**
     * Set _tableName value
     * @param string $_tableName
     * @return \StructType\TUserFieldList
     */
    public function set_tableName($_tableName = null)
    {
        // validation for constraint: string
        if (!is_null($_tableName) && !is_string($_tableName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_tableName, true), gettype($_tableName)), __LINE__);
        }
        $this->_tableName = $_tableName;
        return $this;
    }
    /**
     * Get _userFeildKeyId value
     * @return int|null
     */
    public function get_userFeildKeyId()
    {
        return $this->_userFeildKeyId;
    }
    /**
     * Set _userFeildKeyId value
     * @param int $_userFeildKeyId
     * @return \StructType\TUserFieldList
     */
    public function set_userFeildKeyId($_userFeildKeyId = null)
    {
        // validation for constraint: int
        if (!is_null($_userFeildKeyId) && !(is_int($_userFeildKeyId) || ctype_digit($_userFeildKeyId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_userFeildKeyId, true), gettype($_userFeildKeyId)), __LINE__);
        }
        $this->_userFeildKeyId = $_userFeildKeyId;
        return $this;
    }
    /**
     * Get _userFieldType value
     * @return int|null
     */
    public function get_userFieldType()
    {
        return $this->_userFieldType;
    }
    /**
     * Set _userFieldType value
     * @param int $_userFieldType
     * @return \StructType\TUserFieldList
     */
    public function set_userFieldType($_userFieldType = null)
    {
        // validation for constraint: int
        if (!is_null($_userFieldType) && !(is_int($_userFieldType) || ctype_digit($_userFieldType))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_userFieldType, true), gettype($_userFieldType)), __LINE__);
        }
        $this->_userFieldType = $_userFieldType;
        return $this;
    }
}
